// simple.vert

#extension GL_EXT_gpu_shader4 : enable

varying vec3 position;
varying vec3 normal;

uniform int lightNumber;
uniform float scatter;

float GetSpotEffect(int i, float spotAngleCos){
    float spotCosCutoff = gl_LightSource[i].spotCosCutoff;
    float spotEffect = 0.0;

    if (spotCosCutoff < -0.99){
	spotEffect = 1.0;
    }
    else if (spotAngleCos > spotCosCutoff) {
    	spotEffect = 1.0;//pow(spotEffect, gl_LightSource[i].spotExponent);
    }
    else if (spotAngleCos > spotCosCutoff * 0.9) {
	float factor = (spotAngleCos - spotCosCutoff * 0.9) / spotCosCutoff / 0.1;
	spotEffect = -2.0*factor*factor*factor + 3.0*factor*factor;
    }
    else
	spotEffect = 0.0;

    return spotEffect;
}

void main(void)
{
    gl_TexCoord[0] = gl_MultiTexCoord0;
    gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex;

    gl_FrontColor = gl_Color;

    position = vec3(gl_ModelViewMatrix * gl_Vertex);
    normal = gl_NormalMatrix * gl_Normal;
}
