// "clsAsciiReader.h"
// (c-basic-offset 4)

#include "clsAsciiReader.h"

#include <stdlib.h>

#ifndef TRUE
#define TRUE true
#define FALSE false
#endif

bool AsciiReader_cls::
IsCharExist(char *ptr, char delim, char item){
    bool bExist = FALSE;
    while (TRUE){
	if (*ptr == delim) break;
	if (*ptr == item) bExist = TRUE;
	ptr++;
    }
    return bExist;
}

bool AsciiReader_cls::
SearchChar(char **ptr, char item, char *bufferEnd){
    while (TRUE){
	if (**ptr == item) break;
	if ((*ptr) >= bufferEnd){
	    *ptr = NULL;
	    break;
	}
	(*ptr)++;
    }
    /*
    while (**ptr != item){
	(*ptr) = (*ptr)+1;
	if ((*ptr) >= bufferEnd){
	    *ptr = NULL;
	    break;
	}
    }
    */
    if (*ptr == NULL) return FALSE;
    return TRUE;
}

bool AsciiReader_cls::
SearchTagStr(char **ptr, char *tag, char *bufferEnd, bool bProgress){
    char *pOrg = *ptr;
    if (SearchChar(ptr, ' ', bufferEnd) == FALSE){
	*ptr = pOrg;
	return FALSE;
    }
    
    char strTag[512];
    memcpy(strTag, pOrg, *ptr-pOrg);
    strTag[*ptr-pOrg] = '\0';

    if (strcmp(strTag, tag) == 0){
	if (bProgress == FALSE) *ptr = pOrg; // ptri߂Ȃ
	return TRUE;
    }

    *ptr = pOrg;
    return FALSE;
}

void AsciiReader_cls::
GetStrUptoLineEnd(char **ptr, char *str, char *bufferEnd){
    char *pFileIni = *ptr;
    if (SearchChar(ptr, '\n', bufferEnd) == FALSE) return;
    char *pFileFin = *ptr;
    memcpy(str, pFileIni, pFileFin - pFileIni);
    str[pFileFin - pFileIni] = '\0';
}

int AsciiReader_cls::
_space_sign(const char *s, const char **endptr){
    while (*s == 0x20)
	++s;
    int sign = 0;
    switch (*s){
    case '-':
	sign = -1;
	// fall through
    case '+':
	++s;
	break;
    }
    *endptr = s;
    return sign;
}

//atof(Ȃ, egȂ)
float AsciiReader_cls::
fast_atof32(const char *s){
    int sign = _space_sign(s, &s);
    int result = 0;
    int cnm = 1;
    while(true) {
	if(*s == '.'){
	    s++;
	    break;
	}
	else if(*s > '9' || *s < '0') break;
	
	result = result * 10 + *s - '0';
	s++;
    }

    while(true){
	if(*s > '9' || *s < '0')break;
	result = result * 10 + *s - '0';
	cnm*=10;
	s++;
    }

    if (sign != 0) result = -result;
    
    return (float)result / cnm;
}

//atoi
int AsciiReader_cls::
fast_atoi(const char *s){
     int sign = _space_sign(s, &s);
     int result = 0;
     while(true) {
         if(*s > '9' || *s < '0')break;
         result = result * 10 + *s - '0';
         s++;
     }

     if (sign != 0)
         result = -result;
     return result;
}

float AsciiReader_cls::
ReadFloat(char **pptr, char delim){
    //float value = fast_atof32(*pptr);
    float value = (float)atof(*pptr);
    while (**pptr != delim) (*pptr)++;
    return value;
}

int AsciiReader_cls::
ReadInt(char **pptr, char delim){
    int value = fast_atoi(*pptr);
    //int value = atoi(*pptr);
    while (**pptr != delim && **pptr != '\n' && **pptr != ' ') (*pptr)++;
    return value;
}

bool AsciiReader_cls::
ReadBool(char **pptr, char delim){
    bool bBool = FALSE;
    char *ptmp = *pptr;
    while (**pptr != delim) (*pptr)++;
    if ((*pptr - ptmp) == 2){
	if (ptmp[0] == 'o' && ptmp[1] == 'n') bBool = TRUE;
    }
    if ((*pptr - ptmp) == 1){
	if (ptmp[0] == '1') bBool = TRUE;
    }
	
    return bBool;
}

char* AsciiReader_cls::
GetMemoryBufferFromFile(wxString strFile){
    FILE *fp = fopen(strFile.ToAscii(), "rb"); //!!
    if (fp == NULL) return NULL; 

    fseek( fp, 0, SEEK_END );
    mFileSize = ftell( fp );
    fseek( fp, 0, SEEK_SET);
    
    char *pBuffer = new char [mFileSize+1];
    fread( pBuffer, 1, mFileSize, fp);
    fclose(fp);
    return pBuffer;
}
