// -*- c -*-
// (setq c-basic-offset 4)
// ("clsFilename.cpp")

#ifndef _FILENAME_H_
#define _FILENAME_H_

#define _FN_FULLPATH        0
#define _FN_DRIVE           1
#define _FN_DIR             2
#define _FN_DRIVE_DIR       3
#define _FN_FNAME           4
#define _FN_DRIVE_DIR_FNAME 7
#define _FN_EXT             8
#define _FN_FNAME_EXT       12

#define _FN_INCREMENT_TAIL  0
#define _FN_INCREMENT_EXT   1

#include <string>
#include <wx/wx.h>

class SplitPath_cls{
 public:
    SplitPath_cls(wxString pathStr);

    wxString mstrFullPath;
    wxString mstrFullPathMinusExt;
    wxString mstrDirPlusDrive;
    wxString mstrFilename;
    wxString mstrExt; // .t
    
    wxString GetPathStr(int flag = _FN_FULLPATH);
    wxString GetPathDirLast();
    wxString GetImageTypeStr();
    bool     IsHDF5File();
};

class Filename_cls{
 public:
    wxString mstrPath;
    Filename_cls();
    Filename_cls(const wxChar *path);
    Filename_cls(wxString pathStr);

    wxString GetPathStr(int flag = _FN_FULLPATH);

    const wxChar* c_str();

    void  Set(wxString strPath);

    static void DoubleSlash(wxString &str);
};

class FileSequence_cls : public Filename_cls {
 public:
    FileSequence_cls();
    FileSequence_cls(wxString pathStr);

    void Set(const wxString pathStr, int initSeqNum, int seqInterval = 1);
    
    int SequenceFormatPos();

    void InitFormat(int initSeqNum);
    void SplitFormat(int pos);
    void CalcMaxOffset();

    // abc/def0000.ext
    // abc/def         msFileHead; 
    // anc/def%03d.ext msFormat;
    wxString mstrFileHead;
    wxString mstrFormat;
    wxString mstrExt;
    
    //int         mChannel;     // (KvȂ)RGB
    //int         mDigit;       // AԂ̍ŏ̐
    int         mInit; // AԂ̍ŏ̐
    int         mInterval;
    int         mDigitLength; // AԂ̌
    int         mSeqLength;   // t@C
    wxString GetFormat();
    wxString GetModifiedStr(int index, int stereo = 0);
    wxString GetInfoStr();
    //wxString GetChannelStr();
    void AppendDefaultSequenceTag();
};

bool operator==(const Filename_cls& CLeft,
		const Filename_cls& CRight);


#endif //_FILENAME_H_
