
#ifndef _FILTER_BG_H_
#define _FILTER_BG_H_

#include "../FILTER/clsFilterBase.h"
#include "../SCENEOBJ/clsSceneObj.h"
#include "../MYGL/clsGLTexture.h"

#define _BG_STARS 0
#define _BG_TEXTURE_MAP 1
#define _BG_COLOR_CURVE 2

#define _MAPPING_FISHEYE 0
#define _MAPPING_SPHERICAL   1

class FilterBG_cls;
class FilterPanelPain_cls;
class PovRayCtrl_cls;

class FilterBGGUI_cls : public FilterGUI_cls {
     public:
    FilterBGGUI_cls(FilterBG_cls *pCParent, 
		    FilterPanelPain_cls *pCPanelPain);
    FilterBG_cls *mpCParent;

    int mIndexType;
    int mIndexStarNum;
    int mIndexBright;
    int mIndexMappingType;
    int mIndexTextureA, mIndexTextureB;
    int mIndexColor, mIndexColorType;

    void SetMNumPanel(wxBoxSizer *pBoxSizer, wxWindow *pCParentWindow,
		      int index);

    void HookFunc01(int id, void *pArg);
    void HookFuncHS(int id, void *pArg);
    void HideAndShow();
    void PathSelection(int index);
};

class FilterBGData_cls : public FilterData_cls {
 public:
    FilterBGData_cls();
    ~FilterBGData_cls();

    void CopyFilterDataFromP
	(FilterData_cls *pCFrom,
	 ParamGroup_cls *pCTranslate  = NULL,
	 ParamGroup_cls *pCRotete     = NULL,
	 ParamGroup_cls *pCScale      = NULL,
	 ParamGroup_cls *pCAdditional = NULL);

    ConfItemUINT_cls   mCBGType;
    ConfItemINT_cls    mCStarNumber;
    ConfItemFLOAT_cls  mCBrightness;
    ConfItemFLOAT_cls  mCStarScale;
    ConfItemFLOAT_cls  mCBGScale;
    ConfItemUINT_cls   mCMappingType;
    ConfItemSTR_cls    mCstrTextureA;
    ConfItemSTR_cls    mCstrTextureB;
    ConfItemUINT_cls   mCColorMapType;
    
    ParamGroupStatus_cls mCPGStatusBG;
};

class FilterBG_cls : public FilterBase_cls {
 public:
    FilterBG_cls (FilterPanelPain_cls *pCPanelPain,
		   FilterBGData_cls *pCInitData = NULL);
    ~FilterBG_cls();

    FilterBGData_cls *GetPCData();
    
    void DrawCenterfacedSquare(float x, float y, float z, float size);

    void CompileStars();
    void CompileDome();
    void ProcessFisheyeRim(wxImage &CImg);
    void GLDrawStarField();
    void CheckTextureA();
    void CheckTextureB();
    bool IsClrStatusChanged();
    void CheckTextureClrCurve();
    void GLDrawDome(int index, float scale);
    void GLDrawTextureFishEye();
    void GLDrawTextureSpherical(int type);
    void GLDraw(double doubleIndex);

    GLTexture_cls mCGLTextureStar;
    GLTexture_cls *mpCGLTextureA;
    GLTexture_cls *mpCGLTextureB;
    GLTexture_cls *mpCGLTextureClrCurve;

    int   mDLStars;
    int   mDLStarNumberCompiled;
    float mStarScaleCompiled;
    int   mBGScaleCompiled;
    int   mDLDome, mDLSphere;

    // TextureXV邩̔Ɏg
    int   mPrevStamp[4];
    bool  mPrevClrType;
    int   mPrevMapType;
    float mPrevClrConst[3];

    wxString mstrTexturALoaded;
    wxString mstrTexturBLoaded;
    
    bool IsCommonStatusEffective();
    void GetStrPovStars(wxString &strBG);
    wxString GetStrPovImageMap(wxString strFile, int mapType = 0);
    wxString GetStrPovFinish();
    void GetStrPovTextureFishEye(wxString &strBG, int type);
    void GetStrPovTextureSpherical(wxString &strBG);
    void GetStrPovSkySphere(wxString &strBG, double doubleIndex);
    void GetStrPovMacroForStars(wxString &strBG);
    void GetStrPovMacroForFishEye(wxString &strBG);    
    void GetStrPovBGMain(wxString &strBG, double doubleIndex);
    void GetStrPovBG(wxString &strBG, double doubleIndex, 
		     PovRayCtrl_cls *pCPovRayCtrl);
};

#endif
