
#ifndef _FILTER_COPY_H_
#define _FILTER_COPY_H_

#include "../FILTER/clsFilterBase.h"
#include "../LUA/clsLuaBase.h"

class ArrayAndIndex_cls;
class FilterCopy_cls;
class FilterPanelPain_cls;

#include <wx/thread.h>

class FilterCopyGUI_cls : public FilterGUI_cls {
 public:
    FilterCopyGUI_cls(FilterCopy_cls *pCParent, 
		      FilterPanelPain_cls *pCPanelPain);
    FilterCopy_cls *mpCParent;
    
    int mIndexExpression;
    
    void SetMNumPanel(wxBoxSizer *pBoxSizer, wxWindow *pCParentWindow,
		      int index);

    void HookFunc01(int id, void *pArg); // Periodic
    void HookFunc02(int id, void *pArg); // Expression
};

class FilterCopyData_cls : public FilterData_cls {
public:
    FilterCopyData_cls();
    
    ConfItemINT_cls mCArrayMin[3];
    ConfItemINT_cls mCArrayMax[3];

    ConfItemBOOL_cls mCbExpression;
    ConfItemSTR_cls mCstrExpression;
};

class FilterCopy_cls : public FilterBase_cls, public LuaBase_cls {
public:
    FilterCopy_cls (FilterPanelPain_cls *pCPanelPain,
		    FilterCopyData_cls *pCInitData = NULL);
    ~FilterCopy_cls();
    
    FilterCopyData_cls *GetPCData();

    ArrayAndIndex_cls *mpCIndexAndZ;

    void OpenLua();
    bool CallLuaValidity(int index, int nx, int ny, int nz, float time, int type);
    void CallLuaTranslate(int index, int nx, int ny, int nz, float time,
			  float &fx, float &fy, float &fz);

    int GetNumber();
    int GetNumberValid(double time);
    int GetBitBoundary(int index);
    bool GetBValidity(int index, double time, bool bUseSort, int type);
    std::vector < float > GetVTranslate(int index, double time);
    void ZSortBegin(double cameraPos[3], double cameraDir[3], double time);
    void ZSortEnd();
    void GLTranslate(int index, double time);
    void GetCopyTranslate(float *pTranslate, int index, double time);
    void OpenExpressionDialog();
    wxString GetStrPovTranslate(int index, double time);
};

#endif
