
#ifndef _FILTER_GRID_H_
#define _FILTER_GRID_H_

#include "../FILTER/clsFilterBase.h"
#include "../GLATTRIB/clsColorCurve.h"
#include "../MYGL/clsPositionAndDirection.h"
#include "../SCENEOBJ/clsSceneObj.h"
#include "../POVRAY/MESH/clsPovObjectGrid.h"

class ArrayAndIndex_cls;
class FilterGrid_cls;
class FilterPanelPain_cls;
class TagObject_cls;

#define _GRID_XY 0
#define _GRID_YZ 1
#define _GRID_ZX 2
#define _GRID_CUBIC 3
#define _GRID_CIRCULAR 4

#include <wx/thread.h>

class FilterGridGUI_cls : public FilterGUI_cls {
 public:
    FilterGridGUI_cls(FilterGrid_cls *pCParent, 
		      FilterPanelPain_cls *pCPanelPain);
    FilterGrid_cls *mpCParent;

    int mIndexFlatParam;
    
    void SetMNumPanel(wxBoxSizer *pBoxSizer, wxWindow *pCParentWindow,
		      int index);
};

class FilterGridData_cls : public FilterData_cls {
 public:
    FilterGridData_cls();

    ConfItemUINT_cls  mCGridType;
    ConfItemFLOAT_cls mCGridMin;
    ConfItemFLOAT_cls mCGridMax;
    ConfItemINT_cls mCGridLineNum;
    ConfItemBOOL_cls  mCbCoordTag;
};

class FilterGrid_cls : public FilterBase_cls {
 public:
    FilterGrid_cls (FilterPanelPain_cls *pCPanelPain,
		    FilterGridData_cls *pCInitData = NULL);
    ~FilterGrid_cls();

    FilterGridData_cls *GetPCData();
    
    PovObjectGrid_cls mCPovGrid;

    void GLDraw(double doubleIndex, double scale, bool bHittest);
    void GLDrawRealGrid(double doubleIndex, PositionAndDirection_cls CCamPos,
			std::vector < TagObject_cls > *pVCTagObject);

    void GetStrPovRealGrid(wxString &strObject, double doubleIndex, bool bCopyInstance, wxString strTab, PositionAndDirection_cls CCamPos);
};

#endif
