// "clsFilterBoolean.h"
// (setq basic-c-ofsset 4)

#ifndef _FILTER_STICK_H_
#define _FILTER_STICK_H_

#include "clsFilterBase.h"

#include "../POVRAY/MESH/clsPovObjectSticks.h"
#include "../SCENEOBJ/clsSceneObjTexture.h"

//class ArrayAndIndex_cls;
class FilterStick_cls;
class FilterPanelPain_cls;
class PeriodicBoundary_cls;
class SnapData_cls;

#define _STICK_LINE 0
#define _STICK_CYLINDER 1

#define _STICK_LOAD_FILE 0
#define _STICK_CALC 1

class FilterStickGUI_cls : public FilterGUI_cls {
 public:
    FilterStickGUI_cls(FilterStick_cls *pCParent,
			   FilterPanelPain_cls *pCPanelPain);
    FilterStick_cls *mpCParent;

    int mIndexType, mIndexPath;
    int mIndexRadius, mIndexWidth;
    int mIndexCritType;
    int mIndexCrit;
    int mIndexSpecType;
    int mIndexSpec;
    
    void SetMNumPanel(wxBoxSizer *pBoxSizer, wxWindow *pCParentWindow,
		      int index);

    void HookFuncHS(int id, void *pArg);
    void HookFunc01(int id, void *pArg); // Button
    //static void FuncHookType(void *pUsrDef, void *pArg);
    //static void FuncHookButton(void *pUsrDef, void *pArg);
    void HideAndShow();
    void PathSelection();
};

class FilterStickData_cls : public FilterData_cls {
 public:
    FilterStickData_cls();

    ConfItemUINT_cls mCCalcType;
    ConfItemUINT_cls mCStickType;
    ConfItemSTR_cls  mCstrStickPath;
    ConfItemFLOAT_cls mCRadius;
    ConfItemINT_cls  mCWidth;
    ConfItemUINT_cls  mCCritType;
    ConfItemFLOAT_cls mCCritA;
    ConfItemFLOAT_cls mCCritB;
    ConfItemUINT_cls  mCSpecType;
    ConfItemINT_cls  mCSpecA;
    ConfItemINT_cls  mCSpecB;
    
    SceneObjTexture_cls mCTexture;
    PovObjectSticks_cls mCSticks;

    bool IsConstantFactor();
    void GLDrawSticks(SnapData_cls *pCSnapshot, PeriodicBoundary_cls *pCPeriodic,
		      int bitBoundary, int currentIndex, 
		      PositionAndDirection_cls CCamPos,
		      int lightNumber);
    void GetStrPovSticksRef(wxString &strPData, SnapData_cls *pCSnapshot);
};

class FilterStick_cls : public FilterBase_cls {
 public:
    FilterStick_cls (FilterPanelPain_cls *pCPanelPain,
			 FilterStickData_cls *pCInitData = NULL);
    ~FilterStick_cls();

    FilterStickData_cls *GetPCData();

    void GLDrawStick(SnapData_cls *pCSnapshot, PeriodicBoundary_cls *pCPeriodic,
		     int bitBoundary, int currentIndex, 
		     PositionAndDirection_cls CCamPos, int lightNumber);

    void OnSelected();
    
    wxString GetStrPovCylinderMacro();
    void GetStrPovSticksRef(wxString &strPData, SnapData_cls *pCSnapshot);
};

#endif
