
#ifndef _FILTER_TEXT_H_
#define _FILTER_TEXT_H_

#include "../FILTER/clsFilterBase.h"
#include "../GLATTRIB/clsColorCurve.h"
#include "../MYGL/clsGLTexture.h"
#include "../SCENEOBJ/clsSceneObj.h"
#include "../SCENEOBJ/clsSceneObjTexture.h"

class ArrayAndIndex_cls;
class FilterText_cls;
class FilterPanelPain_cls;

class FilterTextGUI_cls : public FilterGUI_cls {
 public:
    FilterTextGUI_cls(FilterText_cls *pCParent, 
		      FilterPanelPain_cls *pCPanelPain);
    FilterText_cls *mpCParent;
    int mIndexEdit, mIndexFont;
    int mIndexArrayVector;

    void SetMNumPanel(wxBoxSizer *pBoxSizer, wxWindow *pCParentWindow,
		      int index);
    void HookFunc01(int id, void *pArg);
};

class FilterTextData_cls : public FilterData_cls{
 public:
    FilterTextData_cls();

    SceneObjTexture_cls mCTexture;

    ConfItemUINT_cls mCType;
    ConfItemBOOL_cls mCbFaceCamera;
    ConfItemBOOL_cls mCbShadow;
    ConfItemSTR_cls  mCText;
    ConfItemSTR_cls  mCFontDesc;
    
    wxString GetStrPovMatrix();

    void DrawMesh(int currentIndex);
};

class FilterText_cls : public FilterBase_cls {
 public:
    FilterText_cls (FilterPanelPain_cls *pCPanelPain,
		       FilterTextData_cls *pCInitData = NULL);
    ~FilterText_cls();

    FilterTextData_cls *GetPCData();
    GLTexture_cls mCGLTexture;

    wxString mstrTextMade, mstrFontMade;
    int  mTexWidth, mTexHeight;
    float mTexDescend;
    
    void MakeTextTexture();
    void OpenEditor();
    void SelectFont();

    void GLDraw(double doubleIndex, double scale, bool bHittest);
    void GLDrawRealText(bool bCopyInstance, PositionAndDirection_cls CCamPos);
    
    void GetStrPovRealText(wxString &strPov, double doubleIndex, bool bCopyInstance, wxString strTab, PositionAndDirection_cls CCamPos);
   
};

#endif
