// -*- c++ -*-
// "clsColorCurveGUI.cpp"

#ifndef _GL_COLORCURVE_GUI_H
#define _GL_COLORCURVE_GUI_H

#include "../WIDGETCTRL/clsDialogEXKey.h"
#include "../WIDGETCTRL/clsDialogController.h"
#include "../WIDGETCTRL/clsGraphPanel.h"
#include "../WIDGETCTRL/clsHookCtrl.h"
#include "../PARAMETER/clsTics.h"

class ColorCurveBtn_cls;
class ColorCurveCtrl_cls;
class ColorCurveGUI_cls;
class ColorCurveTemplate_cls;
class FrameMain_cls;
class wxButtonEX;

class ColorCurveTics_cls : public wxPanel, public Tics_cls {
public:
    ColorCurveTics_cls(ColorCurveGUI_cls *pCParent, wxWindow* pC, wxWindowID id);
    void OnPaint(wxPaintEvent& event);

    ColorCurveGUI_cls* mpCParentGUILink;

 private:
    // any class wishing to process wxWidgets events must use this macro
    DECLARE_EVENT_TABLE()
};

class ColorCurveGUI_cls : public wxDialogEXKey, public HookItem_cls {
 public:
    ColorCurveGUI_cls(ColorCurveCtrl_cls *pCCtrlLink, wxWindow *pCParent);

    ColorCurveCtrl_cls  *mpCCtrlLink;
    wxWindow            *mpCParent;
    MultiInputPanel_cls *mpCMInputPanelScale;
    MultiInputPanel_cls *mpCMInputPanelColor;

    ColorCurveBtn_cls   *mpCBtnClrCurve;
    ColorCurveTics_cls  *mpCTics;
    GraphPanel_cls      *mpCMainGraph;
    wxButtonEX          *mpCBtnFlipColor;
    wxButtonEX          *mpCBtnFlipRGB;
    wxButtonEX          *mpCBtnRed, *mpCBtnGreen, *mpCBtnBlue, *mpCBtnAlpha;

    wxButtonEX *mpCBtnAddKey, *mpCBtnRemKey, *mpCBtnColor;
    wxButtonEX *mpCBtnLft, *mpCBtnRgt;
    
    ColorCurveTemplate_cls *mpCPanelTemplate;

    float mDummy; // lƂăN
    int mIndexScaleMin, mIndexScaleMax;
    int mIndexWrapType;

    unsigned int mDummyValueType;
    float mDummyValueX;
    float mDummyPColor[4];
    int mIndexValueType;
    int mIndexColor[4];
    
    void RecconectColor(ColorCurve_cls *pCCtrlLink);
    void SetMNumScale(wxBoxSizer *pBoxSizer);
    void SetMNumColor(wxBoxSizer *pBoxSizer);
    int  GetContolMode();

    void SetColorComponent(int clrIndexId);
    void UpdateMNumValues();
    void UpdateButtons();
    void UpdateButtonsRGBA();
    void OnPaint(wxPaintEvent& event);
    void OnKeyDown(wxKeyEvent& event);
    void OnMenuRefreshButton(wxCommandEvent& event);
    void OnButtonFlip(wxCommandEvent& event);
    void OnButtonSwapRGB(wxCommandEvent& event);
    void OnButtonAddKey(wxCommandEvent& event);
    void OnButtonRemKey(wxCommandEvent& event);
    void OnButtonColor(wxCommandEvent& event);
    void OnButtonRGBA(wxCommandEvent& event);
    void OnButtonLft(wxCommandEvent& event);
    void OnButtonRgt(wxCommandEvent& event);
    
    void HookFunc01(int id, void *pArg); // HideAndShow
    void HookFunc02(int id, void *pArg); // Color

    //static void FuncHookRefresh(void *pEvent, void *pArg);
    //static void FuncHookIndex(void *pEvent, void *pArg);
    //static void FuncHookColor(void *pEvent, void *pArg);
 private:
    // any class wishing to process wxWidgets events must use this macro
    DECLARE_EVENT_TABLE()
};

class ColorCurveCtrl_cls : public DialogControl_cls{
 public:
    ColorCurveCtrl_cls(/*FrameMain_cls *pCParentFrame*/);

    FrameMain_cls *mpCParentFrame;
    wxBitmap      *mpBitmapLink;

    ColorCurveGUI_cls *mpCGUI;

    ColorCurve_cls *mpCCurveLinked;
    void DetachLink(ColorCurve_cls *pCClrCurve);
    void LinkColorCurve(ColorCurve_cls *pCClrCurve);
    void SetControlMode(int mode);

    void InitGUI(FrameMain_cls *pC);
    void UpdateItems(bool bForce = FALSE);
    void CopyColorFromP(ColorCurve_cls *pCClrCurve, bool bCurveOnly);
};

#endif
