// -*- c -*- 
// "clsGLAttribute.cpp"

#ifndef _GL_ATTRIBUTE_H_
#define _GL_ATTRIBUTE_H_

#include "../SCENEOBJ/clsSceneObjTexture.h"
#include "../MYGL/clsPositionAndDirection.h"

#define _GL_DRAW_POINT     0
#define _GL_DRAW_BILLBOARD 1
#define _GL_DRAW_SPHERE    2
#define _GL_DRAW_BOTH      3
#define _GL_DRAW_OBJECT    4
#define _GL_DRAW_PSEUDO_SPHERE 5
#define _GL_DRAW_PSEUDO_OBJECT 6
#define _GL_HIDE           7

#define _GL_RADIUS_NORMAL   0
#define _GL_RADIUS_CONSTANT 1

#define _GL_ALPHA_NORMAL         0
#define _GL_ALPHA_INVERSE_SQUARE 1

#define _GL_BLEND     0
#define _GL_BLEND_ADD 1

#define _GL_AMBIENT  0
#define _GL_DIFFUSE  1
#define _GL_SPECULAR 2

#include "../COMMON/CommonDefinitionsGL.h"

#include "../CONFITEM/clsConfItem.h"
#include <wx/wx.h>

class ColorCurve_cls;
class DrawOption_cls;
class FBO_cls;
class FilterCtrl_cls;
class FilterDataBoxData_cls;
class FilterObject_cls;
class GLAttributeGUI_cls;
class LightSRCCtrl_cls;
class PDataSequence_cls;
class ShaderCtrl_cls;

class GLAttribute_cls{
 public:
    GLAttribute_cls(PDataSequence_cls *pCParentSequence, int selfIndex);
    ~GLAttribute_cls();

    void InstantiateGUI(wxWindow *pCParent);
    void RefreshTex(int tex);
    void GenerateBufferRGBA(int tex);
    void DeleteBufferRGBA();
    void BindTexture();
    void SetGLSettingForAtras(int bufferSize, double doubleIndex,
			      FilterDataBoxData_cls *pCScene,
			      PositionAndDirection_cls CCamPos,
			      LightSRCCtrl_cls *pCLightSRCCtrlLink);

    FilterObject_cls *GetPCObject();
    bool IsAtrasNeeded();
    void UpdateBillboardTexture
	(PositionAndDirection_cls CCamPos, LightSRCCtrl_cls *pCLightSRCCtrlLink,
	 double doubleIndex, FilterDataBoxData_cls *pCScene);
    void MakeTextureAtras(FilterObject_cls *pCObj, 
			  int bufferSize, int firstBufferSize,
			  double doubleIndex, 
			  FilterDataBoxData_cls *pCScene, 
			  PositionAndDirection_cls CCamPos,
			  LightSRCCtrl_cls *pCLightSRCCtrlLink);
    
    PDataSequence_cls  *mpCParentSequence;
    static DrawOption_cls *mspCDrawOptionLink;
    GLAttributeGUI_cls *mpCGUI;

    ColorCurve_cls *mpCClrCurveCol;
    ColorCurve_cls *mpCClrCurveMat[3];

    SceneObjTexture_cls mCTexture;
    FBO_cls *mpCFBOBillboard;
    FBO_cls *mpCFBOBillboardBuffer;
    
    unsigned char *mpBufferRGBA;
    int mBufferWidth[2], mBufferHeight[2];

    bool    mbTextureValid[2];
    GLuint  mTexture[2];
    wxImage mCTexImg[2];
    wxString mstrLoadedTex[2];
    
    static int msBlendType;
    
    int mSelfIndex;

    static FilterCtrl_cls *mspCFilterCtrlObjectLink;
    static ShaderCtrl_cls *mspCShaderCtrl;
    static void InitializeShader(wxWindow *pCParent, bool bShaderAvailable);
    static void EnableShader(bool bUseShader);
    void BeginGasShader(int lightNumber);
    void BeginShader(int lightNumber, bool bShadowVolume = FALSE);
    void EndShader();
    void SetBlendFunc();

    float GetRadiusFactor();
    ConfItemList_cls mCConfList;
    ConfItemUINT_cls mCDrawType;
    ConfItemUINT_cls mCDrawQuality;
    ConfItemUINT_cls mCBlendType;
    ConfItemUINT_cls mCRadiusType;
    ConfItemFLOAT_cls mCRadiusFactor;
    ConfItemFLOAT_cls mCRadiusFactorForConst;
    ConfItemINT_cls   mCPointSize;
    ConfItemINT_cls   mCObjectIndex;
    ConfItemUINT_cls  mCAlphaType;
    ConfItemFLOAT_cls mCAlphaFactor;
    ConfItemFLOAT_cls mCAlphaDenendBase;
    ConfItemFLOAT_cls mCAlphaMax;
    ConfItemFLOAT_cls mCGasScattering;

    //----

    wxString mstrStatusSerialized;
    void Memorize();
    bool DoesUseDepthMask();
    bool IsObjectCalling(int index);
    bool IsDifferenceExist();
    bool IsColorCurve(int index);
    bool IsBlack(int index);
    
    //----

    void ReadStrLine(std::wistream &istream, wxString strLine);
    wxString Serialize();
};

#endif
