// -*- c -*- 
// "clsShaderCtrl.cpp"

#ifndef _SHADER_CTRL_H_
#define _SHADER_CTRL_H_

#include "clsShaderBase.h"
#include "../CONFITEM/clsConfItem.h"

#define _TEXTURE_DISABLED 0
#define _TEXTURE_ENABLED  1

class SceneObjTexture_cls;

class ShaderCtrl_cls : public ShaderBase_cls {
 public:
    ShaderCtrl_cls();
    
    static bool msbSingleLightingMode;
    static int  msSingleLightingIndex;

    int mCurrentShader;

    GLuint mGL2ProgramGouraud, mGL2ProgramPhong;
    GLuint mGL2ProgramCartoon, mGL2ProgramOutline;
    GLuint mGL2ProgramGas, mGL2ProgramAlphaClip;
    GLuint mGL2ProgramShadow;
    
    GLint mIDLNumGouraud, mIDLNumPhong, mIDLNumCartoon, mIDLNumOutline;
    GLint mIDTextureGouraud, mIDTexModeGouraud, mIDFogModeGouraud;
    GLint mIDTexturePhong, mIDTexModePhong, mIDFogModePhong;
    GLint mIDTextureCartoon, mIDTexModeCartoon, mIDFogModeCartoon, mIDShadowModeCartoon;
    GLint mIDLightRecieveGouraud, mIDLightRecievePhong;
    GLint mIDEdgeThresholdCartoon;
    GLint mIDTextureOutline, mIDTexModeOutline, mIDFogModeOutline, mIDShadowModeOutline;
    GLint mIDEdgeThresholdOutline, mIDBoldnessOutline;

    GLint mIDTextureGas, mIDLNumGas, mIDFogModeGas, mIDScatterGas;
    GLint mIDAmbientFactorScatter;
    GLint mIDClipThresholdGas, mIDClipThresholdClip;
    GLint mIDTextureAlphaClip, mIDLNumAlphaClip, mIDFogModeAlphaClip;
    
    void InitializeShader(wxWindow *pCParent, bool bShaderAvailable);
  
    int  GetFogMode();
    int  GetTextureMode();
    void GetLightingInfo(int lightRecieve[7], bool *pbLightRecieve);
    void UseProgram(int program);
    void BeginGasShader
	(SceneObjTexture_cls *pCTexture, int lightNumber, float scatter);
    void BeginAlphaClipShader
	(SceneObjTexture_cls *pCTexture, int lightNumber);
    void BeginShader(SceneObjTexture_cls *pCTexture, int lightNumber, bool bShadowVolume = FALSE);
    void EndShader(int shaderType);

    void SetShaderParamIDs();
    void SetTextureState(int texState);
    void SetShaderParamGouraud(int LNum, int fogMode, bool *pbLightRecieve);
    void SetShaderParamPhong  (int LNum, int fogMode, bool *pbLightRecieve);
    void SetShaderParamCartoon(int value, int fogMode);
    void SetShaderParamCartoonShadowMode(bool bShadowMode);
    void SetShaderParamCartoonBoldness(float edgeThreshold);
    void SetShaderParamOutline(int value, int fogMode);
    void SetShaderParamOutlineShadowMode(bool bShadowMode);
    void SetShaderParamOutlineBoldness(float edgeThreshold, float boldness);
    void SetShaderParamGas(int LNum, int fogMode, float clipThreshold, 
			   float scatter, float ambientFactor);
    void SetShaderParamAlphaClip(int LNum, int fogMode, float clipThreshold);
};

#endif
