// -*- c -*-
// "clsGLButton.cpp"

#ifndef _GL_BUTTON_H_
#define _GL_BUTTON_H_

#ifdef WIN32
#include <windows.h>
#include <GL/gl.h>
#include <GL/glu.h>
#elif defined __WXMAC__
#include <OpenGL/glu.h>
#else
#include <GL/glu.h>
#endif

#include <wx/wx.h>

#ifndef _TOP_LEFT
#define _TOP_LEFT  0
#define _TOP_RIGHT 1
#define _BTM_LEFT  2
#define _BTM_RIGHT 3
#endif

class GLButton_cls {
 public:
    GLButton_cls(int offsetType, int offsetX, int offsetY);

    void MakeTextureFromImage(wxString strPath);
    void DrawButton(int canvasWidth, bool bState);
    bool IsMouseOnButton(int canvasWidth, int canvasHeight,
			 int mouseX, int mouseY);
    bool UpdateStatus(int canvasWidth, int canvasHeight,
		      int mouseX, int mouseY);
    
    GLuint mTexID;
    bool mbMouseOn;
    int mWidth, mHeight;
    int mOffsetType, mOffsetX, mOffsetY;
};

#endif
