//(setq c-basic-offset 4)

#include "clsGLCanvasCtrl.h"

#include "../SCENEOBJ/clsCameraPath.h"

#include <wx/tglbtn.h>
#include <wx/valgen.h>

#include "clsMainGLCanvas.h"
#include "../MYGL/clsFBO.h"
#include "../WIDGETCTRL/WX/clsFontProvider.h"
#include "../WIDGETCTRL/clsBitmapPanel.h"
#include "../../wxWidgetEnum.h"
#include "../../wxWidgetEnumMenu.h"

#include "../COMMON/CommonDefinitions.h"

BEGIN_EVENT_TABLE(GLCanvasCtrl_cls, wxPanel)
EVT_PAINT       (GLCanvasCtrl_cls::OnPaint)
EVT_KEY_DOWN    (GLCanvasCtrl_cls::OnKeyDown)
EVT_RIGHT_DOWN  (GLCanvasCtrl_cls::OnMouse)
EVT_SIZE        (GLCanvasCtrl_cls::OnSize)
//EVT_MENU        (GLMenuHidePanel, GLCanvasCtrl_cls::OnMenuHide)
END_EVENT_TABLE()

#define _POV_PERSPECTIVE  0
#define _POV_ORTHOGRAPHIC 1
#define _POV_FISHEYE      2
#define _POV_PANORAMIC    3

GLCanvasCtrl_cls::
GLCanvasCtrl_cls(wxWindow *parent, FrameMain_cls *pCParentFrame,
		 long style, const wxString& name,
		 const wxGLContext *pContextToShare,
		 unsigned int selfIndex, int displayMode,
		 bool bUseQuadBuffer) :
wxPanel(parent, wxID_ANY, wxDP, wxDS, style, name)
{
    mSelfIndex = selfIndex;
    mbPanelShown = TRUE;
    SetFont(FontProvider_cls::GetFont(1));

    //int attribList[5] = {WX_GL_DOUBLEBUFFER, 1, WX_GL_STENCIL_SIZE, 1, 0};
    //int attribList[4] = {WX_GL_STEREO, WX_GL_DOUBLEBUFFER, 1, 0};
    /*
    int attribList[4] = {WX_GL_DOUBLEBUFFER, 1, 0, 0};
    if (bUseQuadBuffer == TRUE)
	attribList[2] = WX_GL_STEREO;
	
    */
    int attribList[8] = {WX_GL_DOUBLEBUFFER, 1, WX_GL_STENCIL_SIZE, 1, WX_GL_DEPTH_SIZE, 24, 0, 0};
    if (bUseQuadBuffer == TRUE)
	attribList[6] = WX_GL_STEREO;

    //2.8ɂ͖
    //bool isOk = wxGLCanvas::IsDisplaySupported(attribList);
    
    if (pContextToShare == NULL)
	mpCGLCanvas = new MainGLCanvas_cls
	    (this, pCParentFrame, attribList,
	     style, name, selfIndex, displayMode);
    else
	mpCGLCanvas = new MainGLCanvas_cls
	    (this, pCParentFrame, attribList,
	     style, name, pContextToShare, selfIndex, displayMode);

    mpCBarPanel = new wxPanel(this, wxID_ANY);
					 
    wxBoxSizer *pBoxSizerSrc = new wxBoxSizer(wxVERTICAL);
    mpBoxSizerBar = new wxBoxSizer(wxHORIZONTAL);
    
    wxString choice[_GL_CANVAS_LINKED_CAM0 + 1 + _PATH_NUM_MAX] = { 
	wxT("Free"), 
	wxT("From -X to +X"),	wxT("From +X to -X"),
	wxT("From -Y to +Y"),	wxT("From +Y to -Y"),
	wxT("From -Z to +Z"),	wxT("From +Z to -Z")
    };

    for (int i = 0; i < _GL_CANVAS_LINKED_CAM0; i++) mAChoiceStr[i] = choice[i];
    for (int i = 0; i < _PATH_NUM_MAX; i++) 
	mAChoiceStr[_GL_CANVAS_LINKED_CAM0 + i] << wxT("Cam") << i;
    mstrChoiceCopyOfView0 = wxT("Copy of View 0");
    mAChoiceStr[_GL_CANVAS_LINKED_CAM0 + _PATH_NUM_MAX] = mstrChoiceCopyOfView0;
    
    mpCComboDirection = new wxComboBox(mpCBarPanel, wxID_ANY, wxT("Free"), wxDP, wxSize(120, -1), 8, mAChoiceStr, wxCB_DROPDOWN | wxCB_READONLY);
    if (mSelfIndex == 4)
	mpCComboDirection->Append(mstrChoiceCopyOfView0);
   
    this->Connect(mpCComboDirection->GetId(), wxEVT_COMMAND_COMBOBOX_SELECTED,
		  wxCommandEventHandler(GLCanvasCtrl_cls::OnComboBox));
    mpCComboDirection->SetToolTip(_("Point of View"));

    wxString strView[4] = { _("Perspective"), _("Orthographic"), _("Fisheye"), _("Panoramic")};
    for (int i = 0; i < 4; i++) mAstrView[i] = strView[i];
	
    mpCComboView = new wxComboBox(mpCBarPanel, wxID_ANY, _("Perspective"), wxDP, wxSize(120, -1), 4, mAstrView, wxCB_DROPDOWN | wxCB_READONLY);
    this->Connect(mpCComboView->GetId(), wxEVT_COMMAND_COMBOBOX_SELECTED,
		  wxCommandEventHandler(GLCanvasCtrl_cls::OnComboBox));
    mpCComboView->SetToolTip(_("Geometry"));

    int itemHeight = mpCComboView->GetSize().GetHeight();

    mpCBoolPivot = new wxCheckBoxEX
	(mpCBarPanel, wxID_ANY, _("Pivot Follows Anchor"), 
	 wxDPS, 0, 
	 wxGenericValidator(&mpCGLCanvas->mCbPivotMode.mbBody));
    Connect(mpCBoolPivot->GetId(), wxEVT_COMMAND_CHECKBOX_CLICKED,
	    wxCommandEventHandler(GLCanvasCtrl_cls::OnCheckBox));

    int iconHeight = mpCComboView->GetBestSize().GetHeight();
    wxSize iconSize(iconHeight, iconHeight);
    mpCPanelMessage = new BitmapPanel_cls(mpCBarPanel, wxID_ANY, wxDP,iconSize);
    mpCPanelMessage->SetBoarder(1, 1);
    mpCPanelMessage->AddBitmapStr(wxT("wxART_MESSAGE_ON"));
    mpCPanelMessage->AddBitmapStr(wxT("wxART_MESSAGE_OFF"));
    mpCPanelMessage->SetMouseEventTarget(this);
    Connect(mpCPanelMessage->GetId(), wxEVT_LEFT_UP,
	    wxMouseEventHandler(GLCanvasCtrl_cls::OnMouseLMessage));
    mpCPanelData = new BitmapPanel_cls(mpCBarPanel, wxID_ANY, wxDP,iconSize);
    mpCPanelData->SetBoarder(1, 1);
    mpCPanelData->AddBitmapStr(wxT("wxART_DATA_ON"));
    mpCPanelData->AddBitmapStr(wxT("wxART_DATA_OFF"));
    mpCPanelData->SetMouseEventTarget(this);
    Connect(mpCPanelData->GetId(), wxEVT_LEFT_UP,
	    wxMouseEventHandler(GLCanvasCtrl_cls::OnMouseLData));
    mpCPanelItems = new BitmapPanel_cls(mpCBarPanel, wxID_ANY, wxDP,iconSize);
    mpCPanelItems->SetBoarder(1, 1);
    mpCPanelItems->AddBitmapStr(wxT("wxART_ITEM_ON"));
    mpCPanelItems->AddBitmapStr(wxT("wxART_ITEM_OFF"));
    mpCPanelItems->SetMouseEventTarget(this);
    Connect(mpCPanelItems->GetId(), wxEVT_LEFT_UP,
	    wxMouseEventHandler(GLCanvasCtrl_cls::OnMouseLItem));
    mpCPanelGrid = new BitmapPanel_cls(mpCBarPanel, wxID_ANY, wxDP,iconSize);
    mpCPanelGrid->SetBoarder(1, 1);
    mpCPanelGrid->AddBitmapStr(wxT("wxART_GRID_ON"));
    mpCPanelGrid->AddBitmapStr(wxT("wxART_GRID_OFF"));
    mpCPanelGrid->SetMouseEventTarget(this);
    Connect(mpCPanelGrid->GetId(), wxEVT_LEFT_UP,
	    wxMouseEventHandler(GLCanvasCtrl_cls::OnMouseLGrid));
    mpCPanelNavigator = new BitmapPanel_cls(mpCBarPanel, wxID_ANY, wxDP,iconSize);
    mpCPanelNavigator->SetBoarder(1, 1);
    mpCPanelNavigator->AddBitmapStr(wxT("wxART_NAVIGATOR_ON"));
    mpCPanelNavigator->AddBitmapStr(wxT("wxART_NAVIGATOR_OFF"));
    mpCPanelNavigator->SetMouseEventTarget(this);
    Connect(mpCPanelNavigator->GetId(), wxEVT_LEFT_UP,
	    wxMouseEventHandler(GLCanvasCtrl_cls::OnMouseLNavigator));

    UpdateWindow();
    UpdateToggleButtonsAndParams();

    mpBoxSizerBar->Add(mpCComboDirection, 0, 0);
    mpBoxSizerBar->Add(10, -1, 0, wxEXPAND);
    mpBoxSizerBar->Add(mpCComboView, 0, 0);
    mpBoxSizerBar->Add(-1, -1, 1, wxEXPAND);
    //mpBoxSizerBar->Add(mpCFBO, 0, wxALIGN_CENTER_VERTICAL);
    mpBoxSizerBar->Add(mpCBoolPivot, 0, wxALIGN_CENTER_VERTICAL);
    
    mpBoxSizerBar->Add(mpCPanelMessage, 0, 0);
    mpBoxSizerBar->Add(mpCPanelData, 0, 0);
    mpBoxSizerBar->Add(mpCPanelItems, 0, 0);
    mpBoxSizerBar->Add(mpCPanelGrid, 0, 0);
    mpBoxSizerBar->Add(mpCPanelNavigator, 0, 0);
    
    //pBoxSizerSrc->Add(mpBoxSizerBar, 0, wxEXPAND);
    mpCBarPanel->SetSizer(mpBoxSizerBar);
    pBoxSizerSrc->Add(mpCBarPanel, 0, wxEXPAND);
    pBoxSizerSrc->Add(mpCGLCanvas, 1, wxEXPAND);

    SetSizer(pBoxSizerSrc);

    mVpCPanelItemLink.push_back(mpCBoolPivot);
    mVpCPanelItemLink.push_back(mpCComboView);
    mVpCPanelItemLink.push_back(mpCPanelMessage);
    mVpCPanelItemLink.push_back(mpCPanelData);
    mVpCPanelItemLink.push_back(mpCPanelItems);
    mVpCPanelItemLink.push_back(mpCPanelGrid);
    mVpCPanelItemLink.push_back(mpCPanelNavigator);
    mVpCPanelItemLink.push_back(mpCComboDirection);
    
    mpCPopupMenu = new wxMenu;
    //mpCPopupMenu->Append(GLMenuHidePanel, _("Hide Control Panel"));
}

GLCanvasCtrl_cls::
~GLCanvasCtrl_cls(){
    delete mpCPopupMenu;
}

int GLCanvasCtrl_cls::
GetDisplayMode(){
    return mpCGLCanvas->mCDisplayMode.mBody;
}

bool GLCanvasCtrl_cls::
IsPanelShown(){
    return mbPanelShown;
}

void GLCanvasCtrl_cls::
ShowPanel(){
    size_t itemNum = mpBoxSizerBar->GetChildren().GetCount();
    for (size_t index = 0; index < itemNum; index++)
	mpBoxSizerBar->Show(index);
    mbPanelShown = TRUE;
    Layout();
}

void GLCanvasCtrl_cls::
UpdateWindow(){
    switch (mpCGLCanvas->mCDisplayMode.mBody){
    case _GL_CANVAS_DISPLAY_FREE:
	mpCComboDirection->SetValue(wxT("Free")); break;
    case _GL_CANVAS_DISPLAY_X_PLUS:
	mpCComboDirection->SetValue(wxT("From -X to +X")); break;
    case _GL_CANVAS_DISPLAY_X_MINUS:
	mpCComboDirection->SetValue(wxT("From +X to -X")); break;
    case _GL_CANVAS_DISPLAY_Y_PLUS:
	mpCComboDirection->SetValue(wxT("From -Y to +Y")); break;
    case _GL_CANVAS_DISPLAY_Y_MINUS:
	mpCComboDirection->SetValue(wxT("From +Y to -Y")); break;
    case _GL_CANVAS_DISPLAY_Z_PLUS:
	mpCComboDirection->SetValue(wxT("From -Z to +Z")); break;
    case _GL_CANVAS_DISPLAY_Z_MINUS:
	mpCComboDirection->SetValue(wxT("From +Z to -Z")); break;
    case _GL_CANVAS_COPY_OF_VIEW_0:
	mpCComboDirection->SetValue(mstrChoiceCopyOfView0); break;
    default: {
	for (int i = 0; i < _PATH_NUM_MAX; i++)
	    if (mpCGLCanvas->mCDisplayMode.mBody == _GL_CANVAS_LINKED_CAM0 + i){
		wxString strCam; strCam << wxT("Cam") << i;
		mpCComboDirection->SetValue(strCam);
	    }
	break; }
    }

    mpCComboView->SetValue(mAstrView[mpCGLCanvas->mCGLGeometry.mBody]);
    mpCBoolPivot->GetValidator()->TransferToWindow();
}

void GLCanvasCtrl_cls::
OnPaint(wxPaintEvent& event){
    event.Skip();
    //SkipAԈړȂǂinvalidateŖ̂AppendB
    //@\邯ǖʂeventłHƖʂȂłH
    mpCGLCanvas->AddPendingEvent(event);
    mpCComboDirection->SetValue(mAChoiceStr[GetDisplayMode()]);
}

void GLCanvasCtrl_cls::
AutoHideAndShow(wxWindow *pCWindow){
    if (GetSize().GetWidth() < GetBestSize().GetWidth()) pCWindow->Hide();
}

void GLCanvasCtrl_cls::
OnSize(wxSizeEvent& event){
    for (unsigned int i = 0; i < mVpCPanelItemLink.size(); i++)
	mVpCPanelItemLink[i]->Show();
    for (unsigned int i = 0; i < mVpCPanelItemLink.size(); i++)
	AutoHideAndShow(mVpCPanelItemLink[i]);
    event.Skip();
}

#include "../MYAPI/MsgBox.h"

void GLCanvasCtrl_cls::
OnKeyDown(wxKeyEvent& event){
    event.SetId(wxGetTopLevelParent(this)->GetId());
    wxGetTopLevelParent(this)->AddPendingEvent(event);
}

void GLCanvasCtrl_cls::
OnComboBox(wxCommandEvent& event){
    SyncDisplayModeToCombobox();
    mpCGLCanvas->SetFocus();
}

void GLCanvasCtrl_cls::
SyncDisplayModeToCombobox(){
    for (int i = 0; i < _GL_CANVAS_LINKED_CAM0 + 1 + _PATH_NUM_MAX; i++)
	if (mpCComboDirection->GetValue().IsSameAs(mAChoiceStr[i]))
	    mpCGLCanvas->SetDisplayMode(i);

    for (int i = 0; i < 4; i++)
	if (mpCComboView->GetValue().IsSameAs(mAstrView[i]))
	    mpCGLCanvas->mCGLGeometry.mBody = i;
    
    for (int i = 0; i < _PATH_NUM_MAX; i++){
	wxString strIndex; strIndex << wxT("Cam") << i;
	if (mpCComboDirection->GetValue() == strIndex)
	    mpCGLCanvas->LinkageConnect();
    }

    mpCGLCanvas->SetThisToBeActiveGL();
    mpCGLCanvas->Refresh(FALSE);
}

void GLCanvasCtrl_cls::
SyncComboboxToDisplayMode(){
    mpCComboView->SetValue(mAstrView[mpCGLCanvas->mCGLGeometry.mBody]);
}

void GLCanvasCtrl_cls::
OnCheckBox(wxCommandEvent& event){
    /*
    wxCommandEvent command = wxCommandEvent(wxEVT_COMMAND_MENU_SELECTED, menuItemRefresh);
    wxGetTopLevelParent(mpCGLCanvas)->AddPendingEvent(command);
    */
    mpCGLCanvas->Refresh(FALSE);
}

void GLCanvasCtrl_cls::
OnMouseLMessage(wxMouseEvent& event){
    mpCGLCanvas->mCbShowMessage.mbBody = ! mpCPanelMessage->mState;
    mpCGLCanvas->Refresh(FALSE);
}

void GLCanvasCtrl_cls::
OnMouseLData(wxMouseEvent& event){
    mpCGLCanvas->mCbShowData.mbBody = ! mpCPanelData->mState;
    mpCGLCanvas->Refresh(FALSE);
}

void GLCanvasCtrl_cls::
OnMouseLItem(wxMouseEvent& event){
    mpCGLCanvas->mCbShowItems.mbBody = ! mpCPanelItems->mState;
    mpCGLCanvas->Refresh(FALSE);
}

void GLCanvasCtrl_cls::
OnMouseLGrid(wxMouseEvent& event){
    mpCGLCanvas->mCbShowGrid.mbBody = ! mpCPanelGrid->mState;
    mpCGLCanvas->Refresh(FALSE);
}

void GLCanvasCtrl_cls::
OnMouseLNavigator(wxMouseEvent& event){
    mpCGLCanvas->mCbShowNavigator.mbBody = ! mpCPanelNavigator->mState;
    mpCGLCanvas->Refresh(FALSE);
}



void GLCanvasCtrl_cls::
OnMenuHide(wxCommandEvent& event){
    size_t itemNum = mpBoxSizerBar->GetChildren().GetCount();
    for (size_t index = 0; index < itemNum; index++)
	mpBoxSizerBar->Hide(index);
    Layout();
    mbPanelShown = FALSE;
}

void GLCanvasCtrl_cls::
OnMouse(wxMouseEvent& event){
    PopupMenu(mpCPopupMenu, wxDefaultPosition);
}

void GLCanvasCtrl_cls::
UpdateToggleButtonsAndParams(){
    mpCPanelMessage->SetStatus(!mpCGLCanvas->mCbShowMessage.mbBody);
    mpCPanelData->SetStatus(!mpCGLCanvas->mCbShowData.mbBody);
    mpCPanelItems->SetStatus(!mpCGLCanvas->mCbShowItems.mbBody);
    mpCPanelGrid->SetStatus(!mpCGLCanvas->mCbShowGrid.mbBody);
    mpCPanelNavigator->SetStatus(!mpCGLCanvas->mCbShowNavigator.mbBody);
    if (mpCGLCanvas->mCGLGeometry.mBody == _POV_ORTHOGRAPHIC)
	mpCGLCanvas->mCGLPerspDraw.mbPerspective = FALSE;
    else
	mpCGLCanvas->mCGLPerspDraw.mbPerspective = TRUE;
}

// ----

void GLCanvasCtrl_cls::
ReadStrLine(std::wistream &istream, wxString strLine){
    mpCGLCanvas->ReadStrLine(istream, strLine);
}

wxString GLCanvasCtrl_cls::
Serialize(){
    return mpCGLCanvas->Serialize();
}
