// "clsMainGLCanvas.h"
// (setq c-basic-offset 4)

#include "../COMMON/CommonDefinitionsGL.h"

#ifdef WIN32
PFNGLTEXIMAGE3DPROC glTexImage3D;
PFNGLCOMPRESSEDTEXIMAGE3DPROC glTexCompressedImage3D;
PFNGLBLENDCOLORPROC glBlendColor;
PFNGLBLENDEQUATIONEXTPROC glBlendEquationEXT;
PFNGLBLENDFUNCSEPARATEPROC glBlendFuncSeparate;
extern PFNGLBINDBUFFERPROC glBindBuffer; //!!

extern PFNGLGENBUFFERSARBPROC glGenBuffersARB;
extern PFNGLDELETEBUFFERSARBPROC glDeleteBuffersARB;
extern PFNGLBINDBUFFERARBPROC glBindBufferARB;
extern PFNGLBUFFERDATAARBPROC glBufferDataARB;
extern PFNGLMAPBUFFERARBPROC glMapBufferARB;
extern PFNGLUNMAPBUFFERARBPROC glUnmapBufferARB;
extern PFNGLGETBUFFERPARAMETERIVARBPROC glGetBufferParameterivARB;
#endif 

#include "../../GL/glsl.h"

#include "clsDistortion.h"
#include "clsDolly.h"
#include "clsMoveItem.h"
#include "clsMainGLCanvas.h"
#include "clsMouseCtrl.h"
#include "NAVIGATORS/clsNavigators.h"
#include "clsStereoGram.h"

#include "../FILTER/clsFilterBG.h"
#include "../FILTER/clsFilterCtrl.h"
#include "../FILTER/clsFilterCopy.h"
#include "../FILTER/clsFilterDataBox.h"
#include "../FILTER/clsFilterFog.h"
#include "../FILTER/clsFilterStick.h"
#include "../GLATTRIB/clsColorCurve.h"
#include "../GLATTRIB/clsShaderCtrl.h"
#include "../GLOBJECTS/clsCamera.h"
#include "../GLOBJECTS/clsCircle.h"
#include "../GLOBJECTS/clsCone.h"
#include "../GLOBJECTS/clsCube.h"
extern Cube_cls *GpCCube;
#include "../GLOBJECTS/clsCylinder.h"
#include "../GLOBJECTS/clsGrid.h"
#include "../GLOBJECTS/clsSphere.h"
extern Sphere_cls *GpCSphere;
#include "../GRAPHIC/clsStereoGram.h"
#include "../LUA/clsLuaBase.h"
#include "../MAINCANVAS/clsOverlay.h"
#include "../MAINCANVAS/clsExposure.h"
#include "../MAINCANVAS/clsDrawOption.h"
#include "../TIMELINE/clsTimeCtrl.h"
#include "../PANELS/clsDataExporter.h"
#include "../PANELS/clsPreference.h"
#include "../PANELS/clsShortcut.h"
#include "../PARTICLEDATA/clsParticleDataSequence.h"
#include "../PARTICLEDATA/clsThreadFileReader.h"
extern ThreadFileReader_cls   *GpCThreadReader;
extern bool                   GbThreadReaderFinished;
extern int                    GThreadReaderPercentage;
#include "../PARTICLEDATA/INTERPOLATE_GET/clsThreadInterpolate.h"
extern ThreadInterpolator_cls *GpCThreadInterpolate;
extern bool                   GbThreadInterpolateFinished;
#include "../PARTICLEDATA/clsZSort.h"

extern int GDrawingStage;
extern int GDrawingPercentage;

#include "../POVRAY/clsPovRay.h"
#include "../SCENEOBJ/clsCameraPath.h"
#include "../SCENEOBJ/clsCameraPathGUI.h"
#include "../SCENEOBJ/clsLightSourceGUI.h"

#include "../../wxWidgetEnum.h"
#include "../../wxWidgetEnumMenu.h"

#include "../COMMON/MyVector.h"
#include "../GLCANVAS/clsGLCanvasCtrl.h"
#include "../MYAPI/MsgBox.h"
#include "../MYGL/clsFBO.h"
#include "../MYGL/clsFishEye.h"
#include "../MYGL/clsGLString2D.h"
#include "../MYGL/clsGLGuides.h"
#include "../MYGL/clsGLInfo.h"
#include "../MYGL/clsGLPerspective.h"
#include "../MYGL/clsGLTexture.h"
#include "../UNDO/clsUndoManager.h"
extern UndoManager_cls GCUndoList;
#include "../UNDO/clsUndoItemConstParam.h"
#include "../WIDGETCTRL/WX/clsUpdateStatusBar.h"
#include "../WIDGETCTRL/EX/clsTextEntryDialogEX.h"

#include <wx/tglbtn.h>

long GTestVariableLong = 0;
int GTestVariableInt = 0;

extern bool      GbForceAbort;
MainGLCanvas_cls* GpCurrentGLPanel;

#include "../GRAPHIC/clsImageIO.h"
#include "../GRAPHIC/clsImgSequence.h"
extern ImageIO_cls GCImgIO;

#include "../../clsFrameMain.h"
#include "../../clsMain.h"

#include <algorithm>
#include <functional>
#include <sstream>

#include <math.h>

#include "../COMMON/CommonDefinitions.h"

int GRefreshQueueCounter = 0;
bool GbGLLockPlayWait = FALSE;
bool GbGLLockDrawing  = FALSE;
bool GbGLLockProjectLoading = FALSE;
bool GbGLLockForLoadingData = FALSE;
bool GbGLLockForInterplateData = FALSE;
bool GbGLLockModalDialog = FALSE;

#define R 0
#define G 1
#define B 2

#define LOOP_YPRY for (int ypry = 0; ypry < 4; ypry++)

#define _STENCIL_MODE_0 0
#define _STENCIL_MODE_1 1
#define _STENCIL_MODE_2 2

#define _MAINGL_NO_MIRROR -1

#ifdef WIN32
#define _FLAG_SET_CURRENT
#endif
#ifdef __WXGTK__
#define _FLAG_SET_CURRENT
#endif

// -----------------------------------------

BEGIN_EVENT_TABLE(MainGLCanvas_cls, wxGLCanvas)
EVT_PAINT       (MainGLCanvas_cls::OnPaint)
EVT_MOUSE_EVENTS(MainGLCanvas_cls::OnMouse)
EVT_MOTION(MainGLCanvas_cls::OnMouseMotion)
EVT_MENU (GLMenuMoveToCamPos,   MainGLCanvas_cls::OnMenuMoveToCamPos)
EVT_MENU (GLMenuSetKeyPos,      MainGLCanvas_cls::OnMenuSetKeyPos)
EVT_MENU (GLMenuSetKeyPosRot,   MainGLCanvas_cls::OnMenuSetKeyPosRot)
EVT_MENU (GLMenuSetKeyAnc,      MainGLCanvas_cls::OnMenuSetKeyAnc)
EVT_MENU (GLMenuToggleLink,     MainGLCanvas_cls::OnMenuToggleLink)
EVT_MENU (GLMenuToggleLink2,    MainGLCanvas_cls::OnMenuToggleLink2)
EVT_MENU (GLMenuTogglePerspective, MainGLCanvas_cls::OnMenuTogglePerspective)
EVT_MENU (GLMenuCenterItem, MainGLCanvas_cls::OnMenuCenterItem)
EVT_MENU (GLMenuCenterOrigin, MainGLCanvas_cls::OnMenuCenterOrigin)
EVT_KEY_DOWN  (MainGLCanvas_cls::OnKeyDown)
END_EVENT_TABLE()

MainGLCanvas_cls::
MainGLCanvas_cls(GLCanvasCtrl_cls *pCParentCtrl, FrameMain_cls *pCParentFrame,
		 int* attribList, long style, const wxString& name,
		 unsigned int selfIndex, int displayMode) : 
wxGLCanvas(pCParentCtrl, wxID_ANY, wxDefaultPosition, wxDefaultSize,
	   style, name, attribList)
{
    ConstructorMain(pCParentCtrl, pCParentFrame, selfIndex, displayMode);
}

MainGLCanvas_cls::
MainGLCanvas_cls(GLCanvasCtrl_cls *pCParentCtrl, FrameMain_cls *pCParentFrame,
		 int* attribList, long style, const wxString& name,
		 const wxGLContext *pContextToShare,
		 unsigned int selfIndex, int displayMode) : 
    /*
      wxGLCanvas(pCParentCtrl, id, attribList, pos, size, style|wxFULL_REPAINT_ON_RESIZE, name), //{͂gC邯ǂ܂Ȃ
    */
#ifdef __WXGTK__
    wxGLCanvas(pCParentCtrl, wxID_ANY, wxDefaultPosition, wxDefaultSize, 
	       style | wxFULL_REPAINT_ON_RESIZE, name, attribList)
#else
    wxGLCanvas(pCParentCtrl, pContextToShare, 
	       wxID_ANY, wxDefaultPosition, wxDefaultSize, 
	       style | wxFULL_REPAINT_ON_RESIZE, name, attribList)
#endif
{
    ConstructorMain(pCParentCtrl, pCParentFrame, selfIndex, displayMode, pContextToShare);
}

void MainGLCanvas_cls::
ConstructorMain(GLCanvasCtrl_cls *pCParentCtrl, FrameMain_cls *pCParentFrame,
		unsigned int selfIndex, int displayMode,
		const wxGLContext *pContextToShare)
{
    mpCMouseCtrl  = NULL;
    mpCMouseInfoInnertia = NULL;
    mpCDolly      = NULL;
    mpCMoveItem   = NULL;

    mpCGLCtrl = pCParentCtrl;
    mpCParentFrameLink = pCParentFrame;
    mspCParentFrameLink = pCParentFrame; 
    // staticlocal݂Ă܂Ă

    mpCNavigators = new Navigators_cls(this);

    mpCGLString2DDirect = new GLStrings2D_cls;    
    mpCGLString2DBuffer = new GLStrings2D_cls;
    mpCTagObjectCtrl = new TagObjectCtrl_cls;

    mpCFBOForFishEyeBuffer = NULL;
    mpCFBOForShadow = NULL;
    mpCFBOForOverlay = NULL;
    mCounter = 0;
    mbInnertia = FALSE;
    
    SetBackgroundColour(*wxBLACK);
    mSelfIndex = selfIndex;
    mbInitialized    = FALSE;
    mbExportDataQueue = FALSE;
    mbExportPovStringQueue = FALSE;
    mbHitTestItemSelect    = FALSE; 
    mbHitTestGuideSelect   = FALSE; 
    mPrevFrame       = -1;
    mPrevStep        = -1;
    mPrevBlurFactor  = -1;
    mVHitObj.push_back(0); mVHitObj.push_back(0);
    mbSaveImageQueue = FALSE;
    mbSaveImgSeqQueue = FALSE;
    mbRefreshQueue   = FALSE;
    mDoubleIndexPrev = -1;

    SetCameraToDefaultPos();
    
    wxString ssTag;
    ssTag << wxT("Panel") << selfIndex;
    mCGLCameraProperty.SetTag(ssTag + wxT("Camera"));
    mCConfList.SetTag(ssTag + wxT("Canvas"));
    
    if (selfIndex == 4)
	mCConfList.Add(&mCbShowMessage, L"ShowMessage=", L"0");
    else
	mCConfList.Add(&mCbShowMessage, L"ShowMessage=", L"1");

    mCConfList.Add(&mCbShowItems , L"ShowItems=", L"1");
    mCConfList.Add(&mCbShowGrid,   L"ShowGrid=", L"1");
    mCConfList.Add(&mCbShowData,   L"ShowData=", L"1");
    mCConfList.Add(&mCbShowNavigator, L"ShowNavigator=", L"1");

    mCConfList.Add(&mCbShowOtherCam, L"ShowOtherCam=", L"0");
    mCConfList.Add(&mCbXOR,          L"DrawItemByXOR=", L"0");
    mCConfList.Add(&mCGLGeometry,    L"GLGeometry=", L"0");
    mCConfList.Add(&mCDisplayMode,   L"DisplayMode=", L"0");
    mCConfList.Add(&mCbPivotMode,    L"PivotMode=", L"0");
    mCConfList.Add(&mCPathIndex,     L"GLPathIndex=", L"0");
    mCConfList.Add(&mCGridType,      L"GridType=", L"0");
    mCConfList.Add(&mCbGridAnti,     L"GridAntialias=", L"0");
    mCConfList.Add(&mCbShowGridTag,  L"GridShowTag=", L"0");
    mCConfList.Add(&mCbDistortion,   L"Distortion", L"0");
    mCConfList.Add(&mCbFisheyeGrid,  L"FisheyeGrid", L"0");
        
    SetDisplayMode(displayMode);

    mCGLCameraProperty.mCGLPersAngle.mBody = mCGLPerspDraw.mDeg;
        
#ifdef __WXGTK__
    mpCGLContext = new wxGLContext(this, pContextToShare);
#else
    mpCGLContext = GetContext();
#endif
   
    mpCCameraPathLinked   = NULL;
    mpCAnchorPathLinked   = NULL;
    mpCDataExporterLinked = NULL;
}

MainGLCanvas_cls::
~MainGLCanvas_cls(){
    if (mpCMouseCtrl != NULL) delete mpCMouseCtrl;
    if (mpCMouseInfoInnertia != NULL) delete mpCMouseInfoInnertia;
    if (mpCDolly != NULL)     delete mpCDolly;
    if (mpCMoveItem != NULL)  delete mpCMoveItem;
    delete mpCNavigators;
    delete mpCGLString2DDirect;
    delete mpCGLString2DBuffer;
    delete mpCTagObjectCtrl;
#ifndef __WXMAC__
    //delete mpCGLContext;
#endif
    
    if (mpCFBOForFishEyeBuffer != NULL) delete mpCFBOForFishEyeBuffer;
    if (mpCFBOForShadow != NULL) delete mpCFBOForShadow;
    if (mpCFBOForOverlay != NULL) delete mpCFBOForOverlay;

    if (mspCDistortion != NULL){
	delete mspCDistortion; mspCDistortion = NULL;
    }
    DeleteStaticTexture(&mspCMask);
    DeleteStaticTexture(&mspCWhite);
    DeleteStaticTexture(&mspCFisheyeGrid);
    DeleteStaticTexture(&mspCCheckerboard);
}

void MainGLCanvas_cls::
DeleteStaticTexture(GLTexture_cls **ppCTexture){
    if (*ppCTexture == NULL) return;
    delete *ppCTexture;
    *ppCTexture = NULL;
}

// ----------

bool MainGLCanvas_cls::
SetGLContext(){
#ifndef __WXMOTIF__
    if (!GetContext()) return FALSE; 
#endif
    
#ifdef _FLAG_SET_CURRENT
    mpCGLContext->SetCurrent(*(wxGLCanvas*)this);
#else
#ifdef __WXMAC__
    SetCurrent();
#else
    mpCGLContext->SetCurrent();
#endif
#endif
    return TRUE;
}

void MainGLCanvas_cls::
InitGL(){
    glClearColor( 0, 0, 0, 1.0f );
    glClearStencil(0);

    glEnable(GL_CULL_FACE);
    glCullFace(GL_BACK);
    glEnable(GL_DEPTH_TEST);
    glEnable(GL_LIGHTING);
    glDisable(GL_COLOR_MATERIAL);
    glLineStipple(2, 0xAAAA);
}

void MainGLCanvas_cls::
InitGLUT(){
    if (msbGLUTInitialized == TRUE) return;
    int argc = 1;
    char **argv = new char* [1];
    argv[0] = new char [6];
    sprintf(argv[0], "dummy");
    glutInit(&argc, argv);
    delete argv[0]; 
    delete argv;
    msbGLUTInitialized = TRUE;
}

void MainGLCanvas_cls::
InitializeShader(){
    
    bool bShaderAvailable = TRUE;
    if (glslInit()) bShaderAvailable = FALSE;
    
    mpCParentFrameLink->mpCParent->
	mpCExposure->Initialize(this, bShaderAvailable);

    GLAttribute_cls::InitializeShader(this, bShaderAvailable);
}

void MainGLCanvas_cls::
MakeFisheyeGridTexture(){
    
    wxMemoryDC *pCMemDC = mspCFisheyeGrid->BeginDC(1024, 1024);
    pCMemDC->SetBackground(wxColour(0, 0, 0));
    pCMemDC->Clear();
    
    pCMemDC->SetPen(wxPen(wxColour(255, 255, 255), 2));
    float scaleX = 512;
    float scaleY = 512;
    std::vector < wxPoint > AVertex;
    for (double r = 1.0; r >= 0; r -= 1.0/90 * 10){
	double r0 = r;
	if (r == 1.0) r0 = 0.997;  
	AVertex.clear();
	for (int i = 0; i <= 360; i+= 5){
	    double theta = ((double)i/180) * 3.14159;
	    double x = (1.0 + r0 * cos(theta)) * scaleX;
	    double y = (1.0 + r0 * sin(theta)) * scaleY;
	    AVertex.push_back(wxPoint(x, y));
	}
	pCMemDC->DrawLines((int)AVertex.size(), AVertex.data());
    }
    for (double i = 0; i <= 360; i += 15){
	double theta = ((double)i/180) * 3.14159;
	double x = (1.0 + cos(theta)* 0.997) * scaleX;
	double y = (1.0 + sin(theta)* 0.997) * scaleY;
	pCMemDC->DrawLine(scaleX, scaleY, x, y);
    }
    mspCFisheyeGrid->EndDC(FALSE);
}

bool MainGLCanvas_cls::
InitializeGLIfNot(){
    if (mbInitialized == TRUE) return FALSE;
    
    if (mspCMask == NULL){ // Pł悢̂

	InitGLUT();
	
	FBO_cls::Initialize();

	glPushAttrib(GL_ALL_ATTRIB_BITS);
	Camera_cls::InitializeIfNot();
	Circle_cls::InitializeIfNot();
	Cone_cls::InitializeIfNot();
	//Cube_cls::InitializeIfNot();
	Cylinder_cls::InitializeIfNot();
	GpCSphere->InitializeIfNot();
	GpCCube->InitializeIfNot();
	glPopAttrib();

	mpCParentFrameLink->mpCGLInfo->Initialize();
	GetPCActiveFileSequence()->RefreshGLAttribTex();
	
	InitializeShader();

#ifdef WIN32
	glBlendEquationEXT = (PFNGLBLENDEQUATIONEXTPROC) wglGetProcAddress("glBlendEquationEXT");
	glBlendColor = (PFNGLBLENDCOLORPROC) wglGetProcAddress("glBlendColor");
	glBlendFuncSeparate = (PFNGLBLENDFUNCSEPARATEPROC) wglGetProcAddress("glBlendFuncSeparate");

	glGenBuffersARB = (PFNGLGENBUFFERSARBPROC)wglGetProcAddress("glGenBuffersARB");
	glDeleteBuffersARB = (PFNGLDELETEBUFFERSARBPROC)wglGetProcAddress("glDeleteBuffersARB");
	glBindBufferARB = (PFNGLBINDBUFFERARBPROC)wglGetProcAddress("glBindBufferARB");
	glBufferDataARB = (PFNGLBUFFERDATAARBPROC)wglGetProcAddress("glBufferDataARB");
	glMapBufferARB = (PFNGLMAPBUFFERARBPROC)wglGetProcAddress("glMapBufferARB");
	glUnmapBufferARB = (PFNGLUNMAPBUFFERARBPROC)wglGetProcAddress("glUnmapBufferARB");
	glGetBufferParameterivARB = (PFNGLGETBUFFERPARAMETERIVARBPROC)wglGetProcAddress("glGetBufferParameterivARB");
#endif 
	glEnable(GL_TEXTURE_2D);
	mspCDrawTimeIndex->Initialize();
	mspCDrawClrLegend->Initialize();

	mspCWhite        = new GLTexture_cls;
	mspCMask         = new GLTexture_cls;
	mspCFisheyeGrid  = new GLTexture_cls;
	mspCCheckerboard = new GLTexture_cls;
	mspCWhite->LoadImage(wxT("Resource/White.png"), TRUE);
	mspCMask->LoadImage(wxT("Resource/DefaultMask.png"), TRUE);
	mspCCheckerboard->LoadImage(wxT("Resource/Checkerboard.png"), TRUE);
	MakeFisheyeGridTexture();

	
	mpCNavigators->InitializeStaticMembers();

	msCHittest.Initialize();
	
	glDisable(GL_TEXTURE_2D);
    }

    InitGL();

    Preference_cls *pCPref = mpCParentFrameLink->mpCPreference;
    mpCMouseCtrl  = new MouseCtrl_cls(pCPref);
    mpCMouseInfoInnertia = new MouseCtrl_cls(pCPref);
    mpCDolly      = new Dolly_cls(pCPref);
    mpCMoveItem   = new MoveItem_cls
	(pCPref, mspCGLGuide, mspCGLGuideScale, mspCGLGuideYPR);
    
    glDepthFunc(GL_LEQUAL);
    mbInitialized = TRUE;
    return TRUE;
}

// ----

void MainGLCanvas_cls::
SetCameraToDefaultPos(){
    double defaultPos[3] = {-1.12,-0.8,+0.56};
    double defaultTop[3] = { 0,  0, +1};

    LOOP_XYZ mCCameraPos.mPos[xyz] = 7 * defaultPos[xyz];
    LOOP_XYZ mCCameraPos.mTgt[xyz] = - defaultPos[xyz];
    LOOP_XYZ mCCameraPos.mTop[xyz] = defaultTop[xyz];
    mCCameraPos.NormalizeAndOrthogonalize();
    mCCameraPosFree   = mCCameraPos;
    mCCameraPosCamera = mCCameraPos;
}

void MainGLCanvas_cls::
UpdateDrawInfo(int width, int height){
    mCDrawInfoPrev = mCDrawInfo;
    mCDrawInfo.mbForceNewDraw = FALSE;
    mCDrawInfo.mCCameraPos = mCCameraPos;
}

PovRayCtrl_cls* MainGLCanvas_cls::
GetPCPovRayCtrlLinked(){
    return mpCParentFrameLink->mpCParent->mpCPovRayCtrl;
}

PositionAndDirection_cls* MainGLCanvas_cls::
GetPCCameraPosition(){
    if (IsAlongAxis() == TRUE)
	return &mCCameraPosOrtho;
    if (mCDisplayMode.mBody == _GL_CANVAS_LINKED_CAM0)
	return &mCCameraPosCamera;
    return &mCCameraPosFree;
}

Position_cls* MainGLCanvas_cls::
GetPCAnchorPosition(){
    if (IsAlongAxis() == TRUE)
	return &msCAnchorPosOrtho;
    return &msCAnchorPos;
}

PDataSequence_cls* MainGLCanvas_cls::
GetPCActiveFileSequence(){
    return mpCParentFrameLink->GetPCActiveFileSequence();
}

TimeCtrl_cls* MainGLCanvas_cls::
GetPCTimeCtrl(){
    return mpCParentFrameLink->GetPCTimeCtrl();
}

void MainGLCanvas_cls::
UpdateCameraPos(){
    if (mPrevFrame == -1 && mPrevStep == -1)
	mpCGLCtrl->SyncDisplayModeToCombobox();

    if (mCbPivotMode.mbBody == _PIVOT_FOLLOW_PATH){
	LOOP_XYZ msCAnchorPos.mPos[xyz] = 
	    GetPLinkedAnchorPath()->mCCurrentObj.mPos[xyz];
    }

    if (mCDisplayMode.mBody == _DIRECTION_FREE){
	mCCameraPosFree.PointAt(msCAnchorPos.mPos);
	mCCameraPos = mCCameraPosFree;
    }

    if (IsAlongAxis() == TRUE){
	ModifyOrthoCamera();
	mCCameraPos = mCCameraPosOrtho;
    }

    if (GetPLinkedCameraPath()->mCbLookAnchor.mbBody == TRUE)
	GetPLinkedCameraPath()->mCCurrentObj.
	    PointAt(GetPLinkedAnchorPath()->mCCurrentObj.mPos);
    
    if (mCDisplayMode.mBody == _GL_CANVAS_LINKED_CAM0){
	if (mPrevFrame != GetPCTimeCtrl()->mFrame ||
	    mPrevStep  != GetPCTimeCtrl()->mInterpStep ||
	    mPrevBlurFactor != GetPCTimeCtrl()->mCBlurCtrl.GetFactor())
	    if (mpCCameraPathLinked != NULL)
		mCCameraPosCamera = mpCCameraPathLinked->mCCurrentObj;
	
	if (mpCCameraPathLinked != NULL &&
	    mpCCameraPathLinked->mCbLookAnchor.mbBody == TRUE)
	    mCCameraPosCamera.PointAt(GetPLinkedAnchorPath()->mCCurrentObj.mPos);

	if (mCCameraPosCamera.IsNearPosition(mpCCameraPathLinked->mCCurrentObj) == FALSE)
	    mCCameraPosCamera.PointAt(msCAnchorPos.mPos);
	/*
	if (!(mCCameraPosCamera == mpCCameraPathLinked->mCCurrentObj))
	    mCCameraPosCamera.PointAt(msCAnchorPos.mPos);
	*/
	
	mCCameraPos = mCCameraPosCamera;
    }

    GetPCCameraPosition()->UpdateYPR();
    mCCameraPos.UpdateYPR();

    msCAnchorPosWithDummyDirection.Set(msCAnchorPos);
}

CameraPath_cls* MainGLCanvas_cls::
GetPLinkedCameraPath(){
    if (mpCCameraPathLinked == NULL) 
	return mpCParentFrameLink->mpCParent->mpCCameraPath;
    return mpCCameraPathLinked;
}

LightSRCCtrl_cls* MainGLCanvas_cls::
GetPLinkLightSourceCtrl(){
    return mpCParentFrameLink->mpCParent->mpCLightSRCCtrl;
}

AnchorPath_cls* MainGLCanvas_cls::
GetPLinkedAnchorPath(){
    if (mpCAnchorPathLinked == NULL)
	return mpCParentFrameLink->mpCParent->mpCAnchorPath;
    return mpCAnchorPathLinked;
}

bool MainGLCanvas_cls::
IsDrawingConditionSatisfied(){
    if (mspCFilterCtrlObjectLink == NULL) return FALSE;
    if (IsShownOnScreen() == FALSE || GbGLLockDrawing == TRUE) return FALSE;
    if (GbGLLockForLoadingData == TRUE)	printf("LockLoading\n");
    if (GbGLLockForLoadingData == TRUE || 
	GbGLLockForInterplateData == TRUE ||
	GbGLLockProjectLoading == TRUE ||
	GbGLLockModalDialog == TRUE) return FALSE;
    return TRUE;
}

bool MainGLCanvas_cls::
IsStereo(){
    if (mspCStereogramLink->mCType.mBody != _STEREO_NONE){
	if (mspCStereogramLink->mCEye.mBody == _STEREO_NONE ||
	    mspCStereogramLink->mCEye.mBody == _STEREO_LFT ||
	    mspCStereogramLink->mCEye.mBody == _STEREO_RGT)
	    return FALSE;
	if (mCDisplayMode.mBody == _DIRECTION_FREE || 
	    mCDisplayMode.mBody >= _GL_CANVAS_LINKED_CAM0)
	    return TRUE;
    }
    return FALSE;
}

bool MainGLCanvas_cls::
IsStereoDualOutput(){
    if (IsStereo() == FALSE) return FALSE;
    if (mspCStereogramLink->mCDualOutput.mBody == 1) return TRUE;
    return FALSE;
}

bool MainGLCanvas_cls::
IsLineByLineFishEye(){
    bool bStereo = IsStereo();
    int  type = mspCStereogramLink->mCEye.mBody;
    bool bFishEye = IsFishEye();
    if (IsStereo() == TRUE &&
	mspCStereogramLink->mCEye.mBody == _STEREO_SCANLINE &&
	IsFishEye() == TRUE)
	return TRUE;
    return FALSE;
}

bool MainGLCanvas_cls::
IsOrthographic(){
    return (mCGLGeometry.mBody == _GEOM_ORTHOGRAPHIC);
}

bool MainGLCanvas_cls::
IsAlongAxis(){
    return (mCDisplayMode.mBody >= _GL_CANVAS_DISPLAY_X_PLUS &&
	    mCDisplayMode.mBody <= _GL_CANVAS_DISPLAY_Z_MINUS);
}

bool MainGLCanvas_cls::
IsFishEye(){
    if (mCDisplayMode.mBody == _DIRECTION_FREE ||
	mCDisplayMode.mBody == _GL_CANVAS_COPY_OF_VIEW_0)
	return (mCGLGeometry.mBody == _GEOM_FISHEYE);

    if (mCDisplayMode.mBody >= _GL_CANVAS_LINKED_CAM0)
	return (GetPLinkedCameraPath()->mCCamGeometry.mBody == _GEOM_FISHEYE);

    return FALSE;
}

bool MainGLCanvas_cls::
IsCylinder(){
    if (mCDisplayMode.mBody == _DIRECTION_FREE ||
	mCDisplayMode.mBody == _GL_CANVAS_COPY_OF_VIEW_0)
	return (mCGLGeometry.mBody == _GEOM_PANORAMIC);
    
    if (mCDisplayMode.mBody >= _GL_CANVAS_LINKED_CAM0)
	return (GetPLinkedCameraPath()->mCCamGeometry.mBody == _GEOM_PANORAMIC);

    return FALSE;
}

void MainGLCanvas_cls::
WaitPrepaing(){
    if (mCbShowData.mbBody == TRUE){
	// ̃t[̏OK?
	// ɎԂ邱Ƃ
	int count = 0; // SuF[vBcOȂ炽܂ɔB
	while (mpCParentFrameLink->IsTheFrameReady(_FM_FRAME_CURRENT) == FALSE && 
	       count < 10){
	    mpCParentFrameLink->PrepareTheFrame(_FM_FRAME_CURRENT);	
	    count++;
	}
	
	// ̃t[̓ǂݍ݊Jn
	mpCParentFrameLink->PrepareFramesAhead
	    (GetPCTimeCtrl()->mPlayDirection);
    }
}

int MainGLCanvas_cls::
GetFBOMax(){
    int fboMax = 1;
    if (GetMultiPanelMode() != 0) fboMax = 4;
    return fboMax;
}

int MainGLCanvas_cls::
GetMultiPanelMode(){
    if (mCDisplayMode.mBody == _DIRECTION_FREE ||
	mCDisplayMode.mBody == _GL_CANVAS_COPY_OF_VIEW_0){
	if (mCGLGeometry.mBody == _GEOM_FISHEYE) return _MULTIPANEL_FISHEYE;
	if (mCGLGeometry.mBody == _GEOM_PANORAMIC) return _MULTIPANEL_CYLINDER;
    }
	
    if (mCDisplayMode.mBody >= _GL_CANVAS_LINKED_CAM0){
	if (GetPLinkedCameraPath()->mCCamGeometry.mBody == _GEOM_FISHEYE)
	    return _MULTIPANEL_FISHEYE;
	if (GetPLinkedCameraPath()->mCCamGeometry.mBody == _GEOM_PANORAMIC)
	    return _MULTIPANEL_CYLINDER;
    }

    return 0;
}

void MainGLCanvas_cls::
SetAngleIfLinked(){
    if (IsOrthographic()) mCGLPerspDraw.mbPerspective = FALSE;
    else                 mCGLPerspDraw.mbPerspective = TRUE;

    if (mCDisplayMode.mBody >= _GL_CANVAS_LINKED_CAM0 &&
	mCDisplayMode.mBody == _GL_CANVAS_LINKED_CAM0){
	mCGLPerspDraw.mDeg = GetPLinkedCameraPath()->mCVAngle.mBody;
	if (GetPLinkedCameraPath()->mCCamGeometry.mBody == _GEOM_PERSPECTIVE &&
	    mCGLPerspDraw.mDeg >= 120) {
	    mCGLPerspDraw.mDeg = 120;
	    mstrWarning << wxT("View angle is limited to 120 deg in perspective view.") << ENDL;
	}
    }
    else{
	mCGLPerspDraw.mDeg = mCGLCameraProperty.mCGLPersAngle.mBody;
	if (mCGLGeometry.mBody == _GEOM_PERSPECTIVE &&
	    mCGLPerspDraw.mDeg >= 120) {
	    mCGLPerspDraw.mDeg = 120;
	    mstrWarning << wxT("View angle is limited to 120 deg in perspective view.") << ENDL;
	}
    }
}

void MainGLCanvas_cls::
ModifyByDomeTilt(PositionAndDirection_cls *pCCam){
    pCCam->RotateYPR(0, GetPLinkedCameraPath()->mCFishEyeOffset.mBody, 0);
}

CameraStructure_cls MainGLCanvas_cls::
GetCCameraStructure(int stereo){
    CameraStructure_cls CCamStruct
	(mCCameraPos, msCAnchorPos,
	 mCGLPerspDraw.mDeg, IsFishEye(), IsOrthographic());
    return CCamStruct;
}

void MainGLCanvas_cls::
UpdateAnc(){
    Position_cls CCurrAnc = GetAncPos();

    if (mpCCameraPathLinked != NULL)
	mCCameraPos.SetAncPos(mpCAnchorPathLinked->mCCurrentObj.mPos);
    else
	mCCameraPos.SetAncPos(CCurrAnc.mPos);
}

Position_cls MainGLCanvas_cls::
GetAncPos(){
    if (mCDisplayMode.mBody == _DIRECTION_FREE ||
	mCDisplayMode.mBody >= _GL_CANVAS_LINKED_CAM0)
	return msCAnchorPos;

    // Œ猩Ăꍇ̃AJ[ʒuԂ
    return msCAnchorPosOrtho;
}

void MainGLCanvas_cls::
GetTimeInfo(double &time, double &dT){
    int    currentIndex = GetPCTimeCtrl()->GetRemappedIndex();
    double doubleInterpStep = GetPCTimeCtrl()->GetRemappedInterpStepDouble();
    GetPCActiveFileSequence()->GetTimeInfo(time, dT, currentIndex, doubleInterpStep);
}

double* MainGLCanvas_cls::
GetAnchorPosForRender(){
    static double ancPosForRender[3];
    LOOP_XYZ ancPosForRender[xyz] = 
	mCCameraPos.mPos[xyz] + mCCameraPos.mTgt[xyz];
    return ancPosForRender;
}

void MainGLCanvas_cls::
UpdateViewInformation(){
    glGetDoublev(GL_MODELVIEW_MATRIX, mMatrixModelView);
    glGetDoublev(GL_PROJECTION_MATRIX, mMatrixProjection);
    glGetIntegerv(GL_VIEWPORT, mMatrixViewport);
}

void MainGLCanvas_cls::
SetPivotToItem(int type){
    if (type == 0){
	SceneObj_cls *pCSceneObj = //mpCSceneObjCtrlLink->GetPCSelected();
	    MoveItem_cls::mspCSelectedObject;
	if (pCSceneObj != NULL){
	    LOOP_XYZ msCAnchorPos.mPos[xyz] = pCSceneObj->mCCurrentObj.mPos[xyz];
	    LOOP_XYZ msCAnchorPosOrtho.mPos[xyz] = pCSceneObj->mCCurrentObj.mPos[xyz];
	}
    }
    
    if (type == -1){
	LOOP_XYZ msCAnchorPos.mPos[xyz] = 0;
	LOOP_XYZ msCAnchorPosOrtho.mPos[xyz] = 0;
    }
}

void MainGLCanvas_cls::
SetKeyPos(){
    std::vector < double > VPos;
    VPos.push_back(GetPCCameraPosition()->mPos[X]);
    VPos.push_back(GetPCCameraPosition()->mPos[Y]);
    VPos.push_back(GetPCCameraPosition()->mPos[Z]);
    
    GCUndoList.OpenBlock();
    GetPLinkedCameraPath()->mpCTranslate->SetKeyFrame(&VPos[0], TRUE);
    GCUndoList.CloseBlock();
}

void MainGLCanvas_cls::
SetKeyPosRot(){
    std::vector < double > VEuler;
    std::vector < double > VPos;
    VPos.push_back(GetPCCameraPosition()->mPos[X]);
    VPos.push_back(GetPCCameraPosition()->mPos[Y]);
    VPos.push_back(GetPCCameraPosition()->mPos[Z]);
    
    VEuler.push_back(GetPCCameraPosition()->mYPR[X]);
    VEuler.push_back(GetPCCameraPosition()->mYPR[Y]);
    VEuler.push_back(GetPCCameraPosition()->mYPR[Z]);
    
    GCUndoList.OpenBlock();
    GetPLinkedCameraPath()->mpCTranslate->SetKeyFrame(&VPos[0], TRUE);
    GetPLinkedCameraPath()->mpCRotation->SetKeyFrame(&VEuler[0], TRUE);
    GCUndoList.CloseBlock();
}

void MainGLCanvas_cls::
SetKeyAnc(){
    GCUndoList.OpenBlock();
    GetPLinkedAnchorPath()->mpCTranslate->
	SetKeyFrame(msCAnchorPos.mPos, TRUE);
    GCUndoList.CloseBlock();
}

void MainGLCanvas_cls::
SetViewport(){
    mCGLPerspDraw.SetViewportOnGL();
}

void MainGLCanvas_cls::
SetPerspective(PositionAndDirection_cls *pCCam){
    mCGLPerspDraw.mbPerspective = (IsOrthographic() == FALSE);
    
    mCGLPerspDraw.mbDivideRender = FALSE;
    if (mbSaveImageQueue == TRUE &&
	mbSaveImgSeqQueue == TRUE &&
	mspCImgSeqLinked != NULL &&
	GetMultiPanelMode() == 0){
	mCGLPerspDraw.mbDivideRender    = mspCImgSeqLinked->mbTiling;
	mCGLPerspDraw.mDivideResolution = mspCImgSeqLinked->mTileResolution;
	mCGLPerspDraw.mDivideIndex      = mspCImgSeqLinked->mTileIndex;
	mCGLPerspDraw.SetClipSize(mspCImgSeqLinked->mClipWidth, 
				  mspCImgSeqLinked->mClipHeight);
    }
    else
	mCGLPerspDraw.SetClipSize(mPanelWidth, mPanelHeight);
    
    mCGLPerspDraw.SetPerspectiveOnGL(pCCam);
}

void MainGLCanvas_cls::
SetLineWidth(FBO_cls *pCFBO){
    if (pCFBO != NULL)
	glLineWidth(msCLineWidth.mBody * pCFBO->GetLineWidthFactor());
    else
	glLineWidth(msCLineWidth.mBody / 3);
}

void MainGLCanvas_cls::
ClearBuffer(double doubleIndex){
    
    float clrBG[3] = {
	mspCClrCurveBG->mCConstantColor.mpBody[R],
	mspCClrCurveBG->mCConstantColor.mpBody[G],
	mspCClrCurveBG->mCConstantColor.mpBody[B]};

    float alphaBG = 1;
    if (msCRenderType.mBody == _TYPE_RGBA) alphaBG = 0;
    glClearColor( clrBG[R], clrBG[G], clrBG[B], alphaBG);
    FilterFog_cls  *pCFog   = (FilterFog_cls*)mspCFilterCtrlWorldLink->GetPCFog();
    if (pCFog != NULL) 
	pCFog->SetGLClearColor(doubleIndex, clrBG);
    
    glClear( GL_COLOR_BUFFER_BIT | GL_ACCUM_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
}

void MainGLCanvas_cls::
ClearCanvas(){
    
    //glClearColor(0, 0, 0, 0);
    SetGLBGColor(1);
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

    if (msCRenderType.mBody == _TYPE_RGBA){
	glDepthMask(GL_FALSE);
	if (IsFishEye() == TRUE)
	    mspCCheckerboard->DrawOnScreen2DTileFit
		(mPanelWidth, mPanelHeight, _TEX_FIT_VERTICAL, 16, 16);
	else
	    mspCCheckerboard->DrawOnScreen2DTileFit
		(mPanelWidth, mPanelHeight, _TEX_FIT_CORNER, 16, 16);
	glDepthMask(GL_TRUE);
	/*
	glClearColor(0.5, 0, 0, 0);
	glClear(GL_COLOR_BUFFER_BIT);
	*/
    }
}

void MainGLCanvas_cls::
DrawDataCopyLoop(FilterDataBoxData_cls *pCScene, int currentIndex, 
		 int fboIndex, int lightNumber,
		 float pLightPosForSV[4], float pLightPhiTheta[2],
		 bool bShadowVolume){
    if (mCbShowData.mbBody == FALSE) return;

    double doubleIndex = GetPCTimeCtrl()->GetDoubleIndex();
    double time = 0, dT = 0;
    GetTimeInfo(time, dT);

    if (pCScene != NULL){
	pCScene->GLSetMatrix();
    }
    
    FilterCopy_cls *pCCopy  = 
	(FilterCopy_cls*)mspCFilterCtrlWorldLink->GetPCCopy();
    
    std::vector < FilterStick_cls* > VpCSticks = 
	mspCFilterCtrlObjectLink->GetVpCSticks();

    PDataSequence_cls *pCSeq = GetPCActiveFileSequence();
    int sortType = _SORT_ORTHO;
    if (IsFishEye() == TRUE || IsCylinder() == TRUE)
	sortType = _SORT_RADIAL;

    float pCopyTranslate[3] = {0, 0, 0};
    if (pCCopy != NULL){
	// !! {́AqWn猩J̈ʒułׂ
	pCCopy->ZSortBegin(mCCameraPos.mPos, mCCameraPos.mTgt, time);
	int copyNum = pCCopy->GetNumber();
	bool bCopiedInstance = FALSE;
	for (int copyIndex = 0; copyIndex < copyNum; copyIndex++){
	    UpdateStatusBar_cls::SetFactor(copyIndex, copyNum);
	    if (pCCopy->GetBValidity(copyIndex, time+dT, TRUE, 0) == FALSE)
		continue;
	    glPushAttrib(GL_ALL_ATTRIB_BITS);
	    glPushMatrix();
	    pCCopy->GLTranslate(copyIndex, time+dT);
	    pCCopy->GetCopyTranslate(pCopyTranslate, copyIndex, time+dT);
	    
	    pCSeq->SetCopyTranrateInfo(pCopyTranslate);
	    pCSeq->GLDrawData
		(fboIndex, bCopiedInstance, 
		 currentIndex, dT, lightNumber, pLightPosForSV, 
		 pLightPhiTheta[0], pLightPhiTheta[1], bShadowVolume,
		 mSelfIndex, sortType);
	    glPopAttrib();
	    glPopMatrix();
	    bCopiedInstance = TRUE;
	}

	if (VpCSticks.size() > 0){
	    glPushAttrib(GL_ALL_ATTRIB_BITS);
	    //glDepthMask(GL_TRUE);
	    //glEnable(GL_DEPTH_TEST);
	    for (int i = 0; i < copyNum; i++){
		UpdateStatusBar_cls::SetFactor(i, copyNum);
		if (pCCopy->GetBValidity(i, time+dT, TRUE, 0) == FALSE) continue;
		glPushMatrix();
		pCCopy->GLTranslate(i, time+dT);
		int bitBoundary = pCCopy->GetBitBoundary(i);
		for (unsigned int j = 0; j < VpCSticks.size(); j++)
		    VpCSticks[j]->GLDrawStick(GLDrawData_cls::mspCSnapShot,
					      mspCPeriodicLink, bitBoundary, 
					      currentIndex, mCCameraPos,
					      lightNumber);
		glPopMatrix();
	    }
	    glPopAttrib();
	}
	pCCopy->ZSortEnd();
    }
    else{
	UpdateStatusBar_cls::SetFactor(0, 1);
	glPushAttrib(GL_ALL_ATTRIB_BITS);
	pCSeq->SetCopyTranrateInfo(pCopyTranslate);
	pCSeq->GLDrawData
	    (fboIndex, FALSE, 
	     currentIndex, dT, lightNumber, pLightPosForSV, 
	     pLightPhiTheta[0], pLightPhiTheta[1], bShadowVolume, 
	     mSelfIndex, sortType);
	glPopAttrib();
	if (VpCSticks.size() > 0){
	    glPushAttrib(GL_ALL_ATTRIB_BITS);
	    //glDepthMask(GL_TRUE);
	    glEnable(GL_DEPTH_TEST);
	    for (unsigned int j = 0; j < VpCSticks.size(); j++)
		VpCSticks[j]->GLDrawStick(GLDrawData_cls::mspCSnapShot,
					  mspCPeriodicLink, 0,
					  currentIndex, mCCameraPos,
					  lightNumber);
	    glPopAttrib();
	}
    }

    pCSeq->GLDrawDataEnd();
}

void MainGLCanvas_cls::
DrawRealObjectCopyLoop(FilterDataBoxData_cls *pCScene, int currentIndex,
		       double doubleIndex, int lightNumber, int drawStep){

    glDepthMask(GL_TRUE);
    glEnable(GL_DEPTH_TEST);
    glBlendFuncSeparate(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA,
			GL_ONE_MINUS_DST_ALPHA, GL_ONE);

    double time = 0, dT = 0;
    GetTimeInfo(time, dT);
    int frame = GetPCTimeCtrl()->GetOffsetForImgSeq();

    if (pCScene != NULL && pCScene->mCInfluence.mBody >= _INFLU_PDATA_OBJECTS)
	 pCScene->GLSetMatrix();
    
    FilterCopy_cls *pCCopy  = 
	(FilterCopy_cls*)mspCFilterCtrlWorldLink->GetPCCopy();
 
    if (pCCopy != NULL){
	int copyNum = pCCopy->GetNumber();
	pCCopy->ZSortBegin(mCCameraPos.mPos, mCCameraPos.mTgt, time);
	// !! ȉ mCCameraPos ́AXeIÕJɂׂ
	for (int i = 0; i < copyNum; i++){
	    if (pCCopy->GetBValidity(i, time+dT, TRUE, 1) == FALSE) continue;
	    glPushMatrix();
	    pCCopy->GLTranslate(i, time+dT);
	    mspCFilterCtrlObjectLink->
		GLDrawRealObject(currentIndex, lightNumber, TRUE, drawStep, mCCameraPos, frame);
	    glPopMatrix();
	}
	mspCFilterCtrlObjectLink->
	    GLDrawRealObject(currentIndex, lightNumber, FALSE, drawStep, mCCameraPos, frame);
	pCCopy->ZSortEnd();
    }
    else{
	mspCFilterCtrlObjectLink->
	    GLDrawRealObject(currentIndex, lightNumber, TRUE, drawStep, mCCameraPos, frame);
	mspCFilterCtrlObjectLink->
	    GLDrawRealObject(currentIndex, lightNumber, FALSE, drawStep, mCCameraPos, frame);
    }
}

void MainGLCanvas_cls::
DrawLightSource(FilterDataBoxData_cls *pCScene, int drawStep){
    if (pCScene != NULL && pCScene->mCInfluence.mBody == _INFLU_ALL)
	 pCScene->GLSetMatrix();
    
    if (drawStep == 0) GetPLinkLightSourceCtrl()->GLDrawRealObj();
}

void MainGLCanvas_cls::
DrawObjectAndData(FilterDataBoxData_cls *pCScene,
		  int currentIndex, double doubleIndex, int lightNumber,
		  int fboIndex, float pLightPosForSV[4], float pLightPhiTheta[2]){
    glPushMatrix();
    DrawRealObjectCopyLoop(pCScene, currentIndex, doubleIndex, lightNumber, 0);
    glPopMatrix(); 

    glPushMatrix();
    DrawLightSource(pCScene, 0);
    glPopMatrix();

    glPushMatrix();    
    DrawDataCopyLoop(pCScene, currentIndex, fboIndex,
		     lightNumber, pLightPosForSV, pLightPhiTheta, FALSE);
    glPopMatrix();

    glPushMatrix();
    DrawLightSource(pCScene, 1);
    glPopMatrix();
    
    glPushMatrix();
    DrawRealObjectCopyLoop(pCScene, currentIndex, doubleIndex, lightNumber, 1);
    glPopMatrix(); 
}

void MainGLCanvas_cls::
DrawDataLitDiffuse(double doubleIndex, double doubleRemapped,
		   int fboIndex, int lightIndex){
    if (mCbShowData.mbBody == FALSE) return;

    double time = 0, dT = 0;
    GetTimeInfo(time, dT);
    int    currentIndex = GetPCTimeCtrl()->GetRemappedIndex();
    double doubleInterpStep = GetPCTimeCtrl()->GetRemappedInterpStepDouble();
    
    GetPCActiveFileSequence()->SetCameraInfo(mCCameraPos);

    FilterDataBoxData_cls *pCScene = 
	(FilterDataBoxData_cls*)mspCFilterCtrlWorldLink->GetPCDataBox();
    
    float pLightPosForSV[4];
    float pLightPhiTheta[2];
    GetPLinkLightSourceCtrl()->
	GetLightInfo(doubleIndex, pLightPosForSV, pLightPhiTheta,
		     lightIndex, TRUE, pCScene);
    GetPLinkLightSourceCtrl()->GLSetSingleDiffuse(lightIndex, doubleIndex, pCScene);
    
    FilterFog_cls     *pCFog   = (FilterFog_cls*)mspCFilterCtrlWorldLink->GetPCFog();

    glDisable(GL_LIGHTING);
    mspCFilterCtrlObjectLink->GLDrawRealGrid
	(doubleIndex, mCCameraPos, &mpCTagObjectCtrl->mVCObject);
    glEnable(GL_LIGHTING);
    
    if (pCScene != NULL) pCScene->UpdateCurrentObj(doubleIndex);
    if (pCFog != NULL)   pCFog->SetGLFog(doubleIndex);
    else glDisable(GL_FOG);

    // ܂ʏ̕`
    DrawObjectAndData(pCScene, 
		      currentIndex, doubleIndex, 1, 
		      fboIndex, pLightPosForSV, pLightPhiTheta);

    // e|ݒ
    glClearStencil(0);
    glClear(GL_STENCIL_BUFFER_BIT);
    glEnable(GL_CULL_FACE);
    glDisable(GL_FOG);
    glEnable(GL_STENCIL_TEST);
    glStencilMask(255);
    glDepthMask(GL_FALSE);
    
    glStencilFunc(GL_ALWAYS, 0, 255);
    if (mspCDrawOptionLink->mCShadow.mBody == 1)
	glColorMask(GL_FALSE, GL_FALSE, GL_FALSE, GL_FALSE);
    glColor4f(1,0.5,0.5,0.2); //?
    glDisable(GL_BLEND);

    // e|S`
    GDrawingStage = 1;
    glPushMatrix(); 
    DrawDataCopyLoop(pCScene, currentIndex, fboIndex, //dT, 
		     0, pLightPosForSV, pLightPhiTheta, TRUE);
    glPopMatrix(); 

    glColorMask(1,1,1,1);
    glDepthMask(GL_TRUE);
    glStencilMask(0);
    
    glStencilFunc(GL_LESS, 0, 255);
    glStencilOp(GL_KEEP, GL_KEEP, GL_KEEP);
    
    //glClear(GL_DEPTH_BUFFER_BIT);
    glDepthMask(GL_FALSE);

    if (GetPCActiveFileSequence()
	->mpCGLAttribute[0]->mCTexture.mCShaderType.mBody != 0){
	// eh
	glEnable(GL_BLEND);
	glMatrixMode(GL_PROJECTION);
	glPushMatrix(); // +2
	glLoadIdentity();
	gluOrtho2D(0, 1, 0, 1);
	glMatrixMode(GL_MODELVIEW);
	glPushMatrix(); // +3
	glLoadIdentity();

	glUseProgram(0);
	glDisable(GL_LIGHTING);
	glColor4f(0, 0, 0, 1);
	glRectf(0,0,1,1);
	
	glPopMatrix(); // +2
	glMatrixMode(GL_PROJECTION);
	glPopMatrix(); // +1
	glMatrixMode(GL_MODELVIEW);
    }
    else{
	GetPLinkLightSourceCtrl()->GLDisableAllLight();
	GDrawingStage = 2;

	if (pCFog != NULL) pCFog->SetGLFog(doubleIndex);
	else glDisable(GL_FOG);
	
	glColor4f(0.0, 0.0, 0.0, 1.0);
	mspCFilterCtrlObjectLink->GLDrawRealGrid
	    (doubleIndex, mCCameraPos, &mpCTagObjectCtrl->mVCObject);

	DrawObjectAndData(pCScene, currentIndex, doubleIndex, 0, 
			  fboIndex, pLightPosForSV, pLightPhiTheta);
    }
    GDrawingStage = 0;
}

void MainGLCanvas_cls::
DrawDataMain(double doubleIndex, double doubleRemapped,
	     int fboIndex, int shadowNumber){
    
    int    currentIndex = GetPCTimeCtrl()->GetRemappedIndex();
    double time = 0, dT = 0;
    GetTimeInfo(time, dT);
    
    int lightNumber =  GetPLinkLightSourceCtrl()->mCLightNum.mBody;
    int firstShadowLight = GetPLinkLightSourceCtrl()->GetFirstShadowedLight();
    
    FilterDataBoxData_cls *pCScene = 
	(FilterDataBoxData_cls*)mspCFilterCtrlWorldLink->GetPCDataBox();    
    
    float pLightPosForSV[4];
    float pLightPhiTheta[2];
    GetPLinkLightSourceCtrl()->
	GetLightInfo(doubleIndex, pLightPosForSV, pLightPhiTheta,
		     firstShadowLight, TRUE, pCScene);
    
    FilterFog_cls         *pCFog   = (FilterFog_cls*)mspCFilterCtrlWorldLink->GetPCFog();
    
    if (pCFog != NULL) pCFog->SetGLFog(doubleIndex);
    else glDisable(GL_FOG);
    
    glEnable(GL_LIGHTING);
    glEnable(GL_DEPTH_TEST);

    PositionAndDirection_cls CCameraPosRelative = mCCameraPos;

    if (pCScene != NULL){
	pCScene->UpdateCurrentObj(doubleIndex);
	int rotOrder = pCScene->mCRotateOrder.mBody;
	float posRelative[3], dirRelatve[3];
	LOOP_XYZ posRelative[xyz] = CCameraPosRelative.mPos[xyz];
	pCScene->CalcRelativePosition(posRelative, doubleIndex, pCScene->mpCAnchor, rotOrder);
	LOOP_XYZ CCameraPosRelative.mPos[xyz] = posRelative[xyz];
	LOOP_XYZ dirRelatve[xyz] = CCameraPosRelative.mTgt[xyz];
	pCScene->CalcRelativeVector(dirRelatve, doubleIndex, rotOrder);
	LOOP_XYZ CCameraPosRelative.mTgt[xyz] = dirRelatve[xyz];
	LOOP_XYZ dirRelatve[xyz] = CCameraPosRelative.mRgt[xyz];
	pCScene->CalcRelativeVector(dirRelatve, doubleIndex, rotOrder);
	LOOP_XYZ CCameraPosRelative.mRgt[xyz] = dirRelatve[xyz];
	LOOP_XYZ dirRelatve[xyz] = CCameraPosRelative.mTop[xyz];
	pCScene->CalcRelativeVector(dirRelatve, doubleIndex, rotOrder);
	LOOP_XYZ CCameraPosRelative.mTop[xyz] = dirRelatve[xyz];
	
    }

    GetPCActiveFileSequence()->SetCameraInfo(CCameraPosRelative);

    DrawObjectAndData(pCScene, currentIndex, doubleIndex, lightNumber,
		      fboIndex, pLightPosForSV, pLightPhiTheta);

    if (shadowNumber > 0){
	glClearStencil(0);
	glClear(GL_STENCIL_BUFFER_BIT);
	glEnable(GL_CULL_FACE);
	glEnable(GL_STENCIL_TEST);
	glStencilMask(255);
	glDepthMask(GL_FALSE);

	glStencilFunc(GL_ALWAYS, 0, 255);
	if (mspCDrawOptionLink->mCShadow.mBody == 1)
	    glColorMask(GL_FALSE, GL_FALSE, GL_FALSE, GL_FALSE);
	glDisable(GL_BLEND);
	
	GDrawingStage = 1;

	// e|S
	glPushMatrix(); 
	DrawDataCopyLoop(pCScene, currentIndex, fboIndex, 
			 lightNumber, pLightPosForSV, pLightPhiTheta, TRUE);
	glPopMatrix(); 

	glColorMask(1,1,1,1);
	glDepthMask(GL_TRUE);
	glStencilMask(0);

	glStencilFunc(GL_LESS, 0, 255);
	glStencilOp(GL_KEEP, GL_KEEP, GL_KEEP);
	
	glClear(GL_DEPTH_BUFFER_BIT);
	
	GDrawingStage = 2;

	mspCFilterCtrlObjectLink->GLDrawRealGrid
	    (doubleIndex, mCCameraPos, &mpCTagObjectCtrl->mVCObject);
	GetPLinkLightSourceCtrl()->SetBasicLight(doubleIndex, 1, pCScene);
	glEnable(GL_LIGHTING);

	DrawObjectAndData(pCScene, currentIndex, doubleIndex, lightNumber,
			  fboIndex,pLightPosForSV, pLightPhiTheta);
	
	GDrawingStage = 0;
    }
}

void MainGLCanvas_cls::  
DrawGrid(double scale, double scale10){
    if (mCbShowGrid.mbBody == FALSE) return;
    glColor4f(0.3f, 0.3f, 0.3f, 1.f);
    Grid_cls::DrawGridFlat(scale10);
}

void MainGLCanvas_cls::
DrawCameraPath(double doubleIndex, double scale, bool bHittest){
    if (mpCCameraPathLinked != NULL && 
	mCCameraPosCamera.IsNearPosition(mpCCameraPathLinked->mCCurrentObj) == TRUE) return;
    // FIX_ME!! IĂ\ׂ
    if (mCbShowItems.mbBody == FALSE) return; 

    glPushName(GetPLinkedCameraPath()->mObjIndex);
    GetPLinkedCameraPath()->GLDraw(bHittest);
    mspCStereogramLink->DrawFocus(GetPLinkedCameraPath()->mCCurrentObj,
				  doubleIndex, scale);
    glPopName();
    if (GetPLinkedAnchorPath()->mCbVisible.mbBody == TRUE){
	glPushName(GetPLinkedAnchorPath()->mObjIndex);
	GetPLinkedAnchorPath()->GLDraw(bHittest);
	glPopName();
    }
}

void MainGLCanvas_cls::
DrawLightSource(double doubleIndex, double scale, bool bHittest){
    if (mCbShowItems.mbBody == FALSE) return;
    GetPLinkLightSourceCtrl()->GLDraw(bHittest);
}

void MainGLCanvas_cls::
DrawFilters(double doubleIndex, double scale, bool bHittest){

    glPushAttrib(GL_ALL_ATTRIB_BITS);
    glEnable(GL_LIGHTING);
    glPopAttrib();

    if (mCbShowItems.mbBody == FALSE) return;

    mspCFilterCtrlBooleanLink->GLDraw(doubleIndex, scale, bHittest);
    mspCFilterCtrlObjectLink->GLDraw(doubleIndex, scale, bHittest);
    mspCFilterCtrlWorldLink->GLDraw(doubleIndex, scale, bHittest);
}

void MainGLCanvas_cls::
DrawAnchor(double scale){
    if (mCbShowItems.mbBody == FALSE) return;

    glColor4f(0.2f, 1.0f, 1.0f, 1.f);
    glPushMatrix(); // +1
    glTranslated(mCCameraPos.mAncPos[0],
		 mCCameraPos.mAncPos[1],
		 mCCameraPos.mAncPos[2]);
    glScaled(scale*0.02, scale*0.02, scale*0.02);
    glCallList(Camera_cls::mDListCrosshair);
    glPopMatrix(); // +-0
}

#define GL_GPU_MEM_INFO_TOTAL_AVAILABLE_MEM_NVX 0x9048
#define GL_GPU_MEM_INFO_CURRENT_AVAILABLE_MEM_NVX 0x9049

bool MainGLCanvas_cls::
DrawWarning(wxPaintDC& dc){
    if (FBO_cls::msbSupported == FALSE){
	dc.SetTextForeground(wxColour(212, 212, 212));
	wxString strMessage = wxT("Your OpenGL version is ");
	strMessage << mpCParentFrameLink->mpCGLInfo->GetGLVersionStr();
	strMessage << wxT("\nFBO is NOT supported. Plase upgrade your OpenGL environment.\nYou can not use most advanced openGL functions on remote desktop.");
	dc.DrawLabel(strMessage, wxNullBitmap, wxRect(0, 0, mPanelWidth, mPanelHeight), wxALIGN_CENTER | wxALIGN_CENTER_VERTICAL);
	return FALSE;
    }
    return TRUE;
}

void MainGLCanvas_cls::
CheckWarnigForDirectDraw(){
    if (mspCStereogramLink->GetStereoNum() == 2)
	mstrWarning << wxT("Direct Display Mode does not support stereogram.") << ENDL;
    if (IsFishEye() == TRUE ||IsCylinder() == TRUE)
	mstrWarning << wxT("Direct Display Mode does not support fisheye or panorama.") << ENDL;
    if (mpCParentFrameLink->mpCParent->mpCExposure->IsDefault() == FALSE)
	mstrWarning << wxT("Direct Display Mode does not support exposure.") << ENDL;
    if (mspCDrawOptionLink->mCShadow.mBody != 0)
	mstrWarning << wxT("Direct Display Mode does not support shadow volume.") << ENDL;
}

void MainGLCanvas_cls::
DrawMessage(){

    if (GLDrawData_cls::msstrWarning.IsEmpty() == FALSE){
	mstrWarning << GLDrawData_cls::msstrWarning;
	GLDrawData_cls::msstrWarning.Clear();
    }

    if (LuaBase_cls::msstrErr.IsEmpty() == FALSE){
	mstrWarning << LuaBase_cls::msstrErr;
	LuaBase_cls::msstrErr.Clear();
    }

    if (mCbShowMessage.mbBody == FALSE){
	mstrWarning.Clear();
	return; 
    }

    glPushAttrib(GL_ALL_ATTRIB_BITS);
    glDisable(GL_DEPTH_TEST);
    glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
    void* font = GLUT_BITMAP_HELVETICA_12;
    int index = GetPCTimeCtrl()->GetRemappedIndex();
        
    GLint total_mem_kb = 10;
    glGetIntegerv(GL_GPU_MEM_INFO_TOTAL_AVAILABLE_MEM_NVX, 
		  &total_mem_kb);
    
    GLint cur_avail_mem_kb = 10;
    glGetIntegerv(GL_GPU_MEM_INFO_CURRENT_AVAILABLE_MEM_NVX, 
		  &cur_avail_mem_kb);

    double time, dT;
    GetTimeInfo(time, dT);
    double doubleIndex = GetPCTimeCtrl()->GetDoubleIndex();
    
    wxString strTime;
    int particleNum = GetPCActiveFileSequence()->GetParticleNumber(index);
    int copyNum = 1;
    if (mspCFilterCtrlWorldLink->GetPCCopy() != NULL){
	copyNum = mspCFilterCtrlWorldLink->GetPCCopy()->GetNumberValid(time + dT);
    }
    strTime << wxT("Time=") << time + dT;
    strTime << wxT(":nt = ") << doubleIndex;
    strTime << wxT(":PNum=") << particleNum
	    << wxT("*") << copyNum;
    if (copyNum != 1)
	strTime << wxT("=") << particleNum * copyNum;
    
    strTime << wxT(":MilliSec") << mCStopWatchSnap.Time()
	    << wxT(":Hitting")  << msCHittest.GetFirstObject()
	    << wxT("+")         << msCHittest.GetFirstObjectSub() 
	    << wxT(":Object")   << (long long)MoveItem_cls::mspCSelectedObject << ENDL;

	;
    
    mpCGLString2DDirect->Draw(font, strTime.ToAscii(), 5, 10, _STRINGS_TOP_LEFT);

    char pBuf[128]; sprintf(pBuf, "GMem0 = %d GMem1 = %d Count = %d UDBlock = %d",
			    total_mem_kb, cur_avail_mem_kb, mCounter, GCUndoList.mBlockDepth);
    mCounter++;

    mpCGLString2DDirect->Draw(font, pBuf, 5, 28, _STRINGS_TOP_LEFT);

    /*
    wxString strUndo = GCUndoList.GetStrList();
    mpCGLString2D->Draw(font, strUndo.ToAscii(), 5, 46, _STRINGS_TOP_LEFT);
    */

    glColor4f(1.0f, 0.5f, 0.5f, 1.0f);
    mpCGLString2DDirect->Draw(font, mstrWarning.ToAscii(), 100, 10, _STRINGS_BOTTOM_LEFT);
    
    glPopAttrib();
}

void MainGLCanvas_cls::
DrawModeAxis(double scale){
}

void MainGLCanvas_cls::
DrawSelectedItem(double scale){

    if (MoveItem_cls::mspCSelectedObject == NULL) return;

    /*
    if (mpCMoveItem->mbMovingItemNow == FALSE) return;
    glColor4f(1.0, 1.0, 0.2, 1.0);
    bool bSelectKey = FALSE;
    
    LOOP_XYZ MoveItem_cls::mspCSelectedObject->mCCurrentObj.mPos[xyz] = MoveItem_cls::msSelectedItemPos[xyz];
    */

    if (mCbShowNavigator.mbBody == FALSE) return; 

    SetLineWidth();
    glDisable(GL_DEPTH_TEST);
    
    if (mpCParentFrameLink->mpCPreference->mCUseFBO.mBody == 1)
	mpCMoveItem->DrawMouseGuide(mpCNavigators->msManipulatorMode, 
				    mpCNavigators->msDragMode,
				    mPanelWidth, mPanelHeight,
				    mspCFishEyeCtrl->mBufferSize,
				    mspCFishEyeCtrl->mBufferSize);
    else
	mpCMoveItem->DrawMouseGuide(mpCNavigators->msManipulatorMode, 
				    mpCNavigators->msDragMode,
				    mPanelWidth, mPanelHeight,
				    mPanelWidth, mPanelHeight);
	
    glEnable(GL_DEPTH_TEST);
}


void MainGLCanvas_cls::
RefreshEX(){
    GRefreshQueueCounter++;
    if (GRefreshQueueCounter > 1) return;
    // QuadBufferPendEventRefreshȂB
    if (mspCStereogramLink->mbQuadStereo == TRUE ||
	mpCParentFrameLink->mpCPreference->mCForceRefresh.mBody == 1)
	Refresh(FALSE);
    else{
	wxPaintEvent com(GetId());
	AddPendingEvent(com);
    }

    if (mSelfIndex == 0){
	MainGLCanvas_cls *pCExt = mpCParentFrameLink->GetPCGLCanvas(4);
	if (pCExt->IsShownOnScreen() == FALSE) return;
	if (pCExt->mCDisplayMode.mBody != _GL_CANVAS_COPY_OF_VIEW_0) return;
	wxPaintEvent com(pCExt->GetId());
	pCExt->AddPendingEvent(com);
	//pCExt->Refresh(FALSE);
	//SendMenuEvent(wxGetTopLevelParent(this), menuEditRefreshGLExt);
    }
}

bool MainGLCanvas_cls::
IsMouseOnClient(){
    wxRect  CScreenRect = GetScreenRect();
    wxPoint CMousePos   = wxGetMousePosition();
    return CScreenRect.Contains(CMousePos);
}

void MainGLCanvas_cls::
ShowPreviousFramePBO(){
}

void MainGLCanvas_cls::
DrawOtherObjects(double doubleIndex, double scale, double scale10){
    glPointSize(6);
    glEnable(GL_DEPTH_TEST);
    glDisable(GL_LIGHTING);
    glDepthMask(GL_TRUE);

    glUseProgram(0);

    DrawGrid(scale, scale10);
    DrawCameraPath(doubleIndex, scale);
    DrawLightSource(doubleIndex, scale);
    DrawFilters(doubleIndex, scale);
    //glDisable(GL_LIGHTING);
    mspCFilterCtrlObjectLink->GLDrawRealGrid
	(doubleIndex, mCCameraPos, &mpCTagObjectCtrl->mVCObject);
    
    //glEnable(GL_LIGHTING);

    if (mbHitTestItemSelect == TRUE || mbHitTestGuideSelect == TRUE){

	msCHittest.StartHitTest((float)mpCMouseCtrl->mMouseX/mPanelWidth,
				(float)mpCMouseCtrl->mMouseY/mPanelHeight,
				(float)mPanelWidth/mPanelHeight,
				this, &mCCameraPos, TRUE);
	glInitNames();
	glDisable(GL_DEPTH_TEST);
	if (msCHittest.mbHitTest == FALSE)
	    DrawGrid(scale, scale10);
	if (mbHitTestItemSelect == TRUE){
	    DrawLightSource(doubleIndex, scale, TRUE);
	    DrawCameraPath(doubleIndex, scale, TRUE);
	    DrawFilters(doubleIndex, scale, TRUE);
	}
	if (mbHitTestGuideSelect == TRUE)
	    DrawSelectedItem(scale);
	msCHittest.EndHitTest();
	
	if (mbHitTestItemSelect == TRUE){
	    int itemName = msCHittest.GetFirstObject();
	    if (itemName != -1){
		if (itemName < 20){ // IuWFNgqbg
		    mpCParentFrameLink->mpCParent->SelectObject(itemName);
		    mpCParentFrameLink->mpCParent->SelectFilter(NULL, FALSE);
		    mbRefreshQueue = TRUE;
		}
		else{
		    mpCParentFrameLink->mpCParent->
			SelectFilterByHittest(itemName, TRUE);
		}
	    }
	}

	if (mbHitTestGuideSelect == TRUE){
	    if (msCHittest.GetFirstObjectSub() != -1)
		mpCNavigators->SetDragMode(msCHittest.GetFirstObjectSub());
	}
	
	mbHitTestItemSelect  = FALSE;
	mbHitTestGuideSelect = FALSE;
    }
    
    glDisable(GL_DEPTH_TEST);
    DrawAnchor(scale);
}

void MainGLCanvas_cls::
RefreshOtherOrthoCanvas(){
    for (unsigned int i = 0; i < mVPOtherCanvas.size(); i++){
	if (mVPOtherCanvas[i]->IsAlongAxis() == TRUE)
	    mVPOtherCanvas[i]->Refresh(FALSE);
    }
}

bool MainGLCanvas_cls::
CheckGLRefresh(int frame, int interpStep){
    if (IsShownOnScreen() == FALSE) return TRUE;
    if (GRefreshQueueCounter > 0) return TRUE;
    if (frame != mPrevFrame || interpStep != mPrevStep){
	wxPaintEvent com(GetId());
	AddPendingEvent(com);
	return FALSE;
    }
    return TRUE;
}

void MainGLCanvas_cls::
DrawOnGL(int stereoEye, double doubleIndex, double doubleRemapped){
    double scale = CalcAutoScale();
    double scale10 = 0.0001;
    while (scale10*10 < scale) scale10 *= 10;

    PositionAndDirection_cls StereoCamera = mCCameraPos;
    mspCStereogramLink->mpCStereoParam->GetInterpolatedValue(doubleIndex, _PARAM_USE_COMMON);
    mspCStereogramLink->ModifyByStereogram(&StereoCamera, stereoEye);
    
    if (IsFishEye() == TRUE && mCDisplayMode.mBody >= _GL_CANVAS_LINKED_CAM0)
	ModifyByDomeTilt(&StereoCamera);

    glPushAttrib(GL_ALL_ATTRIB_BITS);

    ClearBuffer(doubleIndex);
    std::vector < FilterBG_cls* > VpCBG = mspCFilterCtrlWorldLink->GetVpCBG();
    for (int i = 0; i < (int)VpCBG.size(); i++) VpCBG[i]->GLDraw(doubleIndex);

    mCGLPerspDraw.SetWindowSize(mPanelWidth, mPanelHeight);
    mCGLPerspDraw.SetViewportOnGL();
    mCGLPerspDraw.SetPerspectiveOnGL(&StereoCamera, FALSE);
    mCGLPerspDraw.SetModelOrProjectionViewOnGL(&StereoCamera, GL_MODELVIEW);
    mpCMoveItem->GetGLMatrixInfo();
    //mspCGLGuideYPR->GetGLMatrixInfo();

    FilterDataBoxData_cls *pCScene = 
	(FilterDataBoxData_cls*)mspCFilterCtrlWorldLink->GetPCDataBox();   

    GetPLinkLightSourceCtrl()->SetNonShadowLight(doubleIndex, pCScene);

    SetLineWidth();
    DrawDataMain(doubleIndex, doubleRemapped, 0, 0);

    SetLineWidth();
    DrawOtherObjects(doubleIndex, scale, scale10);

    glDisable(GL_LIGHTING);
    glColor4f(1, 1, 1, 1);
    mpCTagObjectCtrl->CalcTagCoordinate();
    mpCTagObjectCtrl->DrawTags(mpCGLString2DBuffer);

    DrawSelectedItem(scale);
    
    glPopAttrib();
}

int MainGLCanvas_cls::
GetFBOBufferSize(int type){
    int bufferSize = msAFBOSize[msCFBOSizeIndex.mBody];
    if (type == 1) // 0: p[c 1: pobt@
	if (GetMultiPanelMode() != 0)
	    switch(msCFBOSizeFishEye.mBody){
	    case 0: bufferSize =2048; break;
	    case 1: bufferSize =4096; break;
	    case 2: bufferSize =8192; break;
	    }
    
    return bufferSize;
}

void MainGLCanvas_cls::
DrawOnFBO(int stereoEye, double doubleIndex, double doubleRemapped, 
	  int bufferSize){
    
    double scale = CalcAutoScale();
    double scale10 = 0.0001;
    while (scale10*10 < scale) scale10 *= 10;

    FilterDataBoxData_cls *pCScene = 
	(FilterDataBoxData_cls*)mspCFilterCtrlWorldLink->GetPCDataBox();   
    
    int fboMax = GetFBOMax();
    
    int shadowNumber = 
	GetPLinkLightSourceCtrl()->GetNumberLightWithShadow();
    if (mspCDrawOptionLink->mCShadow.mBody == FALSE)
	shadowNumber = 0;
    
    if (shadowNumber > 1)
	mpCFBOForShadow->MakeFBO(TRUE);
    
    bool bUseDepthTexture = (msCRenderType.mBody == _TYPE_DEPTHBUFFER) ? TRUE : FALSE;
    int orgDeg = mCGLPerspDraw.mDeg;
    for (int fboIdx = 0; fboIdx < fboMax; fboIdx++){
	FBO_cls *pCFBO = mspCFishEyeCtrl->mpCFBOParts[fboIdx];

	PositionAndDirection_cls StereoCamera = mCCameraPos;
	mspCStereogramLink->mpCStereoParam->GetInterpolatedValue(doubleIndex, _PARAM_USE_COMMON);
	mspCStereogramLink->ModifyByStereogram(&StereoCamera, stereoEye);

	if (IsFishEye() == TRUE && mCDisplayMode.mBody >= _GL_CANVAS_LINKED_CAM0)
	    ModifyByDomeTilt(&StereoCamera);

	mspCFishEyeCtrl->MakeFishEyeProcessFH
	    (fboIdx, StereoCamera, mCGLPerspDraw, GetMultiPanelMode(), 
	     bUseDepthTexture);
	mpCMoveItem->GetGLMatrixInfo();
	
	glPushAttrib(GL_ALL_ATTRIB_BITS);

	ClearBuffer(doubleIndex);
	std::vector < FilterBG_cls* > VpCBG =
	    mspCFilterCtrlWorldLink->GetVpCBG();
	for (int i=0; i < (int)VpCBG.size(); i++) VpCBG[i]->GLDraw(doubleIndex);
	
	if (shadowNumber == 0 || shadowNumber == 1)
	    GetPLinkLightSourceCtrl()->SetNonShadowLight(doubleIndex, pCScene);
	else
	    GetPLinkLightSourceCtrl()->SetBasicLight
		(doubleIndex, mspCDrawOptionLink->mCShadow.mBody, pCScene);
	
	glClear(GL_DEPTH_BUFFER_BIT);
	SetLineWidth(pCFBO);
	DrawDataMain(doubleIndex, doubleRemapped, fboIdx, shadowNumber);

	SetLineWidth(pCFBO);
	DrawOtherObjects(doubleIndex, scale, scale10);

	glDisable(GL_LIGHTING);
	glColor4f(1, 1, 1, 1);
	mpCTagObjectCtrl->CalcTagCoordinate();
	mpCTagObjectCtrl->DrawTags(mpCGLString2DBuffer);
	
	DrawSelectedItem(scale);
	glPopAttrib();
	
	mspCFishEyeCtrl->MakeFishEyeProcessLH(fboIdx);
	
	if (shadowNumber > 1) {
	    for (int i = 0; i < GetPLinkLightSourceCtrl()->mCLightNum.mBody; i++){
		if (GetPLinkLightSourceCtrl()->mpCLightSRC[i]->
		    mCbCastShadow.mbBody == FALSE) continue;
		
		mpCFBOForShadow->Begin(TRUE);
		
		glPushAttrib(GL_ALL_ATTRIB_BITS);
		SetLineWidth(pCFBO);
		DrawDataLitDiffuse(doubleIndex, doubleRemapped, fboIdx, i);
		glPopAttrib();
		
		SetLineWidth(pCFBO);
		DrawSelectedItem(scale);
		mpCTagObjectCtrl->DrawTags(mpCGLString2DBuffer);
		mpCFBOForShadow->End();
		
		pCFBO->Begin(FALSE);
		glMatrixMode(GL_PROJECTION);
		glPushMatrix(); // +1
		glMatrixMode(GL_MODELVIEW);
		glPushMatrix();	// +2    
		
		glPushAttrib(GL_ALL_ATTRIB_BITS);
		glUseProgram(0);
		//glEnable(GL_TEXTURE_2D);
		glDisable(GL_LIGHTING);
		glEnable(GL_BLEND);
		glBlendFunc(GL_SRC_ALPHA, GL_ONE);
		mpCFBOForShadow->DrawOnScreen2DFit(bufferSize, bufferSize, _TEX_FIT_VERTICAL, TRUE);
		glPopAttrib();
		
		glMatrixMode(GL_MODELVIEW);
		glPopMatrix(); // +1
		glMatrixMode(GL_PROJECTION);
		glPopMatrix(); // +-0
		
		pCFBO->End();
	    }
	    ShaderCtrl_cls::msbSingleLightingMode = FALSE;
	}
    }
}

void MainGLCanvas_cls::
GatherFBOMultiPanel(int width, int height, int stereo){
    
    bool bAdd = FALSE;
    bool bUseDepthTexture = FALSE;
    if (msCRenderType.mBody == _TYPE_DEPTHBUFFER) bUseDepthTexture = TRUE;
    
    glClear(GL_STENCIL_BUFFER_BIT);
    if (GetMultiPanelMode() == _MULTIPANEL_FISHEYE){
	
	int bufferSize = GetFBOBufferSize(1);
	if (mpCFBOForFishEyeBuffer == NULL)
	    mpCFBOForFishEyeBuffer = new FBO_cls(bufferSize, bufferSize);
	else
	    mpCFBOForFishEyeBuffer->SetGeometryBuffer(bufferSize, bufferSize);
	int fboDepth = mpCParentFrameLink->mpCPreference->GetFBODepth();
	mpCFBOForFishEyeBuffer->SetDepth(fboDepth);
	
	mpCFBOForFishEyeBuffer->MakeFBO(TRUE);
	mpCFBOForFishEyeBuffer->Begin();
	SetGLBGColor(1);
	glEnable(GL_TEXTURE_2D);
	mspCFishEyeCtrl->GatherFishEye
	    (mCGLPerspDraw.mDeg, bAdd, bufferSize, bufferSize,
	     mspCStereogramLink, stereo, bUseDepthTexture);
	mpCFBOForFishEyeBuffer->End();

	glEnable(GL_BLEND);

	if (mCbFisheyeGrid.mbBody == TRUE){
	    mpCFBOForFishEyeBuffer->Begin(FALSE);
	    glBlendColor(0.5, 0.25, 0.25, 1);
	    glBlendFunc(GL_CONSTANT_COLOR, GL_ONE_MINUS_SRC_COLOR);
	    mspCFisheyeGrid->DrawOnScreen2DFit(bufferSize, bufferSize, _TEX_FIT_CORNER, TRUE);
	    glBlendColor(1, 1, 1, 1);
	    mpCFBOForFishEyeBuffer->End();
	}
	
	if (mCbDistortion.mbBody == TRUE){
	    mpCFBOForFishEyeBuffer->Begin(FALSE);
	    glBlendFunc(GL_ZERO, GL_SRC_COLOR);
	    mspCMask->DrawOnScreen2DFit(bufferSize, bufferSize, _TEX_FIT_VERTICAL, TRUE);
	    mpCFBOForFishEyeBuffer->End();
	}
	
	glBlendFunc(GL_SRC_ALPHA, GL_ONE);
	
	mpCParentFrameLink->mpCParent->mpCExposure->Begin();

	if (mCbDistortion.mbBody == TRUE){
	    glBlendFunc(GL_SRC_ALPHA, GL_ONE);
	    glColor4f(1, 1, 1, 1);
	    mpCFBOForFishEyeBuffer->BindTexture();
	    mspCDistortion->SetGLSetting(width, height);
	    mspCDistortion->GLDrawDistortedTexture((double)width / height, 1, FALSE, 1);
	    mspCStereogramLink->ColorMaskEnd();
	}
	else{
	    glBlendFunc(GL_SRC_ALPHA, GL_ONE);
	    glColor4f(1, 1, 1, 1);
	    mspCStereogramLink->ColorMaskBegin(stereo);
	    mpCFBOForFishEyeBuffer->DrawOnScreen2DFit(width, height, _TEX_FIT_VERTICAL, TRUE);
	    mspCStereogramLink->ColorMaskEnd();
	}

	mpCParentFrameLink->mpCParent->mpCExposure->End();
	
	glBindTexture(GL_TEXTURE_2D, 0);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glDisable(GL_BLEND);
	glDisable(GL_TEXTURE_2D);
    }
    
    if (GetMultiPanelMode() == _MULTIPANEL_CYLINDER){
	mpCParentFrameLink->mpCParent->mpCExposure->Begin();
	mspCFishEyeCtrl->GatherCylinder
	    (mCGLPerspDraw.mDeg, bAdd, 
	     width, height, mspCStereogramLink, stereo, bUseDepthTexture);
	mpCParentFrameLink->mpCParent->mpCExposure->End();
    }
}

void MainGLCanvas_cls::
GatherFBOImages(int width, int height, int stereo){
    
    SetGLBGColor(1);

    if (GetMultiPanelMode() != 0){
	GatherFBOMultiPanel(width, height, stereo);
	return;
    }
    
    // ȉSinglePanel
    TextureBase_cls *pCTex = mspCFishEyeCtrl->mpCFBOParts[0];
    if (msCRenderType.mBody == _TYPE_DEPTHBUFFER){
	if (mspCFishEyeCtrl->mpCFBOParts[0]->mpCDepthTexture != NULL)
	    pCTex = mspCFishEyeCtrl->mpCFBOParts[0]->mpCDepthTexture;
    }
    
    mpCParentFrameLink->mpCParent->mpCExposure->Begin();
    mspCStereogramLink->ColorMaskBegin(stereo);
    glEnable(GL_BLEND);
    //glBlendFunc(GL_SRC_ALPHA, GL_ONE);
    glBlendFunc(GL_ONE, GL_ONE);
    glColor4f(1, 1, 1, 1);
    pCTex->DrawOnScreen2DFit(width, height, TRUE, TRUE);
    mspCStereogramLink->ColorMaskEnd();
    mpCParentFrameLink->mpCParent->mpCExposure->End();
}

void MainGLCanvas_cls::
BakeResultToFBOForImage(int stereo){
    
    double alpha = 1.0;
    
    if (GetPCTimeCtrl()->mCBlurCtrl.mbUseMotionBlur == TRUE) 
	alpha = pow((double)GetPCTimeCtrl()->mCBlurCtrl.GetAlpha(), 1/*0.5*/);
    
    int finalBufferSize = mspCStereogramLink->mBufferSize;

    mpCParentFrameLink->mpCParent->mpCExposure->mAlpha = alpha;
    mpCParentFrameLink->mpCParent->mpCExposure->mBlendMode = 1;
    mspCStereogramLink->DrawOnFBOBegin(stereo);
    GatherFBOImages(finalBufferSize, finalBufferSize, stereo);
    mspCStereogramLink->DrawOnFBOEnd(stereo);
    mpCParentFrameLink->mpCParent->mpCExposure->mAlpha = 1;
    mpCParentFrameLink->mpCParent->mpCExposure->mBlendMode = 0;
}

void MainGLCanvas_cls::
FBODraw(double doubleIndex, double doubleRemapped, int stereo){

    int bufferSize = GetFBOBufferSize(0);
    int fboDepth = mpCParentFrameLink->mpCPreference->GetFBODepth();
    mpCGLString2DBuffer->SetWindowGeometry(bufferSize, bufferSize);
    mspCFishEyeCtrl->MakeFishEyePrepare
	(mCGLPerspDraw.mClipWidth, mCGLPerspDraw.mClipHeight, bufferSize, 
	fboDepth, GetFBOMax());
    
    if (mpCFBOForShadow == NULL)
	mpCFBOForShadow = new FBO_cls(bufferSize, bufferSize);
    else
	mpCFBOForShadow->SetGeometryBuffer(bufferSize, bufferSize);
    mpCFBOForShadow->SetDepth(fboDepth);
    
    int orgDeg = mCGLPerspDraw.mDeg;
    int stereoEye = mspCStereogramLink->GetStereoEye(stereo);
    DrawOnFBO(stereoEye, doubleIndex, doubleRemapped, bufferSize);
    
    // ʌɖ߂
    mCGLPerspDraw.SetModelOrProjectionViewOnGL(&mCCameraPos, GL_MODELVIEW);
    //SetModelView(&mCCameraPos, FALSE); 
    mCGLPerspDraw.mDeg = orgDeg;

    BakeResultToFBOForImage(stereo);
}

void MainGLCanvas_cls::
DirectDraw(double doubleIndex, double doubleRemapped){
    
    int orgDeg = mCGLPerspDraw.mDeg;
    int stereoEye = mspCStereogramLink->GetStereoEye(0);

    DrawOnGL(stereoEye, doubleIndex, doubleRemapped);
}

void MainGLCanvas_cls::
PrepareBaseObjectSettings(){
    double doubleIndex = GetPCTimeCtrl()->GetDoubleIndex();
    
    // ԂωƁA mCPosCameraȂǂǐ
    if (doubleIndex != mDoubleIndexPrev){
	/*
	mpCSceneObjCtrlLink->GetCameraPathPos(mCPosCamera);
	mpCSceneObjCtrlLink->GetAnchorPathPos(mCPosAnchor);
	*/
	mpCMoveItem->InitializeMoveItem();
	mDoubleIndexPrev = doubleIndex;
    }
}

void MainGLCanvas_cls::
GLDrawPrepareParticleSnap(){
    if (mCbShowData.mbBody == FALSE) return;
    
    int    currentIndex     = GetPCTimeCtrl()->GetRemappedIndex();

    double doubleIndex = GetPCTimeCtrl()->GetDoubleIndex();
    double time = 0, dT = 0;
    GetTimeInfo(time, dT);

    PDataSequence_cls *pCSeq = GetPCActiveFileSequence();
    pCSeq->GLDrawPrepareParticleSnap(currentIndex, dT,
				     doubleIndex, mDrawingFrame);
}

bool MainGLCanvas_cls::
GLDrawMain(){
       
    mDrawingFrame = GetPCTimeCtrl()->mFrame;
    mDrawingStep  = GetPCTimeCtrl()->mInterpStep;
    mDrawingBlurFactor      = GetPCTimeCtrl()->mCBlurCtrl.GetFactor();
    double doubleIndex      = GetPCTimeCtrl()->GetDoubleIndex();
    double doubleRemapped   = GetPCTimeCtrl()->GetRemappedIndexDouble();
    int    currentIndex     = GetPCTimeCtrl()->GetRemappedIndex();
    double doubleInterpStep = GetPCTimeCtrl()->GetRemappedInterpStepDouble();

    double time, dT;
    GetTimeInfo(time, dT);
    
    GLDrawData_cls::msCurrentIndex = currentIndex;
    GLDrawData_cls::msCurrentDoubleIndex = doubleIndex;
    Parameters_cls::msCurrentDoubleIndex = doubleIndex;
    Parameters_cls::msCurrentTime = time + dT;
    mpCTagObjectCtrl->mVCObject.clear();

    if (SetGLContext() == FALSE) return FALSE; 

    InitializeGLIfNot();
    
    GLAttribute_cls::EnableShader
	(mpCParentFrameLink->mpCPreference->mCUseShader.mBody == 1);

    GetPCActiveFileSequence()->RefreshGLAttribTex();

    mspCStereogramLink->DrawFunctionOnScreen
	(this, &MainGLCanvas_cls::ClearCanvas);
        
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
    
    if (mCDisplayMode.mBody == _GL_CANVAS_COPY_OF_VIEW_0){
	mCCameraPos = mpCParentFrameLink->GetPCGLCanvas(0)->mCCameraPos;
	mCCameraPosFree = mpCParentFrameLink->GetPCGLCanvas(0)->mCCameraPosFree;
    }

    SetPerspective(&mCCameraPos);
    float min, max;
    mCGLCameraProperty.GetMinAndMax(min, max, time+dT, doubleIndex);

    mCGLPerspDraw.mDepthMIN = min;
    mCGLPerspDraw.mDepthMAX = max;
        
    // J
    GetPLinkedCameraPath()->UpdateCurrentObj(doubleIndex);
    GetPLinkedAnchorPath()->UpdateCurrentObj(doubleIndex);
    UpdateCameraPos();

    mspCFilterCtrlBooleanLink->UpdateInterpolatedValue(doubleIndex);
    mspCFilterCtrlWorldLink->UpdateInterpolatedValue(doubleIndex);
    mspCFilterCtrlObjectLink->UpdateInterpolatedValue(doubleIndex);
    GetPLinkLightSourceCtrl()->UpdateCurrentObj(doubleIndex);

    PrepareBaseObjectSettings();

    mpCNavigators->MakeImage(mCCameraPos);
    PDataSequence_cls *pCPDataSeq = 
	GetPCActiveFileSequence();
    FilterDataBoxData_cls *pCScene = 
	(FilterDataBoxData_cls*)mspCFilterCtrlWorldLink->GetPCDataBox(); 
    for (int i = 0; i < _MAX_PARTICLE_TYPE; i++){
	pCPDataSeq->mpCGLAttribute[i]->UpdateBillboardTexture(mCCameraPos, GetPLinkLightSourceCtrl(), doubleIndex, pCScene);
    }

    mPrevFrame = mDrawingFrame;
    mPrevStep  = mDrawingStep;
    mPrevBlurFactor = mDrawingBlurFactor;
    
    SetAngleIfLinked();
    
    UpdateDrawInfo(mPanelWidth, mPanelHeight);
    int InfoDiff = mCDrawInfo.GetDifference(mCDrawInfoPrev);

    bool bUseFBO = (mpCParentFrameLink->mpCPreference->mCUseFBO.mBody != _PREF_NO_FBO);
    
    if (FALSE || mbExportDataQueue == TRUE){
	ShowPreviousFramePBO();
    }
    else{
	if (GetPCTimeCtrl()->mCBlurCtrl.IsInitBluring() == TRUE) 
	    mspCStereogramLink->ClearFBO();
	
	for (int stereo = 0; stereo < mspCStereogramLink->GetStereoNum(); stereo++){
	    mspCStereogramLink->mBufferSize = GetFBOBufferSize(1);
	    mspCStereogramLink->PrepareStereogram(stereo);
	    
	    if (bUseFBO == TRUE)
		FBODraw(doubleIndex, doubleRemapped, stereo); 
	    else{
		DirectDraw(doubleIndex, doubleRemapped); 
		CheckWarnigForDirectDraw();
		stereo = mspCStereogramLink->GetStereoNum();
	    }
	}
	
	if (bUseFBO == TRUE){
	    glPushAttrib(GL_ALL_ATTRIB_BITS);

	    if (msCRenderType.mBody == _TYPE_RGBA){
		glEnable(GL_BLEND);
		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	    }
	    else
		glDisable(GL_BLEND);
		
	    mspCStereogramLink->mbFitFishEye = 
		(IsFishEye() == TRUE) ? TRUE : FALSE;
	    mspCStereogramLink->DrawOnScreen2D(mCbDistortion.mbBody, this);
	    glPopAttrib();
	}
    }
    return TRUE;
}

void MainGLCanvas_cls::
DrawOverLay(){

    PDataSequence_cls *pCPDataSeq = GetPCActiveFileSequence();
    double time, dT;
    GetTimeInfo(time, dT);
    
    ColorCurve_cls *pAClrCurve[4];
    for (int i = 0; i < 4; i++){
	if (pCPDataSeq->mpCGLAttribute[i]->mCDrawType.mBody == _GL_DRAW_SPHERE)
	    pAClrCurve[i] = pCPDataSeq->mpCGLAttribute[i]->mpCClrCurveMat[0];
	else
	    pAClrCurve[i] = pCPDataSeq->mpCGLAttribute[i]->mpCClrCurveCol;
    };

    if (mbSaveImageQueue == TRUE){
	if ( mspCImgSeqLinked != NULL)
	    mCGLPerspDraw.SetClipSize(mspCImgSeqLinked->mClipWidth, 
					mspCImgSeqLinked->mClipHeight);
	
	if (mpCFBOForOverlay == NULL){
	    mpCFBOForOverlay = new FBO_cls(mCGLPerspDraw.mClipWidth,
					   mCGLPerspDraw.mClipHeight);
	    mpCFBOForOverlay->SetDepth(8);
	}
	else
	    mpCFBOForOverlay->SetGeometryBuffer(mCGLPerspDraw.mClipWidth,
						mCGLPerspDraw.mClipHeight);
	    
	mpCFBOForOverlay->MakeFBO(_FBO_USE_RGBA);
	mpCFBOForOverlay->Begin(TRUE);
	mspCDrawTimeIndex->DrawTimeInfo(time + dT, 
					mCGLPerspDraw.mClipWidth,
					mCGLPerspDraw.mClipHeight);
	mspCDrawClrLegend->DrawClrLegend(pAClrCurve, 
					 mCGLPerspDraw.mClipWidth, 
					 mCGLPerspDraw.mClipHeight);
	mpCFBOForOverlay->End();
    }
    
    mspCDrawTimeIndex->DrawTimeInfo(time + dT, mPanelWidth, mPanelHeight);
    mspCDrawClrLegend->DrawClrLegend(pAClrCurve, mPanelWidth, mPanelHeight);
}

void MainGLCanvas_cls::
ProcessImageSave(){
    if (mbSaveImageQueue == TRUE){
	if (GetPCTimeCtrl()->mCBlurCtrl.IsOutputConditionOK() == TRUE){
	    if (IsStereoDualOutput() == FALSE){
		mspCStereogramLink->CombineStereoBuffer();
		if (mspCStereogramLink->mCType.mBody == _STEREO_NONE)
		    ProcReadImage(0, mpCFBOForOverlay, _STEREO_NONE);
		else
		    ProcReadImage(0, mpCFBOForOverlay, mspCStereogramLink->mCEye.mBody);
	    }
	    else{
		ProcReadImage(0, mpCFBOForOverlay, _STEREO_LFT);
		ProcReadImage(1, mpCFBOForOverlay, _STEREO_RGT);
	    }
	}
    }
}

void MainGLCanvas_cls::
DrawNavigatorAndButtons(){
    if (mCbShowNavigator.mbBody == FALSE) return;
    mCGLPerspDraw.SetWindowSize(mPanelWidth, mPanelHeight);
    SetViewport();

    glDisable(GL_LIGHTING);
    glDisable(GL_BLEND);
    
    mpCNavigators->Show(mPanelWidth, mPanelHeight);
    if (GpCurrentGLPanel == this)
	mpCNavigators->DrawButton(mPanelWidth, mPanelHeight);

    if (msCHittest.mbHitTest == FALSE)
	msCHittest.mpCFBO->DrawOnScreen2D
	    (mPanelWidth, mPanelHeight, 64, 64, 96, 16);
}

void MainGLCanvas_cls::
PrepareDrawOrPovOut(){
    LuaBase_cls::SetPositionLink(&mCCameraPos, wxT("camera"));
    LuaBase_cls::SetPositionLink(&mpCParentFrameLink->mpCParent->mpCCameraPath->mCCurrentObj, wxT("camerapath"));
    LuaBase_cls::SetPositionLink(&msCAnchorPosWithDummyDirection, wxT("anchor"));
    LuaBase_cls::SetPositionLink(&mpCParentFrameLink->mpCParent->mpCAnchorPath->mCCurrentObj, wxT("anchorpath"));
    //LuaBase_cls::SetSnapshotLink(GLDrawData_cls::mspCSnapShot);
}

void MainGLCanvas_cls::
PrepareDrawOrPovOutStatic(){
    // [v[ŎgϐȂǂy鏈΂
    GLAttribute_cls::msBlendType = mspCParentFrameLink->mpCPreference->mCBlendType.mBody;
    mspCFilterCtrlWorldLink->OpenLua();
    mspCFilterCtrlObjectLink->OpenLua();
    mspCFilterCtrlBooleanLink->OpenLua();
    mspCDrawOptionLink->OpenLua();
}

void MainGLCanvas_cls::
EndDrawOrPovOut(){
    // `I鏈΂
    mspCFilterCtrlBooleanLink->CloseLua();
    mspCFilterCtrlObjectLink->CloseLua();
    mspCFilterCtrlWorldLink->CloseLua();
    mspCDrawOptionLink->CloseLua();
}

void MainGLCanvas_cls::
PaintDirectly(wxPaintDC &dc){
    if (DrawWarning(dc) == FALSE) return;

    GbGLLockDrawing = TRUE;
    mCStopWatchSnap.Start();

    // ʃTCY֌W
    mPanelSize = GetClientSize();
    mPanelWidth = mPanelSize.GetWidth();
    mPanelHeight = mPanelSize.GetHeight();

    mspCStereogramLink->SetInfo(mPanelWidth, mPanelHeight, TRUE);
    mpCGLString2DDirect->SetWindowGeometry(mPanelWidth, mPanelHeight);
    if (mspCImgSeqLinked != NULL)
	mspCImgSeqLinked->SetGeom(mPanelWidth, mPanelHeight, mCGLPerspDraw.mDeg);

    WaitPrepaing();
    GLDrawPrepareParticleSnap();
    PrepareDrawOrPovOut();

    if (GLDrawMain() == TRUE){
	mspCStereogramLink->DrawFunctionOnScreen(this, &MainGLCanvas_cls::DrawOverLay);
	//DrawOverLay();
	ProcessImageSave();
	mspCStereogramLink->DrawFunctionOnScreen(this, &MainGLCanvas_cls::DrawNavigatorAndButtons);
	mspCStereogramLink->DrawFunctionOnScreen(this, &MainGLCanvas_cls::DrawMessage);
	mstrWarning.Clear();
	
	if (GetPCTimeCtrl()->mCBlurCtrl.IsLastBluring() == TRUE){
	    if (mbExportDataQueue != TRUE) {
		SwapBuffers(); 
	    }
	    mspCStereogramLink->ClearFBO();
	}
    }
    
    if (GpCurrentGLPanel == this){
	SendMenuEvent(mpCParentFrameLink, menuEditRefreshCamConf);
	SendMenuEvent(mpCParentFrameLink, menuEditRefreshLight);
	SendMenuEvent(mpCParentFrameLink, menuEditRefreshStereo);
    }

    if (mbRefreshQueue == TRUE &&
	mpCParentFrameLink->mpCParent->mpCTime->mbPlayTex == FALSE){
	mbRefreshQueue = FALSE;
	
	if (mCStopWatchSnap.Time() < 1000)
	    SendMenuEvent(mpCParentFrameLink, menuEditRefreshGL);
    }

    mCStopWatchSnap.Pause();
}

void MainGLCanvas_cls::
OnPaint(wxPaintEvent &event){

    if (IsDrawingConditionSatisfied() == FALSE) return;
    
    wxPaintDC dc(this); 

    UpdateStatusBar_cls::BeginProgress();
    UpdateStatusBar_cls::ClearAbort();

    PrepareDrawOrPovOutStatic();
    PaintDirectly(dc);
    EndDrawOrPovOut();

    if (mbExportDataQueue == TRUE)
	GetPCActiveFileSequence()->ExportData
	    (mpCParentFrameLink->mpCParent->mpCDataExporter, 
	     GetPCTimeCtrl()->GetRemappedIndex(),
	     mspCDrawOptionLink->mCDownSize.mBody);

    if (mbExportPovStringQueue == TRUE)
	mpCParentFrameLink->mpCParent->ExportPovAnim(0); //stereo

    FinishPaint(event);
}

void MainGLCanvas_cls::
FinishPaint(wxPaintEvent& event){
    GRefreshQueueCounter = 0;
    GbGLLockDrawing = FALSE;
    GbGLLockPlayWait = FALSE;
    GDrawingPercentage = -1;
    mpCParentFrameLink->UpdateStatusText();
    event.Skip();
}

void MainGLCanvas_cls::
ProcReadImage(int fbo, FBO_cls *pCFBOOverlay, 
	      int stereo){
    glReadBuffer( GL_BACK );

    // FBOۑ
    if (mbSaveImgSeqQueue == TRUE && mspCImgSeqLinked != NULL)
	return ProcReadImageSequence(fbo, pCFBOOverlay, stereo);
	
    // GLʂۑ
    mbSaveImageQueue = FALSE;
    if (GCImgIO.SelectFile
	(mpCParentFrameLink->mCLastOpenedFileOUT.mstrBody, 
	 mpCParentFrameLink) == TRUE){
	mpCParentFrameLink->mCLastOpenedFileOUT.mstrBody = GCImgIO.mstrFile;
	// !! FIX_ME !! XeIooɕۑꍇ́H
	if (IsStereo() == TRUE)
	    GCImgIO.SaveImageFromGL(mPanelWidth, mPanelHeight); 
	else
	    GCImgIO.SaveImageFromGL(mPanelWidth, mPanelHeight);
    }
}

// @in plwidthheight
void MainGLCanvas_cls::
ProcReadImageSequence(int fbo,FBO_cls *pCFBOOverlay, int stereo){
    int currentFrame = mDrawingFrame;
    int offset = GetPCTimeCtrl()->GetOffsetForImgSeq();
    
    bool bSideBySide = mspCStereogramLink->IsSideBySideForOverlayRequired();

    FBO_cls *pCFBO = mspCStereogramLink->mpCFBO[fbo];
    //FBO_cls *pCFBO = mspCFishEyeCtrl->mpCFBOParts[0];
    if (pCFBO != NULL)
	mspCImgSeqLinked->SaveImageFromFBO
	    (&GCImgIO, pCFBO, pCFBOOverlay, msCRenderType.mBody,
	     mPanelWidth, mPanelHeight, offset, stereo, bSideBySide);
    
    if (mspCImgSeqLinked->mbSnapMode == TRUE){
	mspCImgSeqLinked->mbSnapMode = FALSE;
	SendMenuEvent(mpCParentFrameLink, menuPlayStop);
    }
    
    // s̃[`ɗv
    if (mpCParentFrameLink->mpCPreference->mCUseFBO.mBody == FALSE){ 
	mstrWarning << wxT("Direct Display Mode does not support sequential image saving.") << ENDL;
	mbSaveImgSeqQueue = FALSE;
	mbSaveImageQueue = FALSE;
	mspCImgSeqLinked->mpCGUI->AbortRender();
    }
}

void MainGLCanvas_cls::
StartSaveImgSeqProcess(ImgSequence_cls* pCImgSeq){
    mspCImgSeqLinked = pCImgSeq;
    mbSaveImageQueue = TRUE;
    mbSaveImgSeqQueue = TRUE;
    if (mspCImgSeqLinked != NULL)
	mspCImgSeqLinked->mCurrentOffset = 0;
    //mspCStereogramLink->ClearFBO();
}

void MainGLCanvas_cls::
StopSaveImgSeqProcess(){
    mbSaveImageQueue = FALSE;
    mbSaveImgSeqQueue = FALSE;
    if (mspCImgSeqLinked != NULL)
	mspCImgSeqLinked->OutputFinish();
}

void MainGLCanvas_cls::
StartExportDataProcess(DataExporter_cls* pCDataExporter){
    mpCDataExporterLinked = pCDataExporter;
    mbExportDataQueue = TRUE;
    if (mpCDataExporterLinked != NULL){
	mpCDataExporterLinked->mCurrentOffset = 0;
	mpCDataExporterLinked->mCurrentIndex = -1;
    }
}

void MainGLCanvas_cls::
StopExportDataProcess(){
    mbExportDataQueue = FALSE;
    if (mpCDataExporterLinked != NULL)
	mpCDataExporterLinked->ExportFinish();
}

void MainGLCanvas_cls::
StartExportPovStringProcess(){
    mbExportPovStringQueue = TRUE;
}

void MainGLCanvas_cls::
StopExportPovStringProcess(){
    mbExportPovStringQueue = FALSE;
    GetPCPovRayCtrlLinked()->AbortExportPovAnim();
}

void MainGLCanvas_cls::
ModifyOrthoCamera(){
    LOOP_XYZ
	mCCameraPosOrtho.mPos[xyz] = msCAnchorPosOrtho.mPos[xyz];
    float orthoScale = mCGLCameraProperty.mCGLOrthoScale.mBody;
    switch (mCDisplayMode.mBody){
    case _GL_CANVAS_DISPLAY_X_PLUS:
	mCCameraPosOrtho.mPos[X] -= orthoScale; break;
    case _GL_CANVAS_DISPLAY_X_MINUS:
	mCCameraPosOrtho.mPos[X] += orthoScale; break;
    case _GL_CANVAS_DISPLAY_Y_PLUS:
	mCCameraPosOrtho.mPos[Y] -= orthoScale; break;
    case _GL_CANVAS_DISPLAY_Y_MINUS:
	mCCameraPosOrtho.mPos[Y] += orthoScale;	break;
    case _GL_CANVAS_DISPLAY_Z_PLUS:
	mCCameraPosOrtho.mPos[Z] -= orthoScale; break;
    case _GL_CANVAS_DISPLAY_Z_MINUS:
	mCCameraPosOrtho.mPos[Z] += orthoScale;	break;
    }
    mCCameraPosOrtho.SetAncPos(msCAnchorPosOrtho.mPos);
    mCCameraPosOrtho.SetDirection(mCDisplayMode.mBody);
}

double MainGLCanvas_cls::
CalcAutoScale(){
    double scale = MyVector::GetNormRelative(mCCameraPos.mPos,
					     msCAnchorPos.mPos);
    return scale;
}

void MainGLCanvas_cls::
OpenExpressionDialog(){
    wxString strMessage;
    strMessage << wxT("-----") << _("Predefined Variables") << ENDL;
    strMessage << wxT("t = time") << ENDL;
    strMessage << wxT("nt = normalized time") << ENDL;
    strMessage << wxT("min, max") << ENDL;
    strMessage << wxT("-----") << _("Return Value") << ENDL;
    strMessage << wxT("min, max") << ENDL;

    TextEntryDialogEX_cls CDlg(this, strMessage, _("Expression Editor"), mCGLCameraProperty.mCstrGLDepthExpression.mstrBody);

    if (CDlg.ShowModal() == wxID_OK){
	wxString strEdit = CDlg.GetValue().Trim(TRUE);
	int updateBit = _COMMAND_UPDATE_DISPLAY_GL;
	GCUndoList.PushNewCommand
	    (new CommandSetValue_cls(&mCGLCameraProperty.mCstrGLDepthExpression.mstrBody, strEdit, updateBit), 
	     new CommandSetValue_cls(&mCGLCameraProperty.mCstrGLDepthExpression.mstrBody, mCGLCameraProperty.mCstrGLDepthExpression.mstrBody, updateBit));
	GCUndoList.ExecCurrent();
    }
}

void MainGLCanvas_cls::
ShowMenu(int x, int y){
    //--- SetSubWindows;

    // Status bar ̂ helpString͕\Ȃ̂ŏȗ
    // CENbNj[
    wxMenu *pCPopupMenu = new wxMenu; 
    Shortcut_cls *pCSC = mpCParentFrameLink->mpCShortcut;
    
    pCPopupMenu->Append(GLMenuMoveToCamPos, _("Move to Cam Pos"));
    pCPopupMenu->Append
	(GLMenuSetKeyPos   , 
	 wxString::Format(wxT("%s %s"), _("Sey Key Cam Pos"), wxT("(Pos)")));
    pCPopupMenu->Append
	(GLMenuSetKeyPosRot,
	 wxString::Format(wxT("%s %s"), _("Sey Key Cam Pos"), wxT("(Pos+Rot)")));
    pCPopupMenu->Append(GLMenuSetKeyAnc   , _("Sey Key Anc Pos"));
    pCPopupMenu->Append(GLMenuToggleLink  , _("Link/Unlink to Cam"));
    pCPopupMenu->Append(GLMenuToggleLink2, _("Unlink but view remains here"));
    pCPopupMenu->AppendSeparator();
    pCSC->SetMenuItem(pCPopupMenu, GLMenuCenterOrigin);
    pCSC->SetMenuItem(pCPopupMenu, GLMenuCenterItem);
    pCPopupMenu->AppendSeparator();
    pCSC->SetMenuItem(pCPopupMenu, GLMenuTogglePerspective);

#ifdef WIN32
    PopupMenu(pCPopupMenu, x, y);
#else
    PopupMenu(pCPopupMenu);
#endif
    delete pCPopupMenu;

    if (HasCapture() == TRUE) ReleaseMouse();
    return;
}

bool MainGLCanvas_cls::
SetThisToBeActiveGL(){
    if (mpCParentFrameLink->mpCActiveGLCanvasLink != this) {
	mpCParentFrameLink->mpCActiveGLCanvasLink->Refresh(FALSE); 
	mpCParentFrameLink->mpCActiveGLCanvasLink = this;
	return TRUE;
    }
    return FALSE;
}

bool MainGLCanvas_cls::
SetOtherCanvasToBeActiveGL(){
    for (unsigned int i = 0; i < mVPOtherCanvas.size(); i++){
	if (mVPOtherCanvas[i]->IsMouseOnClient() == TRUE){
	    mVPOtherCanvas[i]->SetThisToBeActiveGL();
	    mVPOtherCanvas[i]->SetFocus();
	    mVPOtherCanvas[i]->Refresh(FALSE);
	    return TRUE;
	}
    }
    return FALSE;
}

void MainGLCanvas_cls::
OnKeyDown(wxKeyEvent& event){

    wxWindow *pCTopLevel = wxGetTopLevelParent(this);
    
    if (mSelfIndex == 4)
	pCTopLevel = pCTopLevel->GetParent();
    
    event.SetId(pCTopLevel->GetId());
    pCTopLevel->AddPendingEvent(event);
}

void MainGLCanvas_cls::
InitializeStaticMembers(Overlay_cls *pCOverlayLink){

    mspCDrawOptionLink = mspCParentFrameLink->mpCParent->mpCDrawOption;

    mspCClrCurveBG    = new ColorCurve_cls(wxT("BGColor"), wxT(""), 
					   wxT("0 0 0 0"));
    mspCClrCurveOut   = new ColorCurve_cls(wxT("OutColor"), wxT(""), 
					   wxT("0 0 0 0"));

    TagObjectCtrl_cls::InitializeStaticMembers();
    
    msCConfListStatic.Add(&msCFBOSizeIndex, wxT("FBOBufferSize="), wxT("3"));
    msCConfListStatic.Add(&msCFBOSizeFishEye, wxT("FBOBufferFishEye="), wxT("1"));
    msCConfListStatic.Add(&msCLineWidth, wxT("LineWidth="), wxT("5"));
    msCConfListStatic.Add(&msCRenderType, wxT("GLRenderType="), wxT("0"));
    
    mspCDrawTimeIndex = new DrawTimeIndex_cls(pCOverlayLink);
    mspCDrawClrLegend = new DrawClrLegend_cls(pCOverlayLink);
    mspCFishEyeCtrl   = new FishEye_cls();

    mspCGLGuide      = new GLGuides_cls();
    mspCGLGuideScale = new GLGuides_cls(_GUIDES_SCALE);
    mspCGLGuideYPR   = new GLGuides_cls(_GUIDES_ROTATE);
    
    SceneObj_cls::mspCGLGuideLink      = mspCGLGuide;
    SceneObj_cls::mspCGLGuideYPRLink   = mspCGLGuideYPR;
    SceneObj_cls::mspCGLGuideScaleLink = mspCGLGuideScale;

    mspCDistortion = new Distortion_cls;
    mspCDistortion->ReadWavefrontObject(wxT("Resource/distortion.obj"));

    GpCSphere = new Sphere_cls;
    GpCCube = new Cube_cls;
}

void MainGLCanvas_cls::
DestructStaticMembers(){
    delete mspCClrCurveBG;
    delete mspCClrCurveOut;
    delete TagObjectCtrl_cls::mspCClrCurveTag;
    delete mspCDrawTimeIndex;
    delete mspCDrawClrLegend;
    delete mspCFishEyeCtrl;
    delete mspCGLGuide;
    delete mspCGLGuideScale;
    delete mspCGLGuideYPR;

    delete GpCSphere;
    delete GpCCube;
}

bool MainGLCanvas_cls::
IsGLBlendEquationEXOK(){
    return (glBlendEquationEXT != NULL);
}

void MainGLCanvas_cls::
TogglePerspective(){
    if (mCGLGeometry.mBody == _GEOM_PERSPECTIVE)
	mCGLGeometry.mBody = _GEOM_ORTHOGRAPHIC;
    else
	mCGLGeometry.mBody = _GEOM_PERSPECTIVE;
    Refresh(FALSE);
}

void MainGLCanvas_cls::
SetDisplayMode(int displayMode, bool bUpdateCombobox){
    mCDisplayMode.mBody = displayMode;

    if (mCGLGeometry.mBody == _GEOM_ORTHOGRAPHIC ||
	mCGLGeometry.mBody == _GEOM_PERSPECTIVE){ 
	if (IsAlongAxis() == TRUE)
	    mCGLGeometry.mBody = _GEOM_ORTHOGRAPHIC;
	else
	    mCGLGeometry.mBody = _GEOM_PERSPECTIVE;
    }
    
    mpCCameraPathLinked = NULL;
    Refresh(FALSE);
}

void MainGLCanvas_cls::
LinkageConnect(){
    SetDisplayMode(_GL_CANVAS_LINKED_CAM0);
    mpCCameraPathLinked = mpCParentFrameLink->mpCParent->mpCCameraPath;
    mpCAnchorPathLinked = mpCParentFrameLink->mpCParent->mpCAnchorPath;

    double doubleIndex = 
	GetPCTimeCtrl()->GetDoubleIndex();

    GetPLinkedCameraPath()->UpdateCurrentObj(doubleIndex);
    GetPLinkedAnchorPath()->UpdateCurrentObj(doubleIndex);

    mCCameraPosCamera = mpCCameraPathLinked->mCCurrentObj;
    mCCameraPosCamera.UpdateYPR(FALSE);
}

void MainGLCanvas_cls::
OnMenuMoveToCamPos(wxCommandEvent& WXUNUSED(event)){
    LinkageConnect();
    mpCGLCtrl->UpdateWindow();
    Refresh(FALSE);
}

void MainGLCanvas_cls::
OnMenuSetKeyPos(wxCommandEvent& event){
    SendMenuEvent(mpCParentFrameLink, menuSetKeyPos);
}

void MainGLCanvas_cls::
OnMenuSetKeyPosRot(wxCommandEvent& event){
    SendMenuEvent(mpCParentFrameLink, menuSetKeyPosRot);
}

void MainGLCanvas_cls::
OnMenuSetKeyAnc(wxCommandEvent& event){
    SendMenuEvent(mpCParentFrameLink, menuSetKeyAnc);
}

void MainGLCanvas_cls::
OnMenuToggleLink(wxCommandEvent& event){
    if (mCDisplayMode.mBody >= _GL_CANVAS_LINKED_CAM0)
	SetDisplayMode(_DIRECTION_FREE);
    else
	LinkageConnect();
    mpCGLCtrl->UpdateWindow();
    Refresh(FALSE);
}

void MainGLCanvas_cls::
OnMenuToggleLink2(wxCommandEvent& event){
    if (mCDisplayMode.mBody >= _GL_CANVAS_LINKED_CAM0){
	mCCameraPosFree = mCCameraPosCamera;
	SetDisplayMode(_DIRECTION_FREE);
    }
    
    mpCGLCtrl->UpdateWindow();
    Refresh(FALSE);
}

void MainGLCanvas_cls::
OnMenuTogglePerspective(wxCommandEvent& event){
    TogglePerspective();
}

void MainGLCanvas_cls::
OnMenuCenterItem(wxCommandEvent& event){
    SetPivotToItem(0);
    Refresh();
}

void MainGLCanvas_cls::
OnMenuCenterOrigin(wxCommandEvent& event){
    SetPivotToItem(-1);
    Refresh();
}

void MainGLCanvas_cls::
CopySettingToAll(){
}

void MainGLCanvas_cls::
SetGLBGColor(int index){

    if (index == 0)
	glClearColor(mspCClrCurveBG->mCConstantColor.mpBody[R],
		     mspCClrCurveBG->mCConstantColor.mpBody[G],
		     mspCClrCurveBG->mCConstantColor.mpBody[B], 0.0f);
    if (index == 1)
	glClearColor(mspCClrCurveOut->mCConstantColor.mpBody[R],
		     mspCClrCurveOut->mCConstantColor.mpBody[G],
		     mspCClrCurveOut->mCConstantColor.mpBody[B], 1.0f);
}

void MainGLCanvas_cls::
SelectItem(Parameters_cls *pCParam){
}

// ----

void MainGLCanvas_cls::
ReadStrLine(std::wistream &istream, wxString strLine){
    if (mCConfList.ReadStrLineAllWithTag(istream, strLine) == TRUE) return;
    if (mCGLCameraProperty.ReadStrLine(istream, strLine) == TRUE) return;
}

void MainGLCanvas_cls::
ReadStrLineStaticMember(std::wistream &istream, wxString strLine){
    msCConfListStatic.ReadStrLineAll(strLine);
    mspCClrCurveBG->ReadStrLine(istream, strLine);
    mspCClrCurveOut->ReadStrLine(istream, strLine);
    TagObjectCtrl_cls::ReadStrLineStaticMember(istream, strLine);
}

wxString MainGLCanvas_cls::
Serialize(){
    wxString strOut;
    mCGLCameraProperty.Serialize(strOut);
    mCConfList.SerializeAllWithTag(strOut);
    return strOut;
}

wxString MainGLCanvas_cls::
SerializeStaticMember(){
    return 
	msCConfListStatic.SerializeAll() + 
	mspCClrCurveBG->Serialize() + 
	mspCClrCurveOut->Serialize() +
	TagObjectCtrl_cls::SerializeStaticMember();
}

// ----------------------------------------------

ColorCurve_cls* MainGLCanvas_cls::mspCClrCurveBG = NULL;
ColorCurve_cls* MainGLCanvas_cls::mspCClrCurveOut = NULL;
DrawTimeIndex_cls* MainGLCanvas_cls::mspCDrawTimeIndex = NULL;
DrawClrLegend_cls* MainGLCanvas_cls::mspCDrawClrLegend = NULL;
FishEye_cls* MainGLCanvas_cls::mspCFishEyeCtrl = NULL;
Position_cls MainGLCanvas_cls::msCAnchorPos(0, 0, 0);
Position_cls MainGLCanvas_cls::msCAnchorPosOrtho(0, 0, 0);
PositionAndDirection_cls MainGLCanvas_cls::msCAnchorPosWithDummyDirection;
FilterCtrl_cls* MainGLCanvas_cls::mspCFilterCtrlBooleanLink = NULL;
FilterCtrl_cls* MainGLCanvas_cls::mspCFilterCtrlObjectLink  = NULL;
FilterCtrl_cls* MainGLCanvas_cls::mspCFilterCtrlWorldLink   = NULL;
DF3SeqCtrl_cls* MainGLCanvas_cls::mspCDF3SeqCtrl = NULL;
PeriodicBoundary_cls* MainGLCanvas_cls::mspCPeriodicLink = NULL;
StereoGram_cls* MainGLCanvas_cls::mspCStereogramLink = NULL;
int MainGLCanvas_cls::msAFBOSize[7] = {256, 512, 1024, 2048, 4096, 8192, 16384};
ConfItemList_cls MainGLCanvas_cls::msCConfListStatic;
ConfItemUINT_cls   MainGLCanvas_cls::msCFBOSizeIndex;
ConfItemUINT_cls   MainGLCanvas_cls::msCFBOSizeFishEye;
ConfItemFLOAT_cls  MainGLCanvas_cls::msCLineWidth;
ConfItemUINT_cls   MainGLCanvas_cls::msCRenderType;
int MainGLCanvas_cls::msGLLightIndex[8] = {
    GL_LIGHT0, GL_LIGHT1, GL_LIGHT2, GL_LIGHT3, 
    GL_LIGHT4, GL_LIGHT5, GL_LIGHT6, GL_LIGHT7
};

bool MainGLCanvas_cls::msbGLUTInitialized = FALSE;

HitTest_cls  MainGLCanvas_cls::msCHittest;

GLGuides_cls* MainGLCanvas_cls::mspCGLGuide      = NULL;
GLGuides_cls* MainGLCanvas_cls::mspCGLGuideScale = NULL;
GLGuides_cls* MainGLCanvas_cls::mspCGLGuideYPR   = NULL;
Distortion_cls* MainGLCanvas_cls::mspCDistortion = NULL;
GLTexture_cls*  MainGLCanvas_cls::mspCWhite       = NULL;
GLTexture_cls*  MainGLCanvas_cls::mspCMask        = NULL;
GLTexture_cls*  MainGLCanvas_cls::mspCFisheyeGrid = NULL;
GLTexture_cls*  MainGLCanvas_cls::mspCCheckerboard = NULL;

ImgSequence_cls* MainGLCanvas_cls::mspCImgSeqLinked = NULL;
DrawOption_cls*  MainGLCanvas_cls::mspCDrawOptionLink = NULL;
FrameMain_cls*   MainGLCanvas_cls::mspCParentFrameLink = NULL;
