
#include "clsDolly.h"
#include "clsMoveItem.h"
#include "clsMainGLCanvas.h"
#include "NAVIGATORS/clsNavigators.h"

#include "../MYGL/clsGLGuides.h"
#include "../SCENEOBJ/clsCameraPathGUI.h"
#include "../SCENEOBJ/clsSceneObj.h"
#include "../UNDO/clsUndoManager.h"
extern UndoManager_cls GCUndoList;
#include "../WIDGETCTRL/clsMultiInputPanel.h"

#include "../../wxWidgetEnumMenu.h"

extern MainGLCanvas_cls* GpCurrentGLPanel;

#include "../../clsFrameMain.h"

bool MainGLCanvas_cls::
ProcViewOrItemDragging(bool bOnInnertia){
    bool trigRefresh = FALSE;

    MouseNormalized_cls CMP(mpCMouseCtrl, mPanelSize);
    CMP.LimitMove();

    UpdateAnc();

    double sensitivity = 
	(mCDisplayMode.mBody == _GL_CANVAS_DISPLAY_FREE || 
	 mCDisplayMode.mBody >= _GL_CANVAS_LINKED_CAM0) ? 1 : 0.5;
    sensitivity = 1;

    mpCDolly->SetParameter(sensitivity, &CMP, mPanelSize, mCDisplayMode.mBody);
    mpCMoveItem->SetParameter(sensitivity, &CMP, mPanelSize, mCDisplayMode.mBody);

    if (bOnInnertia == TRUE){
	MouseNormalized_cls CMPInnertia(mpCMouseInfoInnertia, mPanelSize);
	mpCDolly->SetParameter(sensitivity, &CMPInnertia, mPanelSize, mCDisplayMode.mBody);
	if (IsAlongAxis() == TRUE)
	    trigRefresh |= mpCDolly->MoveCenter(GetPCCameraPosition(),
						GetPCAnchorPosition());
	else
	    trigRefresh |= mpCDolly->Gyration  (GetPCCameraPosition());
    }

    if (mpCMouseCtrl->IsInnertia()){
	mbInnertia = TRUE;
	*mpCMouseInfoInnertia = *mpCMouseCtrl;
    }
    if (mpCMouseCtrl->IsGyration()){
	mbInnertia = FALSE;
    }

    if (mpCMouseCtrl->IsGyration() || mpCMouseCtrl->IsInnertia()){
	if (IsAlongAxis() == TRUE)
	    trigRefresh |= mpCDolly->MoveCenter(GetPCCameraPosition(),
						GetPCAnchorPosition());
	else
	    trigRefresh |= mpCDolly->Gyration  (GetPCCameraPosition());
    }

    if (mpCMouseCtrl->IsZoom())
	trigRefresh |= mpCDolly->Zoom      (GetPCCameraPosition(), 
					    &mCGLCameraProperty.mCGLOrthoScale.mBody);
    if (mpCMouseCtrl->IsMoveCenter())
	trigRefresh |= mpCDolly->MoveCenter(GetPCCameraPosition(),
					    GetPCAnchorPosition());

    if (mpCMouseCtrl->IsMoveItem()){
	trigRefresh |= mpCMoveItem->MoveItem(GetPCCameraPosition(),
					     GetClientSize(),
					     mpCNavigators->msManipulatorMode,
					     mpCNavigators->msDragMode, 
					     mspCGLGuideYPR->mbDirectionInv);
    }

    mpCMouseCtrl->SetPreviousPosition();
    
    return trigRefresh;
}

void MainGLCanvas_cls::
ProcItemDraggingEnd(){
    mpCMoveItem->FinishDragging();
    GCUndoList.OpenBlock();
    MoveItem_cls::mspCSelectedObject->mpCTranslate->SetKeyFrameIfChanged();
    MoveItem_cls::mspCSelectedObject->mpCRotation ->SetKeyFrameIfChanged();
    MoveItem_cls::mspCSelectedObject->mpCScale    ->SetKeyFrameIfChanged();
    MoveItem_cls::mspCSelectedObject->Targetting();
    //MoveItem_cls::mspCSelectedObject->mDragMode = -1;
    //MoveItem_cls::mspCSelectedObject->mbDragging = FALSE;
    GCUndoList.CloseBlock();
    mbRefreshQueue = TRUE;
}

bool MainGLCanvas_cls::
ProcCaptureMouse(){
    bool trigRefresh = FALSE;
    
    CaptureMouse();
    
    for (unsigned int i = 0; i < mVPOtherCanvas.size(); i++)
	if (mVPOtherCanvas[i]->HasCapture() == TRUE)
	    mVPOtherCanvas[i]->ReleaseMouse();
    
    trigRefresh |= SetThisToBeActiveGL();

    return trigRefresh;
}

void MainGLCanvas_cls::
OnMouse(wxMouseEvent& event){
    bool trigRefresh = FALSE;
    static bool sbLockDragging = FALSE; // GL{^DragȂ

    if (mpCMouseCtrl == NULL) return;

    mpCMouseCtrl->SetMouseInformation(event);

    // j[
    if (mpCMouseCtrl->IsShowMenu() == TRUE){
	ShowMenu(mpCMouseCtrl->mMouseX, mpCMouseCtrl->mMouseY);
	event.Skip();
	return; }

    // ʏ̃{^
    if (mCbShowNavigator.mbBody == TRUE &&
	mpCMouseCtrl->IsButton(_MOUSE_BTN_LEFT) == TRUE &&
	mpCNavigators->CheckGLButton
	(mPanelWidth, mPanelHeight, mpCMouseCtrl->mMouseX, mpCMouseCtrl->mMouseY) == TRUE){
	RefreshEX();
	sbLockDragging = TRUE;
	event.Skip();
	return; }

    // }EX𗣂
    if (mpCMouseCtrl->IsButtonUp() == TRUE){
	sbLockDragging = FALSE;
	if (HasCapture()) ReleaseMouse();
    }
    
    // qbgeXg
    if (mpCMouseCtrl->IsButtonDown() == TRUE){
	SetFocus();
	if (HasCapture() == FALSE){
	    trigRefresh |= ProcCaptureMouse();
	    trigRefresh = TRUE;
	    StartHitTest();
	    mpCMouseCtrl->SetPreviousPosition();
	    mpCMouseCtrl->SetGyrationMode(mPanelSize);
	}
    }

    // r[܂̓ACẽhbO
    if (mpCMouseCtrl->IsMouseDragging() == TRUE && sbLockDragging == FALSE)
	trigRefresh |= ProcViewOrItemDragging();

    // hbOI
    if (event.ButtonUp(wxMOUSE_BTN_LEFT) ||
	event.ButtonUp(wxMOUSE_BTN_MIDDLE) ||
	event.GetEventType() == wxEVT_MOUSEWHEEL) {
	if (mpCMoveItem->mbMovingItemNow == TRUE && MoveItem_cls::mspCSelectedObject != NULL){
	    ProcItemDraggingEnd();
	    SendMenuEvent(mpCParentFrameLink, menuFilterRefresh);
	}
    }

    // }EXzC[
    if (mpCMouseCtrl->IsWheel() == TRUE){
	if (IsMouseOnClient() == TRUE){
	    UpdateAnc();
	    mpCDolly->mDisplayMode = mCDisplayMode.mBody;
	    trigRefresh |= mpCDolly->ZoomWheel
		(GetPCCameraPosition(), mpCMouseCtrl->mWheelRotationNormalized,
		 &mCGLCameraProperty.mCGLOrthoScale.mBody);
	    mpCMouseCtrl->SetPreviousPosition();
	    SetThisToBeActiveGL();
	}
	else
	    trigRefresh |= SetOtherCanvasToBeActiveGL();
    }
    
    if (trigRefresh == TRUE){
	if (GpCurrentGLPanel != this){
	    GpCurrentGLPanel = this;
	    mpCParentFrameLink->ReconnectCameraPathGUI();
	    SetFocus();
	}

	RefreshEX();
	if (mpCParentFrameLink->GetPCPathCtrl()->mpCGUI != NULL)
	    mpCParentFrameLink->GetPCPathCtrl()->mpCGUI->mpCMNumView[mSelfIndex]->UpdateValues();

	if (IsAlongAxis() == TRUE){
	    RefreshOtherOrthoCanvas();
	    //Refresh(FALSE);
	}
    }
    
    event.Skip();
}

void MainGLCanvas_cls::
OnMouseMotion(wxMouseEvent& event){
    
    if (GpCurrentGLPanel == this){
	bool bRefresh = FALSE;
	int mouseX = event.GetX(), mouseY = event.GetY();
	if (mpCNavigators->UpdateStatus
	    (mPanelWidth, mPanelHeight, mouseX, mouseY) == TRUE)
	    Refresh(FALSE);
    }
    
    event.Skip();
}

void MainGLCanvas_cls::
StartHitTest(){
    // hbOp̃qbgeXg
    if (mpCMouseCtrl->IsMoveItem()) mbHitTestGuideSelect = TRUE;
	
    // ACeZNgp̃qbgeXg
    if (mpCMouseCtrl->IsHitTest()) mbHitTestItemSelect = TRUE;
}
