// -*- c -*-
// "clsMoveItem.cpp"

#ifndef _MOVE_ITEM_H_
#define _MOVE_ITEM_H_

#define _MOVE_ITEM_TRANSLATE 0
#define _MOVE_ITEM_SCALE  1
#define _MOVE_ITEM_ROTATE 2

#define _DOLLY_TRANSLATE 0
#define _DOLLY_SCALE  1
#define _DOLLY_ROTATE 2

#include "clsMouseCtrl.h"
#include "../MYGL/clsPositionAndDirection.h"

class GLGuides_cls;
class MouseNormalized_cls;
class Preference_cls;
class SceneObj_cls;

#include <wx/wx.h>

class MoveItem_cls{
public:
    MoveItem_cls(Preference_cls *pCPreferenceLink,
		 GLGuides_cls *pCGLGuideTranslateLink,
		 GLGuides_cls *pCGLGuideScaleLink,
		 GLGuides_cls *pCGLGuideYPRLink);
    
    Preference_cls *mpCPreferenceLink;
    GLGuides_cls     *mpCGLGuideTranslateLink;
    GLGuides_cls     *mpCGLGuideScaleLink;
    GLGuides_cls     *mpCGLGuideYPRLink;

    static SceneObj_cls *mspCSelectedObject;
    static double        msSelectedItemPos[3];
    static double        msSelectedItemPosOrg[3];
    static double        msSelectedItemYPROrg[3];
    static double        msSelectedItemScaleOrg[3];
    static double        msSelectedItemScale[3];
    static double        msSelectedItemDRot[3];
    static void          SetSelection(SceneObj_cls *pCObj);

    void SetParameter(double sensitivity, MouseNormalized_cls *pCMP, 
		      wxSize sz, int displayMode);

    void MoveItemTranslate(PositionAndDirection_cls *pCCamPos, 
			   double aspectRatio, double dragX, double dragY,
			   int dragMode);
    void MoveItemRotate(double dragRot,   int dragMode);
    void MoveItemScale (double dragScale, int dragMode);

    void DrawMouseGuide(int moveMode, int dragMode,
			int panelWidth, int PanelHeight,
			int bufferWidth, int bufferHeight);
    void InitializeMoveItem();
    bool MoveItem(PositionAndDirection_cls *pCCamPos,
		  wxSize sz, int moveMode, int dragMode, bool bInv);
    void FinishDragging();
    
    bool   mbMovingItemNow;
    double mSensitivity;
    double mAspectRatio;
    MouseNormalized_cls *mpCMP;
    float  mMouseX, mMouseY;
    int    mDisplayMode;

    static double mMatrixModelView[16];
    static double mMatrixProjection[16];
    static int    mMatrixViewport[4];
    void   GetGLMatrixInfo();

    static double mPosItemOnW[3];
    static double mPosItemOrgOnW[3];
};

#endif
