// -*- c -*-
// "clsRefresh.h"

#include "clsRefresh.h"

#include "../TIMELINE/clsTimeCtrl.h"

Refresh_cls::
Refresh_cls(){
    Clear();
}

void Refresh_cls::
Clear(){
    mPrevFrame       = -1;
    mPrevStep        = -1;
    mPrevBlurFactor  = -1;
}

void Refresh_cls::
SetDrawingInfo(TimeCtrl_cls *pCTimeCtrl){
    mDrawingFrame = pCTimeCtrl->mFrame;
    mDrawingStep  = pCTimeCtrl->mInterpStep;
    mDrawingBlurFactor = pCTimeCtrl->mCBlurCtrl.GetFactor();
}

void Refresh_cls::
RecordInfo(){
    mPrevFrame = mDrawingFrame;
    mPrevStep  = mDrawingStep;
    mPrevBlurFactor = mDrawingBlurFactor;
}

bool Refresh_cls::
IsFreshFrame(TimeCtrl_cls* pCTimeCtrl){
    if (mPrevFrame != pCTimeCtrl->mFrame ||
	mPrevStep  != pCTimeCtrl->mInterpStep ||
	mPrevBlurFactor != pCTimeCtrl->mCBlurCtrl.GetFactor())
	return TRUE;
    return FALSE;
}

bool Refresh_cls::
IsFreshFrame(unsigned int frame, unsigned int step){
    if (mPrevFrame != frame ||
	mPrevStep != step)
	return TRUE;
    return FALSE;
}
