// -*- c -*-
// "clsGrid.h"
// (setq c-basic-offset 4)

#include "clsCube.h"

#include "../COMMON/MyVector.h"
#include "../COMMON/CommonDefinitions.h"
#include "../COMMON/CommonDefinitionsGL.h"

#include <math.h>

#ifndef M_PI
#define M_PI 3.131593f
#endif

//bool Cube_cls::mbInitialized = FALSE;
//int  Cube_cls::mDList = -1;

Cube_cls::
Cube_cls(){
    mbInitialized = FALSE;
    mDList[0] = mDList[1] = mDList[2] = mDList[3] = -1;
    mDListNotTex = -1;
}

void Cube_cls::
DrawMainNoTex(){
    glBegin(GL_QUADS);

    glNormal3d(0, 0, 1);
    glVertex3d(-1, -1, 1);
    glVertex3d(+1, -1, 1);
    glVertex3d(+1, +1, 1);
    glVertex3d(-1, +1, 1);
    
    glNormal3d(0, 0, -1);
    glVertex3d(-1, -1, -1);
    glVertex3d(-1, +1, -1);
    glVertex3d(+1, +1, -1);
    glVertex3d(+1, -1, -1);

    glNormal3d(1, 0, 0);
    glVertex3d(1, -1, -1);
    glVertex3d(1, +1, -1);
    glVertex3d(1, +1, +1);
    glVertex3d(1, -1, +1);

    glNormal3d(-1, 0, 0);
    glVertex3d(-1, -1, -1);
    glVertex3d(-1, -1, +1);
    glVertex3d(-1, +1, +1);
    glVertex3d(-1, +1, -1);
    
    glNormal3d(0, -1, 0);
    glVertex3d(-1, -1, -1);
    glVertex3d(+1, -1, -1);
    glVertex3d(+1, -1, +1);
    glVertex3d(-1, -1, +1);

    glNormal3d(0, 1, 0);
    glVertex3d(-1, +1, -1);
    glVertex3d(-1, +1, +1);
    glVertex3d(+1, +1, +1);
    glVertex3d(+1, +1, -1);
        
    glEnd();
}

void Cube_cls::
DrawMainAlongX(){
    glBegin(GL_QUADS);

    glNormal3d(0, 0, 1);
    glTexCoord2d(0, 1);glVertex3d(-1, -1, 1);
    glTexCoord2d(0, 1);glVertex3d(+1, -1, 1);
    glTexCoord2d(1, 1);glVertex3d(+1, +1, 1);
    glTexCoord2d(1, 1);glVertex3d(-1, +1, 1);
    
    glNormal3d(0, 0, -1);
    glTexCoord2d(0, 0);glVertex3d(-1, -1, -1);
    glTexCoord2d(1, 0);glVertex3d(-1, +1, -1);
    glTexCoord2d(1, 0);glVertex3d(+1, +1, -1);
    glTexCoord2d(0, 0);glVertex3d(+1, -1, -1);

    glNormal3d(1, 0, 0);
    glTexCoord2d(0, 0);glVertex3d(1, -1, -1);
    glTexCoord2d(1, 0);glVertex3d(1, +1, -1);
    glTexCoord2d(1, 1);glVertex3d(1, +1, +1);
    glTexCoord2d(0, 1);glVertex3d(1, -1, +1);

    glNormal3d(-1, 0, 0);
    glTexCoord2d(0, 0);glVertex3d(-1, -1, -1);
    glTexCoord2d(0, 1);glVertex3d(-1, -1, +1);
    glTexCoord2d(1, 1);glVertex3d(-1, +1, +1);
    glTexCoord2d(1, 0);glVertex3d(-1, +1, -1);
    
    glNormal3d(0, -1, 0);
    glTexCoord2d(0, 0);glVertex3d(-1, -1, -1);
    glTexCoord2d(0, 0);glVertex3d(+1, -1, -1);
    glTexCoord2d(0, 1);glVertex3d(+1, -1, +1);
    glTexCoord2d(0, 1);glVertex3d(-1, -1, +1);

    glNormal3d(0, 1, 0);
    glTexCoord2d(1, 0);glVertex3d(-1, +1, -1);
    glTexCoord2d(1, 1);glVertex3d(-1, +1, +1);
    glTexCoord2d(1, 1);glVertex3d(+1, +1, +1);
    glTexCoord2d(1, 0);glVertex3d(+1, +1, -1);
    
    glEnd();
}

void Cube_cls::
DrawMainAlongY(){
    glBegin(GL_QUADS);

    glNormal3d(0, 0, 1);
    glTexCoord2d(0, 1);glVertex3d(-1, -1, 1);
    glTexCoord2d(1, 1);glVertex3d(+1, -1, 1);
    glTexCoord2d(1, 1);glVertex3d(+1, +1, 1);
    glTexCoord2d(0, 1);glVertex3d(-1, +1, 1);
    
    glNormal3d(0, 0, -1);
    glTexCoord2d(0, 0);glVertex3d(-1, -1, -1);
    glTexCoord2d(0, 0);glVertex3d(-1, +1, -1);
    glTexCoord2d(1, 0);glVertex3d(+1, +1, -1);
    glTexCoord2d(1, 0);glVertex3d(+1, -1, -1);

    glNormal3d(1, 0, 0);
    glTexCoord2d(1, 0);glVertex3d(1, -1, -1);
    glTexCoord2d(1, 0);glVertex3d(1, +1, -1);
    glTexCoord2d(1, 1);glVertex3d(1, +1, +1);
    glTexCoord2d(1, 1);glVertex3d(1, -1, +1);

    glNormal3d(-1, 0, 0);
    glTexCoord2d(0, 0);glVertex3d(-1, -1, -1);
    glTexCoord2d(0, 1);glVertex3d(-1, -1, +1);
    glTexCoord2d(0, 1);glVertex3d(-1, +1, +1);
    glTexCoord2d(0, 0);glVertex3d(-1, +1, -1);
    
    glNormal3d(0, -1, 0);
    glTexCoord2d(0, 0);glVertex3d(-1, -1, -1);
    glTexCoord2d(1, 0);glVertex3d(+1, -1, -1);
    glTexCoord2d(1, 1);glVertex3d(+1, -1, +1);
    glTexCoord2d(0, 1);glVertex3d(-1, -1, +1);

    glNormal3d(0, 1, 0);
    glTexCoord2d(0, 0);glVertex3d(-1, +1, -1);
    glTexCoord2d(0, 1);glVertex3d(-1, +1, +1);
    glTexCoord2d(1, 1);glVertex3d(+1, +1, +1);
    glTexCoord2d(1, 0);glVertex3d(+1, +1, -1);
    
    glEnd();
}

void Cube_cls::
DrawMainAlongZ(){
    glBegin(GL_QUADS);

    glNormal3d(0, 0, 1);
    glTexCoord2d(0, 0);glVertex3d(-1, -1, 1);
    glTexCoord2d(1, 0);glVertex3d(+1, -1, 1);
    glTexCoord2d(1, 1);glVertex3d(+1, +1, 1);
    glTexCoord2d(0, 1);glVertex3d(-1, +1, 1);
    
    glNormal3d(0, 0, -1);
    glTexCoord2d(0, 0);glVertex3d(-1, -1, -1);
    glTexCoord2d(0, 1);glVertex3d(-1, +1, -1);
    glTexCoord2d(1, 1);glVertex3d(+1, +1, -1);
    glTexCoord2d(1, 0);glVertex3d(+1, -1, -1);

    glNormal3d(1, 0, 0);
    glTexCoord2d(1, 0);glVertex3d(1, -1, -1);
    glTexCoord2d(1, 1);glVertex3d(1, +1, -1);
    glTexCoord2d(1, 1);glVertex3d(1, +1, +1);
    glTexCoord2d(1, 0);glVertex3d(1, -1, +1);

    glNormal3d(-1, 0, 0);
    glTexCoord2d(0, 0);glVertex3d(-1, -1, -1);
    glTexCoord2d(0, 0);glVertex3d(-1, -1, +1);
    glTexCoord2d(0, 1);glVertex3d(-1, +1, +1);
    glTexCoord2d(0, 1);glVertex3d(-1, +1, -1);
    
    glNormal3d(0, -1, 0);
    glTexCoord2d(0, 0);glVertex3d(-1, -1, -1);
    glTexCoord2d(1, 0);glVertex3d(+1, -1, -1);
    glTexCoord2d(1, 0);glVertex3d(+1, -1, +1);
    glTexCoord2d(0, 0);glVertex3d(-1, -1, +1);

    glNormal3d(0, 1, 0);
    glTexCoord2d(0, 1);glVertex3d(-1, +1, -1);
    glTexCoord2d(0, 1);glVertex3d(-1, +1, +1);
    glTexCoord2d(1, 1);glVertex3d(+1, +1, +1);
    glTexCoord2d(1, 1);glVertex3d(+1, +1, -1);
    
    glEnd();
}

int Cube_cls::
DListDraw(int GLMode, bool bUseTex, int mapType){
    int    listName = 0;
	
    if (GLMode == GL_COMPILE || GLMode == GL_COMPILE_AND_EXECUTE){
	listName = glGenLists(1); // VKXg̔ԍ
	glNewList (listName, GLMode); 
    }

    if (bUseTex == TRUE){
	switch(mapType){
	case 0: DrawMainAlongX(); break;
	case 1: DrawMainAlongY(); break;
	case 2: DrawMainAlongZ(); break;
	case 3: DrawMainAlongZ(); break;
	}
    }
    else DrawMainNoTex();

    if (GLMode == GL_COMPILE || GLMode == GL_COMPILE_AND_EXECUTE)
	glEndList(); 
    
    return listName;
}

void Cube_cls::
InitializeIfNot(){
    if (mbInitialized == TRUE) return;
    for (int i = 0; i < 4; i++){
	mDList[i] = DListDraw(GL_COMPILE, TRUE, i);
    }
    mDListNotTex = DListDraw(GL_COMPILE, FALSE, 0);
    mbInitialized = TRUE;
}

void Cube_cls::
Draw(int mapType){
    glCallList(mDList[mapType]);
}

void Cube_cls::
DrawNoTex(){
    glCallList(mDListNotTex);
}

Cube_cls *GpCCube = NULL;
