// (setq c-basic-offset 4)

#ifndef _IMG_SEQUENCE_H_
#define _IMG_SEQUENCE_H_

#include <wx/wx.h>
#include <wx/gauge.h>
#include <wx/stopwatch.h>

#include "clsImgSizeTemplate.h"

#include "../COMMON/clsFilename.h"
#include "../CONFITEM/clsConfItem.h"
#include "../MYGL/clsGLPerspective.h"
#include "../WIDGETCTRL/clsHookCtrl.h"
#include "../WIDGETCTRL/clsDialogEXKey.h"
#include "../WIDGETCTRL/clsDialogController.h"
#include "../WIDGETCTRL/EX/clsButtonEX.h"

class FBO_cls;
class GLInfo_cls;
class ImgSequence_cls;
class ImageIO_cls;
class Main_cls;
class MultiInputPanel_cls;
class TimeCtrl_cls;
class wxGauge;

class ImgSequenceGUI_cls : public wxDialogEXKey, public ImgSizeTemplate_cls, public HookItem_cls {
 public:
    ImgSequenceGUI_cls(ImgSequence_cls* pCParent,
		       wxWindow *pC, wxPoint pos, wxSize size);
    
    ImgSequence_cls* mpCParent;

    int mIndexBlur;
    int mIndexTile;

    void OnButtonInitSeq(wxCommandEvent& event);
    void OnButtonReference(wxCommandEvent &event);
    void OnButtonRender(wxCommandEvent &event);
    void OnButtonSnap(wxCommandEvent &event);
    void OnButtonClose(wxCommandEvent &event);
    void AbortRender();
    void OutputFinish();
    
    MultiInputPanel_cls* mpCMNumImgSeqParam;
    void SetMNumImgSeqParam(wxBoxSizer *pBoxSizer);
    
    wxButtonEX *mpCButtonRender;
    wxButtonEX *mpCButtonSnap;
    wxStaticText *mpCTextExpect;
    wxGauge *mpCGauge;

    void HideAndShow();
    void Geometry();
    void HookFuncHS(int id, void *pArg);
    void HookFunc01(int id, void *pArg);
    
 private:
    // any class wishing to process wxWidgets events must use this macro
    DECLARE_EVENT_TABLE()
};

class ImgSequence_cls : 
public DialogControl_cls{
 public:
    ImgSequence_cls(Main_cls *pCMainLink);

    FrameMain_cls      *mpCFrameMainLink;
    Main_cls           *mpCMainLink;
    ImgSequenceGUI_cls *mpCGUI;
    FileSequence_cls   mCFileSequence;
    
    FBO_cls *mpCFBOBuffer[2];
    
    wxStopWatch mCStopWatch;
    
    ConfItemINT_cls mCInitNum;
    int  mCurrentOffset;
    int  mCurrentStereo;
    int  mTileResolution;
    int  mTileIndex;
    bool mbInRendering;
    bool mbSnapMode, mbTiling;

    int   mClipWidthMax, mClipHeightMax;
    float mAngleOrg;
    int   mClipWidth, mClipHeight;

    int mOffsetX, mOffsetY;
    void SetGeom(int width, int height, float angle,
		 bool bSetTrim = FALSE);
    TimeCtrl_cls *GetPCTimeCtrl();
    void CalcOffset(int widthOrg, int heightOrg);
    void SetAutoInit();
    
    wxString GetWXStrModifiedFilename();
    bool IsSizeValid(GLInfo_cls *pCGLInfo);
    void SetDefaultPath(wxString strPath);
    void UpdateGauge();
    bool SaveImageFromGL(ImageIO_cls *pCImageIO, int widthOrg, int heightOrg, int offset, int stereo);
    bool SaveImageFromFBO
	(ImageIO_cls *pCImageIO, FBO_cls *pCFBO, FBO_cls *pCFBOOverlay,
	 int imageType, int widthOrg, int heightOrg, int offset, int stereo,
	 bool bSideBySide = FALSE);
    
    void SetToDefault();
    void InitGUI(FrameMain_cls *pC);
    void UpdateItems(bool bForce = FALSE);

    void RenderFrameBoxInRender(int width, int height, GLPerspective_cls CGLPerspective);
    void OutputFinish();
};

#endif
