// -*- c -*-
// "clsDataSetAndName.h"

#include "clsDataSetAndName.h"

#ifdef _USE_HDF5

#include "../COMMON/CommonDefinitions.h"

#include <H5DxferProp.h>

DataSetAndName_cls::
DataSetAndName_cls(H5::CommonFG &CGroup,
		   H5std_string stdstrName, H5G_obj_t objType){

    mpCDataType = NULL;
    mpCDataSet = NULL;
    mpCDataSpace = NULL;
    
    if (objType == H5G_GROUP){
	mstrType = wxT("GROUP");
    }

    if (objType == H5G_DATASET){
	mpCDataSet = new H5::DataSet ( CGroup.openDataSet(stdstrName) );
	mpCDataSpace = new H5::DataSpace ( mpCDataSet->getSpace() );
	mstrType = wxT("DATASET");
	mstrDatasetInfo = GetStrType(mpCDataSet->getDataType());
	mstrDatasetInfo << GetStrDim();
    }

    if (objType == H5G_TYPE){
	mpCDataType = new H5::DataType ( CGroup.openDataType(stdstrName));
	mstrType = wxT("TYPE");
    }

    mObjType = objType;
    mstdstrName = stdstrName;
}

DataSetAndName_cls::
~DataSetAndName_cls(){
    if (mpCDataSet != NULL)   delete mpCDataSet;
    if (mpCDataSpace != NULL) delete mpCDataSpace;
    if (mpCDataType != NULL)  delete mpCDataType;
}

int  DataSetAndName_cls::
GetDimension(){
    return mpCDataSpace->getSimpleExtentNdims();
}

void DataSetAndName_cls::
GetDimensionSize(int dim, int *pDimSize){
    hsize_t *pDimSize_hsize = new hsize_t [dim];
    mpCDataSpace->getSimpleExtentDims(pDimSize_hsize);
    for (int i = 0; i < dim; i++)
	pDimSize[i] = (int)pDimSize_hsize[i];
    delete [] pDimSize_hsize;
}

long long DataSetAndName_cls::
GetNPoints(){
    return mpCDataSpace->getSimpleExtentNpoints();
}

wxString DataSetAndName_cls::
GetStrDim(){
    wxString strInfo;
    
    int dim = GetDimension();
    int *pDimSize = new int [dim];

    GetDimensionSize(dim, pDimSize);
    strInfo << wxT("(");
    for (int j = 0; j < dim; j++){
	if (j != 0) strInfo << wxT("x");
	strInfo << pDimSize[j];
    }
    strInfo << wxT(")");
    mDatasetPNum = pDimSize[0];
    delete [] pDimSize;
    
    return strInfo;
}



void DataSetAndName_cls::
CopyDataTo(void *pData, H5::PredType type){
    
    H5::DSetMemXferPropList CDefault;
    mpCDataSet->read(pData, type, H5::DataSpace::ALL, H5::DataSpace::ALL, CDefault);
}

#endif
