// -*- c -*-
// "clsHDF5Common.h"

#ifdef _USE_HDF5

#include "clsHDF5Common.h"

wxString HDF5Common_cls::
GetStrType(H5::DataType dataType){
    
    //H5::DataType dataType = mpCDataSet->getDataType();
        
    H5T_class_t type = dataType.getClass();

    wxString strType;

    if (type == H5T_STRING) strType = wxT("string");
    
    hid_t idDataType = dataType.getId();
    hid_t idNativeType = H5Tget_native_type(idDataType, H5T_DIR_ASCEND);
    htri_t check1, check2;

    check1 = H5Tequal(idDataType, H5T_NATIVE_CHAR); 
    check2 = H5Tequal(idNativeType, H5T_NATIVE_CHAR); 
    if (check1 > 0 || check2 > 0) strType = wxT("char");

    check1 = H5Tequal(idDataType, H5T_NATIVE_UCHAR); 
    check2 = H5Tequal(idNativeType, H5T_NATIVE_UCHAR); 
    if (check1 > 0 || check2 > 0) strType = wxT("uchar");

    check1 = H5Tequal(idDataType, H5T_NATIVE_SHORT); 
    check2 = H5Tequal(idNativeType, H5T_NATIVE_SHORT); 
    if (check1 > 0 || check2 > 0) strType = wxT("short");

    check1 = H5Tequal(idDataType, H5T_NATIVE_INT); 
    check2 = H5Tequal(idNativeType, H5T_NATIVE_INT); 
    if (check1 > 0 || check2 > 0) strType = wxT("int");

    check1 = H5Tequal(idDataType, H5T_NATIVE_FLOAT); 
    check2 = H5Tequal(idNativeType, H5T_NATIVE_FLOAT); 
    if (check1 > 0 || check2 > 0) strType = wxT("float");

    check1 = H5Tequal(idDataType, H5T_NATIVE_DOUBLE); 
    check2 = H5Tequal(idNativeType, H5T_NATIVE_DOUBLE); 
    if (check1 > 0 || check2 > 0) strType = wxT("double");

    //H5Tclose(idNativeType);    
	
    return strType;
}

#endif
