// -*- c++ -*- 
// "clsLuaBase.cpp"
// (setq c-basic-offset 4)

#ifndef _LUA_BASE_H_
#define _LUA_BASE_H_

#include <wx/wx.h>
#include <vector>

extern "C" {
#include "lua.h"
#include "lualib.h"
#include "lauxlib.h"
}

class PositionAndDirection_cls;
class SceneObj_cls;
class SnapData_cls;

class LuaBase_cls {
 public:
    static wxString msstrErr;

    lua_State *mpLua;
    
    LuaBase_cls();
    ~LuaBase_cls();

    void OpenLuaBase(wxString strFunction);
    void CloseLuaBase();
    void ClearLuaStack();
    void CheckErrorMessage(lua_State *pLua, wxString strTag);

    //static std::vector < SceneObj_cls* > msVpCSceneObjLink;
    //static std::vector < wxString > msVstrSceneObjTag;
    static std::vector < PositionAndDirection_cls* > msVpCPositionLink;
    static std::vector < wxString > msVstrPositionTag;
    static SnapData_cls *mspCSnapShotLink;

    static luaL_Reg CLibTable[];
    static int GetPosInfo(lua_State* L, 
			  PositionAndDirection_cls *pCPos, wxString strTag);
    static int GetSnapshotPos(lua_State* L, int index);
    static int GetSnapshotValue1(lua_State* L, int index);

    static int GetObjectInfo(lua_State* L);
    //static void PushSceneObjLink(SceneObj_cls *pCSceneObj, wxString strTag);
    static void SetPositionLink(PositionAndDirection_cls *pCPos, wxString strTag);
    static void SetSnapshotLink(SnapData_cls *pCSnapShotLink);
};

#endif
