// -*- c -*- 
// "clsDrawOption.h"

#include "../PARTICLEDATA/clsShadowVolume.h"
#include "../UNDO/clsUndoManager.h"

#include "../WIDGETCTRL/clsMultiInputPanel.h"
#include "../WIDGETCTRL/clsHookCtrl.h"
#include "clsDrawOption.h"
#include "clsDrawOptionGUI.h"

#include "../COMMON/CommonDefinitions.h"

DrawOptionGUI_cls::
DrawOptionGUI_cls(DrawOption_cls *pCCtrlLink, wxWindow *pCParent){
    mpCCtrlLink = pCCtrlLink;
    mpCParent = pCParent;
    mpCMInputPanel = NULL;
}

void DrawOptionGUI_cls::
SetPanel(wxBoxSizer *pBoxSizer){
    mpCMInputPanel = new MultiInputPanel_cls(mpCParent);

    MultiInputPanel_cls* pC = mpCMInputPanel;

    pC->mTextWidth = 80;
    pC->mItemWidth = 90;
    pC->mUpdateBit = 
	_COMMAND_UPDATE_DISPLAY_GL | _COMMAND_UPDATE_DISPLAY_DRAWOPTIONS | _COMMAND_UPDATE_SNAPSHOT_DATA;
    
    pC->CombinePointerSizer(2, _("Downsize"));
    pC->CombinePointer
	(_ITEM_INTEGER_SPIN, &mpCCtrlLink->mCDownSize.mBody);
    pC->SetRange(_ITEM_LASTITEM, 1, 1000);
    pC->CombinePointer
	(_ITEM_INTEGER_SLIDER, &mpCCtrlLink->mCDownSize.mBody);
    pC->SetRange(_ITEM_LASTITEM, 1, 1000);

    pC->mItemWidth = -1;
    wxString listZSort[4] = {_("No Sort (fast)"), _("Zsort (desc.)"), _("Zsort (asc.)"), _("Sort by type") };
    pC->CombinePointerList
	(&mpCCtrlLink->mCSortOrder.mBody, 
	 4, listZSort, _("Zsort Type"));

    mIndexClassify = pC->CombinePointerSizer(2, _("Classification"));
    wxString listClassify[3] = {_("Use Attrib0 (fast)"), _("Use All Attrib"), wxT("Expression") };
    pC->mComboWidth = 130;
    pC->CombinePointerList
	(&mpCCtrlLink->mCClassify.mBody, 
	 3, listClassify, _("Classification"));
    pC->mItemWidth = 60;
    int indexExpress = pC->CombinePointerButton(wxID_ANY, _("Editor"));
   
    pC->mItemWidth = -1;
    wxString listShadowy[3] = {_("No Shadow"), _("Shadow Volume"), _("Show Shadow") };
    pC->CombinePointerList
	(&mpCCtrlLink->mCShadow.mBody, 
	 3, listShadowy, _("Shadow"));

    mIndexShadowOption = pC->CombinePointerSizer(2, _("Q./Length"));
    wxString listQuality[3] = {_("Low"), _("Middle"), _("High") };
    pC->CombinePointerList
	(&ShadowVolume_cls::msCShadowQuality.mBody, 
	 3, listQuality);
    pC->mItemWidth = 60;
    pC->CombinePointer
	(_ITEM_FLOAT, &ShadowVolume_cls::msCShadowLength.mBody);
    
    pC->FinishSetting(pBoxSizer);

    pC->SetHook(this, &HookItem_cls::HookFuncHS, _HOOK_COMBOBOX);
    pC->SetHook(this, &HookItem_cls::HookFunc01, _HOOK_BUTTON, indexExpress);
    
    HideAndShow();
}

void DrawOptionGUI_cls::
HideAndShow(){
    bool bValid = TRUE;
    if (mpCCtrlLink->mCShadow.mBody == 0) bValid = FALSE;
    
    mpCMInputPanel->EnableItem(mIndexShadowOption, bValid);

    bool bClassifyExpression = (mpCCtrlLink->mCClassify.mBody == 2);
    mpCMInputPanel->EnableItem(mIndexClassify + 2, bClassifyExpression);
}

void DrawOptionGUI_cls::
HookFuncHS(int id, void *pPanel){
    HideAndShow();
}

void DrawOptionGUI_cls::
HookFunc01(int id, void *pPanel){
    mpCCtrlLink->OpenExpressionDialog();
}
