// -*- c -*-
// "clsExposure.h"

#ifndef _EXPOSURE_H_
#define _EXPOSURE_H_

#include "../GLATTRIB/clsShaderBase.h"
#include "../CONFITEM/clsConfItem.h"

class ExposureGUI_cls;
class wxWindow;

class Exposure_cls : public ShaderBase_cls {
 public:
    Exposure_cls();
    ~Exposure_cls();

    void InstantiateGUI(wxWindow *pCParent);
    
    ExposureGUI_cls *mpCGUI;

    bool mbShaderAvailable;
    ConfItemList_cls mCConfList;
    ConfItemDOUBLEARRAY_cls mCLevel;
    ConfItemFLOAT_cls mCGamma;
    ConfItemINT_cls mCHueOffset;
    ConfItemINT_cls mCSaturation;
    float           mAlpha;
    int             mBlendMode;

    GLint mParamIDTexture;
    GLint mParamIDLevelMin;
    GLint mParamIDLevelMax;
    GLint mParamIDExposure;
    GLint mParamIDGamma;
    GLint mParamIDHueOffset;
    GLint mParamIDSaturation;
    GLint mParamIDAlpha;
    GLint mParamIDBlendMode;

    void Initialize(wxWindow *pCParent, bool bShaderAvailable);
    
    GLuint mGL2Program;
    
    void Begin();
    void End();

    void SetParamIDs(GLint program);
    void SetParamTexture(int value);
    void SetParamExposure();

    bool IsDefault();
    
    // ----------------------------

    void ReadStrLine(wxString strLine);
    wxString Serialize();
};

#endif
