// (setq c-basic-offset 4)
// "clsFrameMain.h"
// "wxWidgetEnum.h"

#include "../../clsFrameMain.h"

#include "../MAINCANVAS/clsTopHalfPanel.h"
#include "../PANELS/clsShortcut.h"
#include "../WIDGETCTRL/WX/myArtProv.h"

#include "../../wxWidgetEnumMenu.h"

extern bool GbGLLockModalDialog;

void FrameMain_cls::
AddBitmapMenu(wxMenu *pMenu, int ID, wxString strMain, wxString strSub, 
	      wxString strFile){
    if (strFile.IsEmpty() != TRUE){
	wxBitmap bitMap(strFile, wxBITMAP_TYPE_PNG);
	AddBitmapMenu(pMenu, ID, strMain, strSub, bitMap);  }
    else
	AddBitmapMenu(pMenu, ID, strMain, strSub, wxNullBitmap);
}

void FrameMain_cls::
AddBitmapMenu(wxMenu *pMenu, int ID, wxString strMain, wxString strSub, 
	      wxBitmap bitmap){
    wxMenuItem *pItem = new wxMenuItem(pMenu, ID, strMain, strSub);
    if (bitmap.IsOk() == TRUE)
	pItem->SetBitmap(bitmap);
    pMenu->Append(pItem);
}

void FrameMain_cls::
ClearMenu(){
    int count = mpCMenuBar->GetMenuCount();
    for (int i = 0; i < count; i++)
	delete mpCMenuBar->Remove(0);
}

void FrameMain_cls::
SetMenuItem(){
    ClearMenu();
    Shortcut_cls *pCSC = mpCShortcut;

    // ----- FILE(&F) -----
    wxMenu *pCMenuFile = new wxMenu;
    pCSC->SetMenuItem(pCMenuFile, menuFileOpenProject);
    pCSC->SetMenuItem(pCMenuFile, menuFileSaveProject);
    pCSC->SetMenuItem(pCMenuFile, menuFileSaveProjectAs);
    
    pCMenuFile->AppendSeparator();
    pCSC->SetMenuItem(pCMenuFile, menuFileOpenData, wxT("wxART_PARTICLE"));
    pCMenuFile->AppendSeparator();
    pCSC->SetMenuItem(pCMenuFile, menuFileSaveImageSnap);
    pCSC->SetMenuItem(pCMenuFile, menuFileSaveImageSeq);
    wxMenu *pCMenuExport = new wxMenu;
    pCMenuFile->Append(menuFileExport, 
			wxString::Format(_T("%s(&E)"), _("Export")),
			pCMenuExport, _("Export"));
    pCSC->SetMenuItem(pCMenuExport, menuFileExportData);
    pCSC->SetMenuItem(pCMenuExport, menuFileExportPathPov);
        
    pCMenuFile->AppendSeparator();
    pCSC->SetMenuItem(pCMenuFile, menuFileCloseData);
    
    pCMenuFile->AppendSeparator();
    pCSC->SetMenuItem(pCMenuFile, Minimal_Quit, wxEmptyString, _("Quit this application"));
    
    // ----- EDIT(&E) -----
    wxMenu *pCMenuEdit = new wxMenu;
    mpCMenuEdit = pCMenuEdit; // TimeRemap̃`FbNp
    pCSC->SetMenuItem(pCMenuEdit, menuEditUndo);
    pCSC->SetMenuItem(pCMenuEdit, menuEditRedo);

    pCMenuEdit->AppendSeparator();
    pCSC->SetMenuItem(pCMenuEdit, menuEditGo);

    pCMenuEdit->AppendSeparator();
    pCMenuEdit->AppendCheckItem
	(menuEditTimeRemap, 
	 wxString::Format(_T("%s(&R)"), _("Time Remap")), _("Time Remap"));
    
    pCMenuEdit->AppendSeparator();
    wxMenu *pCMenuRemoveCache = new wxMenu;
    pCMenuEdit->Append(menuEditRemoveCache, 
			wxString::Format(_T("%s(&D)"),_("Remove Cache")),
			pCMenuRemoveCache, _("Remove Cache"));
    pCSC->SetMenuItem(pCMenuRemoveCache, menuEditRemoveCacheSnap);
    pCSC->SetMenuItem(pCMenuRemoveCache, menuEditRemoveCacheAll);
    
    wxSize iconSize = wxSize(16, 16);
    pCMenuEdit->AppendSeparator();
    pCSC->SetMenuItem(pCMenuEdit, menuEditScene, wxT("wxART_SCENE"));
    pCSC->SetMenuItem(pCMenuEdit, menuEditPreference, wxT("wxART_PREFERENCE"));
	 
    // ----- FILTER(&F) ----
    // Popup̂Ńo[
    wxMenu *pCMenuFilter = new wxMenu;
    mpCMenuFilterBoolean = new wxMenu;
    mpCMenuFilterBoolean->Append
	(menuFilterBoolean, wxString::Format(_T("%s(&B)"),_("Boolean")));
    mpCMenuFilterBoolean->Append
	(menuFilterFiltering, wxString::Format(_T("%s(&T)"), _("Filtering")));
    pCMenuFilter->Append(menuFilterMenuBoolean, 
			 wxString::Format(_T("%s(&B)"),_("Bool")),
			 mpCMenuFilterBoolean, _("Boolean"));
    
    mpCMenuFilterObject = new wxMenu;
    mpCMenuFilterObject->Append
	(menuFilterObject, wxString::Format(_T("%s(&O)"), _("Object")));
    mpCMenuFilterObject->Append
	(menuFilterText, wxString::Format(_T("%s(&G)"), _("Text")));
    mpCMenuFilterObject->Append
	(menuFilterStick, wxString::Format(_T("%s(&S)"), _("Stick")));
    mpCMenuFilterObject->Append
	(menuFilterGrid, wxString::Format(_T("%s(&G)"), _("Grid")));
    
    pCMenuFilter->Append(menuFilterMenuObject,
			 wxString::Format(_T("%s(&B)"), _("Object")),
			 mpCMenuFilterObject, _("Object"));

    mpCMenuFilterWorld = new wxMenu;
    mpCMenuFilterWorld->Append
	(menuFilterDataBox, wxString::Format(_T("%s(&C)"),_("DataBox")));
    mpCMenuFilterWorld->Append
	(menuFilterCopy, wxString::Format(_T("%s(&C)"),_("CopyBox")));
    mpCMenuFilterWorld->Append
	(menuFilterFog, wxString::Format(_T("%s(&F)"), _("Fog")));
    mpCMenuFilterWorld->Append
	(menuFilterBG, wxString::Format(_T("%s(&F)"), _("BG")));
    pCMenuFilter->Append(menuFilterMenuWorld,
			 wxString::Format(_T("%s(&W)"), _("World")),
			 mpCMenuFilterWorld, _("World"));
    
    // ----- PovRay(&V) -----
    wxMenu *pCMenuPovRay = new wxMenu;
    pCSC->SetMenuItem(pCMenuPovRay, menuDialogPovRay, wxT("wxART_POVRAY"));
    pCMenuPovRay->AppendSeparator();
    
    mpCMenuItemExportSnap = pCMenuPovRay->Append
	(menuPovExportSnap, wxString::Format(_T("%s (%s)"),
					     _("Export"), _("Snapshot")),
	 _("Export Pov-Ray scene file"));
    mpCMenuItemExportAnim = pCMenuPovRay->Append
	(menuPovExportAnim, wxString::Format(_T("%s (%s)"),
					     _("Export"), _("Animation")),
	 _("Export Pov-Ray scene file"));
    mpCMenuItemRenderSnap = pCMenuPovRay->Append
	(menuPovRenderSnap, wxString::Format(_T("%s (%s)"),
					     _("Render"), _("Snapshot")),
	 _("Render scene using Pov-Ray"));
    mpCMenuItemRenderAnim = pCMenuPovRay->Append
	(menuPovRenderAnim, wxString::Format(_T("%s (%s)"),
					     _("Render"), _("Animation")),
	 _("Render scene using Pov-Ray"));
    
    // ----- VIEW(&V) -----
    wxString strViewIcons[5] = {
	wxT(""), wxT("wxART_SPLIT_V"), wxT("wxART_SPLIT_H"),
	wxT("wxART_SPLIT_4"), wxT("wxART_SPLIT_4") };
    
    wxMenu *pCMenuView = new wxMenu;
    for (int i = 0; i < 5; i++)
	pCSC->SetMenuItem(pCMenuView, menuViewMainPanelType0 + i, strViewIcons[i]);

    pCMenuView->AppendSeparator();
    pCSC->SetMenuItem(pCMenuView, menuViewExtraPanel);

    // ----- Dialog(&D) -----
    wxMenu *pCMenuDialog = new wxMenu;
    pCSC->SetMenuItem(pCMenuDialog, menuDialogCameraPath, wxT("wxART_CAMERA"));
    pCSC->SetMenuItem(pCMenuDialog, menuDialogLightSRC, wxT("wxART_LIGHT"));
    pCSC->SetMenuItem(pCMenuDialog, menuDialogColorCurve, wxT("wxART_COLOR"));
    pCSC->SetMenuItem(pCMenuDialog, menuDialogTexProperty, wxT("wxART_TEXTURE"));
    pCSC->SetMenuItem(pCMenuDialog, menuDialogStereogram, wxT("wxART_STEREOGRAM"));
    pCSC->SetMenuItem(pCMenuDialog, menuDialogPeriodic, wxT("wxART_PERIODIC"));
    
    // ----- HELP(&H) -----
    wxMenu *pCMenuHelp = new wxMenu;
    pCSC->SetMenuItem(pCMenuHelp, menuHelp);
    pCSC->SetMenuItem(pCMenuHelp, Minimal_About);
    pCSC->SetMenuItem(pCMenuHelp, menuAboutGL);
    pCSC->SetMenuItem(pCMenuHelp, menuAboutNetwork);
    pCMenuHelp->Append(menuUnlock, 
			wxString::Format(_T("%s(&U)"), _("Unlock (for Debug)")),
			_("Unlock (for Debug)"));
    pCMenuHelp->Append(menuSpecial,
			wxString::Format(_T("%s(&S)"), _("Special (for Debug)")),
			_("Special (for Debug)"));
    
    mpCMenuBar->Append(pCMenuFile, _("File(&F)"));
    mpCMenuBar->Append(pCMenuEdit, _("Edit(&E)"));
    mpCMenuBar->Append(pCMenuFilter, _("Filter(&L)"));
    mpCMenuBar->Append(pCMenuPovRay, wxT("Pov-Ray(&P)"));
    mpCMenuBar->Append(pCMenuView, _("View(&V)"));
    mpCMenuBar->Append(pCMenuDialog, _("Dialog(&D)"));
    mpCMenuBar->Append(pCMenuHelp, _("Help(&H)"));
}

void FrameMain_cls::
UpdateMenu(){
    mpCMenuBar->Freeze();
    ClearMenu();
    SetMenuItem();
    mpCMenuBar->Thaw();
}

void FrameMain_cls::
InitMenu(){
    mpCMenuBar = new wxMenuBar;

    SetMenuItem();

    // R͕ʂ̏ꏊŎĝŕʂɍ쐬
    mpCMenuFilterManipulate = new wxMenu;
    mpCMenuFilterManipulate->Append
	(menuFilterUp, wxString::Format(_T("%s(&U)"), _("Up")));
    mpCMenuFilterManipulate->Append
	(menuFilterDown, wxString::Format(_T("%s(&D)"), _("Down")));
    mpCMenuFilterManipulate->AppendSeparator();
    mpCMenuFilterManipulate->Append
	(menuFilterDelete, wxString::Format(_T("%s(&X)"), _("Delete")));

    SetMenuBar(mpCMenuBar);
}

