// -*- c -*-
// "clsInformationGUI.h"

#include "clsInformationGUI.h"
#include "clsInformation.h"

#include "../PARTICLEDATA/clsSnapData.h"
#include "../PARTICLEDATA/clsParticleDataBlock.h"
#include "../WIDGETCTRL/clsMultiInputPanel.h"

#include "../UNDO/clsUndoManager.h"
extern UndoManager_cls GCUndoList;
#include "../UNDO/clsUndoItemConstParam.h"

InformationGUI_cls::
InformationGUI_cls(Information_cls *pCCtrlLink, wxWindow *pCParent){
    mpCCtrlLink = pCCtrlLink;
    mpCParent = pCParent;

    mX = 0; mY = 0; mZ = 0;
    mVX = 0; mVY = 0; mVZ = 0;
    mType = 0; mID = 0;
    mRadius = 0; mValue1 = 0;
}

void InformationGUI_cls::
SetPanel(wxBoxSizer *pBoxSizer){
    mpCMInputPanel = new MultiInputPanel_cls(mpCParent);

    MultiInputPanel_cls* pC = mpCMInputPanel;

    pC->mUpdateBit = 
	_COMMAND_UPDATE_DISPLAY_GL | _COMMAND_UPDATE_SNAPSHOT_DATA;
    pC->mTextWidth = 80;
    pC->mItemWidth = 95;

    int boxWidth = 2;
    pC->CombinePointer(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, _("Index"));
    pC->CombinePointer(_ITEM_INTEGER_SPIN, &mpCCtrlLink->mCIndex.mBody);
    pC->SetRange(_ITEM_LASTITEM, 0, 500000000);

    wxString listType[2] = {_("Interp."), _("Raw Data") };
    pC->CombinePointerList(&mpCCtrlLink->mCType.mBody, 2, listType);
    
    pC->mTextWidth = 20;
    pC->mItemWidth = 80;
    
    boxWidth = 3;
    int indexXYZ = pC->CombinePointer
	(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, wxT("x"));
    pC->CombinePointer(_ITEM_FLOAT, &mX);
    pC->CombinePointer(_ITEM_FLOAT, &mY);
    pC->CombinePointer(_ITEM_FLOAT, &mZ);

    int indexV = pC->CombinePointer
	(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, wxT("v"));
    pC->CombinePointer(_ITEM_FLOAT, &mVX);
    pC->CombinePointer(_ITEM_FLOAT, &mVY);
    pC->CombinePointer(_ITEM_FLOAT, &mVZ);
    
    boxWidth = 2;
    pC->mTextWidth = 80;
    pC->mItemWidth = 90;
    pC->CombinePointer(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, wxT("type/ID"));
    pC->CombinePointer(_ITEM_INTEGER, &mType);
    pC->CombinePointer(_ITEM_INTEGER, &mID);

    pC->CombinePointer(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, wxT("rad./value"));
    pC->CombinePointer(_ITEM_FLOAT, &mRadius);
    pC->CombinePointer(_ITEM_FLOAT, &mValue1);

    pC->FinishSetting(NULL);
    pC->SetColorForXYZ(indexXYZ+1);
    pC->SetColorForXYZ(indexV+1);
}

void InformationGUI_cls::
UpdateInfo(SnapData_cls *pCSnapData){
    int index = mpCCtrlLink->mCIndex.mBody;
    if (index >= pCSnapData->mPNumBlock){
	mX = mY = mZ = 0;
	mVX = mVY = mVZ = 0;
	mType = 0; mID = 0;
	mRadius = 0; mValue1 = 0;
    }
    else{
	mX = pCSnapData->mpX[index][0];
	mY = pCSnapData->mpX[index][1];
	mZ = pCSnapData->mpX[index][2];

	mRadius = pCSnapData->mpRadius[index];
	mValue1 = pCSnapData->mpValue1[index];
	mType   = pCSnapData->mpTypeLink[index];
    }

    mpCMInputPanel->UpdateValues();
}

void InformationGUI_cls::
UpdateInfo(PDataBlock_cls *pCDataBlock){
    int index = mpCCtrlLink->mCIndex.mBody;
    if (index >= pCDataBlock->mPNumBlock){
	mX = mY = mZ = 0;
	mVX = mVY = mVZ = 0;
	mType = 0; mID = 0;
	mRadius = 0; mValue1 = 0;
    }
    else{
	mX = pCDataBlock->mpX[index][0];
	mY = pCDataBlock->mpX[index][1];
	mZ = pCDataBlock->mpX[index][2];
	
	mVX = pCDataBlock->mpV[index][0];
	mVY = pCDataBlock->mpV[index][1];
	mVZ = pCDataBlock->mpV[index][2];

	mRadius = pCDataBlock->mpRadius[index];
	mValue1 = pCDataBlock->mpValue1[index];
	mID     = pCDataBlock->mpID[index];
	mType   = pCDataBlock->mpType[index];
    }

    mpCMInputPanel->UpdateValues();
}
