// -*- c -*-
// "clsOverlayGUI.h"

#include "../UNDO/clsUndoManager.h"

#include "../WIDGETCTRL/clsMultiInputPanel.h"
#include "../WIDGETCTRL/clsHookCtrl.h"
#include "../WIDGETCTRL/EX/clsTextCtrlEX.h"
#include "clsOverlay.h"
#include "clsOverlayGUI.h"

#include "../COMMON/CommonDefinitions.h"

OverlayGUI_cls::
OverlayGUI_cls(Overlay_cls *pCOverLayLink, wxWindow *pCParent){
    mpCOverlayLink = pCOverLayLink;
    mpCParent = pCParent;
    mpCMInputPanel = NULL;
}

void OverlayGUI_cls::
SetPanel(wxBoxSizer *pBoxSizer){
    mpCMInputPanel = new MultiInputPanel_cls(mpCParent);

    MultiInputPanel_cls* pC = mpCMInputPanel;

    pC->mUpdateBit |= _COMMAND_UPDATE_DISPLAY_DRAWOPTIONS;

    pC->mTextWidth = 70;
    pC->mItemWidth = 90;
    pC->mUpdateBit = 
	_COMMAND_UPDATE_DISPLAY_GL | _COMMAND_UPDATE_DISPLAY_DRAWOPTIONS ; 

    wxString listPos[5] = {_("Top Left"), _("Top Right"), _("Btm Left"), _("Btm Right"), _("Do not show") };
    
    //int boxWidth = 2;
    pC->CombinePointerSizer(2, _("Time"));
    pC->CombinePointerList
	(&mpCOverlayLink->mCTimePosition.mBody, 5, listPos);
    
    int indexTimeStr = pC->CombinePointer
	(_ITEM_STRING, &mpCOverlayLink->mCTimeTag.mstrBody);
    
    wxString listFont[8] = {wxT("Default"), wxT("Decorative"), wxT("Roman"), wxT("Script"), wxT("Swiss"), wxT("Modern"), wxT("Teletype"), wxT("Custom") };
    
    pC->CombinePointerSizer(2, _("Time Style"));

    mIndexFontFamily = pC->CombinePointerList
	(&mpCOverlayLink->mCTimeFontFamily.mBody, 8, listFont);
    pC->CombinePointer
	(_ITEM_INTEGER_SPIN, &mpCOverlayLink->mCTimeFontPoint.mBody);
    
    pC->CombinePointerSizer(5, _("Legend"));
    pC->CombinePointerList
	(&mpCOverlayLink->mCLegendPosition.mBody, 4, listPos);
    pC->CombinePointer
	(_ITEM_BOOL, &mpCOverlayLink->mCbShowLegend.mpbBody[0]);
    pC->GetLastItem().mItemWidth = 16;
    pC->CombinePointer
	(_ITEM_BOOL, &mpCOverlayLink->mCbShowLegend.mpbBody[1]);
    pC->GetLastItem().mItemWidth = 16;
        pC->CombinePointer
	(_ITEM_BOOL, &mpCOverlayLink->mCbShowLegend.mpbBody[2]);
    pC->GetLastItem().mItemWidth = 16;
    pC->CombinePointer
	(_ITEM_BOOL, &mpCOverlayLink->mCbShowLegend.mpbBody[3]);
    pC->GetLastItem().mItemWidth = 16;

    wxString listAlpha[4] = {
	_("Show Alpha"), _("Hide Alpha") };
    pC->CombinePointerList(&mpCOverlayLink->mCLegendIgnoreAlpha.mBody, 
			   2, listAlpha, _("Alpha"));
    pC->GetLastItem().mItemWidth = -1;
    wxString listTics[4] = {
	_("Show Tics"), _("Hide Tics") };
    pC->CombinePointerList(&mpCOverlayLink->mCLegendIgnoreTics.mBody, 
			   2, listTics, _("Tics"));
    pC->GetLastItem().mItemWidth = -1;
    
    pC->FinishSetting(pBoxSizer);

    ((TextCtrlEX_cls*)(pC->mVCItemList[indexTimeStr].GetPCwxWindow()))->EnableHookSpace(FALSE);

    pC->SetHook(this, &HookItem_cls::HookFunc01, _HOOK_COMBOBOX);
}

void OverlayGUI_cls::
HookFunc01(int id, void *pArg){
    wxCommandEvent* pEvent = (wxCommandEvent*)pArg;
    
    if (id == mpCMInputPanel->GetItemId(mIndexFontFamily) &&
	mpCOverlayLink->mCTimeFontFamily.mBody == 7)
	mpCOverlayLink->SetCustomFont();
}


