
#ifndef _TOP_HALF_PANEL_H_
#define _TOP_HALF_PANEL_H_

#include "../CONFITEM/clsConfItem.h"

#include <wx/wx.h>
#include <wx/splitter.h>
#include <list>

class BitmapPanel_cls;
class FilterPanelPain_cls;
class FrameMain_cls;
class GLCanvasCtrl_cls;
class Preference_cls;
class wxNotebook;

class TopHalfPanel_cls;
class GLAttributeGUI_cls;
class GLAttribute_cls;

class TopHalfPanel_cls : public wxPanel {
 public:
    TopHalfPanel_cls(wxWindow *pC, FrameMain_cls *pCFrame);
    ~TopHalfPanel_cls();
    
    FrameMain_cls *mpCParentFrame;
    
    wxSplitterWindow* mpCSplitterMain;
    wxSplitterWindow* mpCSplitterChildA;
    wxSplitterWindow* mpCSplitterChildB;

    GLCanvasCtrl_cls* mpCGLCtrl[4];

    wxNotebook *mpCNotebookGLAttrib;
    wxBoxSizer *mpCBoxSizerRGT;

    BitmapPanel_cls *mpCFolderAttrib, *mpCFolderSetting;
    
    wxNotebook *mpCNotebookSetting;
    wxNotebook *mpCNotebookFilter;
    FilterPanelPain_cls *mpCFilterPanelPain[3];

    void RecalcSize();
    void SplitPanel(unsigned int type);

    GLAttributeGUI_cls* GetPCGLAttribGUI(int index);
    GLAttribute_cls* GetPCGLAttrib(int index);
    bool CheckGLRefresh(int frame, int interpStep);
    void ClearStatusGLPanels();
    void RefreshGLPanels();
    void RefreshAttrib();
    void HideAndShow();

    //void OnMouse(wxMouseEvent& event);
    void OnMouseLOpen(wxMouseEvent& event);
    
    //void OnKeyDown(wxKeyEvent &event);

    //----

    ConfItemList_cls     mCConfList;
    ConfItemUINT_cls     mCPreviewPanelType;
    void     ReDefineConfList();
    void     ReadStrLine(std::wistream &istream, wxString strLine);
    wxString Serialize();

 private:
    // any class wishing to process wxWidgets events must use this macro
    //DECLARE_EVENT_TABLE()
};

#endif
