// -*- c -*-
// "clsCameraPath.cpp"

#ifndef _MESH_BASE_H
#define _MESH_BASE_H

#include <vector>

//#include "../COMMON/CommonDefinitions.h"

#define _MESH_MATERIAL -1
#define _MESH_POLYGONS_ARRAY -2

class CallBackMaterial_cls {
 public:
    virtual void CallMaterial(int type) = 0;
};

class MeshBase_cls {
 public:
    MeshBase_cls (CallBackMaterial_cls *pCCallBackParent);
    CallBackMaterial_cls *mpCCallBackParent;

    std::vector < float > mVVertex;
    std::vector < float > mVNormal;
    std::vector < float > mVUV2;

    std::vector < unsigned int > mVFaceIndexVertex;
    std::vector < unsigned int > mVFaceIndexNormal;
    std::vector < unsigned int > mVFaceIndexUV2;
    std::vector < int > mVMaterialAndPolygon;

    // 434343...  ngonׂ
    // -1(_MESH_MATERIAL)ƁA}eAύX
    // -2(_MESH_POLYGONS_ARRAY)̌ɂ́AGL_QUADSGL_TRIANGLESĂ̌[face]̐
    
    void ClearAll();
    void MinimizeMemoryUse();
    void ReserveVertexNumber(int num);
    void ReserveFaceNumber(int num);
    void SetVertexNumber(int num);
    void SetFaceNumber(int num);
    void SetMaterialAndPolygonNumber(int num);

    void GLDrawUseNormalUseTexture();
    void GLDrawUseNormal();
    void GLDraw(bool bUseNornal = true, bool bUseUV = true);
    void GLDrawArrayMesh(int polyType, int faceNum,
			 int &faceIndexOffset,
			 bool bUseNornal, bool bUseUV);
};

#endif
