// "clsFBO.h"
// (setq c-basic-offset 4)

#ifndef _FBO_DRAW_H_
#define _FBO_DRAW_H_

#define _FBO_USE_RGBA true

#include "clsTextureBase.h"
#include "clsGLPerspective.h"

#define _FBO_ADD  true
#define _FBO_DRAW false

#include <vector>

class FBO_cls : public TextureBase_cls {
 public:
    FBO_cls(int width, int height);
    ~FBO_cls();

    static void Initialize();
    static bool msbInitialized;
    static bool msbSupported;
    static std::vector < FBO_cls* > msVpCStack;

    TextureBase_cls *mpCDepthTexture;

    bool mbClear;
    bool mbGenerated;

    void SetGeometryBuffer(int width, int height);
    void SetDepth(int depth);
    int mWidthBuffer, mHeightBuffer;
    int mWidthGenerated, mHeightGenerated; //ۂɍTCY
    int mDepth;
    int mDepthGenerated;
    bool mbAlphaGenerated;
    bool mbDepthTextureUsed;
    
    void MakeFBO(bool bUseRGBA = FALSE, bool bUseDepthTexture = FALSE);
    void ClearFBO();
    void Begin(bool bClear = TRUE, bool bCalledInFBOStack = FALSE);
    void End();

    GLuint mRBId;
    GLuint mFBOId;

    float  GetLineWidthFactor();
    
};

#endif
