// "clsFishEye.cpp"
// (setq c-basic-offset 4)

#ifndef _FISHEYE_DRAW_H_
#define _FISHEYE_DRAW_H_

#define _MULTIPANEL_FISHEYE  1
#define _MULTIPANEL_CYLINDER 2

#include "../MYGL/clsPositionAndDirection.h"
#include "../MYGL/clsGLPerspective.h"

class StereoGram_cls;
class FBO_cls;

#define _FISHEYE_MAX 80

class FishEye_cls {
 public:
    FishEye_cls();
    ~FishEye_cls();

    int mBufferSize;
    int mPanelWidth, mPanelHeight;
    int mPartsBufSize;
    FBO_cls *mpCFBOParts[4];

    int  mDeg;
    int  mDList[4];

    void ModifyByDomeTilt(PositionAndDirection_cls *pCCam);
    void ModifyForFishEye(PositionAndDirection_cls *pCCam, int fisheyeIndex);
    void ModifyForCylinder(PositionAndDirection_cls *pCCam, int fisheyeIndex);
    void SetUptoViewport(GLPerspective_cls *pCGLPerspective,
			 PositionAndDirection_cls *pCCam, int fisheyeIndex,
			 int multiPanelMode);

    void MakeStencilBegin();
    void MakeStencilEnd();
    void MakeCirclePatternOnStencil();
    void MakePanoramaMaskPatternOnStencil(double deg);
    void DrawDomeTexSegment(double coordu, double coordv0, double coordv1,
			    double x0, double x1, double y0, double y1, 
			    double z0, double z1, double deg);
    void GatherGLSetting(bool bAdd, int clipWidth, int clipHeight);
    void MakeLists(double deg);
    void GatherFishEye
	(double deg, bool bAdd, int clipWidth, int clipHeight,
	 StereoGram_cls *pCSGLink, int stereo, bool bUseDepthTexture);
    void GatherCylinder
	(double deg, bool bAdd, int clipWidth, int clipHeight,
	 StereoGram_cls *pCSGLink, int stereo, bool bUseDepthTexture);
    
    // ---

    void MakeFishEyePrepare(int width, int height, int partsBufSize,
			    int depth, int fboMax = 4);
    void MakeFishEyeProcessFH(int fboIdx, PositionAndDirection_cls CPos,
			      GLPerspective_cls CGLPerspective, 
			      int multiPanelMode, bool bUseDepthTexture);

    void MakeFishEyeProcessLH(int fboIdx);
    
};

#endif
