// -*- c -*-
// "clsCameraProperty.cpp"

#include "clsGLCameraProperty.h"

#include "../COMMON/CommonDefinitions.h"

GLCameraProperty_cls::
GLCameraProperty_cls(){
    mCConfList.Add(&mCGLPersAngle,   L"GLPersAngle=", L"35");
    mCConfList.Add(&mCGLOrthoScale,  L"GLOrthoScale=", L"1");
    mCConfList.Add(&mCGLDepthMin,    L"GLDepthMin=", L"0.03");
    mCConfList.Add(&mCGLDepthMax,    L"GLDepthMax=", L"5000");
    mCConfList.Add(&mCstrGLDepthExpression, L"GLExpression=", L"return min, max");
}

void GLCameraProperty_cls::
SetTag(wxString strTag){
    mCConfList.SetTag(strTag);
}

void GLCameraProperty_cls::
GetMinAndMax(float &min, float &max, float time, double doubleIndex){
    wxString strFunction;
    strFunction << wxT("function script(t,nt,min,max)") << ENDL;
    strFunction << mCstrGLDepthExpression.mstrBody << ENDL;
    strFunction << wxT("end") << ENDL;

    min = mCGLDepthMin.mBody;
    max = mCGLDepthMax.mBody;
    
    OpenLuaBase(strFunction);
    lua_getglobal(mpLua,"script"); // ֐ς
    lua_pushnumber(mpLua, time); 
    lua_pushnumber(mpLua, doubleIndex);
    lua_pushnumber(mpLua, min);
    lua_pushnumber(mpLua, max);
    
    if (lua_pcall(mpLua, 4, 2, 0) != 0)
	CheckErrorMessage(mpLua, wxT("OpenGL Depth::"));
    else{
	min = lua_tonumber(mpLua, 1);
	max = lua_tonumber(mpLua, 2);
    }

    ClearLuaStack();
}

bool GLCameraProperty_cls::
ReadStrLine(std::wistream &istream, wxString strLine){
    return mCConfList.ReadStrLineAllWithTag(istream, strLine);
}

void GLCameraProperty_cls::
Serialize(wxString &strOut){
    mCConfList.SerializeAllWithTag(strOut);
}
