// -*- c -*- 
// (setq c-basic-offset 4)
// "clsDataExporter.h"

#include "clsDataExporter.h"
#include "clsDataLoader.h"
#include "clsDataLoaderGUI.h"

#include "../MYAPI/MsgBox.h"
#include "../PARTICLEDATA/clsParticleDataBlock.h"
#include "../PARTICLEDATA/clsParticleDataSnap.h"
#include "../TIMELINE/clsTimeCtrl.h"
#include "../UNDO/clsUndoManager.h"
extern UndoManager_cls GCUndoList;
#include "../UNDO/clsUndoItemConstParam.h"
#include "../WIDGETCTRL/clsHookCtrl.h"
#include "../WIDGETCTRL/EX/clsFileDialogEX.h"
extern wxFileDialogEX*   GpCFileDialog;
#include "../WIDGETCTRL/EX/clsListCtrlEX.h"

#include "../COMMON/CommonDefinitions.h"

#include "../../clsMain.h"
#include "../../clsFrameMain.h"

#include "../../wxWidgetEnum.h"
#include "../../wxWidgetEnumMenu.h"

#include <wx/filename.h>

//extern wxFrame  *GpCMainFrameCLS;

#ifdef WIN32
#define DELIM L"\\"
#define DELIMWX wxT("\\")
#else
#define DELIM L"/"
#define DELIMWX wxT("/")
#endif

BEGIN_EVENT_TABLE(DataExporterGUI_cls, wxDialog)
EVT_KEY_DOWN(DataExporterGUI_cls::OnKeyDown)
EVT_BUTTON(btnDataLoaderDefault,   DataExporterGUI_cls::OnBtnDefault)
EVT_MENU(menuGrammerInsertDummy1,  GrammerBaseGUI_cls::OnInsertDummy1)
EVT_MENU(menuGrammerInsertDummy3,  GrammerBaseGUI_cls::OnInsertDummy3)
EVT_MENU(menuGrammerInsertDummy10, GrammerBaseGUI_cls::OnInsertDummy10)
EVT_MENU(menuGrammerInsertXYZ,     GrammerBaseGUI_cls::OnInsertXYZ)
EVT_MENU(menuGrammerInsertVxVyVz,  DataExporterGUI_cls::OnInsertVXVYVZ)
EVT_MENU(menuGrammerInsertRadius,  DataExporterGUI_cls::OnInsertRadius)
EVT_MENU(menuGrammerInsertType,    DataExporterGUI_cls::OnInsertType)
EVT_MENU(menuGrammerInsertId,      DataExporterGUI_cls::OnInsertId)
EVT_MENU(menuGrammerInsertValue1,  DataExporterGUI_cls::OnInsertValue1)
EVT_MENU(menuGrammerInsertTime,    DataExporterGUI_cls::OnInsertTime)
EVT_MENU(menuGrammerInsertNumber,  DataExporterGUI_cls::OnInsertNumber)
EVT_MENU(menuGrammerDelete,        DataExporterGUI_cls::OnDelete)
EVT_BUTTON(btnDataExportExport,    DataExporterGUI_cls::OnButtonExport)
EVT_BUTTON(btnDataExportInitSeq,   DataExporterGUI_cls::OnButtonInitSeq)
EVT_BUTTON(btnDataExportReference, DataExporterGUI_cls::OnButtonReference)
EVT_BUTTON(btnDataExportCopyFrom,  DataExporterGUI_cls::OnButtonCopyFromLoader)
EVT_BUTTON(btnDataExportLoad,      DataExporterGUI_cls::OnButtonLoadGrammer)
EVT_MOUSE_EVENTS(GrammerBaseGUI_cls::OnMouse)
EVT_LIST_KEY_DOWN(wxID_ANY, GrammerBaseGUI_cls::OnListKeyDown)
END_EVENT_TABLE()

DataExporterGUI_cls::
DataExporterGUI_cls(DataExporter_cls *pCCtrl, wxWindow *pC,
		    wxPoint pos, wxSize size) :
GrammerBaseGUI_cls(pCCtrl, pC, _("Data Exporter"), wxT("wxART_IMG_SEQ"))
{
    mpCCtrl = pCCtrl;
    mpCFrameMainLink = mpCCtrl->mpCMainLink->mpCFrame;
    SetPCPosInfoAtClose(&pCCtrl->mCDialogPos);
 
    // TCU[
    wxBoxSizer       *pBoxSizerSrc      = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer       *pBoxSizerParam    = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer       *pBoxSizerFormat   = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer       *pBoxSizerFormatL  = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer       *pBoxSizerFormatLT = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer       *pBoxSizerFormatR  = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer       *pBoxSizerFormatRT = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer       *pBoxSizerButtons  = new wxBoxSizer(wxHORIZONTAL);

    SetMNumExportParam(pBoxSizerParam);

    wxStaticText *pStaticTextHead = new wxStaticText
	(this, wxID_ANY, _("Header Format"));
    wxStaticText *pStaticTextBody = new wxStaticText
	(this, wxID_ANY, _("Body Format"));
    
    pBoxSizerFormatLT->Add(4, -1, 0, wxEXPAND);
    pBoxSizerFormatLT->Add(pStaticTextHead, 0, wxEXPAND);
    pBoxSizerFormatRT->Add(4, -1, 0, wxEXPAND);
    pBoxSizerFormatRT->Add(pStaticTextBody, 0, wxEXPAND);

    pBoxSizerFormatL->Add(pBoxSizerFormatLT, 0, wxEXPAND);
    pBoxSizerFormatR->Add(pBoxSizerFormatRT, 0, wxEXPAND);

    int listCtrlWidth = 280;

    mpCListCtrlHead = new wxListCtrlEX
	(this, wxID_ANY, wxDefaultPosition, wxSize(listCtrlWidth, 180),
	 wxLC_REPORT | wxSUNKEN_BORDER);
    SetColumn(mpCListCtrlHead);
    UpdateList(mpCListCtrlHead, mpCCtrl->mCGrammerHead); 

    mpCListCtrlBody = new wxListCtrlEX
	(this, wxID_ANY, wxDefaultPosition, wxSize(listCtrlWidth, 180),
	 wxLC_REPORT | wxSUNKEN_BORDER);
    SetColumn(mpCListCtrlBody);
    UpdateList(mpCListCtrlBody, mpCCtrl->mCGrammerBody);
    
    pBoxSizerFormatL->Add(mpCListCtrlHead, 1, wxEXPAND);
    pBoxSizerFormatR->Add(mpCListCtrlBody, 1, wxEXPAND);

    mpCBtnDefault = new wxButtonEX(this, btnDataLoaderDefault, wxT("Default"));
    
#ifdef WIN32
    int buttonWidth=100;
#else
    int buttonWidth=140;
#endif
    mpCButtonExport =
	new wxButtonEX(this, btnDataExportExport, _("Export Data"),
		       wxDP, wxSize(buttonWidth*1.5, -1));
    
    wxButtonEX *pCButtonLoad = 
	new wxButtonEX(this, btnDataExportLoad, _("Grammer Load"),
		       wxDP, wxSize(buttonWidth, -1));
    
    wxButtonEX *pCButtonCopy =
	new wxButtonEX(this, btnDataExportCopyFrom, _("Copy From Loader"),
		       wxDP, wxSize(buttonWidth*2, -1));
    
    pBoxSizerButtons->Add(mpCBtnDefault, 0, wxEXPAND);
    pBoxSizerButtons->Add(pCButtonLoad, 0, wxEXPAND);
    pBoxSizerButtons->Add(pCButtonCopy, 0, wxEXPAND);
    pBoxSizerButtons->Add(-1, -1, 1, wxEXPAND);
    pBoxSizerButtons->Add(mpCButtonExport, 0, wxEXPAND);

    pBoxSizerSrc->Add(pBoxSizerParam, 0, wxEXPAND);

    pBoxSizerFormat->Add(pBoxSizerFormatL, 1, wxEXPAND);
    pBoxSizerFormat->Add(pBoxSizerFormatR, 1, wxEXPAND);

    pBoxSizerSrc->Add(pBoxSizerFormat, 0, wxEXPAND);
    pBoxSizerSrc->Add(pBoxSizerButtons, 0, wxEXPAND);

    SetSizerAndFit(pBoxSizerSrc);
    
    mpCButtonExport->SetFocus();
}

DataExporterGUI_cls::
~DataExporterGUI_cls(){
    mpCCtrl->mpCGUI = NULL;
}

void DataExporterGUI_cls::
SetMNumExportParam(wxBoxSizer *pBoxSizer){
    mpCMNumExportParam = new MultiInputPanel_cls(this);
    
    MultiInputPanel_cls *pCurr = mpCMNumExportParam;
    //pCurr->mUpdateBit = ????

    int boxWidth = 3;
    pCurr->mTextWidth = 160/*-1*/;
    pCurr->mItemWidth = -1;

    wxString strListType[2] = {
	wxT("Simple Binary"),wxT("Simple Ascii") };
    pCurr->CombinePointerList(&mpCCtrl->mCDataType.mBody,
			      2, strListType, _("Data Type"));

    pCurr->CombinePointer(_ITEM_BOXSIZERHORIZONTAL, &boxWidth,
			  _("Initial sequence"));
    pCurr->CombinePointer(_ITEM_INTEGER, &mpCCtrl->mCInitNum.mBody);
    pCurr->CombinePointerButton(btnDataExportInitSeq, _("Calc. Auto"));
    pCurr->CombinePointerButton(btnDataExportReference, _("Reference"));
    
    pCurr->mItemWidth = -1;
    pCurr->CombinePointer(_ITEM_STRING, &mpCCtrl->mCFileSequence.mstrFormat);
    
    pCurr->mMinimumWidth = 560;

    pCurr->FinishSetting(pBoxSizer);
    
    pCurr->SetHook(this, &HookItem_cls::HookFunc01, _HOOK_COMBOBOX);
}

void DataExporterGUI_cls::
OnButtonInitSeq(wxCE &event){
    mpCCtrl->SetAutoInit();
    mpCMNumExportParam->UpdateValues();
}

void DataExporterGUI_cls::
OnButtonReference(wxCE& event){
    GpCFileDialog->SetMessage(_("Select filename to export data"));
    GpCFileDialog->SetWildcard(wxT("data(*.*)|*.*"));
    GpCFileDialog->SetStyle(wxFD_SAVE | wxFD_OVERWRITE_PROMPT);
    GpCFileDialog->SetInitPathFull(mpCCtrl->mCFileSequence.GetPathStr(_FN_FULLPATH));
    
    if (GpCFileDialog->ShowModal() == wxID_OK){
	GCUndoList.PushNewCommand
	    (new CommandSetValue_cls(&mpCCtrl->mCFileSequence.mstrFormat, GpCFileDialog->GetPath(), _COMMAND_UPDATE_DISPLAY_EXPORTER),
	     new CommandSetValue_cls(&mpCCtrl->mCFileSequence.mstrFormat, mpCCtrl->mCFileSequence.mstrPath, _COMMAND_UPDATE_DISPLAY_EXPORTER));
	GCUndoList.ExecCurrent();
	mpCCtrl->mCFileSequence.Set(mpCCtrl->mCFileSequence.mstrFormat, 0, 1);
	//mpCCtrl->mCFileSequence.Set(GpCFileDialog->GetPath());
	if (mpCCtrl->mCFileSequence.mDigitLength != -1)
	    mpCCtrl->mCInitNum.mBody = mpCCtrl->mCFileSequence.mInit;
	mpCMNumExportParam->UpdateValues();
    }
}

void DataExporterGUI_cls::
OnButtonCopyFromLoader(wxCE& event){
    mpCCtrl->CopyFromLoader();
    UpdateList(mpCListCtrlHead, mpCCtrlBase->mCGrammerHead);
    UpdateList(mpCListCtrlBody, mpCCtrlBase->mCGrammerBody);
}

void DataExporterGUI_cls::
OnButtonLoadGrammer(wxCE& event){

    GpCFileDialog->SetMessage(wxT("Choose grammer file to load"));
    GpCFileDialog->SetWildcard(wxT("Grammer file (*.grm)|*.grm"));
    if (mpCFrameMainLink->mCLastOpenedFileGRM.mstrBody.IsEmpty() == FALSE){
	wxFileName CName = mpCFrameMainLink->mCLastOpenedFileGRM.mstrBody;
	GpCFileDialog->SetInitPath(CName.GetPath(), CName.GetFullName());
    }
    GpCFileDialog->SetStyle(wxFD_FILE_MUST_EXIST);
    if (GpCFileDialog->ShowModal() == wxID_OK){
	bool bSucceed = mpCCtrl->LoadGrammer(GpCFileDialog->GetPath());
	UpdateListFromGrammer();
	//HideAndShow();
	if (bSucceed == FALSE)
	    MsgBox(this, wxT("Error"), wxT("File open failed."));
	else
	    mpCFrameMainLink->mCLastOpenedFileGRM.mstrBody = 
		GpCFileDialog->GetPath();
    }
}

void DataExporterGUI_cls::
OnButtonExport(wxCE& event){
    if (mpCCtrl->mbInExporting == TRUE){ 
	AbortExport(); return; }

    mpCMNumExportParam->AssignBase();
    
    mpCCtrl->mCFileSequence.Set(mpCCtrl->mCFileSequence.GetFormat(), 0, 1);
    mpCMNumExportParam->UpdateValues();

    if (mpCCtrl->mCFileSequence.mDigitLength == -1){
	if (MsgBoxYesno(this, _("Sequence Format error"),
			_("Not Sequence. Append 4-digit tag ?")) == FALSE)
	    return;
	mpCCtrl->mCFileSequence.AppendDefaultSequenceTag();
	mpCMNumExportParam->UpdateValues();
    }

    if (mpCCtrl->mCInitNum.mBody !=
	- GetPCTimeCtrl()->GetOffsetForImgSeq(0, 0)){
	wxString strMessage;
	strMessage << _("Initial Number is set to ") << mpCCtrl->mCInitNum.mBody << ENDL;
	strMessage << _("Working area starts at ") << GetPCTimeCtrl()->mCWAMin.mBody << ENDL;
	strMessage << _("Recommended Initial Number is ") << - GetPCTimeCtrl()->GetOffsetForImgSeq(0, 0) << ENDL;
	strMessage << _("Change Initial Number ?");
	if (MsgBoxYesno(this, _("Confirmation"), strMessage) == TRUE)
	    mpCCtrl->SetAutoInit();
    }

    mpCCtrlBase->SetHeaderGrammer(GetVGrammer(mpCListCtrlHead));
    mpCCtrlBase->SetBodyGrammer(GetVGrammer(mpCListCtrlBody));

    wxCommandEvent cmd(wxEVT_COMMAND_MENU_SELECTED, menuItemExportDataBegin);
    GetParent()->AddPendingEvent(cmd);
    mpCButtonExport->SetLabel(wxT("Abort Export"));
    mpCButtonExport->SetBackgroundColour(wxColour(wxT("RED")));
    mpCButtonExport->SetForegroundColour(wxColour(wxT("WHITE")));
    mpCCtrl->mbInExporting = TRUE;
}

void DataExporterGUI_cls::
OnButtonClose(wxCE& event){
    mpCMNumExportParam->UpdateValues();
    CloseEXKey();
}

void DataExporterGUI_cls::
AbortExport(){
    wxCommandEvent cmd(wxEVT_COMMAND_MENU_SELECTED, menuPlayStop);
    GetParent()->AddPendingEvent(cmd);
    ExportFinish();
}

void DataExporterGUI_cls::
ExportFinish(){
    mpCButtonExport->SetLabel(wxT("Export Data"));
    mpCButtonExport->SetBackgroundColour(wxNullColour);
    mpCButtonExport->SetForegroundColour(wxNullColour);
    mpCCtrl->mbInExporting = FALSE;
}

TimeCtrl_cls *DataExporterGUI_cls::
GetPCTimeCtrl(){
    return mpCCtrl->mpCMainLink->mpCTime;
}

//--

void DataExporterGUI_cls::
OnBtnUpHead(wxCommandEvent& event){
    SwapList(mpCListCtrlHead, -1);
}

void DataExporterGUI_cls::
OnBtnDownHead(wxCommandEvent& event){
    SwapList(mpCListCtrlHead, +1);
}

void DataExporterGUI_cls::
OnBtnUpBody(wxCommandEvent& event){
    SwapList(mpCListCtrlBody, -1);
}

void DataExporterGUI_cls::
OnBtnDownBody(wxCommandEvent& event){
    SwapList(mpCListCtrlBody, +1);
}

void DataExporterGUI_cls::
OnBtnDefault(wxCommandEvent& event){
    SetToDefault(this, mpCCtrl->mCGrammerHead, mpCCtrl->mCGrammerBody);
}

void DataExporterGUI_cls::
OnDelete(wxCommandEvent &event){
    DeleteSelectedItem(GetPActiveListCtrl());
    UpdateIndexAndColor(GetPActiveListCtrl());
}

void DataExporterGUI_cls::
OnKeyDown(wxKeyEvent& event){
    SendKeyEventToTop(mpCFrameMainLink, event);
    //SendKeyEventToTop(GpCMainFrameCLS, event);
}

void DataExporterGUI_cls::
HookFunc01(int id, void *pArg){
    OnHookCombobox();
}

// ---

DataExporter_cls::
DataExporter_cls(Main_cls *pCMain, DataLoader_cls *pCDataLoaderLink) :
//mCFileSequence(wxGetCwd() + DELIMWX + wxT("Data%04d.bin3")),
GrammerBase_cls(wxT("DataExport"))
{
    mpCGUI = NULL;
    mpCMainLink = pCMain;
    mpCDataLoaderLink = pCDataLoaderLink;
    
    mCConfList.Add(&mCLastSavedFile, wxT("DataExportLastSavedFile="), wxT("NONE"));
    mCConfList.Add(&mCInitNum, wxT("DataExportInitNum="), wxT("0"));
}

void DataExporter_cls::
SetAutoInit(){
    mCInitNum.mBody = - mpCMainLink->mpCTime->GetOffsetForImgSeq(0, 0);
}

void DataExporter_cls::
InitGUI(FrameMain_cls *pC){
    mpCGUI = new DataExporterGUI_cls(this, pC, mCDialogPos, wxDS);
    SetPDialog(mpCGUI);
}

void DataExporter_cls::
OpenWindow(FrameMain_cls *pCParent){
    if (mpCGUI == NULL) InitGUI(pCParent);
    if (mpCGUI->IsShownOnScreen() == FALSE){
	mpCGUI->Show(TRUE);
	mpCGUI->SetFocus();
    }
    else
	mpCGUI->SetFocus();

    mpCGUI->Raise();
}

void DataExporter_cls::
UpdateItems(bool bForce){
    mpCGUI->mpCMNumExportParam->UpdateValues(_MN_ALLITEM);
}

void DataExporter_cls::
ExportFinish(){
    if (mpCGUI != NULL)
	mpCGUI->ExportFinish();
}

bool DataExporter_cls::
ExportBinary(wxString strFilename, PDataBlock_cls *pCDataBlock, int downsize){
    FILE *fp = fopen(strFilename.char_str(), "wb");
    if (fp == NULL) return FALSE;

    std::vector < int > VGrammerHead, VGrammerBody;
    for (int i = 0; i < (int)mCGrammerHead.mDimension; i++)
	VGrammerHead.push_back(mCGrammerHead.mpBody[i]);
    for (int i = 0; i < (int)mCGrammerBody.mDimension; i++)
	VGrammerBody.push_back(mCGrammerBody.mpBody[i]);

    float  time = pCDataBlock->mpCParentSnap->mTime;
    int    PNum = pCDataBlock->mPNumBlock;

    int    PNumDownsized = PNum/downsize;
    if (PNum % downsize != 0) PNumDownsized++;

    printf("%S time=%f\n", strFilename.c_str(), time);

    float dummy[10];

    if (PNum == 0 || pCDataBlock->mbAllocated == FALSE) {
	fclose(fp);
	return FALSE;
    }

    int headNumber = (int)VGrammerHead.size();
    for (int i = 0; i < headNumber; i++){
	switch(VGrammerHead[i]){
	case _GRAMMER_TIME:
	    fwrite(&time, sizeof(float), 1, fp);
	    break;
	case _GRAMMER_NUMBER:
	    fwrite(&PNumDownsized, sizeof(int), 1, fp);
	    break;
	case _GRAMMER_DUMMY1:
	    fwrite(&dummy, sizeof(float), 1, fp);
	    break;
	case _GRAMMER_DUMMY3:
	    fwrite(&dummy, sizeof(float), 3, fp);
	    break;
	case _GRAMMER_DUMMY10:
	    fwrite(&dummy, sizeof(float), 10, fp);
	    break;
	}
    }

    float (*pX)[3] = pCDataBlock->mpX;
    float (*pV)[3] = pCDataBlock->mpV;
    float *pRadius = pCDataBlock->mpRadius;
    float *pValue1 = pCDataBlock->mpValue1;
    unsigned char *pTypeChar = pCDataBlock->mpType;
    int   *pID     = pCDataBlock->mpID;
    bool  bUseID   = pCDataBlock->mbUseID;

    int itemNumber = (int)VGrammerBody.size();
    for (int i = 0; i < PNum; i+=downsize){
	for (int j = 0; j < itemNumber; j++){
	    switch(VGrammerBody[j]){
	    case _GRAMMER_XYZ:
		fwrite(&pX[i], sizeof(float), 3, fp);
		break;
	    case _GRAMMER_VXVYVZ:
		fwrite(&pV[i], sizeof(float), 3, fp);
		break;
	    case _GRAMMER_RADIUS:
		fwrite(&pRadius[i], sizeof(float), 1, fp);
		break;
	    case _GRAMMER_TYPE: {
		int type = (int)pTypeChar[i];
		fwrite(&type, sizeof(int), 1, fp);
		break; }
	    case _GRAMMER_ID:
		if (bUseID == TRUE)
		    fwrite(&pID[i], sizeof(int), 1, fp);
		else
		    fwrite(&i, sizeof(int), 1, fp);
		break;
	    case _GRAMMER_VALUE1:
		fwrite(&pValue1[i], sizeof(int), 1, fp);
		break;
	    case _GRAMMER_DUMMY1:
		fwrite(&dummy, sizeof(float), 1, fp);
		break;
	    case _GRAMMER_DUMMY3:
		fwrite(&dummy, sizeof(float), 3, fp);
		break;
	    case _GRAMMER_DUMMY10:
		fwrite(&dummy, sizeof(float), 10, fp);
		break;
	    }
	}
    }
    
    fclose(fp);
    mCurrentOffset++;
    return TRUE;
}

bool DataExporter_cls::
ExportAscii(wxString strFilename, PDataBlock_cls *pCDataBlock, int downsize){
    FILE *fp = fopen(strFilename.char_str(), "wt");
    if (fp == NULL) return FALSE;

    std::vector < int > VGrammerHead, VGrammerBody;
    for (int i = 0; i < (int)mCGrammerHead.mDimension; i++)
	VGrammerHead.push_back(mCGrammerHead.mpBody[i]);
    for (int i = 0; i < (int)mCGrammerBody.mDimension; i++)
	VGrammerBody.push_back(mCGrammerBody.mpBody[i]);

    float  time = pCDataBlock->mpCParentSnap->mTime;
    int    PNum = pCDataBlock->mPNumBlock;

    int    PNumDownsized = PNum/downsize;
    if (PNum % downsize != 0) PNumDownsized++;

    printf("%S time=%f\n", strFilename.c_str(), time);

    int headNumber = (int)VGrammerHead.size();
    for (int i = 0; i < headNumber; i++){
	switch(VGrammerHead[i]){
	case _GRAMMER_TIME:
	    fprintf(fp, "%f\n", time);
	    break;
	case _GRAMMER_NUMBER:
	    fprintf(fp, "%d\n", PNumDownsized);
	    break;
	case _GRAMMER_DUMMY1:
	    fprintf(fp, "dummy");
	    break;
	case _GRAMMER_DUMMY3:
	    for (int i = 0; i < 3; i++)
		fprintf(fp, "dummy");
	    break;
	case _GRAMMER_DUMMY10:
	    for (int i = 0; i < 10; i++)
		fprintf(fp, "dummy");
	    break;
	}
    }
    
    float (*pX)[3] = pCDataBlock->mpX;
    float (*pV)[3] = pCDataBlock->mpV;
    float *pRadius = pCDataBlock->mpRadius;
    float *pValue1 = pCDataBlock->mpValue1;
    unsigned char *pTypeChar = pCDataBlock->mpType;
    int   *pID     = pCDataBlock->mpID;
    bool  bUseID   = pCDataBlock->mbUseID;

    int itemNumber = (int)VGrammerBody.size();
    for (int i = 0; i < PNum; i+=downsize){
	for (int j = 0; j < itemNumber; j++){
	    switch(VGrammerBody[j]){
	    case _GRAMMER_XYZ:
		fprintf(fp, "%f %f %f ", pX[i][X], pX[i][Y], pX[i][Z]);
		break;
	    case _GRAMMER_VXVYVZ:
		fprintf(fp, "%f %f %f ", pV[i][X], pV[i][Y], pV[i][Z]);
		break;
	    case _GRAMMER_RADIUS:
		fprintf(fp, "%f ", pRadius[i]);
		break;
	    case _GRAMMER_TYPE: {
		int type = (int)pTypeChar[i];
		fprintf(fp, "%d ", type);
		break; }
	    case _GRAMMER_ID:
		if (bUseID == TRUE)
		    fprintf(fp, "%d ", pID[i]);
		else
		    fprintf(fp, "%d ", i);
		break;
	    case _GRAMMER_VALUE1:
		fprintf(fp, "%f ", pValue1[i]);
		break;
	    case _GRAMMER_DUMMY1:
		fprintf(fp, "0 ");
		break;
	    case _GRAMMER_DUMMY3:
		fprintf(fp, "0 ");
		break;
	    case _GRAMMER_DUMMY10:
		fprintf(fp, "0 ");
		break;
	    }
	}
	fprintf(fp, "\n");
    }
    
    fclose(fp);
    mCurrentOffset++;
    return TRUE;
}

wxString DataExporter_cls::
GetWXStrModifiedFilename(){
    return mCFileSequence.GetModifiedStr(mCurrentOffset + mCInitNum.mBody);
}

void DataExporter_cls::
ExportData(PDataBlock_cls *pCDataBlock, int downsize, int index){
    if (index == mCurrentIndex) return;
    if (mCDataType.mBody == _DATA_SIMPLEBINARY)
	ExportBinary(GetWXStrModifiedFilename(), pCDataBlock, downsize);
    else
	ExportAscii(GetWXStrModifiedFilename(), pCDataBlock, downsize);
    mCurrentIndex = index;
}

void DataExporter_cls::
CopyFromLoader(){
    mpCDataLoaderLink->UpdateGrammerFromList(mpCDataLoaderLink->mpCGUI);

    mCGrammerHead.mDimension = mpCDataLoaderLink->mCGrammerHead.mDimension;
    for (int i = 0; i < mCGrammerHead.mDimension; i++)
	mCGrammerHead.mpBody[i] = mpCDataLoaderLink->mCGrammerHead.mpBody[i];
    mCGrammerBody.mDimension = mpCDataLoaderLink->mCGrammerBody.mDimension;
    for (int i = 0; i < mCGrammerBody.mDimension; i++)
	mCGrammerBody.mpBody[i] = mpCDataLoaderLink->mCGrammerBody.mpBody[i];
}

bool DataExporter_cls::
LoadGrammer(wxString strFile){
    std::wifstream ifstream(strFile.char_str(), std::ios::in);
    if (ifstream.fail()) return FALSE;
    std::wstring wstrLine;
    while ( std::getline (ifstream, wstrLine)){
	wxString strLine = wstrLine.c_str();
	strLine.Replace(wxT("DataLoad"), wxT("DataExport"));
	ReadStrLine(strLine);
    }
    
    return TRUE;
}

//----

void DataExporter_cls::
ReadStrLine(wxString strLine){
    mCConfList.ReadStrLineAll(strLine);
}

wxString DataExporter_cls::
Serialize(){
    return mCConfList.SerializeAll();
}
