// (setq c-basic-offset 4)
// "clsDataExporter.cpp"

#ifndef _DATA_EXPORTER_H_
#define _DATA_EXPORTER_H_

#include <wx/wx.h>
#include <wx/glcanvas.h>

#include "../COMMON/CommonDefinitionsForH.h"

class DataExporter_cls;
class FrameMain_cls;
class Main_cls;
class PDataBlock_cls;
class TimeCtrl_cls;

#define _DATA_SIMPLEBINARY 0
#define _DATA_SIMPLEASCII  1

#include "clsGrammerBase.h"

#include "../COMMON/clsFilename.h"
#include "../CONFITEM/clsConfItem.h"
#include "../WIDGETCTRL/clsHookCtrl.h"
#include "../WIDGETCTRL/clsMultiInputPanel.h"
#include "../WIDGETCTRL/clsDialogEXKey.h"
#include "../WIDGETCTRL/clsDialogController.h"
#include "../WIDGETCTRL/EX/clsButtonEX.h"

class DataLoader_cls;

class DataExporterGUI_cls : public GrammerBaseGUI_cls, public HookItem_cls {
 public:
    DataExporterGUI_cls(DataExporter_cls* pCCtrl,
			wxWindow *pC, wxPoint pos, wxSize size);
    ~DataExporterGUI_cls();

    FrameMain_cls *mpCFrameMainLink;

    DataExporter_cls* mpCCtrl;

    void OnButtonInitSeq  (wxCE& event);
    void OnButtonReference(wxCE& event);
    void OnButtonExport   (wxCE& event);
    void OnButtonClose    (wxCE& event);
    void OnButtonCopyFromLoader(wxCE& event);
    void OnButtonLoadGrammer(wxCE& event);
    void OnButtonAbort      (wxCE& event);
    void AbortExport();
    void ExportFinish();

    MultiInputPanel_cls* mpCMNumExportParam;
    void SetMNumExportParam(wxBoxSizer *pBoxSizer);

    wxButtonEX     *mpCButtonExport;

    TimeCtrl_cls *GetPCTimeCtrl();

    void OnBtnUpHead(wxCommandEvent &event);
    void OnBtnDownHead(wxCommandEvent &event);
    void OnBtnUpBody(wxCommandEvent &event);
    void OnBtnDownBody(wxCommandEvent &event);
    void OnBtnDefault(wxCommandEvent &event);
    void OnDelete(wxCommandEvent &event);
    void OnKeyDown(wxKeyEvent& event);

    void HookFunc01(int id, void *pArg);

 private:
    // any class wishing to process wxWidgets events must use this macro
    DECLARE_EVENT_TABLE()
};

class DataExporter_cls :
public GrammerBase_cls, public DialogControl_cls{
 public:
    DataExporter_cls(Main_cls *pCMain, DataLoader_cls *pCDataLoaderLink);
    
    Main_cls            *mpCMainLink;
    DataExporterGUI_cls *mpCGUI;
    DataLoader_cls      *mpCDataLoaderLink;
    FileSequence_cls    mCFileSequence;
    

    ConfItemSTR_cls   mCLastSavedFile;
    ConfItemINT_cls   mCInitNum;
    int             mCurrentOffset;
    int             mCurrentIndex;
    bool            mbInExporting;

    void SetAutoInit();

    void InitGUI(FrameMain_cls *pC);
    void OpenWindow(FrameMain_cls *pCParent);
    void UpdateItems(bool bForce = FALSE);

    void ExportFinish();

    bool ExportBinary(wxString strFilename, PDataBlock_cls *pCDataBlock, int downsize);
    bool ExportAscii(wxString strFilename, PDataBlock_cls *pCDataBlock, int downsize);
    wxString GetWXStrModifiedFilename();
    void ExportData(PDataBlock_cls *pCDataBlock, int downsize, int index);
    void CopyFromLoader();
    bool LoadGrammer(wxString strFile);
    
    void ReadStrLine(wxString strLine);
    wxString Serialize();
};

#endif
