// -*- c++ -*- 
// "clsDataLoader.cpp"
// (setq c-basic-offset 4)

#ifndef _DATA_LOADER_GUI_H_
#define _DATA_LOADER_GUI_H_

#include "clsGrammerBase.h"

#include "../HDF5/clsHDF5GUI.h"

#include "../WIDGETCTRL/clsHookCtrl.h"
#include "../WIDGETCTRL/clsDialogEXKey.h"
#include <wx/notebook.h>

class DataLoader_cls;
class MultiInputPanel_cls;
class wxButtonEX;

class DataLoaderGUI_cls : public GrammerBaseGUI_cls, public HookItem_cls
{
 public: 
    DataLoaderGUI_cls(wxWindow *pCParent, DataLoader_cls *pCCtrl);
    ~DataLoaderGUI_cls();
    
    wxWindow *mpCParent;
    DataLoader_cls *mpCCtrl;

    HDF5GUI_cls *mpCHDF5GUI;
    
    wxButton *mpCButtonCheckHDF5;

    wxStaticText   *mpCStaticTextHead;
    wxStaticText   *mpCStaticTextBody;
    
    wxNotebook *mpCBook1;

    MultiInputPanel_cls* mpCMInput;
    MultiInputPanel_cls* mpCMInputManipulate;
    MultiInputPanel_cls* mpCMInputLimitter;
    MultiInputPanel_cls* mpCMInputSequence;
    MultiInputPanel_cls* mpCMInputPeriodic;
    void SetMInput(wxBoxSizer *pBoxSizer);
    void SetMInputModifier(wxWindow *pCParent);
    void SetMInputLimitter(wxWindow *pCParent);
    void SetMInputSequence(wxWindow *pCParent);
    void SetMInputPeriodic(wxBoxSizer *pBoxSizer);
    
    void HideAndShow();
    
    bool CheckDataHDF5(wxString strFilePath);

    void SetFileDialogInfo();
    void OnBtnCheckHDF5(wxCommandEvent& event);
    void OnBtnOpenFile(wxCommandEvent& event);
    void OnBtnDefault(wxCommandEvent& event);
    void OnBtnPeriodic(wxCommandEvent &event);
    void OnBtnSave(wxCommandEvent& event);
    void OnBtnLoad(wxCommandEvent& event);
    void OnDelete(wxCommandEvent &event);
    void OnKeyDown(wxKeyEvent& event);
    
    void HookFunc01(int id, void *pArg);
    //static void FuncHookCombobox(void *pEvent, void *pArg);
    
    DECLARE_EVENT_TABLE()
};

#endif
