// -*- c++ -*-
// "clsGrammerBase.h"
// (setq c-basic-offset 4)

#include "clsGrammerBase.h"
#include "clsDataLoader.h"

#include "../MYAPI/MsgBox.h"

#include "../WIDGETCTRL/EX/clsListCtrlEX.h"
#include "../WIDGETCTRL/WX/myArtProv.h"

#include "../../wxWidgetEnum.h"
#include "../../wxWidgetEnumMenu.h"

#include "../COMMON/CommonDefinitions.h"

// ---

GrammerBaseGUI_cls::
GrammerBaseGUI_cls(GrammerBase_cls *pCCtrlBase, wxWindow *pC, 
		   wxString strLabel, wxString strIcon) :
    wxDialogEXKey(pC, wxID_ANY, strLabel, wxDPS, ART(strIcon))
{
    mpCCtrlBase = pCCtrlBase;

    mpPopupMenuHeader = new wxMenu;
    mpPopupMenuBody = new wxMenu;

    mstrItemName[0].push_back(wxT("Time"));
    mstrItemName[0].push_back(wxT("Number"));
    mstrItemName[0].push_back(wxT("Dummy"));
    mstrItemName[0].push_back(wxT("Dummy*3"));
    mstrItemName[0].push_back(wxT("Dummy*10"));
    mstrItemDescript[0].push_back(wxT("float"));
    mstrItemDescript[0].push_back(wxT("integer"));
    mstrItemDescript[0].push_back(wxT("float"));
    mstrItemDescript[0].push_back(wxT("float*3"));
    mstrItemDescript[0].push_back(wxT("float*10"));
    mstrItemByte[0].push_back(wxT("4"));
    mstrItemByte[0].push_back(wxT("4"));
    mstrItemByte[0].push_back(wxT("4"));
    mstrItemByte[0].push_back(wxT("12"));
    mstrItemByte[0].push_back(wxT("40"));

    mstrItemName[1].push_back(wxT("x y z"));
    mstrItemName[1].push_back(wxT("Vx Vy Vz"));
    mstrItemName[1].push_back(wxT("Dummy"));
    mstrItemName[1].push_back(wxT("Dummy*3"));
    mstrItemName[1].push_back(wxT("Dummy*10"));
    mstrItemName[1].push_back(wxT("Radius"));
    mstrItemName[1].push_back(wxT("ID"));
    mstrItemName[1].push_back(wxT("Type"));
    mstrItemName[1].push_back(wxT("Value1"));
    mstrItemDescript[1].push_back(wxT("float*3"));
    mstrItemDescript[1].push_back(wxT("float*3"));
    mstrItemDescript[1].push_back(wxT("float"));
    mstrItemDescript[1].push_back(wxT("float*3"));
    mstrItemDescript[1].push_back(wxT("float*10"));
    mstrItemDescript[1].push_back(wxT("float"));
    mstrItemDescript[1].push_back(wxT("integer"));
    wxString strInteger = wxString::Format(wxT("integer[0-%d]"), _MAX_PARTICLE_TYPE-1);
    mstrItemDescript[1].push_back(strInteger);
    mstrItemDescript[1].push_back(wxT("float"));
    mstrItemByte[1].push_back(wxT("12"));
    mstrItemByte[1].push_back(wxT("12"));
    mstrItemByte[1].push_back(wxT("4"));
    mstrItemByte[1].push_back(wxT("12"));
    mstrItemByte[1].push_back(wxT("40"));
    mstrItemByte[1].push_back(wxT("4"));
    mstrItemByte[1].push_back(wxT("4"));
    mstrItemByte[1].push_back(wxT("4"));
    mstrItemByte[1].push_back(wxT("4"));
}

GrammerBaseGUI_cls::
~GrammerBaseGUI_cls(){
    delete mpPopupMenuHeader;
    delete mpPopupMenuBody;
}

wxListCtrl* GrammerBaseGUI_cls::
GetPActiveListCtrl(){
    if (mActiveList == 0)
	return mpCListCtrlHead;
    return mpCListCtrlBody;
}

std::vector < int > GrammerBaseGUI_cls::
GetVGrammer(wxListCtrl* pCList){
    std::vector < int > VGrammer;
    wxInt32 nItem = -1;
    while (TRUE){
	nItem = pCList->GetNextItem(nItem, wxLIST_NEXT_ALL);
	if (nItem == -1) break;
	VGrammer.push_back((int)pCList->GetItemData(nItem));
    }
    return VGrammer;
}

int GrammerBaseGUI_cls::
GetListId(wxListCtrl *pCList){
    if (pCList == mpCListCtrlHead) return 0;
    return 1;
}

void GrammerBaseGUI_cls::
SetColumn(wxListCtrl* pCList){
    pCList->InsertColumn(0,wxT(""), wxLIST_FORMAT_CENTER, 20);
    pCList->InsertColumn(1,_("Data"), wxLIST_FORMAT_LEFT, 90);
    pCList->InsertColumn(2,_("Type"), wxLIST_FORMAT_LEFT, 90);
    pCList->InsertColumn(3,_("Byte"), wxLIST_FORMAT_LEFT, 70);
}

void GrammerBaseGUI_cls::
SetToDefault(wxWindow *pCParent, 
	     ConfItemINTARRAY_cls &CGrammerHead, 
	     ConfItemINTARRAY_cls &CGrammerBody){
    if (MsgBoxYesno(pCParent, _("Inquery"), _("Set to default ?")) == TRUE){
	CGrammerHead.SetItem(mpCCtrlBase->mstrTag + wxT("GrammerHead="), wxT("0 1"));
	CGrammerBody.SetItem(mpCCtrlBase->mstrTag + wxT("GrammerBody="), wxT("0 1 5 6 7 8"));
	UpdateListFromGrammer();
    }
}

void GrammerBaseGUI_cls::
UpdateListFromGrammer(){
    UpdateList(mpCListCtrlHead, mpCCtrlBase->mCGrammerHead);
    UpdateList(mpCListCtrlBody, mpCCtrlBase->mCGrammerBody);
}
void GrammerBaseGUI_cls::
UpdateList(wxListCtrl *pCList, ConfItemINTARRAY_cls &Grammer){
    if (pCList == mpCListCtrlHead){
	mpCListCtrlHead->DeleteAllItems();
	for (int i = 0; i < Grammer.mDimension; i++)
	    AddListItem(mpCListCtrlHead, -1, Grammer.mpBody[i]);
	UpdateIndexAndColor(pCList);
    }
    if (pCList == mpCListCtrlBody){
	mpCListCtrlBody->DeleteAllItems();
	for (int i = 0; i < Grammer.mDimension; i++)
	    AddListItem(mpCListCtrlBody, -1, Grammer.mpBody[i]);
	UpdateIndexAndColor(pCList);
    }
}

void GrammerBaseGUI_cls::
DeleteSelectedItem(wxListCtrl *pCList){
    wxInt32 nItem = -1;
    while (TRUE){
	nItem = pCList->GetNextItem(nItem, wxLIST_NEXT_ALL, 
				    wxLIST_STATE_SELECTED);
	if (nItem == -1) break;
	pCList->DeleteItem(nItem);
	nItem = -1;
    }
}

void GrammerBaseGUI_cls::
AddListItem(wxListCtrl *pCList, wxInt32 nID, int typeItem/*, int typeFormat*/){
    int listId = GetListId(pCList);
    wxListItem listItem;
    
    if (nID == -1)
	nID = pCList->GetNextItem(-1, wxLIST_NEXT_ALL, 
				  wxLIST_STATE_SELECTED);
    
    if (nID == -1)// ǉ
	nID = pCList->GetItemCount();
    else
	;//nID++; //Î̎
    
    listItem.SetId(nID);
    listItem.SetMask(wxLIST_MASK_DATA | wxLIST_MASK_STATE);
    listItem.SetData(typeItem);
    
    wxString strNum; strNum << pCList->GetItemCount();
    listItem.SetText(strNum);
    pCList->InsertItem(listItem);
    
    pCList->SetItem(nID, 1, mstrItemName[listId][typeItem]);

    if (mpCCtrlBase->mCDataType.mBody == _DATA_SIMPLEBINARY){
	pCList->SetItem(nID, 2, mstrItemDescript[listId][typeItem]);
	pCList->SetItem(nID, 3, mstrItemByte[listId][typeItem]);
    }
    else{
	pCList->SetItem(nID, 2, wxT("-"));
	pCList->SetItem(nID, 3, wxT("-"));
    }
}

void GrammerBaseGUI_cls::
UpdateIndexAndColor(wxListCtrl *pCList){
    wxInt32 nItem = -1;
    int index = 0;
    while (TRUE){
	nItem = pCList->GetNextItem(nItem, wxLIST_NEXT_ALL);
	if (nItem == -1) break;
	wxString strIndex; strIndex << index;
	pCList->SetItem(nItem, 0, strIndex);
	int typeItem = (int)pCList->GetItemData(nItem);
	wxListItem listItem;
	listItem.SetId(nItem);
	if (typeItem == _GRAMMER_DUMMY1 ||
	    typeItem == _GRAMMER_DUMMY3 ||
	    typeItem == _GRAMMER_DUMMY10){
	    pCList->GetItem(listItem);
	    listItem.SetTextColour(*wxLIGHT_GREY);
	    pCList->SetItem(listItem);
	}
	else{
	    pCList->GetItem(listItem);
	    listItem.SetTextColour(*wxBLACK);
	    pCList->SetItem(listItem);
	}
	index++;
    }
}

void GrammerBaseGUI_cls::
SwapList(wxListCtrl *pCList, int relativeTgt){
    if (pCList->GetItemCount() < 2) return;

    int listId = GetListId(pCList);
    std::vector < wxInt32 > VItemList;

    wxInt32 nItem = -1, nItemPrev;
    while (TRUE){
	nItem = pCList->GetNextItem(nItem, wxLIST_NEXT_ALL);
	if (nItem == -1) break;
	VItemList.push_back(nItem);
    }

    while (TRUE){
	if (relativeTgt == 0) break;

	int index = 0;
	if (relativeTgt > 0)
	    index = (int)VItemList.size() - 1; //SwapDown͉T
    
	while (TRUE){
	    if (index < 0 || index >= (int)VItemList.size()) break;
	    nItem = VItemList[index];
	    
	    // ݂̃ACeIACeȂ珈
	    int stateCurr = 
		pCList->GetItemState(nItem, wxLIST_STATE_SELECTED);
	    
	    if (stateCurr != 0){
		int prevIndex = index;
		if (relativeTgt > 0) prevIndex++;
		if (relativeTgt < 0) prevIndex--;
		
		if (prevIndex < 0 || prevIndex >= (int)VItemList.size()){
		    if (relativeTgt > 0) index--;
		    if (relativeTgt < 0) index++;
		    continue;
		}
		nItemPrev = VItemList[prevIndex];
		
		int statePrev = 
		    pCList->GetItemState(nItemPrev, wxLIST_STATE_SELECTED);
		
		// Xbvf[^
		wxUIntPtr ptrPrev = pCList->GetItemData(nItemPrev);
		wxUIntPtr ptrCurr = pCList->GetItemData(nItem);
		
		// Xbvs
		pCList->SetItemData (nItemPrev, (int)pCList->GetItemData(nItem));
		pCList->SetItemState(nItemPrev, stateCurr, wxLIST_STATE_SELECTED);
		pCList->SetItemData (nItem, ptrPrev);
		pCList->SetItemState(nItem, statePrev, wxLIST_STATE_SELECTED);

		int typeCurr = (int)pCList->GetItemData(nItem);
		int typePrev = (int)pCList->GetItemData(nItemPrev);

		wxString strNameA = mstrItemName[listId][typeCurr];
		wxString strNameB = mstrItemName[listId][typePrev];

		pCList->SetItem(nItem,1,mstrItemName[listId][typeCurr]);
		pCList->SetItem(nItemPrev,1,mstrItemName[listId][typePrev]);
		
		if (mpCCtrlBase->mCDataType.mBody == _DATA_SIMPLEBINARY){
		    pCList->SetItem(nItem,2,mstrItemDescript[listId][typeCurr]);
		    pCList->SetItem(nItem,3,mstrItemByte[listId][typeCurr]);
		    pCList->SetItem(nItemPrev,2,mstrItemDescript[listId][typePrev]);
		    pCList->SetItem(nItemPrev,3,mstrItemByte[listId][typePrev]);
		}
		else{
		    pCList->SetItem(nItem,2,wxT("-"));
		    pCList->SetItem(nItem,3,wxT("-"));
		    pCList->SetItem(nItemPrev,2,wxT("-"));
		    pCList->SetItem(nItemPrev,3,wxT("-"));
		}
	    }
	    
	    if (relativeTgt > 0) index--;
	    if (relativeTgt < 0) index++;
	}
	if (relativeTgt > 0) relativeTgt --;
	if (relativeTgt < 0) relativeTgt ++;
    }

    UpdateIndexAndColor(pCList);
}

void GrammerBaseGUI_cls::
ClearMenu(wxMenu* pMenu){
    wxMenuItemList list = pMenu->GetMenuItems();
    
    for (wxMenuItemList::iterator iter = list.begin(); iter != list.end(); 
	 ++iter)
	pMenu->Delete(*iter);
}

void GrammerBaseGUI_cls::
UpdateMenuHead(){
    ClearMenu(mpPopupMenuHeader);
    
    bool bTime   = FALSE;
    bool bNumber = FALSE;
    
    wxListCtrl *pCList = mpCListCtrlHead;
    wxInt32 nItem = -1;
    while (TRUE){
	nItem = pCList->GetNextItem(nItem, wxLIST_NEXT_ALL);
	if (nItem == -1) break;
	if (pCList->GetItemData(nItem) == _GRAMMER_TIME)   bTime   = TRUE;
	if (pCList->GetItemData(nItem) == _GRAMMER_NUMBER) bNumber = TRUE;
    }

    mpPopupMenuHeader->Append(menuGrammerDelete, _("Delete item"));
    mpPopupMenuHeader->AppendSeparator();
    if (pCList->GetNextItem(-1, wxLIST_NEXT_ALL, wxLIST_STATE_SELECTED) == -1)
	mpPopupMenuHeader->Enable(menuGrammerDelete, FALSE);

    if (bTime == FALSE) 
	mpPopupMenuHeader->Append(menuGrammerInsertTime, wxT("Time"));
    if (bNumber == FALSE) 
	mpPopupMenuHeader->Append(menuGrammerInsertNumber, wxT("Number"));

    mpPopupMenuHeader->Append(menuGrammerInsertDummy1, _("Dummy"));
    mpPopupMenuHeader->Append(menuGrammerInsertDummy3, _("Dummy*3"));
    mpPopupMenuHeader->Append(menuGrammerInsertDummy10, _("Dummy*10"));
}

void GrammerBaseGUI_cls::
UpdateMenuBody(){
    ClearMenu(mpPopupMenuBody);

    bool bXYZ    = FALSE;
    bool bVxVyVz = FALSE;
    bool bRadius = FALSE;
    bool bId     = FALSE;
    bool bType   = FALSE;
    bool bValue1 = FALSE;
    
    wxListCtrl *pCList = mpCListCtrlBody;
    wxInt32 nItem = -1;
    while (TRUE){
	nItem = pCList->GetNextItem(nItem, wxLIST_NEXT_ALL);
	if (nItem == -1) break;
	if (pCList->GetItemData(nItem) == _GRAMMER_XYZ)    bXYZ = TRUE;
	if (pCList->GetItemData(nItem) == _GRAMMER_VXVYVZ) bVxVyVz = TRUE;
	if (pCList->GetItemData(nItem) == _GRAMMER_RADIUS) bRadius = TRUE;
	if (pCList->GetItemData(nItem) == _GRAMMER_ID)     bId   = TRUE;
	if (pCList->GetItemData(nItem) == _GRAMMER_TYPE)   bType = TRUE;
	if (pCList->GetItemData(nItem) == _GRAMMER_VALUE1) bValue1 = TRUE;
    }

    mpPopupMenuBody->Append(menuGrammerDelete, _("Delete item"));
    mpPopupMenuBody->AppendSeparator();
    if (pCList->GetNextItem(-1, wxLIST_NEXT_ALL, wxLIST_STATE_SELECTED) == -1)
	mpPopupMenuBody->Enable(menuGrammerDelete, FALSE);

    if (bXYZ == FALSE) 
	mpPopupMenuBody->Append(menuGrammerInsertXYZ, wxT("XYZ"));
    if (bVxVyVz == FALSE) 
	mpPopupMenuBody->Append(menuGrammerInsertVxVyVz, wxT("VxVyVz"));
    if (bRadius == FALSE) 
	mpPopupMenuBody->Append(menuGrammerInsertRadius, wxT("Raius"));
    if (bId == FALSE)
	mpPopupMenuBody->Append(menuGrammerInsertId, wxT("ID"));
    if (bType == FALSE)
	mpPopupMenuBody->Append(menuGrammerInsertType, wxT("Type"));
    if (bValue1 == FALSE)
	mpPopupMenuBody->Append(menuGrammerInsertValue1, wxT("Value1"));
    
    mpPopupMenuBody->Append(menuGrammerInsertDummy1, _("Dummy"));
    mpPopupMenuBody->Append(menuGrammerInsertDummy3, _("Dummy*3"));
    mpPopupMenuBody->Append(menuGrammerInsertDummy10, _("Dummy*10"));
}

void GrammerBaseGUI_cls::
OnHookCombobox(){
    mpCCtrlBase->SetHeaderGrammer(GetVGrammer(mpCListCtrlHead));
    mpCCtrlBase->SetBodyGrammer(GetVGrammer(mpCListCtrlBody));
    UpdateList(mpCListCtrlHead, mpCCtrlBase->mCGrammerHead);
    UpdateList(mpCListCtrlBody, mpCCtrlBase->mCGrammerBody);
}

void GrammerBaseGUI_cls::
OnInsertDummy1(wxCommandEvent &event){
    AddListItem(GetPActiveListCtrl(), -1, _GRAMMER_DUMMY1);
    UpdateIndexAndColor(GetPActiveListCtrl());
}

void GrammerBaseGUI_cls::
OnInsertDummy3(wxCommandEvent &event){
    AddListItem(GetPActiveListCtrl(), -1, _GRAMMER_DUMMY3);
    UpdateIndexAndColor(GetPActiveListCtrl());
}

void GrammerBaseGUI_cls::
OnInsertXYZ(wxCommandEvent& event){
    AddListItem(GetPActiveListCtrl(), -1, _GRAMMER_XYZ);
    UpdateIndexAndColor(GetPActiveListCtrl());
}

void GrammerBaseGUI_cls::
OnInsertDummy10(wxCommandEvent &event){
    AddListItem(GetPActiveListCtrl(), -1, _GRAMMER_DUMMY10);
    UpdateIndexAndColor(GetPActiveListCtrl());
}

void GrammerBaseGUI_cls::
OnInsertVXVYVZ(wxCommandEvent& event){
    AddListItem(GetPActiveListCtrl(), -1, _GRAMMER_VXVYVZ);
    UpdateIndexAndColor(GetPActiveListCtrl());
}

void GrammerBaseGUI_cls::
OnInsertRadius(wxCommandEvent& event){
    AddListItem(GetPActiveListCtrl(), -1, _GRAMMER_RADIUS);
    UpdateIndexAndColor(GetPActiveListCtrl());
}

void GrammerBaseGUI_cls::
OnInsertType(wxCommandEvent& event){
    AddListItem(GetPActiveListCtrl(), -1, _GRAMMER_TYPE);
    UpdateIndexAndColor(GetPActiveListCtrl());
}

void GrammerBaseGUI_cls::
OnInsertId(wxCommandEvent& event){
    AddListItem(GetPActiveListCtrl(), -1, _GRAMMER_ID);
    UpdateIndexAndColor(GetPActiveListCtrl());
}

void GrammerBaseGUI_cls::
OnInsertValue1(wxCommandEvent& event){
    AddListItem(GetPActiveListCtrl(), -1, _GRAMMER_VALUE1);
    UpdateIndexAndColor(GetPActiveListCtrl());
}

void GrammerBaseGUI_cls::
OnInsertTime(wxCommandEvent& event){
    AddListItem(GetPActiveListCtrl(), -1, _GRAMMER_TIME);
    UpdateIndexAndColor(GetPActiveListCtrl());
}

void GrammerBaseGUI_cls::
OnInsertNumber(wxCommandEvent& event){
    AddListItem(GetPActiveListCtrl(), -1, _GRAMMER_NUMBER);
    UpdateIndexAndColor(GetPActiveListCtrl());
}

void GrammerBaseGUI_cls::
OnListKeyDown(wxListEvent& event){
    if (event.GetKeyCode() == WXK_DELETE){
	DeleteSelectedItem(GetPActiveListCtrl());
	UpdateIndexAndColor(GetPActiveListCtrl());
    }
    event.Skip();
}

void GrammerBaseGUI_cls::
OnMouse(wxMouseEvent& event){
    if (event.GetId() == mpCListCtrlHead->GetId()) mActiveList = 0;
    if (event.GetId() == mpCListCtrlBody->GetId()) mActiveList = 1;

    if (event.RightDown() == TRUE){
	if (event.GetId() == mpCListCtrlHead->GetId()){
	    //mActiveList = 0;
	    UpdateMenuHead();
	    PopupMenu(mpPopupMenuHeader);
	}
	else if (event.GetId() == mpCListCtrlBody->GetId()){
	    //mActiveList = 1;
	    UpdateMenuBody();
	    PopupMenu(mpPopupMenuBody);
	}
	
    }

    if (event.LeftUp() == TRUE){
	if (event.GetId() == mpCListCtrlHead->GetId()){
	    int dragStart = mpCListCtrlHead->mDragStart;
	    int dragEnd = mpCListCtrlHead->mDragEnd;
	    if (dragStart != -1 && dragStart != dragEnd)
		SwapList(mpCListCtrlHead, dragEnd - dragStart);
	}
	if (event.GetId() == mpCListCtrlBody->GetId()){
	    int dragStart = mpCListCtrlBody->mDragStart;
	    int dragEnd = mpCListCtrlBody->mDragEnd;
	    if (dragStart != -1 && dragStart != dragEnd)
		SwapList(mpCListCtrlBody, dragEnd - dragStart);
	}
    }
}

// ----

GrammerBase_cls::
GrammerBase_cls(wxString strTag){
    mstrTag = strTag;
    mCConfList.Add(&mCDataType, strTag + wxT("DataType="), wxT("0"));
    mCConfList.Add(&mCGrammerHead, strTag + wxT("GrammerHead="), wxT("0 1"));
    mCConfList.Add(&mCGrammerBody, strTag + wxT("GrammerBody="), wxT("0 1 5 6 7 8"));
}

bool GrammerBase_cls::
IsItemExistHead(int itemID){
    bool bExist = FALSE;
    int itemNumber = mCGrammerHead.mDimension;
    for (int i = 0; i < itemNumber; i++)
	if (mCGrammerHead.mpBody[i] == itemID) bExist = TRUE;
    return bExist;
}

bool GrammerBase_cls::
IsItemExistBody(int itemID){
    bool bExist = FALSE;
    int itemNumber = mCGrammerBody.mDimension;
    for (int i = 0; i < itemNumber; i++)
	if (mCGrammerBody.mpBody[i] == itemID) bExist = TRUE;
    return bExist;
}

void GrammerBase_cls::
SetHeaderGrammer(std::vector < int > VHeader){
    mCGrammerHead.mDimension = (int)VHeader.size();
    for (int i = 0; i < mCGrammerHead.mDimension; i++)
	mCGrammerHead.mpBody[i] = VHeader[i];
}

void GrammerBase_cls::
SetBodyGrammer(std::vector < int > VBody){
    mCGrammerBody.mDimension = (int)VBody.size();
    for (int i = 0; i < mCGrammerBody.mDimension; i++)
	mCGrammerBody.mpBody[i] = VBody[i];
}

void GrammerBase_cls::
UpdateGrammerFromList(GrammerBaseGUI_cls *pCGUI){
    SetHeaderGrammer(pCGUI->GetVGrammer(pCGUI->mpCListCtrlHead));
    SetBodyGrammer(pCGUI->GetVGrammer(pCGUI->mpCListCtrlBody));
}

int GrammerBase_cls::
GetHeaderByte(){
    int byte = 0;
    for (int i = 0; i < mCGrammerHead.mDimension; i++)
	switch(mCGrammerHead.mpBody[i]){
	case _GRAMMER_TIME:
	case _GRAMMER_NUMBER:
	case _GRAMMER_DUMMY1:
	    byte += 4; break;
	case _GRAMMER_DUMMY3:
	    byte += 12; break;
	case _GRAMMER_DUMMY10:
	    byte += 40; break;
	}
    return byte;
}

int GrammerBase_cls::
GetHeaderLine(){
    int line = 0;
    for (int i = 0; i < mCGrammerHead.mDimension; i++)
	switch(mCGrammerHead.mpBody[i]){
	case _GRAMMER_TIME:
	case _GRAMMER_NUMBER:
	case _GRAMMER_DUMMY1:
	    line += 1; break;
	case _GRAMMER_DUMMY3:
	    line += 3; break;
	case _GRAMMER_DUMMY10:
	    line += 10; break;
	}
    return line;
}

int GrammerBase_cls::
GetBodyItemByte(int itemID){
    switch(itemID){
    case _GRAMMER_XYZ:    return 12;
    case _GRAMMER_VXVYVZ: return 12;
    case _GRAMMER_RADIUS: return 4;
    case _GRAMMER_TYPE:   return 4;
    case _GRAMMER_ID:     return 4;
    case _GRAMMER_VALUE1: return 4;
    case _GRAMMER_DUMMY1: return 4;
    case _GRAMMER_DUMMY3: return 12;
    case _GRAMMER_DUMMY10: return 40;
    }
    return 0;
}

int GrammerBase_cls::
GetBodyParticleByte(){
    int byte = 0;
    for (int i = 0; i < mCGrammerBody.mDimension; i++)
	byte += GetBodyItemByte(mCGrammerBody.mpBody[i]);
    return byte;
}

