// -*- c++ -*- 
// "clsGrammerBase.cpp"
// (setq c-basic-offset 4)

#ifndef _GRAMMER_BASE_H_
#define _GRAMMER_BASE_H_

#include "../CONFITEM/clsConfItem.h"
#include "../WIDGETCTRL/EX/clsButtonEX.h"
#include "../WIDGETCTRL/clsDialogEXKey.h"

#include "../COMMON/CommonDefinitionsForH.h"

#include <vector>
#include <wx/wx.h>
#include <wx/listctrl.h>

class GrammerBase_cls;
class wxListCtrlEX;

// ----

class GrammerBaseGUI_cls : public wxDialogEXKey {
 public:
    GrammerBaseGUI_cls(GrammerBase_cls *mpCCtrlBase, wxWindow *pC, 
		       wxString strLabel, wxString strIcon = wxES);
    ~GrammerBaseGUI_cls();

    GrammerBase_cls *mpCCtrlBase;

    wxListCtrlEX   *mpCListCtrlHead;
    wxListCtrlEX   *mpCListCtrlBody;

    wxButtonEX     *mpCBtnDefault;
    wxButtonEX     *mpCBtnLoad;
    wxButtonEX     *mpCBtnSave;

    wxMenu         *mpPopupMenuHeader;
    wxMenu         *mpPopupMenuBody;

    int mActiveList;

    wxListCtrl*     GetPActiveListCtrl();
    std::vector < int > GetVGrammer(wxListCtrl* pCList);
    int GetListId(wxListCtrl *pCList);

    void SetMenu();
    void SetColumn(wxListCtrl *pCList);
    void SetToDefault(wxWindow *pCParent, 
		      ConfItemINTARRAY_cls &CGrammerHead, 
		      ConfItemINTARRAY_cls &CGrammerBody);
    void UpdateListFromGrammer();
    void UpdateList(wxListCtrl *pCList, ConfItemINTARRAY_cls &Grammer);
    void DeleteSelectedItem(wxListCtrl *pCList);
    void AddListItem(wxListCtrl *pCList, wxInt32 nID, int typeItem);
    void UpdateIndexAndColor(wxListCtrl *pCList);
    void SwapList(wxListCtrl *pCList, int relativeTgt);
    
    void ClearMenu(wxMenu *pMenu);
    void UpdateMenuHead();
    void UpdateMenuBody();
    void OnHookCombobox();

    void OnInsertDummy1(wxCommandEvent& event);
    void OnInsertDummy3(wxCommandEvent& event);
    void OnInsertDummy10(wxCommandEvent& event);
    void OnInsertXYZ(wxCommandEvent &event);
    void OnInsertVXVYVZ(wxCommandEvent &event);
    void OnInsertRadius(wxCommandEvent &event);
    void OnInsertType(wxCommandEvent &event);
    void OnInsertId(wxCommandEvent &event);
    void OnInsertValue1(wxCommandEvent &event);
    void OnInsertTime(wxCommandEvent &event);
    void OnInsertNumber(wxCommandEvent &event);
    
    void OnListKeyDown(wxListEvent& event);
    void OnMouse(wxMouseEvent& event);
    
    std::vector < wxString > mstrItemName[2];
    std::vector < wxString > mstrItemDescript[2];
    std::vector < wxString > mstrItemByte[2];
};

class GrammerBase_cls{
public:
    GrammerBase_cls(wxString strTag = wxT(""));

    GrammerBase_cls *mpCGUI;
    
    wxString mstrTag;
    ConfItemList_cls  mCConfList;

    ConfItemINT_cls   mCDataType;
    ConfItemINTARRAY_cls mCGrammerBody;
    ConfItemINTARRAY_cls mCGrammerHead;

    bool IsItemExistHead(int itemID);
    bool IsItemExistBody(int itemID);
    void SetHeaderGrammer(std::vector < int > VHeader);
    void SetBodyGrammer(std::vector < int > VBody);
    void UpdateGrammerFromList(GrammerBaseGUI_cls *pCGUI);
    int  GetHeaderByte();
    int  GetHeaderLine();
    int  GetBodyItemByte(int itemID);
    int  GetBodyParticleByte();
};

#endif
