// -*- c -*-
// "clsPreference.h"

#include "clsPreference.h"
#include "clsPreferenceGUI.h"
#include "clsShortcut.h"

#include "../../clsFrameMain.h"

#include "../COMMON/CommonDefinitions.h"

#define _MOUSE_BTN_LEFT   0
#define _MOUSE_BTN_MIDDLE 1
#define _MOUSE_BTN_RIGHT  2

int GThreadNumberReadAscii = 4;

Preference_cls::
Preference_cls(/*Shortcut_cls *pCShortcutLink*/){
    //mpCShortcutLink = pCShortcutLink;
    SetToDefaultMouse(0);
    SetToDefaultParam();
    mpCGUI = NULL;
};

Preference_cls::
~Preference_cls(){
}

void Preference_cls::
InitGUI(FrameMain_cls *pCParentFrameLink){
    mpCParentFrame = pCParentFrameLink;
    mpCShortcutLink = pCParentFrameLink->mpCShortcut;
    mpCGUI = new PreferenceGUI_cls(this, pCParentFrameLink);
    SetPDialog(mpCGUI);
}

void Preference_cls::
UpdateItems(bool bForce){
    mpCGUI->mpCMNumMouseParam->UpdateValues();
    mpCGUI->mpCMNumMemParam->UpdateValues();
}

void Preference_cls::
UpdateShortcutItems(){
    mpCShortcutLink->UpdateListItem(mpCGUI->mpCListCtrl, -1);
}

void Preference_cls::
OpenWindow(wxWindow *pC){
    DialogControl_cls::OpenWindow(pC);
    UpdateItems(TRUE);
    mpCGUI->SetColoring();
}

// {^sꍇ
void Preference_cls::
ModulateBTN(bool bAModifier[4], bool bAMouseBTN[4]){
    if (bAMouseBTN[0] == TRUE)
	if (bAModifier[mCMButtonEmulate.mBody] == TRUE){
	    bAMouseBTN[_MOUSE_BTN_LEFT] = FALSE;
	    bAMouseBTN[_MOUSE_BTN_MIDDLE] = TRUE;
	}
    bAModifier[mCMButtonEmulate.mBody] = FALSE;
}

bool Preference_cls::
IsMouse4Gyration(bool bAModifier[4], bool bAMouseBTN[4]){
    if (bAMouseBTN[mCGyrationMouse.mBody] == FALSE) return FALSE;
    for (unsigned int i = 0; i < 3; i++){
	bool condition = mCbGyrationMod.mpbBody[i];
	if (i == mCMButtonEmulate.mBody) condition = FALSE;
	if (bAModifier[i] != condition) return FALSE;
    }
    return TRUE;
}

bool Preference_cls::
IsMouse4Zoom(bool bAModifier[4], bool bAMouseBTN[4]){
        if (bAMouseBTN[mCZoomMouse.mBody] == FALSE) return FALSE;
    for (unsigned int i = 0; i < 3; i++)
	if (bAModifier[i] != mCbZoomMod.mpbBody[i]) return FALSE;
    return TRUE;
}

bool Preference_cls::
IsMouse4MoveCenter(bool bAModifier[4], bool bAMouseBTN[4]){
    if (bAMouseBTN[mCCenterMouse.mBody] == FALSE) return FALSE;
    for (unsigned int i = 0; i < 3; i++){
	bool condition = mCbCenterMod.mpbBody[i];
	if (i == mCMButtonEmulate.mBody) condition = FALSE;
	if (bAModifier[i] != condition) return FALSE;
    }
    return TRUE;
}

bool Preference_cls::
IsMouse4MoveItem(bool bAModifier[4], bool bAMouseBTN[4]){
    if (bAMouseBTN[mCItemMouse.mBody] == FALSE) return FALSE;
    for (unsigned int i = 0; i < 3; i++){
	bool condition = mCbItemMod.mpbBody[i];
	if (i == mCMButtonEmulate.mBody) condition = FALSE;
	if (bAModifier[i] != condition) return FALSE;
    }
    return TRUE;
}

bool Preference_cls::
IsMouse4Menu(bool bAModifier[4], bool bAMouseBTN[4]){
    if (bAMouseBTN[mCMenuMouse.mBody] == FALSE) return FALSE;
    for (unsigned int i = 0; i < 3; i++)
	if (bAModifier[i] != mCbMenuMod.mpbBody[i])
	    return FALSE;
    return TRUE;
}

bool Preference_cls::
IsMouse4HitTest(bool bAModifier[4], bool bAMouseBTN[4]){
    if (bAMouseBTN[mCHitTestMouse.mBody] == FALSE) return FALSE;
    for (unsigned int i = 0; i < 3; i++){
	bool condition = mCbHitTestMod.mpbBody[i];
	if (i == mCMButtonEmulate.mBody) condition = FALSE;
	if (bAModifier[i] != condition) return FALSE;
    }
    return TRUE;
}

bool Preference_cls::
IsMouse4Innertia(bool bAModifier[4], bool bAMouseBTN[4]){
    if (bAMouseBTN[mCInnertiaMouse.mBody] == FALSE) return FALSE;
    for (unsigned int i = 0; i < 3; i++){
	bool condition = mCbInnertiaMod.mpbBody[i];
	if (i == mCMButtonEmulate.mBody) condition = FALSE;
	if (bAModifier[i] != condition) return FALSE;
    }
    return TRUE;
}

void Preference_cls::
SetToDefaultMouse(int type){
    ConfItemList_cls *pCList = &mCConfListMouse;
    pCList->Clear();
    switch(type){
    case 0:
	pCList->Add(&mCGyrationMouse, wxT("GUI_GYRATION="), L"0");
	pCList->Add(&mCbGyrationMod,  wxT("GUI_GYRATION_MOD="), wxT("0 0 0"));
	pCList->Add(&mCbGyrationInvert, wxT("GUI_GYRATION_INVERT="), L"0");
	pCList->Add(&mCZoomMouse, wxT("GUI_ZOOM="), L"1");
	pCList->Add(&mCbZoomMod, wxT("GUI_ZOOM_MOD="), L"0 0 0");
	pCList->Add(&mCbZoomInvert, wxT("GUI_ZOOM_INVERT="), L"0");
	pCList->Add(&mCCenterMouse, wxT("GUI_CENTER="), L"0");
	pCList->Add(&mCbCenterMod, wxT("GUI_CENTER_MOD="), L"1 1 0");
	pCList->Add(&mCItemMouse, wxT("GUI_ITEM="), L"0");
	pCList->Add(&mCbItemMod, wxT("GUI_ITEM_MOD="), L"1 0 0");
	pCList->Add(&mCMenuMouse, wxT("GUI_MENU="), L"2");
	pCList->Add(&mCbMenuMod, wxT("GUI_MENU_MOD="), L"0 0 0");
	pCList->Add(&mCHitTestMouse, wxT("GUI_HITTEST="), L"2");
	pCList->Add(&mCbHitTestMod, wxT("GUI_HITTEST_MOD="), L"1 0 0");
	pCList->Add(&mCInnertiaMouse, wxT("GUI_INNERTIA="), L"0");
	pCList->Add(&mCbInnertiaMod, wxT("GUI_INNERTIA_MOD="), L"0 1 0");
	pCList->Add(&mCMButtonEmulate, wxT("GUI_MBUTTON_EMULATE="), L"2");
	break;
    case 1:
	pCList->Add(&mCGyrationMouse, wxT("GUI_GYRATION="), L"1");
	pCList->Add(&mCbGyrationMod, wxT("GUI_GYRATION_MOD="), L"0 0 0");
	pCList->Add(&mCbGyrationInvert, wxT("GUI_GYRATION_INVERT="), L"0");
	pCList->Add(&mCZoomMouse, wxT("GUI_ZOOM="), L"1");
	pCList->Add(&mCbZoomMod, wxT("GUI_ZOOM_MOD="), L"0 1 0");
	pCList->Add(&mCbZoomInvert, wxT("GUI_ZOOM_INVERT="), L"1");
	pCList->Add(&mCCenterMouse, wxT("GUI_CENTER="), L"1");
	pCList->Add(&mCbCenterMod, wxT("GUI_CENTER_MOD="), L"1 0 0");
	pCList->Add(&mCItemMouse, wxT("GUI_ITEM="), L"0");
	pCList->Add(&mCbItemMod, wxT("GUI_ITEM_MOD="), L"0 0 0");
	pCList->Add(&mCMenuMouse, wxT("GUI_MENU="), L"2");
	pCList->Add(&mCbMenuMod, wxT("GUI_MENU_MOD="), L"1 0 0");
	pCList->Add(&mCHitTestMouse, wxT("GUI_HITTEST="), L"2");
	pCList->Add(&mCbHitTestMod, wxT("GUI_HITTEST_MOD="), L"0 0 0");
	pCList->Add(&mCInnertiaMouse, wxT("GUI_INNERTIA="), L"0");
	pCList->Add(&mCbInnertiaMod, wxT("GUI_INNERTIA_MOD="), L"0 1 0");
	pCList->Add(&mCMButtonEmulate, wxT("GUI_MBUTTON_EMULATE="), L"2");
	break;
    }
}

void Preference_cls::
SetToDefaultParam(){
    ConfItemList_cls *pCList = &mCConfListParam;
    pCList->Clear();
    pCList->Add(&mCSortType, wxT("PREF_SORT_TYPE="), L"0");
    pCList->Add(&mCCachedSort, wxT("PREF_CACHED_SORT="), L"0");
    pCList->Add(&mCUseFBO, wxT("PREF_USE_FBO="), L"1");
    pCList->Add(&mCUseQuadBuffer, wxT("PREF_USE_QUADBUFFER="), L"1"); //1 notUse
    pCList->Add(&mCForceRefresh, wxT("PREF_FORCE_REFRESH="), L"0");
    pCList->Add(&mCBlendType, wxT("PREF_BELND_TYPE="), L"0");
    pCList->Add(&mCIOThreadNumber, wxT("PREF_IO_THREAD"), L"1");
    pCList->Add(&mCUseShader, wxT("PREF_USE_SHADER"), L"1");
}

int Preference_cls::
GetFBODepth(){
    if (mCUseFBO.mBody == _PREF_USE_FBO_16) return 16;
    return 8;
}

// ----

void Preference_cls::
ReadStrLine(wxString strLine){
    mCConfListMouse.ReadStrLineAll(strLine);
    mCConfListParam.ReadStrLineAll(strLine);
}

wxString Preference_cls::
Serialize(){
    return mCConfListMouse.SerializeAll() + mCConfListParam.SerializeAll(); 
}

wxString Preference_cls::
SerializeForConfigure(){
    wxString strOut;
    strOut << mCUseFBO.Serialize();
    strOut << mCUseQuadBuffer.Serialize();
    strOut << mCIOThreadNumber.Serialize();
    strOut << mCForceRefresh.Serialize();
    return strOut;
}

