// -*- c -*-
// "clsPreferenceGUI.h"
// (setq c-basic-offset 4)

#include "clsPreferenceGUI.h"
#include "clsPreference.h"

#include "../GRAPHIC/clsImageIO.h"
extern ImageIO_cls GCImgIO;
#include "../PANELS/clsShortcut.h"
#include "../PARTICLEDATA/clsParticleDataSeqCtrl.h"
#include "../WIDGETCTRL/EX/clsButtonEX.h"
#include "../WIDGETCTRL/EX/clsListCtrlEX.h"
#include "../WIDGETCTRL/WX/myArtProv.h"
#include "../WIDGETCTRL/WX/clsFontProvider.h"

#include "../../clsFrameMain.h"
#include "../../wxWidgetEnum.h"

#include <wx/list.h>
#include <wx/notebook.h>

//extern int GThreadNumberReadAscii;

// ÓIɃCxgт
BEGIN_EVENT_TABLE(PreferenceGUI_cls, wxDialog)
EVT_LIST_ITEM_ACTIVATED(wxID_ANY, PreferenceGUI_cls::OnListClick)
END_EVENT_TABLE()

PreferenceGUI_cls::
PreferenceGUI_cls(Preference_cls* pCParent, wxWindow *pC) :
wxDialogEXKey(pC, wxID_ANY, _("Preference"), 
	      wxDPS, ARTWXFRAMEICON("wxART_PREFERENCE")) {
    
    mpCParent = pCParent;
    mTemplateSetting = 0;
    mTemplateShortcut = 0;
    
    // TCU[
    wxBoxSizer    *pBoxSizerSrc  = new wxBoxSizer(wxVERTICAL);

    wxFont CFont;
    FontProvider_cls::GetBasicFont(CFont, 10);
    mpCBook = new wxNotebook(this, ID_BOOK_PREFERENCE);
    mpCBook->SetFont(CFont);

    SetMNumMouseParam();
    mpCBook->AddPage(mpCMNumMouseParam, _("Mouse"));
    
    SetMNumMemParam();
    mpCBook->AddPage(mpCMNumMemParam, _("Performance"));

    wxSize bestSize = mpCMNumMouseParam->GetBestSize();
    int listCtrlWidth = bestSize.GetWidth();
    int listCtrlHeight = bestSize.GetHeight();

    wxPanel *pCShortcutPanel = new wxPanel(mpCBook, wxID_ANY, wxDPS);
    SetMNumShortcut(pCShortcutPanel);
    wxBoxSizer *pBoxSizerShortcut = new wxBoxSizer(wxVERTICAL);

    int inputPanelHeight = mpCMNumShortcut->GetBestSize().GetHeight();

    mpCListCtrl = new wxListCtrlEX
	(pCShortcutPanel, wxID_ANY, 
	 wxPoint(0, inputPanelHeight), wxSize(listCtrlWidth, listCtrlHeight - inputPanelHeight),  wxLC_REPORT | wxSUNKEN_BORDER);
    mpCParent->mpCShortcutLink->SetList(mpCListCtrl);

    pBoxSizerShortcut->Add( mpCMNumShortcut, 0, wxEXPAND);
    pBoxSizerShortcut->Add( mpCListCtrl, 1, wxEXPAND);
    mpCBook->AddPage(pCShortcutPanel, _("Shortcut"));

    pCShortcutPanel->SetSizer(pBoxSizerShortcut);
    pBoxSizerSrc->Add( mpCBook, 0, wxEXPAND);

    SetSizerAndFit(pBoxSizerSrc);
}

PreferenceGUI_cls::
~PreferenceGUI_cls(){
    //MakeModal(FALSE);
}

void PreferenceGUI_cls::
SetMNumMouseParam(){
    MultiInputPanel_cls* pCurr = 
	MultiInputPanel_cls::Initialize(&mpCMNumMouseParam, mpCBook);
    int boxWidth = 4;
    
    pCurr->mTextWidth = 100;
    pCurr->mItemWidth = -1;
    pCurr->mComboWidth = 130;
    pCurr->mCheckBoxWidth = 55;

    wxString strListC[2] = { _("Defalut"), _("Blender Like")};
    int indexTemplate = pCurr->CombinePointerList
	(&mTemplateSetting, 2, strListC,  _("Template"));

    wxString strList[4] = {
	_("Left Mouse BTN"), _("Middle Mouse BTN"), _("Right Mouse BTN"), _("Not Assigned")};
    wxString strListB[4] = { _("Left BTN + Shift"), _("Left BTN + Ctrl"), _("Left BTN + Alt"), _("Not Assigned")};
    
    pCurr->CombinePointer(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, _("Gyration"));
    pCurr->CombinePointerList(&mpCParent->mCGyrationMouse.mBody, 4, strList);
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbGyrationMod.mpbBody[0],
			  wxT("Shift"));
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbGyrationMod.mpbBody[1],
			  wxT("Ctrl"));
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbGyrationMod.mpbBody[2],
			  wxT("Alt"));

    pCurr->CombinePointer(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, _("Zoom"));
    pCurr->CombinePointerList(&mpCParent->mCZoomMouse.mBody, 4, strList);
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbZoomMod.mpbBody[0], 
			  wxT("Shift"));
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbZoomMod.mpbBody[1],
			  wxT("Ctrl"));
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbZoomMod.mpbBody[2],
			  wxT("Alt"));
    
    pCurr->CombinePointer(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, _("Move Center"));
    pCurr->CombinePointerList(&mpCParent->mCCenterMouse.mBody, 4, strList);
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbCenterMod.mpbBody[0], 
			  wxT("Shift"));
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbCenterMod.mpbBody[1],
			  wxT("Ctrl"));
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbCenterMod.mpbBody[2],
			  wxT("Alt"));

    pCurr->CombinePointer(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, _("Move Item"));
    pCurr->CombinePointerList
	(&mpCParent->mCItemMouse.mBody, 4, strList);
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbItemMod.mpbBody[0], 
			  wxT("Shift"));
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbItemMod.mpbBody[1],
			  wxT("Ctrl"));
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbItemMod.mpbBody[2],
			  wxT("Alt"));

    pCurr->CombinePointer(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, _("Menu"));
    pCurr->CombinePointerList(&mpCParent->mCMenuMouse.mBody, 4, strList);
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbMenuMod.mpbBody[0], 
			  wxT("Shift"));
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbMenuMod.mpbBody[1],
			  wxT("Ctrl"));
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbMenuMod.mpbBody[2],
			  wxT("Alt"));
    
    pCurr->CombinePointer(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, _("Item Selection"));
    pCurr->CombinePointerList(&mpCParent->mCHitTestMouse.mBody, 4, strList);
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbHitTestMod.mpbBody[0], 
			  wxT("Shift"));
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbHitTestMod.mpbBody[1],
			  wxT("Ctrl"));
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbHitTestMod.mpbBody[2],
			  wxT("Alt"));

    pCurr->CombinePointer(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, _("Innertia"));
    pCurr->CombinePointerList(&mpCParent->mCInnertiaMouse.mBody, 4, strList);
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbInnertiaMod.mpbBody[0], 
			  wxT("Shift"));
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbInnertiaMod.mpbBody[1],
			  wxT("Ctrl"));
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbInnertiaMod.mpbBody[2],
			  wxT("Alt"));
    
    int indexMButton = pCurr->CombinePointerList
	(&mpCParent->mCMButtonEmulate.mBody, 4, strListB, _("MButton Emulate"));

    boxWidth = 2;
    pCurr->CombinePointer(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, _("Invert"));
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbZoomInvert.mbBody,
			  _("Zoom"));
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbGyrationInvert.mbBody,
			  _("Gyration"));

    
    
    pCurr->FinishSetting();

    Connect(pCurr->GetItemId(indexTemplate), wxEVT_COMMAND_COMBOBOX_SELECTED,
	    wxCommandEventHandler(PreferenceGUI_cls::OnTemplate));
    Connect(pCurr->GetItemId(indexMButton), wxEVT_COMMAND_COMBOBOX_SELECTED,
	    wxCommandEventHandler(PreferenceGUI_cls::OnEmulateMiddleButton));
}

void PreferenceGUI_cls::
SetMNumMemParam(){
    MultiInputPanel_cls* pCurr = 
	MultiInputPanel_cls::Initialize(&mpCMNumMemParam, mpCBook);
    pCurr->mTextWidth = 140;
    pCurr->mItemWidth = -1;

    int boxWidth = 2;
    pCurr->CombinePointer(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, _("Memory Limit(MB)"));
    pCurr->CombinePointer(_ITEM_INTEGER, 
			  &mpCParent->mpCParentFrame->GetPCDataSeqCtrl()->mMemoryLimitationMB,
			  wxT("Critical"));
    pCurr->CombinePointer(_ITEM_INTEGER, 
			  &mpCParent->mpCParentFrame->GetPCDataSeqCtrl()->mTotalUsedMemoryMB,
			  wxT("NowUsed"), FALSE);

    pCurr->CombinePointer(_ITEM_INTEGER,
			  &mpCParent->mCIOThreadNumber.mBody, _("Thread (Data I/O)"));
    pCurr->SetRange(_ITEM_LASTITEM, 1, 4);
    
    pCurr->CombinePointer(_ITEM_INTEGER,
			  &GCImgIO.mCJpegQuality.mBody, _("JPEG Quality"));
    wxString strListThread[2] = { wxT("off"), wxT("on")};
    pCurr->CombinePointerList
	(&GCImgIO.mCMultiThread.mBody, 2, strListThread,  _("Thread (Image I/O)"));
    
    wxString strListSort[4] = { _("Precise"), _("Approximate 10"), _("Approximate 100"), _("Approximate 1000")};
    pCurr->CombinePointerList
	(&mpCParent->mCSortType.mBody, 4, strListSort,  _("Z-Sort Algorithm"));

    wxString strCachedSort[2] = { _("Precise"), _("Fast (approximate)")};
    pCurr->CombinePointerList
	(&mpCParent->mCCachedSort.mBody, 2, strCachedSort,  _("Re-Sort Algorithm"));
    
    wxString strListShader[2] = { _("Do not use shader"), _("Use shader")};
    pCurr->CombinePointerList
	(&mpCParent->mCUseShader.mBody, 2, strListShader, _("Shader"));
    
    wxString strListQuad[2] = { _("Use Quad Buffer if able"), _("Do not use Quad Buffer")};
    pCurr->CombinePointerList
	(&mpCParent->mCUseQuadBuffer.mBody, 2, strListQuad, _("Quad Buffer Stereo"));

    wxString strListRefresh[2] = { _("Send Refresh Event"), _("Force Refresh")};
    pCurr->CombinePointerList
	(&mpCParent->mCForceRefresh.mBody, 2, strListRefresh, _("Refresh Type"));
    
    pCurr->FinishSetting();
}

void PreferenceGUI_cls::
SetMNumShortcut(wxWindow *pCParent){
    MultiInputPanel_cls* pCurr = 
	MultiInputPanel_cls::Initialize(&mpCMNumShortcut, pCParent);

    pCurr->mTextWidth = 100;
    pCurr->mItemWidth = -1;
    
    wxString strListC[2] = { _("Defalut"), _("Blender Like")};
    int indexTemplate = pCurr->CombinePointerList
	(&mTemplateShortcut, 2, strListC,  _("Template"));

    pCurr->FinishSetting();

    Connect(pCurr->GetItemId(indexTemplate), wxEVT_COMMAND_COMBOBOX_SELECTED,
	    wxCommandEventHandler(PreferenceGUI_cls::OnTemplateShortcut));
}

void PreferenceGUI_cls::
SetColoring(){
    MultiInputPanel_cls* pCurr = mpCMNumMouseParam;
    for (int i = 3; i <=35; i+=5){
	pCurr->GetPCwxWindow(i+0)->SetBackgroundColour(wxNullColour);
	pCurr->GetPCwxWindow(i+1)->SetBackgroundColour(wxNullColour);
	pCurr->GetPCwxWindow(i+2)->SetBackgroundColour(wxNullColour);
    }
    
    int button = mpCParent->mCMButtonEmulate.mBody;
    if (button <= 2)
	for (int i = 3; i <=35; i+=5)
	    pCurr->GetPCwxWindow(i+button)->
		SetBackgroundColour(wxColour(216, 191, 191));

    for (int i = 3; i <=35; i+=5){
	pCurr->GetPCwxWindow(i+0)->Refresh();
	pCurr->GetPCwxWindow(i+1)->Refresh();
	pCurr->GetPCwxWindow(i+2)->Refresh();
    }
}

void PreferenceGUI_cls::
OnTemplate(wxCommandEvent &event){
    mpCParent->SetToDefaultMouse(mTemplateSetting);
    mpCMNumMouseParam->UpdateValues();
}

void PreferenceGUI_cls::
OnTemplateShortcut(wxCommandEvent &event){
    mpCParent->mpCShortcutLink->SetDefault(mTemplateShortcut);
    mpCParent->mpCShortcutLink->UpdateListItem(mpCListCtrl, -1);
    mpCParent->mpCParentFrame->UpdateMenu();
}

void PreferenceGUI_cls::
OnListClick(wxListEvent &event){
    if (mpCParent->mpCShortcutLink->PopupEditor(event.GetIndex(), this) == FALSE) return;
    if (mpCParent->mpCShortcutLink->mConflict != -1)
	mpCParent->mpCShortcutLink->UpdateListItem(mpCListCtrl, mpCParent->mpCShortcutLink->mConflict);
    mpCParent->mpCShortcutLink->UpdateListItem(mpCListCtrl, event.GetIndex());
    mpCParent->mpCParentFrame->UpdateMenu();
}

void PreferenceGUI_cls::
OnEmulateMiddleButton(wxCommandEvent& event){
    SetColoring();
}
