// -*- c -*-
// "clsPreferenceGUI.cpp"
// (setq c-basic-offset 4)

#ifndef _PREFERENCE_GUI_H_
#define _PREFERENCE_GUI_H_

#include "../WIDGETCTRL/clsMultiInputPanel.h"
#include "../WIDGETCTRL/clsDialogEXKey.h"

class Preference_cls; 
class wxNotebook;
class wxListCtrlEX;
class wxListEvent;

#include "../COMMON/CommonDefinitions.h"

class PreferenceGUI_cls : public wxDialogEXKey {
 public:
    PreferenceGUI_cls(Preference_cls* pCParent, wxWindow *pC);
    ~PreferenceGUI_cls();

    Preference_cls    *mpCParent;
    wxNotebook        *mpCBook;

    wxListCtrlEX      *mpCListCtrl;

    MultiInputPanel_cls* mpCMNumMouseParam;
    MultiInputPanel_cls* mpCMNumMemParam;
    MultiInputPanel_cls* mpCMNumShortcut;

    void SetMNumMouseParam();
    void SetMNumMemParam();
    void SetMNumShortcut(wxWindow *pCParent);

    void SetColoring();
    void OnTemplate(wxCommandEvent& event);
    void OnTemplateShortcut(wxCommandEvent& event);
    void OnListClick(wxListEvent& event);
    void OnEmulateMiddleButton(wxCommandEvent& event);

    unsigned int mTemplateSetting;
    unsigned int mTemplateShortcut;

 private:
    // any class wishing to process wxWidgets events must use this macro
    DECLARE_EVENT_TABLE()
};
#endif
