// -*- c -*-
// "clsPreference.cpp"

#ifndef _SHORTCUT_H_
#define _SHORTCUT_H_

#include "../../clsFrameMain.h"
#include "../WIDGETCTRL/clsWidgetCommon.h"

#include <wx/wx.h>
#include <wx/listctrl.h>

#include <vector>
#include <fstream>
#include <sstream>

#define _MAX_SHORTCUT 30

class wxListCtrlEX;

enum{
    _SC_DESELECT = 0,
    _SC_OPEN_PROJECT,
    _SC_SAVE_PROJECT,
    _SC_SAVE_PROJECT_AS,
    _SC_OPEN_DATA,
    _SC_SAVE_SNAPSHOT,
    _SC_SAVE_IMGSEQ,
    _SC_EXPORT_PDATA,
    _SC_EXPORT_PATH,
    _SC_CLOSE_DATA,
    _SC_QUIT,
    _SC_UNDO,
    _SC_REDO,
    _SC_GO,
    _SC_TIMEREMAP,
    _SC_REMOVE_SNAPSHOT,
    _SC_REMOVE_ALLCACHE,
    _SC_SCENE,
    _SC_PREFERENCE,
    _SC_SPLIT1,
    _SC_SPLIT2,
    _SC_SPLIT3,
    _SC_SPLIT4,
    _SC_SPLIT5,
    _SC_EXTRA,

    _SC_CAMERAPATH,
    _SC_LIGHTSOURCE,
    _SC_COLORCURVE, 
    _SC_TEXPROPERTY,
    _SC_STEREOGRAM,
    _SC_PERIODIC,

    _SC_POVRAY,

    _SC_HELP,
    _SC_ABOUT,
    _SC_ABOUT_GL,
    _SC_ABOUT_NETWORK,

    _SC_CENTER_ORIGIN,
    _SC_CENTER_ITEM,    
    _SC_VIEW_0,
    _SC_VIEW_1,
    _SC_VIEW_3,
    _SC_VIEW_5,
    _SC_VIEW_7,
    _SC_VIEW_1_CTRL,
    _SC_VIEW_3_CTRL,
    _SC_VIEW_7_CTRL,
    _SC_ROTATION,
    _SC_SCALE,
    _SC_TRANSLATION,
    _SC_DRAG_X,
    _SC_DRAG_Y,
    _SC_DRAG_Z,
    _SC_NEXT_KEY,
    _SC_PREV_KEY,
    _SC_SET_WA_MIN,
    _SC_SET_WA_MAX,
    _SC_TL_ZOOM_IN,
    _SC_TL_ZOOM_OUT,
    _SC_PLAY,
    _SC_LEFT,
    _SC_RIGHT,
    _SC_FULLSCREEN,
    _SC_ESCAPE,
};

class ShortcutItem_cls {
 public:
    ShortcutItem_cls(int type, wxString strBase, wxString strName, 
		     int charactor, bool bShift, bool bCtrl, bool bAlt);
    int GetType(int code, bool bShift, bool bCtrl, bool bAlt);
    
    int mType;
    wxString mstrName;
    wxString mstrBase;
    int mChar;
    bool mbShift, mbCtrl, mbAlt;
};

class MenuCommandItem_cls {
 public:
    MenuCommandItem_cls(int type, int menuID);
    int mType;
    int mMenuID;
};

class Shortcut_cls : public WidgetCommon_cls {
 public:
    Shortcut_cls(FrameMain_cls *pCParentFrame);
    FrameMain_cls* mpCParentFrame;
    wxPoint mCPos;
    int mConflict; // Փ˂ňꏏɍXVꂽV[gJbg

    std::vector < ShortcutItem_cls > mVCItems;
    std::vector < MenuCommandItem_cls > mVCMenuCommand;

    void SetDefault(int type);
    void ReadTemplate(wxString strFile);
    void Add(int type, wxString strBase, wxString strName, 
		 int charactor = '\0', 
		 bool bShift = FALSE, bool bCtrl = FALSE, bool bAlt = FALSE);

    void AddMenuCommand(int type, int menuID);

    int      GetSpecialKeyFromIndex(int index);
    int      GetSpecialKeyIndex(int keyChar);
    wxString GetStrSpecialKey(int keyChar);
    wxString GetStrShortcut(int index);
    wxString GetStrFullString(int type, bool bShortCut = TRUE);
    std::vector < wxString > GetVstrItem(int index);
    int      GetIndexFromBase(wxString strBase);
    wxString GetMenuString(int ID);
    wxString GetMenuHelpString(int ID);
    wxMenuItem* GetPNewMenuItem(wxMenu *pMenu, int ID, wxString strHelpString = wxEmptyString, bool bChackItem = FALSE);
    void SetMenuItem(wxMenu *pMenu, int ID, 
		     wxString strMenuBitmap = wxEmptyString,
		     wxString strHelpString = wxEmptyString);
    void SetMenuCheckItem(wxMenu *pMenu, int ID, 
			  wxString strMenuBitmap = wxEmptyString,
			  wxString strHelpString = wxEmptyString);
    
    bool ProcFromList(int code, bool bShift, bool bCtrl, bool bAlt);
    void ProcShortcutKey(int modifier, int code);
    void SetList(wxListCtrlEX* pCList);
    void UpdateListItem(wxListCtrlEX *pCList, int index);
    bool PopupEditor(int index, wxWindow *pC);

    void ReadStrLine(std::wistream &istream, wxString strLineTag);
    wxString SerializeForConfigure();
};

#endif
