// -*- c -*-
// "clsParaGroupGUI.h"
// (setq c-basic-offset 4)

#include "clsParamGroupGUI.h"
#include "clsParamGroup.h"
#include "clsParametersPanel.h"
#include "../GLCANVAS/clsMainGLCanvas.h"
#include "../GLCANVAS/clsMoveItem.h"
#include "../MAINCANVAS/clsParamGUICtrl.h"
#include "../SCENEOBJ/clsSceneObj.h"
#include "../WIDGETCTRL/clsBitmapPanel.h"
#include "../WIDGETCTRL/EX/clsStaticTextEX.h"

#include "../WIDGETCTRL/WX/clsFontProvider.h"

#include "../COMMON/CommonDefinitions.h"

#include "../../wxWidgetEnumMenu.h"

ParamGroupGUI_cls::
ParamGroupGUI_cls
(ParamGroup_cls *pCParamGroup, ParamGUICtrl_cls *pCParentCtrl, 
 wxString strLabel, int depth, wxWindowID id, wxPoint pos, wxSize size) :
wxPanel(pCParentCtrl, id, pos, size)
{
    mpCCtrlLink = pCParentCtrl;
    mpCParentGroup = pCParamGroup;
    mDepth = depth;

    SetParamBackgroundColour();

    wxBoxSizer *pCBoxSizerSRC = new wxBoxSizer(wxHORIZONTAL);

    mpCBPanelFolder = new BitmapPanel_cls(this, wxID_ANY, wxDP, wxSize(14,16));
    mpCBPanelFolder->SetBoarder(1, 1);
    mpCBPanelFolder->AddBitmapStr(wxT("wxART_OPEN_FOLDER"));
    mpCBPanelFolder->AddBitmapStr(wxT("wxART_CLOSE_FOLDER"));
    mpCBPanelFolder->SetBitmapStrDisable(wxT("wxART_CLOSE_FOLDER"));
    Connect(mpCBPanelFolder->GetId(), wxEVT_LEFT_UP,
	    wxMouseEventHandler(ParamGroupGUI_cls::OnMouseLOpen));

    mpCLabelText = new wxStaticTextEX(this, wxID_ANY, strLabel,
				      wxDP, wxSize(-1, 12));
    mpCLabelText->SetFont(FontProvider_cls::GetFont(0));

    if (mDepth > 0) pCBoxSizerSRC->Add(12, -1, 0, wxEXPAND);
    pCBoxSizerSRC->Add(mpCBPanelFolder, 0, wxEXPAND);

    Connect(mpCLabelText->GetId(), wxEVT_LEFT_DOWN,
	    wxMouseEventHandler(ParamGroupGUI_cls::OnMouseLSelect));
    Connect(GetId(), wxEVT_LEFT_DOWN,
	    wxMouseEventHandler(ParamGroupGUI_cls::OnMouseLSelect));

    mpCBPanelKilroy = new BitmapPanel_cls(this, wxID_ANY, wxDP, wxSize(14, 16));
    mpCBPanelKilroy->SetBoarder(1, 1);
    mpCBPanelKilroy->AddBitmapStr(wxT("wxART_KILROY_HERE"));
    mpCBPanelKilroy->AddBitmapStr(wxT("wxART_KILROY_THERE"));
    Connect(mpCBPanelKilroy->GetId(), wxEVT_LEFT_UP,
	    wxMouseEventHandler(ParamGroupGUI_cls::OnMouseLKilroy));
    pCBoxSizerSRC->Add(2, -1, 0, wxEXPAND);
    pCBoxSizerSRC->Add(mpCBPanelKilroy, 0, wxEXPAND);

    pCBoxSizerSRC->Add(mpCLabelText, 0, wxEXPAND);

    if (mDepth > 0){
	mpCBPanelVisible = NULL;
	mpCBPanelLink = new BitmapPanel_cls(this, wxID_ANY, wxDP, wxSize(14,16));
	mpCBPanelLink->SetBoarder(1, 1);
	mpCBPanelLink->AddBitmapStr(wxT("wxART_LINKED"));
	mpCBPanelLink->AddBitmapStr(wxT("wxART_UNLINKED"));
	mpCBPanelLink->SetBitmapStrDisable(wxT("wxART_UNLINKED"));
	Connect(mpCBPanelLink->GetId(), wxEVT_LEFT_UP,
		wxMouseEventHandler(ParamGroupGUI_cls::OnMouseLLink));
	pCBoxSizerSRC->Add(2, -1, 0, wxEXPAND);
	pCBoxSizerSRC->Add(mpCBPanelLink, 0, wxEXPAND);

	mpCBPanelExpression = new BitmapPanel_cls(this, wxID_ANY, wxDP, wxSize(14, 16));
	mpCBPanelExpression->SetBoarder(1, 1);
	mpCBPanelExpression->AddBitmapStr(wxT("wxART_EXPRESSION_NOT"));
	mpCBPanelExpression->AddBitmapStr(wxT("wxART_EXPRESSION"));
	mpCBPanelExpression->SetBitmapStrDisable(wxT("wxART_EXPRESSION_NOT"));
	Connect(mpCBPanelExpression->GetId(), wxEVT_LEFT_UP,
		wxMouseEventHandler(ParamGroupGUI_cls::OnMouseLExpression));
	pCBoxSizerSRC->Add(2, -1, 0, wxEXPAND);
	pCBoxSizerSRC->Add(mpCBPanelExpression, 0, wxEXPAND);


	mpCBPanelInput = new BitmapPanel_cls(this, wxID_ANY, wxDP, wxSize(14, 16));
	mpCBPanelInput->SetBoarder(1, 1);
	mpCBPanelInput->AddBitmapStr(wxT("wxART_INPUT"));
	//mpCBPanelInput->AddBitmapStr(wxT("wxART_EXPRESSION"));
	//mpCBPanelInput->SetBitmapStrDisable(wxT("wxART_EXPRESSION_NOT"));
	Connect(mpCBPanelInput->GetId(), wxEVT_LEFT_UP,
		wxMouseEventHandler(ParamGroupGUI_cls::OnMouseLInput));
	pCBoxSizerSRC->Add(2, -1, 0, wxEXPAND);
	pCBoxSizerSRC->Add(mpCBPanelInput, 0, wxEXPAND);

	//mpCBPanelKilroy = NULL;
    }
    else {
	mpCBPanelLink = NULL;
	mpCBPanelVisible = new BitmapPanel_cls(this, wxID_ANY, wxDP, wxSize(14,16));
	mpCBPanelVisible->SetBoarder(1, 1);
	mpCBPanelVisible->AddBitmapStr(wxT("wxART_EYE_P"));
	mpCBPanelVisible->AddBitmapStr(wxT("wxART_EYE_N"));
	mpCBPanelVisible->SetBitmapStrDisable(wxT("wxART_EYE_N"));
	Connect(mpCBPanelVisible->GetId(), wxEVT_LEFT_UP,
		wxMouseEventHandler(ParamGroupGUI_cls::OnMouseLVisible));
	pCBoxSizerSRC->Add(2, -1, 0, wxEXPAND);
	pCBoxSizerSRC->Add(mpCBPanelVisible, 0, wxEXPAND);
	mpCBPanelExpression = NULL;
	mpCBPanelInput = NULL;
    }

    SetSizerAndFit(pCBoxSizerSRC);
    if (mpCBPanelLink != NULL) mpCBPanelLink->SetAspect(wxVERTICAL, 1.0f);
    if (mpCBPanelExpression != NULL) mpCBPanelExpression->SetAspect(wxVERTICAL, 1.0f);
    if (mpCBPanelInput != NULL) mpCBPanelInput->SetAspect(wxVERTICAL, 1.0f);
    if (mpCBPanelKilroy != NULL) mpCBPanelKilroy->SetAspect(wxVERTICAL, 1.0f);
    if (mpCBPanelFolder != NULL) mpCBPanelFolder->SetAspect(wxVERTICAL, 1.0f);
    SetSizerAndFit(pCBoxSizerSRC);
}

void ParamGroupGUI_cls::
UpdateButtonStatus(){
    if (mpCBPanelLink != NULL)
	mpCBPanelLink->SetStatus(mpCParentGroup->mCbLinking.mbBody == FALSE);
    
    if (mpCBPanelExpression != NULL)
	mpCBPanelExpression->SetStatus(mpCParentGroup->mCbExpression.mbBody == TRUE);
}

void ParamGroupGUI_cls::
ShowButtons(bool bShow){
    if (mpCBPanelLink != NULL) mpCBPanelLink->Show(bShow);
    if (mpCBPanelExpression != NULL){ 
	mpCBPanelExpression->Show(bShow);
	if (mpCBPanelInput != NULL){
	    if (mpCParentGroup->mCbExpression.mbBody == TRUE)
		mpCBPanelInput->Show(bShow);
	    else
		mpCBPanelInput->Show(FALSE);
	}
    }
}

void ParamGroupGUI_cls::
SetParamBackgroundColour(){
    if (mpCParentGroup->mpCSceneObjLink != NULL &&
	mpCParentGroup->mpCSceneObjLink->mbSelected == TRUE){
	if (mDepth == 0)
	    SetBackgroundColour(wxColour(192, 192, 255));
	else
	    SetBackgroundColour(wxColour(192, 192, 255));
    }
    else{
	if (mDepth == 0)
	    SetBackgroundColour(wxColour(255, 255, 96));
	else
	    SetBackgroundColour(wxColour(255, 255, 164));
    }
    Refresh(TRUE);
}

void ParamGroupGUI_cls::
OnMouseLOpen(wxMouseEvent& event){
    mpCCtrlLink->HideAndShow();
}

void ParamGroupGUI_cls::
OnMouseLLink(wxMouseEvent& event){
    if (mpCBPanelLink->mState == 1)
	mpCParentGroup->mCbLinking.mbBody = FALSE;
    else
	mpCParentGroup->mCbLinking.mbBody = TRUE;
}

void ParamGroupGUI_cls::
OnMouseLExpression(wxMouseEvent& event){
    if (mpCBPanelExpression->mState == 1)
	mpCParentGroup->mCbExpression.mbBody = TRUE;
    else
	mpCParentGroup->mCbExpression.mbBody = FALSE;
    ShowButtons(TRUE);
    SendMenuEventToTop(this, menuEditRefreshTL);
}

void ParamGroupGUI_cls::
OnMouseLInput(wxMouseEvent& event){
    mpCParentGroup->OpenExpressionDialog();
}

void ParamGroupGUI_cls::
OnMouseLVisible(wxMouseEvent& event){
    if (mpCParentGroup->mpCSceneObjLink != NULL){
	if (mpCBPanelVisible->mState == 1)
	    mpCParentGroup->mpCSceneObjLink->mCbVisible.mbBody = FALSE;
	else
	    mpCParentGroup->mpCSceneObjLink->mCbVisible.mbBody = TRUE;
    }
    mpCParentGroup->mbObjectVisible = !mpCBPanelVisible->mState;
    
    wxCommandEvent dummy(wxEVT_COMMAND_MENU_SELECTED, menuEditRefreshGL);
    wxGetTopLevelParent(this)->AddPendingEvent(dummy);
}

void ParamGroupGUI_cls::
OnMouseLKilroy(wxMouseEvent& event){
    mpCParentGroup->SetModeShy(mpCBPanelKilroy->mState);
}

void ParamGroupGUI_cls::
OnMouseLSelect(wxMouseEvent& event){
    if (mpCParentGroup->mpCSceneObjLink != NULL)
	MoveItem_cls::SetSelection
	    (mpCCtrlLink->SelectObject(mpCParentGroup->mpCSceneObjLink));
}

