
#ifndef _THREAD_INTERPOLATER_H_
#define _THREAD_INTERPOLATER_H_

#define _INTERPOLATE_LINEAR  0
#define _INTERPOLATE_HERMITE 1
#define _INTERPOLATE_NO      2

#define _INTERPOLATE_PNUM_CONSTANT 0
#define _INTERPOLATE_PNUM_VARIABLE 1
#define _INTERPOLATE_PNUM_ID_SORTED 2

#include <wx/wx.h>
#include <wx/thread.h>

class DataLoader_cls;
class PeriodicBoundary_cls;

class BasicDataPointers_cls{
 public:
    BasicDataPointers_cls(float (*pX)[3], float (*pV)[3],
			  float (*pA)[3], float (*pJ)[3],
			  float *pRadius, float *pDRadius,
			  float *pValue1, float *pDValue1,
			  unsigned char *pType, int *pID);
    void CopyPointers(float (**ppX)[3], float (**ppV)[3],
		      float (**ppA)[3], float (**ppJ)[3],
		      float **ppRadius, float **ppDRadius,
		      float **ppValue1, float **ppDValue1,
		      unsigned char **ppType, int **ppID);
    float (*mpX)[3], (*mpV)[3], (*mpA)[3], (*mpJ)[3];
    float *mpRadius, *mpDRadius;
    float *mpValue1, *mpDValue1;
    unsigned char *mpType;
    int *mpID;
	
};

class ThreadInterpolatorBlockHermite_cls{
};

class ThreadInterpolator_cls : public wxThread {
 public:		 
    ThreadInterpolator_cls(wxThreadKind kind);

    void SetParameters(bool *pbFinishedFlag,
		       DataLoader_cls *pCDataLoader,
		       int PNum, int PNumNext, float dtime,
		       int interpolateType, int variablePNum,
		       int searchLimit, 
		       BasicDataPointers_cls *pCDataPointers,
		       BasicDataPointers_cls *pCDataPointersNext);

    bool *mpbFinishedFlagLink;
    DataLoader_cls *mpCDataLoaderLink;
    PeriodicBoundary_cls *mpCPeriodicLink;
    int   mInterpolateType;
    int   mVariablePNum;
    int   mSearchLimit;
    
    BasicDataPointers_cls *mpCDataPointers, *mpCDataPointersNext;

    int    mPNum, mPNumNext;
    float  mDTime;
    
    int CalcThreadNumber();
    void CalcPInitPFin(int &PInit, int &PFin, 
		       int PNumLocal, int core, int threadNumber);
    virtual ExitCode Entry();
};

#endif
