
#ifndef _THREAD_INTERPOLATE_LINEAR_H_
#define _THREAD_INTERPOLATE_LINEAR_H_

#include "clsThreadInterpolateCommon.h"

#include <wx/wx.h>
#include <wx/thread.h>

class BasicDataPointers_cls;
class DataLoader_cls;
class PeriodicBoundary_cls;

class ThreadInterpBlockLinear_cls : public wxThread, public ThreadInterporateCommon_cls {
 public:
    ThreadInterpBlockLinear_cls(wxThreadKind kind);

    void SetParameters(int PInit, int PFin,
		       int PNumNext, float dtime, int variablePNum,
		       int searchLimit,
		       PeriodicBoundary_cls *pCPeriodicLink,
		       BasicDataPointers_cls *pCDataPointers,
		       BasicDataPointers_cls *pCDataPointersNext);

    int   mPeriodicType;
    float mPeriodicSize[3]; // R͂e\
    int   mPeriodicEffect;

    float (*mpX)[3], (*mpV)[3], (*mpA)[3], (*mpJ)[3];
    unsigned char *mpType;
    float *mpRadius, *mpDRadius;
    float *mpValue1, *mpDValue1;
    int   *mpID;
    
    float (*mpXNext)[3];
    float (*mpVNext)[3];
    float (*mpANext)[3];
    float (*mpJNext)[3];
    unsigned char *mpTypeNext;
    float *mpRadiusNext, *mpDRadiusNext;
    float *mpValue1Next, *mpDValue1Next;

    int   mPIni, mPFin;
    float  mDTime;
    
    void InterpolateDataLinearCore(int i, int iNext, float dtime);
    void InterpolateDataLinearCorePeriodicXYEeffect0(int i, int iNext, float dtime);
    void InterpolateDataLinearCorePeriodicXYEeffect1(int i, int iNext, float dtime);
    void InterpolateDataLinearCorePeriodicXYZEeffect0(int i, int iNext, float dtime);
    void InterpolateDataLinearCorePeriodicXYZEeffect1(int i, int iNext, float dtime);
    void InterpolateDataLinear();
    void InterpolateDataLinearPeriodic();
    void InterpolateDataLinearSearchingID();
    void InterpolateDataLinearSearchingIDSorted();

    virtual ExitCode Entry();
};

#endif
