// -*- c -*- 
// "clsGLDrawData.cpp"

#ifndef _GL_DRAW_DATA_H_
#define _GL_DRAW_DATA_H_

#include "../MYGL/clsPositionAndDirection.h"
#include "../WIDGETCTRL/WX/clsUpdateStatusBar.h"

#include "clsGLDrawSphere.h"

#include <wx/thread.h>
#include <wx/stopwatch.h>

class GLAttribute_cls;
class FilterCtrl_cls;
class InformationGUI_cls;
class PDataBlock_cls;
class ShadowVolume_cls;
class SnapData_cls;
class ZSort_cls;

#include "../COMMON/CommonDefinitions.h"
#include "../COMMON/CommonDefinitionsGL.h"

#define _SORT_RADIAL 0
#define _SORT_ORTHO  1

class ThreadA_cls : public wxThread {
 public:
    ThreadA_cls(wxThreadKind kind);

    void SetParameters(bool *pbFinishedFlag, float *pX, int offset, int pnumber, 
		       float *vertexArray, float *pRotatedArray);
    
    bool  *mpbFinishedFlagLink;
    float *mpX;
    int    mOffset;
    int    mPNumber;
    float *mvertexArray;
    float *mpRotatedArray;
    
    virtual ExitCode Entry();
};

class GLDrawData_cls : public GLDrawSphere_cls {
 public:
    GLDrawData_cls();
    ~GLDrawData_cls();

    static float        msVertexArrayOrg[12];
    static bool         msbInitialized;
    static SnapData_cls *mspCSnapShot;
    static InformationGUI_cls* mspCInfoPanel;
    static float             *mspAlphaMask;
    //static FilterCtrl_cls    *mspCFilterCtrlBooleanLink;
    //static FilterCtrl_cls    *mspCFilterCtrlObjectLink;
    static double       msCurrentDoubleIndex;
    static int          msCurrentIndex;

    unsigned int *mpIndices;
    
    ShadowVolume_cls *mpCShadowVolume;
    ZSort_cls *mpCZSort;
    int    mSortType;

    //wxStopWatch mCStopWatch;
    
    float  mpZero4[4];
    float  mCameraPos[3], mCameraDir[3];
    float  mCopyTranslate[3];

    int    mLightNum;
    double mLightPos[3];
    
    double mLightPhi, mLightTheta;
    
    PositionAndDirection_cls mCLightPos;
    PositionAndDirection_cls mCParticlePos;

    bool  mbShadowVolume;
    bool  mbMainFrame;
        
    //void UpdateStatusBar();
    void SetCameraPos(double *pCamPos);
    void SetCameraDir(double *pCamDir);
    void SetCopyTranrateInfo(float *pCopyTranslate);
    void SetTranrateInfo(float *pTranslate);
    void SetLightSourceInfo(int lightNumber,
			    float *pLightPos, //float *pLightClr,
			    double lightPhi, double lightTheta);
    float GetSteppingAlphaFactor(int step);
    float GetSteppingRadiusFactor(int step);

    void GLDrawPrepareParticleSnap
	(PDataBlock_cls *pCDataBlock, GLAttribute_cls **ppCGLAttribute,
	 double dT, double doubleInde, int frame);
    void GLDraw(int fboIndex, bool bCopiedInstance, 
		PDataBlock_cls *pCDataBlock, GLAttribute_cls **ppCGLAttribute,
		double dT);
    void GLDrawEnd();

    void GLDrawPointAll
	(int downsized,	SnapData_cls *pCDataSnap, GLAttribute_cls *pCGLAttrib);
    void GLDrawPointArrayElement
	(int downsized, SnapData_cls *pCDataSnap, GLAttribute_cls *pCGLAttrib);

    void GetVertexArrayLookAtCamera(float pParticlePos[3], float array[12]);
    void MultiplyMatrixOnVertexArrayOrg(GLfloat matrix[16], float array[3]);
    void GLDrawShadowVolumeAll
	(int downsized, float (*pPos)[3], float *pRadius,
	 float radiusFactor, GLAttribute_cls *pCGLAttrib, 
	 bool bConstantRadius, bool bUseOffset);
    void GLDrawBillboardAll
	(int downsized, SnapData_cls *pCDataSnap, GLAttribute_cls *pCGLAttrib);
    void GLDrawSphereAll
	(int downsized, SnapData_cls *pCDataSnap, GLAttribute_cls *pCGLAttrib);
    void GLDrawObjectAll
	(int downsized, SnapData_cls *pCDataSnap, GLAttribute_cls *pCGLAttrib);

    void ZSortExec(int PNum, int step, float (*pX)[3], unsigned char *pType,
		   int sortOrder);
    int  ZSort(int fboIndex, bool bCopiedInstance,
	       SnapData_cls* pCDataSnap, GLAttribute_cls *pCGLAttribute);

    bool mbSeqLightEnabled;
    bool mbSeqTexEnabled;
    bool mbSeqDepthEnabled;
    void EnableLight(bool bEnable);
    void EnableTexture2D(bool bEnable);
    void EnableDepthMask(bool bEnable);

    void MakeAtrasForSequential(float *pTexCoord, int atrasGrid);
    void GLDrawSequential
	(int fboIndex, bool bCopiedInstance,
	 SnapData_cls *pCDataSnap, GLAttribute_cls **ppCGLAttrib);
    void GLDrawShadowVolumeSequential
	(SnapData_cls *pCDataSnap, int downsized, 
	 int drawTypeList[_MAX_PARTICLE_TYPE],
	 int radiusTypeList[_MAX_PARTICLE_TYPE], 
	 float radiusFactorList[_MAX_PARTICLE_TYPE], 
	 bool bCastShadowList[_MAX_PARTICLE_TYPE],
	 bool bShadowOffset[_MAX_PARTICLE_TYPE],
	 unsigned char *pType, float (*pPos)[3], float *pRadius);
};

#endif
