// -*- c -*- 
// "clsGLDrawSphere.cpp"

#ifndef _GL_DRAW_SPHERE_H_
#define _GL_DRAW_SPHERE_H_

#define _GL_DRAW_SPHERE_BUFFER PACKNUM * 300

#include <wx/thread.h>

#include "clsGLDrawBillboard.h"

#include "../COMMON/CommonDefinitionsForH.h"

class FilterObject_cls;

class ThreadCalcTranslate_cls : public wxThread {
 public:
    ThreadCalcTranslate_cls();
    
    void SetParameters(bool *pbFinishedFlag, int ini, int fin, int offset,
		       float (*pTranslateBuffer)[3], float *pRatioBuffer,
		       ArrayAndIndex_cls *pIndexAndZ,
		       float (*pPos)[3], float *pRaidius, float radiusFactor);

    bool *mpbFinishedFlagLink;
    int  mIni, mFin, mOffset;
    float (*mpTranslateBuffer)[3];
    float *mpRatioBuffer;
    ArrayAndIndex_cls *mpIndexAndZ;
    float (*mpPos)[3], *mpRadius;
    float mRadiusFactor;

    void CalcTranslate();
    virtual ExitCode Entry();
};

class GLDrawSphere_cls : public GLDrawBillboard_cls {
 public:
    GLDrawSphere_cls();
    ~GLDrawSphere_cls();

    void MakeDList(int dList[_MAX_MESH], int *dListList, bool bUseTextue,
		   int quality);

    void GLDrawSphereConstRadiusConstColor
	(int downsized, bool bUseTextue, float (*pPos)[3], 
	 float radiusFactor, int quality, int *dListList = NULL,
	 FilterObject_cls *pCObj = NULL);

    void GLDrawSphereConstRadiusVariableColor
	(int downsized, bool bUseTextue, float (*pPos)[3], float *pValue1,
	 float radiusFactor, int quality, float steppingAlphaFactor,
	 GLAttribute_cls *pCGLAttribute);

    void GLDrawSphereMTDraw
	(int number2Draw, bool bUseTextue, int ithread, int dList, 
	 float (*pTranslateBuffer)[3], float *pRatioBuffer);
    
    void GLDrawSphereVariableRadiusConstColorMT
	(int downsized, bool bUseTextue, float (*pPos)[3], float *pRadius,
	 float radiusFactor, int quality);
    void GLDrawSphereVariableRadiusConstColor
	(int downsized, bool bUseTextue, float (*pPos)[3], float *pRadius,
	 float radiusFactor, int quality, int *dListList = NULL,
	 FilterObject_cls *pCObj = NULL);

    void GLDrawSphereVariableRadiusVariableColor
	(int downsized, bool bUseTextue, float (*pPos)[3], float *pRadius, 
	 float *pValue1, float radiusFactor, float quality, 
	 float steppingAlphaFactor, GLAttribute_cls *pCGLAttribute);
    
    void DrawDList(float pos[3], float scale, int dList);
    //void DrawSphereNoTex(float pos[3], float scale, int quality);

    float (*mpTranslateBufferA)[3];
    float (*mpTranslateBufferB)[3];
    float *mpRatioBufferA;
    float *mpRatioBufferB;
};

#endif
