// -*- c -*- 
// "clsParticleDataSeqCtrl.cpp"

#ifndef _PARTICLE_DATA_SEQ_CTRL_H_
#define _PARTICLE_DATA_SEQ_CTRL_H_

#include "../COMMON/CommonDefinitionsForH.h"

#define _ALL_SEQUENCE    -2
#define _ACTIVE_SEQUENCE -1

#include <wx/wx.h>
#include <fstream>

class DataLoader_cls;
class PDataSequence_cls;
class DrawOption_cls;

class PDataSeqCtrl_cls{
 public:
    PDataSeqCtrl_cls();
    ~PDataSeqCtrl_cls();

    PDataSequence_cls *mpCPDataSequence[_MAX_PDATA_CHANNEL];
    PDataSequence_cls *GetPCActiveFileSequence();

    int mActiveChannel;
    int mTotalUsedMemoryMB;
    int mMemoryLimitationMB;

    void ClearData(int channel, int index, bool bClearFileInfo);
    int  OpenDataFile(wxString strFilePathInit, DataLoader_cls *pCDataLoader);
    wxString GetStrActiveFileSequencePath();
    int  GetActiveFileSequenceLength();

    void CleanUpMemory(int frame, int animStep);
    void PrepareIndex(int index, double indexmod, bool bUseBlur,
		      bool bWaitFinish);
    int  CalcAndGetUsedTotalMemoryMB();
    int  GetLoadedFrameNumber();
    bool IsTheIndexReady(int index, double indexmod, bool bUseBlur);
    bool IsTheIndexReading(int index);
    bool IsTheIndexLoaded(int index);
    
    void ClearSnipping();
    void SetSnipping(int index);

    wxString Serialize();
    void ReadStrLine(std::wistream &istream, wxString strLine, DataLoader_cls *pCDataLoader);
};

#endif
