// -*- c -*- 
// "clsParticleDataSequence.cpp"

#ifndef _PARTICLE_DATA_SEQUENCE_H_
#define _PARTICLE_DATA_SEQUENCE_H_

#define _MAX_PDATA_INDEX 10000
#define _SEQUENCE_CURRENT_INDEX -1
#define _SEQUENCE_ALL_INDEX     -2

#include "clsGLDrawData.h"
#include "../GLATTRIB/clsGLAttribute.h"
#include "../MYGL/clsPositionAndDirection.h"

#include "../COMMON/clsFilename.h"
#include "../COMMON/CommonDefinitions.h"

#include <fstream>
#include <wx/wx.h>

class DataExporter_cls;
class DrawOption_cls;
class PDataSnap_cls;
class PovRayCtrl_cls;

class PDataSequence_cls{
 public:
    PDataSequence_cls(int index);
    ~PDataSequence_cls();

    void InstantiateGLAttribGUI(wxWindow *pCParent);
    void RefreshGLAttribTex();

    PDataSnap_cls *mpCPDataSnap[_MAX_PDATA_INDEX];
    int mSelfIndex;
    GLDrawData_cls   *mpCGLDrawData;
    GLAttribute_cls  *mpCGLAttribute[_MAX_PARTICLE_TYPE];
    FileSequence_cls mCFileSequence;
    int mSnapNumInFile;

    ConfItemSTR_cls mCConfSelfIndex;

    void Clear(int index, bool bClearFileInfo);
    void ReleaseMemoryOutofStep(int animStep);
    int  SearchLowNeedStepLarge(int currentIndex, bool bSnipped);
    int  SearchLowNeedStepSmall(int currentIndex, bool bSnipped);
    bool ReleaseMemoryAStep(int currentIndex, int animStep);

    void SetIndividualFilenames();
    void SetIndividualFilenamesHDF5();
    int  OpenDataFile(wxString strFilePathInit, bool bSequential,
		      int initSeqNum, int seqInterval);

    int  ClampIndexWithinRange(int index);
    wxString GetFilename(int index);
    int      GetFilenameStatus(int index);
    int      GetParticleNumber(int index);
    double   GetTime(int index);
    //double   GetDT(int index, double interpStepDouble);
    void     GetTimeInfo(double &time, double &dT, int index, double interpStepDouble);
    int      GetSeqLength();

    void ClearSnipping();
    void SetSnipping(int index);

    void PrepareIndex(int index, double indexmod, 
		      bool bUseBlur, bool bWaitFinish);
    int  GetUsedTotalMemoryMB();
    int  GetLoadedFrameNumber();
    //bool IsPreparing(int index, double indexmod);
    bool IsTheIndexReady(int index, double indexmod, bool bUseBlur);
    bool IsTheIndexReading(int index);
    bool IsTheIndexLoaded(int index);

    void Special_Copy(int indexA, int indexB);

    // ----
    void SetCameraInfo(PositionAndDirection_cls CCameraPos);
    void SetCopyTranrateInfo(float *pCopyTranslate);
    void GLDrawPrepareParticleSnap(int index, double dT,
				   double doubleIndex, int frame);
    void GLDrawData(int fboIndex, bool bCopiedInstance,
		    int index, double dT, 
		    int lightNumber, float *pLightPos, 
		    double lightPhi, double lightTheta,
		    bool bShadowVolume, int indexGLCanvas, int sortType);
    void GLDrawDataEnd();
    void ExportData(DataExporter_cls *pCDataExporter, int index,
		    int downsize);
    bool GetPovDataRef(wxString &strPData, PovRayCtrl_cls *pCPovRayCtrl,
		       int index, double dT);
    
    wxString SerializeFile();
    wxString Serialize();
    void ReadStrLine(std::wistream &istream, wxString strLine,
		     bool bSequential, int initSeqNum, int seqInterval);
    
};

#endif
