// -*- c -*- 
// "clsParticleDataSnap.cpp"

#ifndef _PARTICLE_DATA_SNAP_H_
#define _PARTICLE_DATA_SNAP_H_

#define _MAX_PDATA_BLOCK 1

#define _FN_STATUS_UNDEF 0
#define _FN_STATUS_VALID 1
#define _FN_STATUS_INVALID 2

#include <wx/wx.h>
#include <vector>

class DataExporter_cls;
class GLAttribute_cls;
class GLDrawData_cls;
class PDataBlock_cls;
class PDataSequence_cls;
class PovRayCtrl_cls;

class PDataSnap_cls{
 public:
    PDataSnap_cls(PDataSequence_cls *pCParentSequence, int index);
    ~PDataSnap_cls();

    PDataBlock_cls *mpCPDataBlock[_MAX_PDATA_BLOCK];
    PDataSequence_cls *mpCParentSequence;
    PDataSnap_cls     *mpCNextPDSnapLink;
    PDataSnap_cls     *mpCPrevPDSnapLink;

    std::vector < PDataSnap_cls* > mVpCSnapsInFile;

    void SetPNextSnap(PDataSnap_cls *pCPDataSnap);
    void SetPPrevSnap(PDataSnap_cls *pCPDataSnap);
    void Clear(bool bClearFileInfo);
    void ReleaseData();

    int mSelfIndex;
    double mTime;
    bool mbSnipping;

    wxString mstrFilePath;
    void SetFilePath(wxString strFilePath);

    int  mFilenameStatus;

    bool mbLoadStarted;
    bool mbLoadFinished;
    
    bool mbInterpolateStarted;
    bool mbInterpolateFinishd;

    int  GetParticleNumber();

    bool IsFileValid();
    void WaitThreadReading
	(PDataSnap_cls *pCSnap, bool bPreparing);
    void WaitThreadInterpolate
	(PDataSnap_cls *pCSnap, bool bPreparing);
    void PrepareData(bool bUseInterpolate, bool bWaitFinish);
    void AllocateSnapsInFile();
    void MarkLoadingStateStart();
    void MarkLoadingStateFinished();
    void LoadData(bool bWaitFinish);
    void InterpolateData(bool bWaitFinish);
    int  GetUsedMemoryKB();
    bool IsPreparing(bool bUseInterpolate);
    bool IsItReady(bool bUseInterpolate);
    bool IsItReading();
    bool IsItLoaded();
    
    void Special_Copy(PDataSnap_cls *pCFrom);

    // ----
    void GLDrawPrepareParticleSnap(GLDrawData_cls *pCDrawData,
				   GLAttribute_cls **ppCGLAttribute,
				   double dT, double doubleIndex, int frame);
	
    void GLDrawData(int fboIndex, bool bCopiedInstance, 
		    GLDrawData_cls *pCDrawData, 
		    GLAttribute_cls **ppCGLAttribute, double dT);
    void ExportData(DataExporter_cls *pCDataExporter, int downsize);
    bool GetPovDataRef(wxString &strPData, PovRayCtrl_cls *pCPovRayCtrl,
		       GLAttribute_cls **pCGLAttribute, double dT);

};

#endif
