// -*- c++ -*- 
// "clsPeriodicBoundary.h"
// (setq c-basic-offset 4)

#include "clsPeriodicBoundary.h"
#include "clsPeriodicBoundaryGUI.h"

#include "../../clsFrameMain.h"

#include "../COMMON/CommonDefinitions.h"

PeriodicBoundary_cls::
PeriodicBoundary_cls(){
    SetToDefault();
}

void PeriodicBoundary_cls::
InitGUI(FrameMain_cls *pCParentFrameLink){
    mpCGUI = new PeriodicBoundaryGUI_cls(this, pCParentFrameLink);
    SetPDialog(mpCGUI);
}

void PeriodicBoundary_cls::
UpdateItems(bool bForce){
    mpCGUI->mpCMNum->UpdateValues();
}

void PeriodicBoundary_cls::
OpenWindow(wxWindow *pC){
    DialogControl_cls::OpenWindow(pC);
    UpdateItems(TRUE);
}

void PeriodicBoundary_cls::
SetToDefault(){
    mCConfList.Clear();
    mCConfList.Add(&mCType, wxT("PeriodicType="), wxT("0"));
    mCConfList.Add(&mCSize, wxT("PeriodicSize="), wxT("1 1 1"));
    mCConfList.Add(&mCEffect, wxT("PeriodicEffect="), wxT("0"));
    mCConfList.Add(&mCBaseVector[0], wxT("PeriodicBaseVector0="), wxT("10 0 0"));
    mCConfList.Add(&mCBaseVector[1], wxT("PeriodicBaseVector1="), wxT("0 10 0"));
    mCConfList.Add(&mCBaseVector[2], wxT("PeriodicBaseVector2="), wxT("0 0 10"));
}

void PeriodicBoundary_cls::
GetBoundaryVector(float vec[3], int axis){
    LOOP_XYZ vec[xyz] = mCSize.mpBody[xyz] * mCBaseVector[axis].mpBody[xyz];
}

void PeriodicBoundary_cls::
ReadStrLine(wxString strLine){
    mCConfList.ReadStrLineAll(strLine);
}

wxString PeriodicBoundary_cls::
Serialize(){
    return mCConfList.SerializeAll();
}
