
#ifndef _THREAD_FILE_READER_H_
#define _THREAD_FILE_READER_H_

#include "INTERPOLATE_GET/clsThreadInterpolateCommon.h"

#include <string>
#include <vector>

#include <wx/wx.h>
#include <wx/thread.h>

#include <fstream>
#include <sstream>

class DataLoader_cls;
class GrammerHDF5_cls;
class PDataBlock_cls;
class Preference_cls;
class ReadHDF5Data_cls;

class ThreadReadBuffer_cls : public wxThread {
 public:
    ThreadReadBuffer_cls(wxThreadKind kind);
    void SetParameters(bool *pbFinishedFlagLink,
		       std::fstream *pifstream, char *pBuf, int size);

    bool *mpbFinishedFlagLink;
    std::fstream *mpifstream;
    char *mpBuf;
    int  mSize;

    virtual ExitCode Entry();
};

class ThreadFileReader_cls : public wxThread, public ThreadInterporateCommon_cls {
 public:
    ThreadFileReader_cls(wxThreadKind kind);

    void SetParameters(int selfThreadIndex, //bool *pbFinishedFlag, 
		       DataLoader_cls *pCDataLoder,
		       PDataBlock_cls *pCDataBlock,
		       wxString strFilePath, int pNum,
		       bool bUseID);
    
    //bool *mpbFinishedFlagLink;
    int   mSelfThreadIndex;
    wxString mstrFilePath;
    
    float (*mpX)[3];
    float (*mpV)[3];
    float (*mpA)[3];
    float (*mpJ)[3];
    float *mpRadius;
    float *mpDRadius;
    unsigned char *mpType;
    int   *mpID;
    float *mpValue1;
    float *mpDValue1;

    // 1t@Cɕf[^
    std::vector < float(*)[3] > mVpXList;
    std::vector < float(*)[3] > mVpVList;
    std::vector < float(*)[3] > mVpAList;
    std::vector < float(*)[3] > mVpJList;
    std::vector < float* > mVpRadiusList;
    std::vector < float* > mVpDRadiusList;
    std::vector < unsigned char* > mVpTypeList;
    std::vector < int* > mVpIDList;
    std::vector < float* > mVpValue1List;
    std::vector < float* > mVpDValue1List;

    bool  mbUseID;
    bool  mbUseDefaultFormat;

    int   mPNum;
    int   mPNumSrc; // HDF̂ƂɎg
    DataLoader_cls *mpCDataLoaderLink;
    PDataBlock_cls *mpCDataBlockLink;
    int   mDataType;
    std::vector < int > mVGrammerBody;
    bool  mbTranslate, mbScaling, mbScalingValue1;
    bool  mbSortById;
    float mTranslate[3];
    float mScaling;
    float mScalingValue1;
    float mLogarithmValue1;
    int   mHeaderByte;
    int   mHeaderLine;
    
    void  DoAdjusting();
    void  DoAdjustingHDF5(GrammerHDF5_cls &CGrammerHDF5);
    void  MakeListSearchingID(bool *pbCheck, bool *pbCheckSrc, int *pPrevIndex, 
			      int snap, int src);
    void  MakeListSearchingIDSorted(bool *pbCheck, bool *pbCheckSrc, int *pPrevIndex, 
				    int snap, int src);
    void  InterpolateTOKI(int snap, ReadHDF5Data_cls& CRead, GrammerHDF5_cls& CGrammerHDF5);
    void  ReadBinaryBodyDefaultFormat
	(std::fstream& ifstream, int progressInterval);
    void  ReadBinaryBody();
    void  ReadAsciiBody();
    void  ReadHDF5Body();
    void  SortById();
    void  SortByIdHDF5(int snap);
    virtual ExitCode Entry();

    static bool IsReadThreadIdleAny();
    static bool IsReadThreadIdleAll();
    static int  GetIdleThreadIndex();
    static int  GetThreadIndexReading(int snapIndex);
    static Preference_cls *mspCPreferenceLink;
};

#endif
