// "clsPovObjectMesh.cpp"
// (c-basic-offset 4)

#ifndef _POV_MESH_H_
#define _POV_MESH_H_

#include "clsWavefrontMaterial.h"

#include "../../MESH/clsMeshBase.h"
#include "../../POVRAY/clsPovSerialize.h"

#include "../../COMMON/clsAsciiReader.h"

#include <wx/wx.h>
#include <vector>

#include <wx/thread.h>

class PovRayCtrl_cls;

class ThreadReadMesh2Sub : public wxThread, public AsciiReader_cls {
 public:
    ThreadReadMesh2Sub(char *pBuffer, int fileSize, int posStart,
		       int itemNum, int skipLine, 
		       std::vector < float > *pVNormals,
		       bool *pbFinishedFlagLink);

    virtual ExitCode Entry();

    bool *mpbFinishedFlagLink;
    char *mpBuffer;
    int mFileSize;
    int mPosStart, mItemNum, mSkipLine;

    //float ReadFloat(char **ptr, char pDelim);
    std::vector < float > *mpVData;
};



// -----

class PovObjectMesh_cls : public AsciiReader_cls, public PovSerialize_cls, public CallBackMaterial_cls{
 public:
    PovObjectMesh_cls();

    static PovRayCtrl_cls *mspCPovRayLink;
    
    // -- Mesh
    WavefrontMaterialCtrl_cls mCWFMaterial;
    MeshBase_cls mCMesh;
    
    bool mbUseMaterialColor;
    bool mbMaterialExist;
    
    wxString mstrLoaded;
    wxString mstrPovLabel; // .pov ǂ񂾂Ƃ̃IuWFNg
    wxString mstrObjectLabel;
    int mCalledMaterialType;

    void ClearMesh();
    int  GetGLPolygon(int poly);
    void FlushPolyList(std::vector < int > &VMP,
		       int &polyMem, int &seqNum);
    void CheckGeometry();

    bool ReadMesh2File(wxString strFile);
    int  GetFaceNum();
    int  GetFaceNumTriangle();
    void ConstructNormalVectors();
    bool ReadObjFile(wxString strFile);
    void ReadMeshFromFile(wxString strFile);

    void CallMaterial(int type);
    void GLDraw(bool bUseMaterialColor);
    
    void GetStrPovMesh2(wxString& strPov, bool bUseMaterial, float clr[3][4],
			wxString strFinishOption, wxString strNormal);
    void GetStrPovInclude(wxString &strPov, wxString strLabel, 
			  bool bUseMaterial, float clr[3][4], 
			  wxString strFinishOption, wxString strNormal);

};

#endif
