// "clsPovObjectMesh.cpp"
// (c-basic-offset 4)

#ifndef _POV_STICKS_H_
#define _POV_STICKS_H_

#include "../../MYGL/clsPositionAndDirection.h"

#include <wx/wx.h>
#include <wx/thread.h>
#include <vector>

class ArrayAndIndex_cls;
class ColorCurve_cls;
class PeriodicBoundary_cls;
class SnapData_cls;

class ThreadStickString_cls : public wxThread{
public:
    ThreadStickString_cls(bool *pbFinishedFlagLink,
			  char *pBuf, int init, int fin, int loop,
			  int *pVListA, int *pVListB, 
			  char *pVBoundaryType, float *pVFactor,
			  bool bConstancFactor,
			  float basedVector[8][3], float (*pPos)[3]);

    bool GetCoordString(char strCoordA[64], char strCoordB[64],
			float pBoaA[3], float pPosB[3]);
    
    virtual ExitCode Entry();

    bool *mpbFinishedFlagLink;
    char *mpBuf;
    int  mInit, mFin, mLoop;
    int *mpVListA, *mpVListB;
    char *mpVBoundaryType;
    float *mpVFactor;
    bool   mbConstantFactor;
    float (*mpBaseVector)[3];
    float (*mpPos)[3];
};

class ThreadStickCalc_cls : public wxThread {
public:
    ThreadStickCalc_cls
	(bool *pbFinishedFlagLink,
	 std::vector < int > &VListA, 
	 std::vector < int > &VListB,
	 std::vector < char > &VBoundaryType,
	 std::vector < float > &VFactor);
    
    void SetParameter(float (*pX)[3], unsigned char *pValueType,
		      int init1, int fin1, int init2, int fin2, int num, 
		      int critType, int specType,
		      int specA, int specB,
		      float critA, float critB, float critA2, float critB2);
    
    bool *mpbFinishedFlagLink;
    
    float (*mpX)[3];
    unsigned char *mpValueType;
    int mInit1, mFin1, mInit2, mFin2, mNum;
    int mCritType, mSpecType;
    int mSpecA, mSpecB;
    float mCritA, mCritB;
    float mCritA2, mCritB2;

    std::vector < int > &mVListA;
    std::vector < int > &mVListB;
    std::vector < char > &mVBoundaryType;
    std::vector < float > &mVFactor;

    void CheckStep(float (*pX)[3], int i, int j, float critA2);
    void CheckRamp(float (*pX)[3], int i, int j, float critA, float critB);
    void CheckStepBetween(float (*pX)[3], int i, int j, float critA2, float critB2);
    
    virtual ExitCode Entry();
			
};

class PovObjectSticks_cls {
public:
    PovObjectSticks_cls();
    ~PovObjectSticks_cls();

    std::vector < int > mVListA;
    std::vector < int > mVListB;
    std::vector < char > mVBoundaryType;
    std::vector < float > mVFactor;

    static ArrayAndIndex_cls *mspIndexAndZ;
    PeriodicBoundary_cls *mpCPeriodicLink;
    float mBaseVector[8][3];
    float mSin[13], mCos[13];

    wxString mstrLoaded;
    long mFileSize;
    
    double mCalcedTime;
    int  mCalcedIndex, mCalcedCritType, mCalcedSpecType;
    float mCalcedCritA, mCalcedCritB;
    int  mCalcedSpecA, mCalcedSpecB;
    bool mbConstantFactor;

    bool mbPNumValidity;
    int  mPNumAtChecked;

    void ClearList();
    bool IsConstantFactor();
    void CheckValidity(SnapData_cls* pCSnapshot);

    unsigned char* GetMemoryBufferFromFile(wxString strFile);
    void ReadListFromBinary(wxString strFile);
    void ReadListFromFile(wxString strFormat, int currentIndex);

    void CalcFromData(SnapData_cls *pCSnapshot, int currentIndex,
		      int critType, float critA, float critB,
		      int specType, int specA, int specB);

    void SetPPeriodicBoundary(PeriodicBoundary_cls *pCPeriodic);
    void GLDrawSort(SnapData_cls *pCSnapshot, int type, float alpha,
		    float radius, int width, int bitBoundary,
		    PositionAndDirection_cls CCamPos,
		    std::vector < ColorCurve_cls* > &VpCColorCurve);
    void GLDraw(SnapData_cls *pCSnapshot, int type, float alpha,
		float radius, int width, int bitBoundary,
		PositionAndDirection_cls CCamPos,
		std::vector < ColorCurve_cls* > &VpCColorCurve);
    void GetStrPovSticksRef(wxString &strPData, SnapData_cls *pCSnapshot);
};

#endif
