// "clsPovThreadWriter.cpp"
// (c-basic-offset 4)

#ifndef _POV_THREAD_WRITER_H_
#define _POV_THREAD_WRITER_H_

#include <wx/thread.h>

class ThreadWriterBase_cls : public wxThread {
 public:
    ThreadWriterBase_cls();

    void SerializeClose(char **ppBuf);
    
    int mItemIndex, mItemNumber;
    bool *mpbFinishedFlagLink;
    char *mpBuf;
    int  mNum;
};

class ThreadWriterVectors3_cls : public ThreadWriterBase_cls {
 public:
    ThreadWriterVectors3_cls();

    void SetParameters(bool *pbFinishedFlag, char *pBuf, int num, 
		       float *pVertices, int digit, int itemNumber);

    float *mpVertices;
    char mAFormat[22];
    
    void SerializeVertices(char **ppBuf, float *pVertices);
    void WriteToBuffer();

    virtual ExitCode Entry();
};

class ThreadWriterVectors2_cls : public ThreadWriterBase_cls {
 public:
    ThreadWriterVectors2_cls();
    
    void SetParameters(bool *pbFinishedFlag, char *pBuf, int num,
		       float *pVertices, int digit, int itemNumber);
    
    float *mpVertices;
    char mAFormat[22];
    
    void SerializeVertices(char **ppBuf, float *pVertices);
    void WriteToBuffer();

    virtual ExitCode Entry();
};

class ThreadWriterFaces_cls : public ThreadWriterBase_cls {
 public:
    ThreadWriterFaces_cls();
    
    void SetParameters
	(bool *pbFinishedFlag, char *pBuf, int num, 
	 int *pMaterialAndPolygon, unsigned int *pVertexIndex, 
	 int materialNum,
	 int itemNumber);
    
    int *mpMaterialAndPolygon;
    unsigned int *mpVertexIndex;
    int mMaterialNum;

    void SerializeFaces(char **ppBuf, int vertex1, int vertex2, int vertex3,
			int materialIndex);
    void SerializeFaces(char **ppBuf, int vertex1, int vertex2, int vertex3);
    void WriteToBuffer();
    
    virtual ExitCode Entry();
};

#endif
