// "clsWavefrontMaterial.cpp"
// (c-basic-offset 4)

#ifndef _POV_WAVEFRONT_MTL_H_
#define _POV_WAVEFRONT_MTL_H_

#include "../../COMMON/clsAsciiReader.h"
#include "../../MYGL/clsGLTexture.h"
#include "../clsPovSerialize.h"

#include <wx/wx.h>
#include <vector>

class WavefrontMaterialItem_cls : public AsciiReader_cls, public PovSerialize_cls {
 public:
    WavefrontMaterialItem_cls(wxString strName, wxString strDir, char **ptr, char *bufferEnd);
    wxString mstrName;

    float mDiffuse[4];
    float mAmbient[4];
    float mSpecular[4];
    float mAlpha;
    float mTransmission[4];
    int  mIllumMode;
    float mIOR;

    void GLSetMaterial(bool bUseMaterialColor);

    wxString mstrTexDiffuse;
    GLTexture_cls mCTexture;

    //static void GetAlphaForMultiLayer2(float &alpha);
    void GetClrInfo(float clr0[3][4], float *clrOvwr);
    /*
    void GetStrPovTextureDiffuse 
	(wxString &strPov, wxString strPigment, float clr0[3][4], 
	 wxString strFinishOption, wxString strNormal);
    void GetStrPovTextureAmbientSpecular 
	(wxString &strPov, wxString strPigment, float clr0[3][4],
	 wxString strFinishOption, wxString strNormal);
    */
};

class WavefrontMaterialCtrl_cls : public AsciiReader_cls, public PovSerialize_cls {
 public:
    std::vector < WavefrontMaterialItem_cls > mVCItems;
    
    void Clear();
    void ReadMtllib(wxString strDir, wxString strFile);
    void MakeMaterialIfEmpty();

    int GetIndexFromTag(wxString strTag);
    void GLSetMaterial(int index, bool bUseMaterialColor);

    wxString mstrDirectory;

    void GetStrPovTextureSingle(wxString& strPov, wxString strLabel);
    void GetStrPovTextureList(wxString& strPov, wxString strLabel);
    void GetStrPovTextureDeclare(wxString& strPov, wxString strLabel, float *clrOvwr, wxString strFinishOption, wxString strNormal);
    void GetStrPovTextureDeclareNoMap(wxString& strPov, wxString strLabel, float clr0[3][4], wxString strFinishOption, wxString strNormal);
};

#endif
