
#ifndef _POV_FORMAT_H_
#define _POV_FORMAT_H_

#include "../../CONFITEM/clsConfItem.h"
#include "../../GRAPHIC/clsImgSizeTemplate.h"
#include "../../WIDGETCTRL/clsHookCtrl.h"

#include "clsPovOptions.h"

#define _POV_FORMAT_NUMBER 8
#define _POV_PNG_8BIT  0
#define _POV_PNG_12BIT 1
#define _POV_PNG_16BIT 3
#define _POV_SYSTEM    3
#define _POV_PPM       4
#define _POV_JPG       5
#define _POV_EXR       6
#define _POV_HDR       7

class PovRayCtrl_cls;
class PovRayGUI_cls;

class PovFormat_cls : public PovOptions_cls, public ImgSizeTemplate_cls, public HookItem_cls {
public:
    PovFormat_cls(PovRayCtrl_cls *pCCtrlLink);

    PovRayCtrl_cls *mpCCtrlLink;
    
    void SetToDefault();
    void SetMNumFormat(wxWindow *pCParentPanel);

    wxString mstrAFormat[_POV_FORMAT_NUMBER];

    ConfItemUINT_cls    mCOutputFormat;
    ConfItemINT_cls     mCWidth, mCHeight;
    ConfItemBOOL_cls    mCbAbsolutePath;
    ConfItemBOOL_cls    mCbAntiAlias, mCbDisplay, mCbPause;//, mCbPreview;
    ConfItemBOOL_cls    mCbJitter, mCbOutputAlpha;

    ConfItemFLOAT_cls   mCAAThreshold, mCJitterAmount;
    ConfItemINT_cls     mCAntiAliasDepth;
    ConfItemBOOL_cls    mCbFastColoring;

    ConfItemUINT_cls     mCBoundingMethod;

    void HideAndShow();
    void HookFunc01(int id, void *pArg); // HideAndShow

    wxString GetStrPovFormat(wxString strFile);

    void ReadStrLine(wxString strLine);
};

#endif
