// -*- c -*- 
// (setq c-basic-offset 4)
// "clsPovPhotons.h"

#include "clsPovPhotons.h"

#include "../clsPovRay.h"
#include "../clsPovRayGUI.h"
#include "../../../wxWidgetEnum.h"
#include "../../WIDGETCTRL/clsAtoSTextCtrl.h"
#include "../../WIDGETCTRL/clsDialogEXKey.h"
#include "../../WIDGETCTRL/clsHookCtrl.h"
#include "../../WIDGETCTRL/clsMultiInputPanel.h"

#include "../../COMMON/CommonDefinitions.h"

PovPhotons_cls::
PovPhotons_cls(){
    SetToDefault();
}

void PovPhotons_cls::
SetToDefault(){
    mCConfList.Clear();
    mCConfList.Add(&mCType, wxT("PovPhotonsType="), L"0");
    mCConfList.Add(&mCCount, wxT("PovPhotonsCount="), L"20");
    mCConfList.Add(&mCMaxTrace, wxT("PovPhotonsMaxTrace="), L"5");
}

void PovPhotons_cls::
SetMNumPhotons(wxWindow* pCParentPanel, wxString *psWorkingDir){
    MultiInputPanel_cls* pCurr = 
	MultiInputPanel_cls::Initialize(&mpCMNum, pCParentPanel);

    pCurr->mTextWidth  = -1;
    pCurr->mItemWidth = 180;

    wxString photonsType[2] = {_("No Photons"), _("Use Photons") };
    mIndexType = pCurr->CombinePointerList
	(&mCType.mBody, 2, photonsType, _("Photon Mapping"));
    
    pCurr->mTextWidth = 120;
    pCurr->mItemWidth = -1;
    int boxWidth = 2;
    mIndexCount = pCurr->SetInputAndSlider
	(_ITEM_INTEGER, &mCCount.mBody, _("photon (x1000)"));
    pCurr->SetRange(_ITEM_LASTITEMx2, 2, 2500);

    mIndexMaxTrace = pCurr->SetInputAndSlider
	(_ITEM_INTEGER, &mCMaxTrace.mBody, wxT("max_trace_level"));
    pCurr->SetRange(_ITEM_LASTITEMx2, 2, 10);
    
#ifdef WIN32
    pCurr->mMinimumWidth = 320;
#else
    pCurr->mMinimumWidth = 340;
#endif
    pCurr->FinishSetting();

    pCurr->SetHook(this, &HookItem_cls::HookFunc01, _HOOK_COMBOBOX);

    HideAndShow();
}

void PovPhotons_cls::
HideAndShow(){
    HideAndShowBegin();
    MultiInputPanel_cls *pCurr = mpCMNum;
    bool bShow = (mCType.mBody > _POV_PHOTONS_NOUSE);
    pCurr->ShowItem(mIndexCount, bShow);
    pCurr->ShowItem(mIndexMaxTrace, bShow);
    HideAndShowEnd();
}

void PovPhotons_cls::
HookFunc01(int id, void *pArg){
    HideAndShow();
    RecalcSize();
}

wxString PovPhotons_cls::
GetStrPovGlobal(){
    if (mCType.mBody == _POV_PHOTONS_NOUSE) return wxT("");
    wxString strPov;

    strPov << wxT("\tphotons {") << ENDL;
    strPov << wxT("\t\tcount ") << mCCount.mBody * 1000;
    strPov << wxT("\t\tautostop ") << 0;
    strPov << wxT("\t\tjitter ") << .4;
    strPov << wxT("\t\tmax_trace_level ") << mCMaxTrace.mBody;

    strPov << wxT("\t}") << ENDL;

    return strPov;
}

wxString PovPhotons_cls::
GetStrPovIni(){
    wxString strIni;
    return strIni;
}

void PovPhotons_cls::
GetStrPovPhotonSetting(wxString& strPov,
		       double alpha, double reflectMin, double reflectMax,
		       bool bTarget, bool bCollect){
    //wxString strPov;
    if (mCType.mBody == _POV_PHOTONS_NOUSE) return;

    wxString strTarget = wxT("target ");
    wxString strReflection = wxT("reflection ");
    wxString strRefraction = wxT("refraction ");
    wxString strCollect = wxT("collect ");
    
    bool bReflection = FALSE;
    if (reflectMin >= 0.1 || reflectMax >= 0.2) bReflection = TRUE;
    bool bRefraction = FALSE;
    if (alpha <= 0.9) bRefraction = TRUE;

    if (bReflection == FALSE) strReflection << wxT("off ");
    else                      strReflection << wxT("on ");

    if (bRefraction == FALSE) strRefraction << wxT("off ");
    else                      strRefraction << wxT("on ");

    if (bRefraction == FALSE && bReflection == FALSE)
	bTarget = FALSE;

    if (bTarget == FALSE) strTarget << wxT("off ");
    else                  strTarget << wxT("on ");

    if (bCollect == FALSE) strCollect << wxT("off ");
    else                   strCollect << wxT("on ");
    
    strPov << wxT("\tphotons{ ") << strTarget << strReflection << strRefraction << strCollect << wxT("}") << ENDL;

    /*
    if (alpha > 0.8) // 0.8 ȏł͕sȂ̂targetɂȂ
	strPov << wxT("\tphotons{ reflection on refraction}") << ENDL;
    else if (alpha < 0.1) // 0.1 ȉłcollectȂ
	strPov << wxT("\tphotons{ target reflection on refraction on collect off}") << ENDL;
    else
	strPov << wxT("\tphotons{ target reflection on refraction on collect on}") << ENDL;
    */

    return;// strPov;
}


