
#ifndef _POV_RADIOSITY_H_
#define _POV_RADIOSITY_H_

#include "../../COMMON/clsFilename.h"
#include "../../CONFITEM/clsConfItem.h"
#include "../../WIDGETCTRL/clsHookCtrl.h"

#include "clsPovOptions.h"

#include <wx/filename.h>

#define _POV_RADIOSITY_NOUSE 0
#define _POV_RADIOSITY_PRETRACE 1
#define _POV_RADIOSITY_FULL 2

class MultiInputPanel_cls;
class PovRayCtrl_cls;
class PovRayGUI_cls;

class PovRadiosity_cls : public PovOptions_cls, public HookItem_cls {
 public:
    PovRadiosity_cls(PovRayCtrl_cls *pCCtrlLink);

    PovRayCtrl_cls *mpCCtrlLink;

    void SetToDefault();

    void SetMNumRadiosity(wxWindow *pCParentPanel, wxString *pstrWorkingDir);
    
    void HideAndShow();
    void HookFunc01(int id, void *pArg); // HideAndShow

    wxString mstrListOnOff[2];
    int  mIndexType, mIndexCount, mIndexError;
    int  mIndexMinReuse, mIndexNearestCount;
    int  mIndexRecursionLimit;
    int  mIndexBoolOptions; 
    int  mIndexReuse, mIndexPath;
    int  mIndexTraceStartEnd;
    int  mIndexReproducibility;

    bool IsRadiosityFormatOK();
    wxString GetStrPovGlobal();
    wxString GetStrPovIni();

    ConfItemUINT_cls      mCType, mCReuse;
    ConfItemSTR_cls       mCPathStr;
    ConfItemINT_cls       mCRayCount, mCNearestCount, mCRecursionLimit;
    ConfItemFLOAT_cls     mCError, mCTraceStart, mCTraceEnd;
    ConfItemFLOAT_cls     mCMinimumReuse;
    ConfItemBOOL_cls      mCbZeroAmbient, mCbMedia, mCbNormal;
    ConfItemUINT_cls      mCHighReproducibility;
};

#endif
