// -*- c -*- 
// (setq c-basic-offset 4)
// "clsPovFormat.h"

#include "clsPovRender.h"

#include "../clsPovRay.h"
#include "../clsPovRayGUI.h"
#include "../../COMMON/clsFilename.h"
#include "../../TIMELINE/clsTimeCtrl.h"
#include "../../WIDGETCTRL/clsDialogEXKey.h"
#include "../../WIDGETCTRL/clsMultiInputPanel.h"
#include "../../WIDGETCTRL/clsHookCtrl.h"

#include "../../../wxWidgetEnum.h"
#include "../../COMMON/CommonDefinitions.h"

PovRender_cls::
PovRender_cls(PovRayCtrl_cls *pCCtrlLink){
    mpCCtrlLink = pCCtrlLink;
    SetToDefault();
}

void PovRender_cls::
SetToDefault(){
    mCConfList.Clear();
    mCConfList.Add(&mCAnimationType, wxT("PovAnimationType="), L"0");
    mCConfList.Add(&mCRegionType,   wxT("PovRenderRegion="), L"0");
    mCConfList.Add(&mCRegionCustomMin, wxT("PovRegionCustomMin="), L"0");
    mCConfList.Add(&mCRegionCustomMax, wxT("PovRegionCustomMax="), L"100");
    mCConfList.Add(&mCAnimInit, wxT("PovRenderAnimNinit="), L"0");
}

void PovRender_cls::
SetMNumRender(wxWindow* pCParentPanel){
    MultiInputPanel_cls* pCurr = 
	MultiInputPanel_cls::Initialize(&mpCMNum, pCParentPanel);
    

    pCurr->mTextWidth  = 140;
    pCurr->mComboWidth = -1;
    pCurr->mItemWidth = -1;

    wxString listAnimation[2] = {_("Sequential"), _("Flythrough")};
    pCurr->CombinePointerList
	(&mCAnimationType.mBody, 2, listAnimation, _("Animation Type"));
    
    wxString listRegion[3] = {_("Render Working Area"), _("Render All Scene"), _("Custum")};

    pCurr->CombinePointerList
	(&mCRegionType.mBody, 3, listRegion, _("Region to render"));

    mIndexCustomArea = pCurr->CombinePointerSizer(3, _("Custom Region"));
    wxString strText = wxT(" - ");
    pCurr->CombinePointer(_ITEM_INTEGER, &mCRegionCustomMin.mBody);
    pCurr->mItemWidth = 30;
    pCurr->CombinePointer(_ITEM_STATIC_TEXT, &strText);
    pCurr->mItemWidth = -1;
    pCurr->CombinePointer(_ITEM_INTEGER, &mCRegionCustomMax.mBody);
    
    pCurr->CombinePointerSizer(2, _("Initial sequence"));
    pCurr->CombinePointer(_ITEM_INTEGER_SPIN, &mCAnimInit.mBody);
    int indexAutoCalc = pCurr->CombinePointerButton(btnPovRenderInitSeq, _("Calc. Auto"));
  
    pCurr->FinishSetting();

    HideAndShow();
    pCurr->SetHook(this, &HookItem_cls::HookFunc02, _HOOK_COMBOBOX);
    pCurr->SetHook(this, &HookItem_cls::HookFunc01, _HOOK_BUTTON, indexAutoCalc);
}

void PovRender_cls::
HideAndShow(){
    HideAndShowBegin();
    MultiInputPanel_cls* pCurr = mpCMNum;

    if (mCRegionType.mBody == _RENDER_REGION_CUSTOM)
	pCurr->ShowItem(mIndexCustomArea);
    else
	pCurr->HideItem(mIndexCustomArea);
    
    //pCurr->UpdateValues();
    HideAndShowEnd();
}

void PovRender_cls::
HookFunc01(int id, void *pArg){
    AutoCalc();
}

void PovRender_cls::
HookFunc02(int id, void *pArg){
    HideAndShow();
    mpCCtrlLink->mpCGUI->UpdateButtonLabel();
    RecalcSize();
}

void PovRender_cls::
GetRenderRegion(int &ini, int &fin){
    TimeCtrl_cls *pCTime = mpCCtrlLink->GetPCTimeCtrl();
    if (mCRegionType.mBody == _RENDER_REGION_ALL){
	ini = 0; fin = pCTime->mCMaxFrame.mBody; return;
    }
    if (mCRegionType.mBody == _RENDER_REGION_WA){
	ini = pCTime->mCWAMin.mBody;
	fin = pCTime->mCWAMax.mBody;
	return;
    }
    ini = mCRegionCustomMin.mBody;
    fin = mCRegionCustomMax.mBody;
}

void PovRender_cls::
AutoCalc(){
    if (mCRegionType.mBody == 0)
	mCAnimInit.mBody = -mpCCtrlLink->
	    GetPCTimeCtrl()->GetOffsetForImgSeq(0, 0);
    if (mCRegionType.mBody == 1) mCAnimInit.mBody = 0;
    if (mCRegionType.mBody == 2)
	mCAnimInit.mBody = mCRegionCustomMin.mBody /
	    mpCCtrlLink->GetPCTimeCtrl()->mCAnimStep.mBody *
	    mpCCtrlLink->GetPCTimeCtrl()->mCAnimInterp.mBody;
    
    mpCMNum->UpdateValues();
}
