
#include "clsPovMaterialColor.h"

#include "../COMMON/CommonDefinitions.h"

void PovMaterialColor_cls::
GetStrPovFinishIndividual(wxString& strPov, wxString strTab, float pClrAmbient[3], float diffuse, float specular, float roughness, wxString strFinishOptions){
    strPov << strTab << wxT("finish { ") 
	   << PovOut3f(wxT("emission "), pClrAmbient, 3)
	   << PovOutf(wxT(" diffuse "), diffuse, 3)
	   << PovOutf(wxT(" specular "), specular, 3)
	   << PovOutf(wxT(" metallic roughness "), roughness, 3)
	   << strFinishOptions << wxT("}") ;
}

void PovMaterialColor_cls::
GetStrPovTextureFinish(wxString&strPov, wxString strTab, int type, float roughness, wxString strOptions, wxString strNormal, int itemNum){
    
    strPov << strTab << wxT("finish { ");
    switch(type){
    case 0:
	strPov << wxT("emission ") << itemNum 
	       << wxT(" diffuse 0 specular 0") << strOptions;
	break;
    case 1:
	strPov << wxT("emission 0 diffuse ") << itemNum
	       << wxT(" specular 0") << strOptions; 
	break;
    case 2:
	strPov << wxT("emission 0 diffuse 0 specular ") << itemNum
	       << wxT(" metallic roughness ");
	strPov << roughness;
	strPov << strOptions;
	break;
    }
    strPov << wxT("}") << strNormal;
}

wxString PovMaterialColor_cls::
GetStrPovTextureFinishAmbSp(float roughness, float ambient[4], float specular[4], wxString strOptions, wxString strNormal, bool bFilterAlpha){
    wxString strFinish;

    float clrAmbientMod[4];
    LOOP_RGB clrAmbientMod[rgb] = 2*ambient[rgb] / (specular[rgb]+0.002);
    
    strFinish << wxT("finish { ");
    strFinish << wxT("emission ") << PovOut3f(wxT("rgb "), clrAmbientMod, 4);
    strFinish << wxT(" diffuse 0");
    strFinish << wxT(" specular 2 metallic roughness ") << roughness << wxT(" ");
    strFinish << strOptions;
    strFinish << wxT("}") << strNormal;
    return strFinish;
}

wxString PovMaterialColor_cls::
GetStrPovTextureFastColor(wxString strTab, float pClrMat[3][4], float roughness,
			  wxString strFinishOptions, wxString strPigment,
			  bool bFilterAlpha, bool bSetDiffuseZero){
    wxString strTex;

    float diffuseNorm = sqrt(
	pClrMat[1][0]*pClrMat[1][0] +
	pClrMat[1][1]*pClrMat[1][1] +
	pClrMat[1][2]*pClrMat[1][2]);
    float specularNorm = sqrt(
	pClrMat[2][0]*pClrMat[2][0] +
	pClrMat[2][1]*pClrMat[2][1] +
	pClrMat[2][2]*pClrMat[2][2]);
    

    float diffuse = 1;
    if (bSetDiffuseZero == TRUE) diffuse = 0;

    if (strPigment.IsEmpty() == TRUE){
	if (bFilterAlpha == TRUE){
	    strPigment << wxT("rgbt <") 
		       << pClrMat[1][0] << wxT(",")
		       << pClrMat[1][1] << wxT(",")
		       << pClrMat[1][2] << wxT(",1-")
		       << pClrMat[1][3] << wxT("*FilterAlpha>");
	}
	else{
	    if (pClrMat[1][3] == 1)
		strPigment = PovOut3f(wxT("rgb "), pClrMat[1], 4);
	    else{
		strPigment = PovOut4fRGBTfromRGBA(pClrMat[1], 4);
	    }
	}

	// eNX`ȂGL̕\ɋ߂Â钲
	if (diffuseNorm != 0)
	    specularNorm /= diffuseNorm;
	else
	    specularNorm = 0;
	LOOP_XYZ{
	    if (pClrMat[1][xyz] != 0) 
		pClrMat[0][xyz] = pClrMat[0][xyz] / pClrMat[1][xyz];
	}
    }
    else{
	// eNX`̎͑f
	diffuse *= diffuseNorm;
    }
    
    strTex << strTab << wxT("\tpigment {") << strPigment << ENDLCLOSE
	   << strTab << wxT("\tfinish {") << PovOut3f(wxT(" emission "), pClrMat[0], 4) << wxT(" diffuse ") << diffuse << wxT(" specular ") << specularNorm;
    
    if (bFilterAlpha == TRUE) strTex << wxT("*FilterAlpha ");

    strTex << wxT(" metallic roughness ") << roughness << strFinishOptions << ENDLCLOSE;
    return strTex;
}


void PovMaterialColor_cls::
GetStrPovMaterialColor(wxString& strPov, float pClr[4], bool bFilterAlpha){
    strPov << wxT("pigment { ");
    strPov << PovOut4fRGBTfromRGBA(pClr, 4, TRUE, bFilterAlpha);
    strPov << wxT("}");
}

wxString PovMaterialColor_cls::
GetStrPovTextureGLColor(wxString strTab, float pClrMat[3][4], float roughness,
			wxString strFinishOptions, wxString strNormal, 
			wxString strPigment, 
			bool bFilterAlpha, bool bSetDiffuseZero){
    wxString strTex;
    wxString strDiffuse, strSpecular;

    float clrAmbient[4];
    float clrSpecular[4];
    LOOP_RGBA clrAmbient[rgba] = pClrMat[0][rgba];
    LOOP_RGBA clrSpecular[rgba] = pClrMat[2][rgba];

    LOOP_RGB if (pClrMat[2][rgb] == 0) pClrMat[2][rgb] = 0.01;
    if (strPigment.IsEmpty() == TRUE){
	GetStrPovMaterialColor(strDiffuse,  pClrMat[1], bFilterAlpha);
	GetStrPovMaterialColor(strSpecular, clrSpecular, bFilterAlpha);
    }
    else{
	strDiffuse = strPigment;
	strSpecular = strPigment;
    }
    
    strTab << GetTab(1);
    strTex 
	<< strTab << wxT("average") << ENDL
	<< strTab << wxT("texture_map {") << ENDL
	<< strTab << wxT("\t[") << strDiffuse;
    GetStrPovTextureFinish(strTex, wxT(" "), 1, roughness, strFinishOptions, strNormal, 2);
    strTex << wxT("]") << ENDL;
    strTex << strTab << wxT("\t[") << strSpecular << wxT(" ") << GetStrPovTextureFinishAmbSp(roughness, clrAmbient, clrSpecular, strFinishOptions, strNormal, FALSE)
	
	   << wxT("]") << ENDL
	   << strTab << wxT("}") << ENDL;
    
    return strTex;
}

wxString PovMaterialColor_cls::
GetStrPovTextureBase(wxString strTab, wxString strPigment,
		     wxString strFinish, wxString strNormal){
    wxString strTex;
    
    strTex << strTab << wxT("texture {") << ENDL
	   << strTab << wxT("\tpigment {") << strPigment << ENDLCLOSE
	   << strTab << strFinish << ENDL;
    if (strNormal.IsEmpty() == FALSE)
	strTex << strTab << strNormal << ENDL;
    strTex << strTab << ENDLCLOSE;
    
    return strTex;
}

void PovMaterialColor_cls::
GetStrPovTextureColorFilter(wxString &strPov, wxString strTab, float clr[4]){
    float rgbft[5];
    LOOP_RGB rgbft[rgb] = clr[rgb];
    rgbft[3] = clr[3];
    rgbft[4] = 1.0 - clr[3];
    strPov << strTab << wxT("texture { pigment { ") << PovOut5rgbft(rgbft, 3);
    strPov << wxT("}}") << ENDL;
}
