
#ifndef _POV_RAY_GUI_H_
#define _POV_RAY_GUI_H_

#include "../WIDGETCTRL/clsDialogEXKey.h"

//#include "../../clsFrameMain.h"

#define _POV_SNAP 0
#define _POV_ANIM 1

#define _POV_PERSPECTIVE  0
#define _POV_ORTHOGRAPHIC 1
#define _POV_FISHEYE      2
#define _POV_CYLINDER     3

#define _POV_FORMAT_NUMBER 8
#define _POV_PNG_8BIT  0
#define _POV_PNG_12BIT 1
#define _POV_PNG_16BIT 3
#define _POV_SYSTEM    3
#define _POV_PPM       4
#define _POV_JPG       5
#define _POV_EXR       6
#define _POV_HDR       7

#define _POV_RENDER_WORKAREA  0
#define _POV_RENDER_FULLSCENE 1
#define _POV_RENDER_CUSTOM    2

#define _POV_FOLLOW_CAMERA     0
#define _POV_SAME_AS_PREVIEW0  1
#define _POV_SAME_AS_PREVIEW1  2
#define _POV_SAME_AS_PREVIEW2  3
#define _POV_SAME_AS_PREVIEW3  4

#define _POVRAY_36 0
#define _POVRAY_37 1

#define _POVRAY_MAX_THREAD 16

#define _POV_EXPORT 0
#define _POV_RENDER 1

class AtoiSpinCtrl_cls;
class AtoSTextCtrl_cls;
class PovRayCtrl_cls;
class FilterBase_cls;
class wxNotebook;
class wxButtonEX;

class PovRayGUI_cls : public wxDialogEXKey {
public:
    PovRayGUI_cls(PovRayCtrl_cls* pCCtrlLink, wxWindow *pC);
    ~PovRayGUI_cls();

    void SetContents();
    
    //static PovRayGUI_cls *mspCThis;
    PovRayCtrl_cls       *mpCCtrlLink;
    
    wxPanel  *mpCCheckPovray;
    wxPanel  *mpCCheckWorkDir;
    AtoSTextCtrl_cls *mpCPathPovray, *mpCPathWorkDir;
    AtoSTextCtrl_cls *mpCStrSnap, *mpCStrAnim;
    AtoiSpinCtrl_cls *mpCSnapNum, *mpCAnimInit;
    wxButtonEX *mpCButtonPathPovRay;
    wxButtonEX *mpCButtonPathWorkDir;
    wxButtonEX *mpCButtonExportSnap, *mpCButtonRenderSnap;
    wxButtonEX *mpCButtonExportAnim, *mpCButtonRenderAnim;
    wxButtonEX *mpCButtonAdv, *mpCButtonDEF;
    
    wxNotebook *mpCBook1, *mpCBook2;

    void SetMNumBook1();
    void SetMNumBook2();

    void RecalcSize();
    void EnableButtons(bool b0, bool b1, bool b2, bool b3, bool bOthers);
    void EnableAllOptions(bool bEnable);
    void UpdateButtonLabel();
    void UpdateFromText();

    bool CheckConsistency  (int type = _POV_RENDER);    
    bool CheckFileExistencePov();
    bool IsWorkingDirOk();
    bool CheckFileExistenceWorkdir();
    void OnTextRefPov(wxCommandEvent& event);
    void OnTextRefWorkdir(wxCommandEvent& event);
    void OnButtonWorkingDir(wxCommandEvent &event);
    void OnButtonPathPovray(wxCommandEvent &event);
    void OnButtonExportSnap(wxCommandEvent &event);
    void OnButtonExportAnim(wxCommandEvent &event);
    void OnButtonRenderSnap(wxCommandEvent &event);
    void OnButtonRenderAnim(wxCommandEvent &event);
    void OnButtonDefault   (wxCommandEvent &event);
    void OnButtonAdvanced  (wxCommandEvent &event);
    void OnMenuPovUpdateLabel(wxCommandEvent &event);

 private:
    // any class wishing to process wxWidgets events must use this macro
    DECLARE_EVENT_TABLE()
};

#endif
