// "clsPovSerialize.h"

#include "clsPovSerialize.h"

#include "clsPovMaterialColor.h"

#include "../COMMON/CommonDefinitions.h"

PovSerialize_cls::
PovSerialize_cls(){
    mItemIndex = 0;
    mItemNumber = 3;
}

void PovSerialize_cls::
SerializeItem(wxString& strTgt, wxString strItem){
    if (mItemIndex % mItemNumber == 0)
	strTgt << mstrTab << wxT("\t");
    strTgt << strItem << wxT(",");
    if ((mItemIndex + 1) % mItemNumber == 0) strTgt << ENDL;
    mItemIndex++;
}

void PovSerialize_cls::
SerializeCloseItem(wxString& strTgt){
    if (mItemIndex % mItemNumber != 0) strTgt << ENDL;
    strTgt << mstrTab << ENDLCLOSE;
}

wxString PovSerialize_cls::
PovOutf(float value, int digit){
    wxString strFormat = wxString::Format(wxT("%%.%df"), digit);
    return wxString::Format(strFormat, value);
}

wxString PovSerialize_cls::
PovOutf(wxString str, float value, int digit){
    wxString strFormat = wxString::Format(wxT("%%.%df"), digit);
    str << wxString::Format(strFormat, value);
    return str;
}

wxString PovSerialize_cls::
PovOut3d(wxString str, double vec[3], int digit){
    wxString strFormat = wxString::Format
	(wxT("<%%.%df,%%.%df,%%.%df>"), digit, digit, digit);
    str << wxString::Format(strFormat, vec[0], vec[1], vec[2]);
    return str;
}

wxString PovSerialize_cls::
PovOut3dS(wxString str, double vec[3], int digit){
    wxString strFormat = wxString::Format(wxT("%%.%df"), digit);
    str << wxT("<") << GetShortString(wxString::Format(strFormat, vec[0]))
	<< wxT(",") << GetShortString(wxString::Format(strFormat, vec[1]))
	<< wxT(",") << GetShortString(wxString::Format(strFormat, vec[2]))
	<< wxT(">");
    return str;
}

wxString PovSerialize_cls::
PovOut2f(wxString str, float vec[2], int digit){
    wxString strFormat = wxString::Format
	(wxT("<%%.%df,%%.%df>"), digit, digit);
    str << wxString::Format(strFormat, vec[0], vec[1]);
    return str;
}

wxString PovSerialize_cls::
PovOut3f(wxString str, float vec[3], int digit){
    wxString strFormat = wxString::Format
	(wxT("<%%.%df,%%.%df,%%.%df>"), digit, digit, digit);
    str << wxString::Format(strFormat, vec[0], vec[1], vec[2]);
    return str;
}

wxString PovSerialize_cls::
PovOut3fS(wxString str, float vec[3], int digit){
    wxString strFormat = wxString::Format(wxT("%%.%df"), digit);
    str << wxT("<") << GetShortString(wxString::Format(strFormat, vec[0]))
	<< wxT(",") << GetShortString(wxString::Format(strFormat, vec[1]))
	<< wxT(",") << GetShortString(wxString::Format(strFormat, vec[2]))
	<< wxT(">");
    return str;
}

wxString PovSerialize_cls::
PovOut3ui(wxString str, unsigned int vec[3]){
    wxString strFormat = wxT("<%d,%d,%d>");
    str << wxString::Format(strFormat, vec[0], vec[1], vec[2]);
    return str;
}

wxString PovSerialize_cls::
PovOut2f(float vec[2], int digit){
    return PovOut2f(wxT(""), vec, digit);
}

wxString PovSerialize_cls::
PovOut3f(float vec[3], int digit){
    return PovOut3f(wxT(""), vec, digit);
}

wxString PovSerialize_cls::
PovOut3fS(float vec[3], int digit){
    return PovOut3fS(wxT(""), vec, digit);
}

wxString PovSerialize_cls::
PovOut4f(wxString str, float vec[4], int digit){
    wxString strFormat = wxString::Format
	(wxT("<%%.%df,%%.%df,%%.%df,%%.%df>"), digit, digit, digit, digit);
    str << wxString::Format(strFormat,
			    vec[0], vec[1], vec[2], vec[3]);
    return str;
}

wxString PovSerialize_cls::
PovOut4(wxString str, float a, float b, float c, float d){
    str << wxString::Format(wxT("<%g,%g,%g,%g>"),
			       a, b, c, d);
    return str;
}

wxString PovSerialize_cls::
PovOut3(wxString str, float a, float b, float c){
    str << wxString::Format(wxT("<%g,%g,%g>"), 
			       a, b, c);
    return str;
}

wxString PovSerialize_cls::
PovOutRotation(wxString strTab, double pRot[4]){
    wxString strRot;
    if (pRot[3] != 0)
	strRot << strTab << PovOut3(L"rotate", 0, 0, pRot[3]) << ENDL; 
    if (pRot[2] != 0)
	strRot << strTab << PovOut3(L"rotate", 0, pRot[2], 0) << ENDL; 
    if (pRot[1] != 0)
	strRot << strTab << PovOut3(L"rotate", pRot[1], 0, 0) << ENDL; 
    if (pRot[0] != 0)
	strRot << strTab << PovOut3(L"rotate", 0, 0, pRot[0]) << ENDL;
    return strRot;
}

wxString PovSerialize_cls::
PovOut4fRGBTfromRGBA(float vec[4], int digit, bool bAddRGBT, bool bFilterAlpha){
    wxString str;
    wxString strFormat;
        
    if (bFilterAlpha == TRUE){
	if (bAddRGBT == TRUE) str << wxT("rgbt ");
	strFormat = wxString::Format(wxT("<%%.0%df,%%.0%df,%%.0%df,1-%%.0%df*FilterAlpha>"), digit, digit, digit, digit);
	str << wxString::Format(strFormat,
				vec[0], vec[1], vec[2], vec[3]);
    }
    else{
	if (vec[3] != 1){
	    if (bAddRGBT == TRUE) str << wxT("rgbt ");
	    strFormat = wxString::Format(wxT("<%%.0%df,%%.0%df,%%.0%df,%%.0%df>"), digit, digit, digit, digit);
	    str << wxString::Format(strFormat,
				    vec[0], vec[1], vec[2], 1.0f-vec[3]);
	}
	else{
	    if (bAddRGBT == TRUE) str << wxT("rgb ");
	    strFormat = wxString::Format(wxT("<%%.0%df,%%.0%df,%%.0%df>"), digit, digit, digit);
	    str << wxString::Format(strFormat,
				    vec[0], vec[1], vec[2]);
	}
    }
    return str;
}

wxString PovSerialize_cls::
PovOut5rgbft(float vec[4], int digit){
        wxString str;
    wxString strFormat;
    strFormat = wxString::Format(wxT("rgbft <%%.0%df,%%.0%df,%%.0%df,%%.0%df,%%.0%df>"), digit, digit, digit, digit, digit);
	
    str << wxString::Format(strFormat,
			    vec[0], vec[1], vec[2], vec[3], vec[4]);
    return str;
}

wxString PovSerialize_cls::
GetCutoffString(float value, int digit){
    wxString str;
    wxString strFormat = wxString::Format(wxT("%%.%df"), digit);
    str << wxString::Format(strFormat, value);
    return str;
}

wxString PovSerialize_cls::
GetShortString(float value){
    wxString str;
    str << value;
    return GetShortString(str);
}

wxString PovSerialize_cls::
GetShortString(wxString str){
    if (str.Find('.') == wxNOT_FOUND) return str;
    while (str.GetChar(str.Len()-1) == wxT('0'))
	str.RemoveLast();
    if (str.GetChar(str.Len()-1) == '.')
	str.RemoveLast();
    return str;
}

void PovSerialize_cls::
PushBackPovOut3f(wxString *pstrTgt, 
		 wxString str, float vec[3], int digit){
    wxString strFormat = wxString::Format
	(wxT("<%%.%df,%%.%df,%%.%df>"), digit, digit, digit);
    *pstrTgt << str << wxString::Format(strFormat, vec[0], vec[1], vec[2]);
}

wxString PovSerialize_cls::
GetTab(int depth){
    switch(depth){
    case 1: return wxT("\t");
    case 2: return wxT("\t\t");
    case 3: return wxT("\t\t\t");
    case 4: return wxT("\t\t\t\t");
    case 5: return wxT("\t\t\t\t\t");
    case 6: return wxT("\t\t\t\t\t\t");
    case 7: return wxT("\t\t\t\t\t\t\t");
    }
    return wxT("");
}

void PovSerialize_cls::
GetStrPovPigmentImageMap(wxString &strPov, wxString strFile, bool bUseUV, int mapType, float alpha, float gamma){
    if (strFile.IsEmpty() == TRUE) return;

    if (bUseUV == TRUE) 
	strPov << wxT("uv_mapping ");
    strPov << wxT("image_map { png \"") << strFile << wxT("\"");
    strPov << PovOutf(wxT(" gamma "), gamma, 2);
    strPov << wxT(" interpolate 2");
    if (alpha != 1)
	strPov << wxT(" transmit all ") << PovOutf(1.0-alpha, 3);
    if (mapType != 0)
	strPov << wxT("map_type ") << mapType;
    strPov << wxT("}");
}

void PovSerialize_cls::
GetStrPovTextureColor(wxString &strPov, wxString strTab, 
		      bool bFastColoring,
		      float pClrMat[3][4], float roughness,
		      wxString strFinishOptions, wxString strNormal, 
		      wxString strPigment, 
		      bool bFilterAlpha, bool bSetDiffuseZero){
    strPov << strTab << wxT("texture {") << ENDL;
    if (bFastColoring == TRUE){
	strPov << PovMaterialColor_cls::GetStrPovTextureFastColor(strTab, pClrMat, roughness, strFinishOptions, strPigment, bFilterAlpha, bSetDiffuseZero);
	if (strNormal.IsEmpty() == FALSE) strPov << strTab << strNormal;
    }
    else
	strPov << PovMaterialColor_cls::GetStrPovTextureGLColor(strTab, pClrMat, roughness, strFinishOptions, strNormal, strPigment, bFilterAlpha, bSetDiffuseZero);

    strPov << strTab << ENDLCLOSE;
}

void PovSerialize_cls::
GetAlphaForMultiLayer2(float& alpha){
    // eNX`2d˂̏ꍇ
    float tr = 1.0-alpha;
    float trsq = sqrt(tr);
    alpha = 1.0 - trsq;
}

void PovSerialize_cls::
GetStrPovTextureDiffuse(wxString &strPov, wxString strPigment, float clr0[3][4], wxString strFinishOption, wxString strNormal){
    
    float clr[3][4];
    LOOP_RGBA clr[0][rgba] = 0;
    LOOP_RGB  clr[1][rgb ] = clr0[1][rgb] * 2; clr [1][3] = clr0[1][3];
    LOOP_RGBA clr[2][rgba] = 0;

    wxString strFinish;
    PovMaterialColor_cls::GetStrPovFinishIndividual(strFinish, GetTab(1), clr[0], 2, 0, 0, strFinishOption);
    strPov << PovMaterialColor_cls::GetStrPovTextureBase
	(wxES, strPigment, strFinish, strNormal);
    LOOP_RGB clr[1][rgb] /= 2;
    GetAlphaForMultiLayer2(clr[1][3]);
    PovMaterialColor_cls::GetStrPovTextureColorFilter(strPov, wxES, clr[1]);
}

void PovSerialize_cls::
GetStrPovTextureAmbientSpecular(wxString &strPov, wxString strPigment, float clr0[3][4], wxString strFinishOption, wxString strNormal){
    float clr[3][4];
    LOOP_RGB clr[0][rgb] = clr0[0][rgb] * 2; clr[0][3] = clr0[0][3];
    LOOP_RGB clr[1][rgb] = clr0[2][rgb] * 2; clr[1][3] = clr0[2][3];
    LOOP_RGB clr[2][rgb] = clr0[2][rgb] * 2; clr[2][3] = clr0[2][3];
    LOOP_RGB if (clr[2][rgb] < 0.02){
	clr[2][rgb] = 0.02;
	clr[1][rgb] = 0.02;
    }
    
    wxString strFinish;
    GetAlphaForMultiLayer2(clr[2][3]);
    LOOP_RGB clr[0][rgb] /= (clr[2][rgb] / 2);
    LOOP_RGB clr[0][rgb] *= clr[2][3];
    PovMaterialColor_cls::GetStrPovFinishIndividual(strFinish, GetTab(1), clr[0], 0, 2 * clr[2][3], 0.156*0.156, strFinishOption);
    strPov << PovMaterialColor_cls::GetStrPovTextureBase
	(wxES, strPigment, strFinish, strNormal);
    LOOP_RGB clr[2][rgb] /= 2;
    PovMaterialColor_cls::GetStrPovTextureColorFilter(strPov, wxES, clr[2]);
}

wxString PovSerialize_cls::
mAstrAxis[3] = {wxT("x"), wxT("y"), wxT("z")};

wxString PovSerialize_cls::
mAstrAxisUC[3] = {wxT("X"), wxT("Y"), wxT("Z")};

