// "clsCameraPathGUI.cpp"

#ifndef _CAMERA_PATH_GUI_H
#define _CAMERA_PATH_GUI_H

#include "../WIDGETCTRL/clsHookCtrl.h"
#include "../WIDGETCTRL/clsDialogEXKey.h"
#include "../WIDGETCTRL/clsDialogController.h"
#include "../WIDGETCTRL/clsMinimizeButton.h"

#include <wx/notebook.h>

class AnchorPath_cls;
class CameraPath_cls;
class CameraPathCtrl_cls;
class FrameMain_cls;
class MainGLCanvas_cls;

class CameraPathGUI_cls : public wxDialogEXKey, public MinimizeButton_cls, public HookItem_cls {
 public:
    CameraPathGUI_cls(CameraPathCtrl_cls* pCCtrl, 
		      wxWindow *pC);

    CameraPathCtrl_cls *mpCCtrl;

    wxButtonEX *mpCBTNAdv, *mpCBTNPath;
    wxNotebook *mpCBook1;
    wxNotebook *mpCBook2;

    MultiInputPanel_cls* mpCMNumView[5];
    MultiInputPanel_cls* mpCMNumBG;
    MultiInputPanel_cls* mpCMNumRender;
    MultiInputPanel_cls* mpCMNumPath;

    int mIndexAnglePath;
    int mIndexFishEyeOffset;
    int mIndexGrid;
    int mIndexBG0, mIndexBG1;
    int mIndexFBOSize, mIndexBlend;
    int mIndexTagFont;
    int mIndexDepthEditor, mIndexDistortion;

    MainGLCanvas_cls* GetPCActiveGLCanvas();
    bool HideAndShowView(int i);
    bool HideAndShowRender();
    void HideAndShowAll();

    void SetMNumView(int i, wxWindow *pCWindow);
    void SetMNumBG  (wxWindow *pCWindow);
    void SetMNumRender(wxWindow *pCWindow);
    void SetMNumPath(wxWindow *pCWindow);
    void ReconnectView();
    void ReconnectViewBG();

    void OnNotebookChanged(wxNotebookEvent &event);
    void OnButtonViewDefault(wxCommandEvent &event);

    void HookFunc01(int id, void *pArg); // Show
    void HookFunc02(int id, void *pArg); // SyncGL
    void HookFunc03(int id, void *pArg); // DepthExpression
    void HookFuncHS(int id, void *pArg);
    void HookFuncAssign(int id, void *pArg);
    void HookFuncHideButton(int id, void *pArg);
    
    void UpdateValuesAll();

private:
    // any class wishing to process wxWidgets events must use this macro
    DECLARE_EVENT_TABLE()
};

class CameraPathCtrl_cls : public DialogControl_cls {
 public:
    CameraPathCtrl_cls(CameraPath_cls *pCCameraPath,
		       AnchorPath_cls *pCAnchorPath);

    FrameMain_cls *mpCParentFrame;
    CameraPathGUI_cls *mpCGUI;

    AnchorPath_cls *mpCAnchorPathLinked;
    CameraPath_cls *mpCCameraPathLinked;
    
    int mActiveView;

    void InitGUI(FrameMain_cls *pCParentFrameLink);
    void UpdateItems(bool bForce = FALSE);
};

#endif
