// -*- c -*-
// "clsLightSource.cpp"

#ifndef _LIGHT_SOURCE_H_
#define _LIGHT_SOURCE_H_

#include "clsSceneObj.h"
#include "../CONFITEM/clsConfItem.h"
#include "../MYGL/clsPositionAndDirection.h"
#include "../POVRAY/clsPovRay.h"

#define _LIGHT_NUM_MAX 7
#define _LIGHT_POINT 0
#define _LIGHT_SPOT  1
#define _LIGHT_CYLINDER 2
#define _LIGHT_PARALLEL 3

#define _LIGHT_FADE_OFF 0
#define _LIGHT_FADE_1   1
#define _LIGHT_FADE_2   2

class FilterDataBoxData_cls;
class LightSRC_cls;

class LightSRC_cls : public SceneObj_cls {
 public:
    LightSRC_cls(int selfIndex, wxString strTag);
    ~LightSRC_cls();

    int mSelfIndex;
    int mUpdateBit;

    //ParamGroup_cls *mpCLightColor;
    ParamGroup_cls *mpCLightStrength;

    ConfItemINT_cls   mCLightType;
    ConfItemINT_cls   mCFadeType;
    ConfItemFLOAT_cls mCFadeDistance;
    ConfItemINT_cls   mCSpotAngle;
    ConfItemBOOL_cls   mCbEnable;
    ConfItemBOOL_cls  mCbCastShadow;
    ConfItemBOOL_cls  mCbAreaLight;
    ConfItemBOOL_cls  mCbDrawObject;
    ConfItemUINT_cls  mCObjType;
    ConfItemFLOAT_cls mCAreaSize;
    ConfItemUINT_cls  mCAreaQuality;
    ConfItemBOOL_cls  mCbAreaJitter;
    
    void CopyFromP(LightSRC_cls *pCFrom);
    void GetLightInfo(double doubleIndex, float pLightPos[4], 
		      float pLightPhiTheta[2], bool bSV,
		      FilterDataBoxData_cls *pCScene);
    void GetLightColor(double doubleIndex, float pLightColor[4]);
    void GetLightDir(double doubleIndex, float pLightDir[4], bool bSV);
    void GLSetSpotEffect(int GLLightType, double doubleIndex, float pos[4]);
    void GLSetAttenuation(int GLLightType);
    void GLSetLightSourceComp
	(int GLLightIndex, double doubleIndex, bool bAmbient, bool bDiffuse,
	 FilterDataBoxData_cls *pCScene);

    void GLSetLightSource(double doubleIndex, bool bEnable,
			  int shadowMode, FilterDataBoxData_cls *pCScene);
    void GLDrawRealObj();
    void GLDraw(bool bHittest);

    wxString GetStrPovAttenuation();
    wxString GetStrPovAreaLight(float parallelFactor);
    wxString GetStrPovLight(double doubleIndex, FilterDataBoxData_cls *pCScene);

    

    wxString Serialize();
    void ReadStrLine(std::wistream &istream, wxString strLineTag);
};

#endif
