// "clsLightSourceGUI.cpp"

#ifndef _LIGHT_SOURCE_GUI_H
#define _LIGHT_SOURCE_GUI_H

#include "clsLightSource.h"

#include "../CONFITEM/clsConfItem.h"
#include "../WIDGETCTRL/clsHookCtrl.h"
#include "../WIDGETCTRL/clsDialogEXKey.h"
#include "../WIDGETCTRL/clsDialogController.h"

#include <vector>

class FilterDataBoxData_cls;
class FrameMain_cls;
class LightSRC_cls;
class LightSRCCtrl_cls;

class LightSRCGUI_cls : public wxDialogEXKey, public HookItem_cls {
 public:
    LightSRCGUI_cls(LightSRCCtrl_cls* pCCtrl,
		    wxWindow *pC, wxPoint pos, wxSize size);

    LightSRCCtrl_cls *mpCCtrl;

    std::vector < wxIcon > mVIcon;
    std::vector < wxIcon > mVLightTypeIcon;

    int mIndexAdd, mIndexDelete, mIndexIcon;
    int mIndexType, mIndexFadeType, mIndexTarget;
    int mIndexTranslate, mIndexRotate, mIndexScale, mIndexStrength;
    int mIndexSpotAngle;
    int mIndexFadeDistance;
    int mIndexShadow;
    int mIndexArea, mIndexAreaParam;
    int mIndexDrawObject;//, mIndexObjectParam;
    int mIndexEnable;

    MultiInputPanel_cls* mpCMInputMain;
    MultiInputPanel_cls* mpCMInputLight;

    void SetMNumMain();
    void SetMNumParam();
    void ReconnectParam();
    void HideAndShowAll();
    void RemakeIconList(int selected = -1);


    void OnButtonAdd(wxCommandEvent& event);
    void OnButtonRemove(wxCommandEvent& event);
    void OnSelector(wxCommandEvent& event);

    void HookFuncAssign(int id, void *pArg);
    void HookFuncHS(int id, void *pArg); 

    void UpdateValuesAll();

 private:
    DECLARE_EVENT_TABLE()
};

class LightSRCCtrl_cls  : public DialogControl_cls{
 public:
    LightSRCCtrl_cls();
    ~LightSRCCtrl_cls();

    void InitGUI(FrameMain_cls *pC);

    FrameMain_cls *mpCParentFrameLink;
    LightSRCGUI_cls *mpCGUI;

    int mUpdateBit;
    int mActiveItem;
    
    ConfItemList_cls mCConfList;
    ConfItemINT_cls  mCLightNum;
    
    ParamGroup_cls *mpCParamGroup[_LIGHT_NUM_MAX];
    LightSRC_cls   *mpCLightSRC[_LIGHT_NUM_MAX];

    void SelectLight(int index);
    void AddLight();
    void RemoveLight();
    void UpdateTLShown();

    GLuint GetLightType(int lightIndex);

    int  GetNumberLightEnabled();
    int  GetNumberLightWithShadow();
    int  GetFirstShadowedLight();
    int  GetFirstValidLight();
    void GetLightInfo(double doubleIndex, 
		      float pLightPos[4],   float pLightThetaPhi[2],
		      int index, bool bSV/* = TRUE*/,
		      FilterDataBoxData_cls* pCScene);
    void UpdateCurrentObj(double doubleIndex);
    //void GLDrawPath(double doubleIndex);
    /*
    void GLDrawCurrent(double doubleIndex, double scale, 
		       int displayList, int mode);
    */
    void GLDrawRealObj();
    void GLDraw(bool bHittest);
    void GLDisableAllLight();
    void GLSetSingleDiffuse(int lightIndex, double dobuleIndex, FilterDataBoxData_cls *pCScene);
    void SetNonShadowLight(double doubleIndex, FilterDataBoxData_cls *pCScene);
    void SetBasicLight(double doubleIndex, int shadowMode, FilterDataBoxData_cls *pCScene);
	
    void UpdateItems(bool bForce = FALSE);

    wxString GetStrPovLights(double doubleIndex, FilterDataBoxData_cls *pCScene);

    wxString Serialize();
    void ReadStrLine(std::wistream &istream, wxString strLine);
};

#endif
