// -*- c -*-
// "clsSceneObj.h"

#include "clsSceneObjTexture.h"
#include "clsTexPropertyGUI.h"

#include "../COMMON/CommonDefinitions.h"

SceneObjTexture_cls::
SceneObjTexture_cls(){
    //ConfItems̏
    //̃NXێĂe邱ƂɂB
    mpCLinkedToMe = NULL;
}

SceneObjTexture_cls::
~SceneObjTexture_cls(){
    if (mpCLinkedToMe != NULL){
	mpCLinkedToMe->mpCTextureLinked = NULL;
	mpCLinkedToMe->ReconnectTexture(NULL);
    }
}

void SceneObjTexture_cls::
AppendDefaultItems(ConfItemList_cls &mCConfList, int texType, wxString strTag){
    mTexType = texType;

    mCConfList.Add(&mCShaderType, strTag+wxT("ShaderType="), wxT("2"));
    mCConfList.Add(&mCGasShader, strTag+wxT("GasShader="), wxT("0"));
    mCConfList.Add(&mCShininess, strTag+wxT("Shininess="), wxT("10"));
    mCConfList.Add(&mCCartoonBoldness, strTag+wxT("CartoonBold="), wxT("0.2"));
    mCConfList.Add(&mCOutlineBoldness, strTag+wxT("OutlineBold="), wxT("0"));
    mCConfList.Add(&mCAlphaClipping, strTag+wxT("AlphaCripping="), wxT("0"));
    mCConfList.Add(&mCScatterAmbientFacter, strTag+wxT("ScatterAmbient="), wxT("0.5"));
    mCConfList.Add(&mCTransmitType, strTag+wxT("TransmitType="), wxT("0"));
    mCConfList.Add(&mCAlpha, strTag+wxT("Alpha="), wxT("1"));
    mCConfList.Add(&mCReflectType, strTag+wxT("ReflectType="), wxT("0"));
    mCConfList.Add(&mCReflectMin, strTag+wxT("ReflectMin="), wxT("0.2"));
    mCConfList.Add(&mCReflectMax, strTag+wxT("ReflectMax="), wxT("0.5"));
    mCConfList.Add(&mCbRefrectFresnel, strTag+wxT("ReflectFresnel="), wxT("0"));
    mCConfList.Add(&mCbRefrectConserve, strTag+wxT("ReflectConserve="), wxT("0"));
    mCConfList.Add(&mCIOR, strTag+wxT("IOR="), wxT("1"));
    mCConfList.Add(&mCbPhotonTarget, strTag+wxT("PhotonTarget="), wxT("0"));
    mCConfList.Add(&mCbPhotonCollect, strTag+wxT("PhotonCollect="), wxT("0"));
    mCConfList.Add(&mCstrTexFormat[0], strTag+wxT("TexFormat0="), wxT("NONE"));
    mCConfList.Add(&mCstrTexFormat[1], strTag+wxT("TexFormat1="), wxT("NONE"));
    mCConfList.Add(&mCMappingType, strTag+wxT("Mapping="), wxT("0"));
    mCConfList.Add(&mCTextureSize, strTag+wxT("TextureSize="), wxT("0"));
    mCConfList.Add(&mCbImgSeqRepeat, strTag+wxT("ImgSeqRepeat="), wxT("0"));
    mCConfList.Add(&mCImgSeqOffset, strTag+wxT("ImgSeqOffset="), wxT("0"));
    mCConfList.Add(&mCImgSeqLength, strTag+wxT("ImgSeqLength="), wxT("-1"));
    
    mCConfList.Add(&mCbLightRecieve, strTag+wxT("LightRecieve="), wxT("1 1 1 1 1 1 1"));
    mCConfList.Add(&mCbFogRecieve, strTag+wxT("FogRecieve="), wxT("1"));
    mCConfList.Add(&mCCastShadow, strTag+wxT("CastShadow="), wxT("1"));
    
    for (int i = 0; i < _TEX_NORMAL_MAX; i++){
	wxString strTagPattern = strTag+wxT("NormalPattern");
	strTagPattern << i << wxT("=");
	mCConfList.Add(&mCNormalPattern[i], strTagPattern, wxT("0"));
	wxString strTagDegree = strTag+wxT("NormalDegree");
	strTagDegree << i << wxT("=");
	mCConfList.Add(&mCNormalDegree[i], strTagDegree, wxT("0.3"));
	wxString strTagScale = strTag+wxT("NormalScale");
	strTagScale << i << wxT("=");
	mCConfList.Add(&mCNormalScale[i], strTagScale, wxT("1"));
    }
}

wxString SceneObjTexture_cls::
GetStrTexFile(int frame){
    if (mstrFileSequenceChecked.IsSameAs(mCstrTexFormat[0].mstrBody)){
	if (mCImgSeqLength.mBody == 0){
	    return mCstrTexFormat[0].mstrBody;
	}
	if (mCFileSequence.mSeqLength == 0) return wxES;
	int seqLength = mCFileSequence.mSeqLength;
	if (seqLength < 0) seqLength = mCFileSequence.mSeqLength;
	if (mCbImgSeqRepeat.mbBody == TRUE)
	    frame = frame % seqLength;
	else
	    if (frame >= seqLength) frame = seqLength - 1;
	return mCFileSequence.GetModifiedStr(frame);
    }
    
    mCFileSequence.Set(mCstrTexFormat[0].mstrBody, mCImgSeqOffset.mBody);
    mCFileSequence.CalcMaxOffset();
    mstrFileSequenceChecked = mCstrTexFormat[0].mstrBody;
    return GetStrTexFile(frame);
}

float SceneObjTexture_cls::
GetAlpha(){
    if (mCTransmitType.mBody == 0) return 1;
    return mCAlpha.mBody;
}

void SceneObjTexture_cls::
GetAlphaInfo(float clr[3][4]){
    if (mCTransmitType.mBody == 0){
	clr[0][3] = 1; clr[1][3] = 1; clr[2][3] = 1;
	return;
    }
    clr[0][3] = mCAlpha.mBody;
    clr[1][3] = mCAlpha.mBody;
    clr[2][3] = mCAlpha.mBody;
}

wxString SceneObjTexture_cls::
GetStrPovInteriorOptions(){
    wxString strInteriorOptions;
    if (mCIOR.mBody != 1){
	strInteriorOptions << wxT(" ior ") << mCIOR.mBody;
    }
    return strInteriorOptions;
}

wxString SceneObjTexture_cls::
GetStrPovFinishOptions(){
    wxString strFinishOptions;
    if (mCReflectType.mBody > 0){
	strFinishOptions << wxT(" reflection{") 
			 << mCReflectMin.mBody << wxT(",")
			 << mCReflectMax.mBody;
	if (mCReflectType.mBody == 2)
	    strFinishOptions << wxT(" metallic 1");
	if (mCbRefrectFresnel.mbBody == TRUE)
	    strFinishOptions << wxT(" fresnel on");
	strFinishOptions << wxT("}");
	if (mCbRefrectFresnel.mbBody == TRUE)
	    strFinishOptions << wxT(" conserve_energy");
    }
    return strFinishOptions;
}

wxString SceneObjTexture_cls::
GetStrPovNormalBase(int index, float scale[3]){
    
    wxString normalPatternList[12] = {
	wxT("no normal pattern"),
	wxT("agate"), wxT("bozo"),
	wxT("bumps"), wxT("brick"), 
	wxT("cells"), wxT("checker"),
	wxT("crackle"), wxT("dents"),
	wxT("facets"), wxT("marble"), 
	wxT("function { f_ridged_mf(x, y, z, 0.07, 2.2,  7, 0.6, 0.9, 1) }")
    };
    
    wxString strNormal;

    strNormal << normalPatternList[mCNormalPattern[index].mBody];
    strNormal << wxT(" ") << mCNormalDegree[index].mBody;
    strNormal << PovOut3f(wxT(" scale "), scale, 4);
    //strNormal << wxT(" turbulence ") << mCNormalTurb[index].mBody;
    
    return strNormal;
}

wxString SceneObjTexture_cls::
GetStrPovNormal(){
    wxString strNormal;
    if (mCNormalPattern[0].mBody == 0 && mCNormalPattern[1].mBody == 0) return strNormal;
    
    if (mCNormalPattern[0].mBody != 0 && mCNormalPattern[1].mBody != 0){
	float scale0[3] = {1, 1, 1};
	float scale1[3] = {1, 1, 1};

	LOOP_XYZ scale0[xyz] *= mCNormalScale[0].mBody;
	LOOP_XYZ scale1[xyz] *= mCNormalScale[1].mBody;

	/*
	CalcScale(scale0, mCNormalScale[0].mBody, bGlobalCoord, rotAxis);
	CalcScale(scale1, mCNormalScale[1].mBody, bGlobalCoord, rotAxis);
	
	scale0[X] *= scaleFactorX;
	scale0[Y] *= scaleFactorY;
	scale0[Z] *= scaleFactorZ;
	scale1[X] *= scaleFactorX;
	scale1[Y] *= scaleFactorY;
	scale1[Z] *= scaleFactorZ;
	*/
	
	strNormal << L"\tnormal {" << ENDL
		  << L"\t\taverage" << ENDL
		  << L"\t\t\tnormal_map {" << ENDL
		  << L"\t\t\t [ 1.00 " << GetStrPovNormalBase(0, scale0) << L" ]" << ENDL
		  << L"\t\t\t [ 1.00 " << GetStrPovNormalBase(1, scale1) << L" ]" << ENDL
		  << L"\t\t}" << ENDL
		  << L"\t}" << ENDL;
    }
    else{
	for (int i = 0; i < _TEX_NORMAL_MAX; i++)
	    if (mCNormalPattern[i].mBody != 0){
		float scale[3] = {1, 1, 1};
		
		LOOP_XYZ scale[xyz] *= mCNormalScale[i].mBody;

		/*
		CalcScale(scale, mCNormalScale[0].mBody, bGlobalCoord, rotAxis);
		
		scale[X] *= scaleFactorX;
		scale[Y] *= scaleFactorY;
		scale[Z] *= scaleFactorZ;
		*/
		strNormal << L"\tnormal {" << GetStrPovNormalBase(i, scale) <<  L" }";
	    }
    }
    
    return strNormal;
}
