// -*- c -*-
// "clsTexture.cpp"

#ifndef _SCENE_OBJECT_TEXTURE_H_
#define _SCENE_OBJECT_TEXTURE_H_

#include "../COMMON/clsFilename.h"
#include "../CONFITEM/clsConfItem.h"
#include "../POVRAY/clsPovSerialize.h"

#define _TEX_NORMAL_MAX 2

#define _TEX_FOR_PARTILCE 0
#define _TEX_FOR_MATERIAL 1

#define _MAPPING_LOCAL_X 0
#define _MAPPING_LOCAL_Y 1
#define _MAPPING_LOCAL_Z 2
#define _MAPPING_UV      3

class TexPropertyGUI_cls;

class SceneObjTexture_cls : public PovSerialize_cls {
public:
    SceneObjTexture_cls();
    ~SceneObjTexture_cls();

    void AppendDefaultItems(ConfItemList_cls &mCConfList, int texType, wxString strTag = wxEmptyString);

    int mTexType;
    ConfItemUINT_cls  mCShaderType;
    ConfItemUINT_cls  mCGasShader;
    ConfItemINT_cls   mCShininess;
    ConfItemFLOAT_cls mCCartoonBoldness;
    ConfItemFLOAT_cls mCOutlineBoldness;
    ConfItemFLOAT_cls mCAlphaClipping;
    ConfItemFLOAT_cls mCScatterAmbientFacter;
    
    ConfItemUINT_cls       mCReflectType;
    ConfItemFLOAT_cls      mCReflectMin, mCReflectMax;
    ConfItemBOOL_cls       mCbRefrectFresnel;
    ConfItemBOOL_cls       mCbRefrectConserve;
    
    ConfItemFLOAT_cls      mCFadeDistance;
    ConfItemFLOAT_cls      mCIOR;

    ConfItemBOOL_cls       mCbPhotonTarget;
    ConfItemBOOL_cls       mCbPhotonCollect;

    ConfItemUINT_cls       mCTransmitType;
    ConfItemFLOAT_cls      mCAlpha;

    ConfItemUINT_cls       mCNormalPattern[_TEX_NORMAL_MAX];
    ConfItemFLOAT_cls      mCNormalDegree[_TEX_NORMAL_MAX];
    ConfItemFLOAT_cls      mCNormalScale[_TEX_NORMAL_MAX];

    ConfItemSTR_cls        mCstrTexFormat[2];
    ConfItemUINT_cls       mCMappingType;
    ConfItemUINT_cls       mCTextureSize;
    ConfItemBOOL_cls       mCbImgSeqRepeat;
    ConfItemINT_cls        mCImgSeqOffset;
    ConfItemINT_cls        mCImgSeqLength;

    ConfItemBOOLARRAY_cls  mCbLightRecieve;
    ConfItemBOOL_cls       mCbFogRecieve;

    ConfItemUINT_cls       mCCastShadow;

    FileSequence_cls    mCFileSequence;
    wxString            mstrFileSequenceChecked;
    
    wxString GetStrTexFile(int frame);
    void     GetAlphaInfo(float clr[3][4]);
    float    GetAlpha();
    wxString GetStrPovFinishOptions();
    wxString GetStrPovInteriorOptions();
    wxString GetStrPovNormalBase(int index, float scale[3]);
    wxString GetStrPovNormal(/*wxString strTab*/);
    
    TexPropertyGUI_cls* mpCLinkedToMe;
    //SceneObjTexture_cls **mppCLinkedMe;
};

#endif

