// "clsTexPropertyGUI.cpp"

#ifndef _TEX_PROPERTY_GUI_H
#define _TEX_PROPERTY_GUI_H

#include "clsSceneObjTexture.h"

#include "../WIDGETCTRL/clsHookCtrl.h"
#include "../WIDGETCTRL/clsDialogEXKey.h"
#include "../WIDGETCTRL/clsDialogController.h"

#include <wx/notebook.h>

class FrameMain_cls;
class TexPropertyCtrl_cls;

class TexPropertyGUI_cls : public wxDialogEXKey, public HookItem_cls {
public:
    TexPropertyGUI_cls(TexPropertyCtrl_cls *pCCtrl, wxWindow *pC);
    ~TexPropertyGUI_cls();

    FrameMain_cls *mpCFrameMainLink;

    SceneObjTexture_cls* mpCTextureLinked;
    MultiInputPanel_cls* mpCMInputTexture;

    wxNotebook *mpCBook1;
    wxNotebook *mpCBook2;

    MultiInputPanel_cls* mpCMInputTexFormat;
    MultiInputPanel_cls* mpCMInputBump;
    MultiInputPanel_cls* mpCMInputMirror;
    MultiInputPanel_cls* mpCMInputInterior;
    MultiInputPanel_cls* mpCMInputPhotons;
    MultiInputPanel_cls* mpCMInputRecieve;
    MultiInputPanel_cls* mpCMInputCast;

    void SetMNumParam();
    void SetMNumBump(wxWindow *pCParent);
    void SetMNumTexFormat(wxWindow *pCParent);
    void SetMNumMirror(wxWindow *pCParent);
    void SetMNumInterior(wxWindow *pCParent);
    void SetMNumPhotons(wxWindow *pCParent);
    void SetMNumRecieve(wxWindow *pCParent);
    void SetMNumCast(wxWindow *pCParent);
    
    wxString mstrTitle;
    
    unsigned int mDummyShader, mDummyShaderGas;
    int          mDummyShininess;
    unsigned int mDummyTransmitType;
    float        mDummyAlpha;
    float        mDummyCartoonBoldness;
    float        mDummyOutlineBoldness;
    float        mDummyAlphaClipping;
    float        mDummyScatterAmbientFactor;
    unsigned int mDummyMappingType;
    unsigned int mDummyTextureSize;
    bool         mbDummySeqRepeat;
    int          mDummySeqOffset, mDummySeqLength;

    int   mDummyReflectionType;
    float mDummyReflectionMin, mDummyReflectionMax;
    bool  mbDummyReflectionFresnel, mbDummyReflectionConserve;
    
    float mDummyFadeDistance;
    float mDummyIOR;

    bool  mDummyPhotonTarget;
    bool  mDummyPhotonCollect;

    wxString mDummyTexFormat[2];
    
    unsigned int mDummyNormalPattern[_TEX_NORMAL_MAX];
    float mDummyNormalDegree[_TEX_NORMAL_MAX];
    float mDummyNormalScale[_TEX_NORMAL_MAX];

    bool mbDummyLightRecieve[7];
    bool mbDummyFogRecieve;

    unsigned int mDummyCastShadow;

    int  mIndexShader;
    int  mIndexShininess, mIndexAlphaClipping;
    int  mIndexScatterAmbientFactor;
    int  mIndexTransmit, mIndexAlpha;
    int  mIndexCartoonBoldness, mIndexOutlineBoldness;
    
    int  mIndexReflexType;
    int  mIndexReflexMin, mIndexReflexMax;
    int  mIndexReflexOptions;
    int  mIndexNormalPattern[_TEX_NORMAL_MAX];
    int  mIndexNormalDegree[_TEX_NORMAL_MAX];
    int  mIndexNormalScale[_TEX_NORMAL_MAX]; 
    
    int  mIndexFadeDistance, mIndexIOR;
    int  mIndexPhotonTarget, mIndexPhotonCollect;

    int  mIndexTexFormat[2];
    int  mIndexTexDefault;
    int  mIndexMapping, mIndexTextureSize;
    int  mIndexImgSeq1, mIndexImgSeq2;
    int  mIndexLightRecieve[7], mIndexFogRecieve;
    int  mIndexCastShadow;

    void RecalcSize();

    void UpdateValuesAll();
    void ReconnectBase(SceneObjTexture_cls *pCTex);
    void ReconnectTexture(SceneObjTexture_cls *pCTexture, 
			  wxString strCustomName = wxT(""));
    void ReconnectTexFormat(SceneObjTexture_cls *pCTex);
    void ReconnectBump(SceneObjTexture_cls *pCTex);
    void ReconnectMirror(SceneObjTexture_cls *pCTex);
    void ReconnectInterior(SceneObjTexture_cls *pCTex);
    void ReconnectPhotons(SceneObjTexture_cls *pCTex);
    void ReconnectRecieve(SceneObjTexture_cls *pCTex);
    void ReconnectCast(SceneObjTexture_cls* pCTex);

    void HideAndShowTexture();
    void HideAndShowTexFormat();
    void HideAndShowBump();
    void HideAndShowMirror();
    void HideAndShowInterior();
    void HideAndShowPhotons();
    void HideAndShowRecieve();
    void HideAndShowCast();
    
    void HookFuncHS(int id, void *pArg);
    void HookFunc01(int id, void *pArg);
    void HookFunc02(int id, void *pArg);
    void HookFunc03(int id, void *pArg);
    //static void HookHideAndShow(void *pUsrdef, void *pEvent);
};

class TexPropertyCtrl_cls : public DialogControl_cls{
 public:
    TexPropertyCtrl_cls();
    ~TexPropertyCtrl_cls();
    
    FrameMain_cls *mpCFrameMainLink;
    TexPropertyGUI_cls *mpCGUI;

    void InitGUI(FrameMain_cls *pCParentFrameLink);
    void UpdateItems(bool bForce = FALSE);
    void ReconnectTexture(SceneObjTexture_cls *pCTexture, wxString strCustomName);
};

#endif
