// -*- c++ -*-/
// "clsPlayCtrlGUI.h"

#include "clsPlayCtrlGUI.h"
#include "clsTimeCtrl.h"

#include "../../wxWidgetEnum.h"
#include "../../wxWidgetEnumMenu.h"

#include "../WIDGETCTRL/EX/clsBitmapButtonEX.h"
#include "../WIDGETCTRL/EX/clsButtonEX.h"
#include "../WIDGETCTRL/EX/clsCheckBoxEX.h"
#include "../WIDGETCTRL/EX/clsStaticTextEX.h"
#include "../WIDGETCTRL/WX/clsFontProvider.h"

#include "../PARTICLEDATA/clsGLDrawData.h"

#include <wx/tglbtn.h>
#include <wx/artprov.h>

extern bool GbForceAbort;

#define wxDefPos wxDefaultPosition

BEGIN_EVENT_TABLE(PlayCtrlGUI_cls, wxPanel)
EVT_BUTTON(btnCtrlSetKeyPos, PlayCtrlGUI_cls::OnButtonSetKeyPos)
EVT_BUTTON(btnCtrlSetKeyPosRot, PlayCtrlGUI_cls::OnButtonSetKeyPosRot)
EVT_BUTTON(btnCtrlSetKeyAnc, PlayCtrlGUI_cls::OnButtonSetKeyAnc)
EVT_BUTTON(btnCtrlStepBCK2,  PlayCtrlGUI_cls::OnButtonStepBCK2)
EVT_BUTTON(btnCtrlPlayBCK1,  PlayCtrlGUI_cls::OnButtonPlayBCK1)
EVT_BUTTON(btnCtrlStepBCK1,  PlayCtrlGUI_cls::OnButtonStepBCK1)
EVT_BUTTON(btnCtrlStepFWD1,  PlayCtrlGUI_cls::OnButtonStepFWD1)
EVT_BUTTON(btnCtrlPlayFWD1,  PlayCtrlGUI_cls::OnButtonPlayFWD1)
EVT_BUTTON(btnCtrlStepFWD2,  PlayCtrlGUI_cls::OnButtonStepFWD2)
EVT_BUTTON(btnCtrlAbort,     PlayCtrlGUI_cls::OnButtonAbort)
EVT_TOGGLEBUTTON(btnRepeat,    PlayCtrlGUI_cls::OnToggleRepeat)
EVT_TOGGLEBUTTON(btnAutoAbort, PlayCtrlGUI_cls::OnToggleAutoAbort)
EVT_SPINCTRL(spnAnimStep,   PlayCtrlGUI_cls::OnSpinAnimStep)
EVT_SPINCTRL(spnAnimInterp, PlayCtrlGUI_cls::OnSpinAnimInterp)
EVT_SPINCTRL(spnPrefetch,   PlayCtrlGUI_cls::OnSpinPrefetch)
EVT_KEY_DOWN(PlayCtrlGUI_cls::OnKeyDown)
END_EVENT_TABLE()

PlayCtrlGUI_cls::
PlayCtrlGUI_cls(wxWindow *pCParent, TimeCtrl_cls *pCCtrl,
		wxWindowID id, wxPoint pos, wxSize size):
wxPanel(pCParent, id, pos, size)
{
    mpCTimeLink = pCCtrl;
    SetBackgroundColour(wxColour(216, 216, 216));
    SetFont(FontProvider_cls::GetFont(1));

    //i
    wxBoxSizer *pBoxSizerButtons2 = new wxBoxSizer(wxHORIZONTAL);

    SetStaticText(pBoxSizerButtons2, _("Set Key"));
    
    mpCButtonSetKeyPos  = 
	new wxButtonEX(this, btnCtrlSetKeyPos, wxT("POS"),
		       wxDefPos, wxSize(60, -1));

    mpCButtonSetKeyPosRot  = 
	new wxButtonEX(this, btnCtrlSetKeyPosRot, wxT("POS+ROT"),
		       wxDefPos, wxSize(90, -1));

    mpCButtonSetKeyAnc  =
	new wxButtonEX(this, btnCtrlSetKeyAnc, wxT("ANC"),
		       wxDefPos, wxSize(60, -1));

    mpCButtonStepBCK2 = new wxBitmapButtonEX
	(this, btnCtrlStepBCK2,
	 wxArtProvider::GetBitmap(wxT("wxART_STARTPOINT"), wxART_TOOLBAR),
	 wxDefPos, wxSize(40, -1));
    mpCButtonPlayBCK1 = new wxBitmapButtonEX
	(this, btnCtrlPlayBCK1,
	 wxArtProvider::GetBitmap(wxT("wxART_PLAY_BACK"), wxART_TOOLBAR),
	 wxDefPos, wxSize(40, -1));
    mpCButtonStepBCK1 =	new wxBitmapButtonEX
	(this, btnCtrlStepBCK1,
	 wxArtProvider::GetBitmap(wxT("wxART_STEP_BACKWARD"), wxART_TOOLBAR),
	 wxDefPos, wxSize(40, -1));
    mpCButtonStepFWD1 =	new wxBitmapButtonEX
	(this, btnCtrlStepFWD1,
	 wxArtProvider::GetBitmap(wxT("wxART_STEP_FORWARD"), wxART_TOOLBAR),
	 wxDefPos, wxSize(40, -1));
    mpCButtonPlayFWD1 =	new wxBitmapButtonEX
	(this, btnCtrlPlayFWD1,
	 wxArtProvider::GetBitmap(wxT("wxART_PLAY"), wxART_TOOLBAR),
	 wxDefPos, wxSize(40, -1));
    mpCButtonStepFWD2 =	new wxBitmapButtonEX
	(this, btnCtrlStepFWD2,
	 wxArtProvider::GetBitmap(wxT("wxART_ENDPOINT"), wxART_TOOLBAR),
	 wxDefPos, wxSize(40, -1));

    mpCButtonAbort = new wxBitmapButtonEX
	(this, btnCtrlAbort, 
	 wxArtProvider::GetBitmap(wxT("wxART_DELETE"), wxART_TOOLBAR),
	 wxDefPos, wxSize(30, -1));
    mpCButtonAbort->SetBackgroundColour(wxColour(255, 128, 128));

    mpCButtonSetKeyPos   ->mKeyEventTarget = _WIDGETEX_TOPPARENT;
    mpCButtonSetKeyPosRot->mKeyEventTarget = _WIDGETEX_TOPPARENT;
    mpCButtonSetKeyAnc   ->mKeyEventTarget = _WIDGETEX_TOPPARENT;
    //mpCButtonStepBCK2->mKeyEventTarget = _WIDGETEX_TOPPARENT;
    //mpCButtonPlayBCK1->mKeyEventTarget = _WIDGETEX_TOPPARENT;
    //mpCButtonStepBCK1->mKeyEventTarget = _WIDGETEX_TOPPARENT;
    //mpCButtonStepFWD1->mKeyEventTarget = _WIDGETEX_TOPPARENT;
    //mpCButtonPlayFWD1->mKeyEventTarget = _WIDGETEX_TOPPARENT;
    //mpCButtonStepFWD2->mKeyEventTarget = _WIDGETEX_TOPPARENT;
    //mpCButtonAbort->mKeyEventTarget = _WIDGETEX_TOPPARENT;
    
    mpCSpinAnimStep = 
	new wxSpinCtrl(this, spnAnimStep, wxT(""),
		       wxDefPos, wxSize(50, -1));
    mpCSpinAnimStep->SetRange(1, 99);

    mpCSpinAnimInterp = 
	new wxSpinCtrl(this, spnAnimInterp, wxT(""),
		       wxDefPos, wxSize(50, -1));
    mpCSpinAnimInterp->SetRange(1, 99);

    mpCSpinPrefetch = 
	new wxSpinCtrl(this, spnPrefetch, wxT(""),
		       wxDefPos, wxSize(50, -1));
    mpCSpinPrefetch->SetValue(3);
    mpCSpinPrefetch->SetRange(1, 99);
    
    mpCToggleRepeat    =
	new wxToggleButton(this, btnRepeat, wxT("Repeat"),
			   wxDefPos, wxSize(70, -1));

    int flags = wxEXPAND | wxALIGN_CENTER_VERTICAL;

    pBoxSizerButtons2->Add(mpCButtonSetKeyAnc,     0, flags);
    pBoxSizerButtons2->Add(mpCButtonSetKeyPos,     0, flags);
    pBoxSizerButtons2->Add(mpCButtonSetKeyPosRot,  0, flags);
    pBoxSizerButtons2->Add(10, -1);
    pBoxSizerButtons2->Add(mpCButtonStepBCK2,   0, flags);
    pBoxSizerButtons2->Add(mpCButtonPlayBCK1,   0, flags);
    pBoxSizerButtons2->Add(mpCButtonStepBCK1,   0, flags);
    pBoxSizerButtons2->Add(mpCButtonStepFWD1,   0, flags);
    pBoxSizerButtons2->Add(mpCButtonPlayFWD1,   0, flags);
    pBoxSizerButtons2->Add(mpCButtonStepFWD2,   0, flags);
    pBoxSizerButtons2->Add(10, -1);
    pBoxSizerButtons2->Add(mpCToggleRepeat,     0, flags);
    pBoxSizerButtons2->Add(10, -1);

    SetStaticText(pBoxSizerButtons2, _("Stepping"));
    pBoxSizerButtons2->Add(mpCSpinAnimStep,     0, flags);

    SetStaticText(pBoxSizerButtons2, _("Interval"));
    pBoxSizerButtons2->Add(mpCSpinAnimInterp,   0, flags);
    pBoxSizerButtons2->Add(10, -1);

    SetStaticText(pBoxSizerButtons2, _("Prefetch"));
    pBoxSizerButtons2->Add(mpCSpinPrefetch  ,   0, flags);

    mpCAutoAbort    =
	new wxToggleButton(this, btnAutoAbort, _("Auto Abort"),
			   wxDefPos, wxSize(120, -1));
    mpCAutoAbort->SetToolTip(_("Abort drawing process if it takes too much time.")); 
    
    pBoxSizerButtons2->Add(-1, 0, flags);
    pBoxSizerButtons2->Add(mpCAutoAbort, 0, flags);
    pBoxSizerButtons2->Add(mpCButtonAbort, 0, flags);
    
    
    //pBoxSizerButtons2->Add(10, -1);

    //pBoxSizerSrc->Add(pBoxSizerButtons2, 0, flags);

    this->SetSizer(pBoxSizerButtons2);
}

void PlayCtrlGUI_cls::
SetStaticText(wxBoxSizer *pBoxSizerSrc, wxString strTag){
    wxBoxSizer *pBoxSizerTag = new wxBoxSizer(wxVERTICAL);
    wxStaticTextEX *pCTag    = new wxStaticTextEX(this, wxID_ANY, strTag);
    pBoxSizerTag->AddStretchSpacer();
    pBoxSizerTag->Add(pCTag, 0, wxALIGN_CENTER_VERTICAL);
    pBoxSizerTag->AddStretchSpacer();
    pBoxSizerSrc->Add(pBoxSizerTag, 0, wxEXPAND);
}

bool PlayCtrlGUI_cls::
IsAbortClicked(wxPoint mousePos){
    if (mpCButtonAbort->IsShownOnScreen() == FALSE) return FALSE;
    if (mpCButtonAbort->GetScreenRect().Contains(mousePos))
	return TRUE;
    return FALSE;
}

void PlayCtrlGUI_cls::
OnButtonSetKeyPos(wxCommandEvent &event){
    SendMenuEventToTop(this, menuSetKeyPos);
    //wxCommandEvent com(wxEVT_COMMAND_MENU_SELECTED, menuItemSetKeyPos);
    //wxGetTopLevelParent(this)->AddPendingEvent(com);
}

void PlayCtrlGUI_cls::
OnButtonSetKeyPosRot(wxCommandEvent &event){
    SendMenuEventToTop(this, menuSetKeyPosRot);
    //wxCommandEvent com(wxEVT_COMMAND_MENU_SELECTED, menuItemSetKeyPosRot);
    //wxGetTopLevelParent(this)->AddPendingEvent(com);
}

void PlayCtrlGUI_cls::
OnButtonSetKeyAnc(wxCommandEvent &event){
    SendMenuEventToTop(this, menuSetKeyAnc);
}

void PlayCtrlGUI_cls::
OnButtonStepBCK2(wxCommandEvent& event){
    mpCTimeLink->MoveFrameCommandLarge(-1);
    RefreshGLPanels();
}

void PlayCtrlGUI_cls::
OnButtonPlayBCK1(wxCommandEvent& event){
    mpCTimeLink->StartPlayCommand(-1);
}

void PlayCtrlGUI_cls::
OnButtonStepBCK1(wxCommandEvent& event){
    mpCTimeLink->MoveInterpStepCommand(-1);
}

void PlayCtrlGUI_cls::
OnButtonStepFWD1(wxCommandEvent& event){
    mpCTimeLink->MoveInterpStepCommand(+1);
}

void PlayCtrlGUI_cls::
OnButtonPlayFWD1(wxCommandEvent& event){
    mpCTimeLink->StartPlayCommand(+1);
}

void PlayCtrlGUI_cls::
OnButtonStepFWD2(wxCommandEvent& event){
    mpCTimeLink->MoveFrameCommandLarge(+1);
    RefreshGLPanels();
}

void PlayCtrlGUI_cls::
OnButtonAbort(wxCommandEvent& event){
    GbForceAbort = TRUE;
}

void PlayCtrlGUI_cls::
OnToggleRepeat(wxCommandEvent& event){
    bool newValue = mpCToggleRepeat->GetValue();
    bool oldValue = mpCTimeLink->mCbRepeat.mbBody;
    if (newValue != oldValue) 
	mpCTimeLink->SetRepeatCommand((int)newValue, (int)oldValue);
}

void PlayCtrlGUI_cls::
OnToggleAutoAbort(wxCommandEvent& event){
    GLDrawData_cls::msbUseAbortion = mpCAutoAbort->GetValue();
}

void PlayCtrlGUI_cls::
OnSpinAnimStep(wxSpinEvent& event){
    int newValue = mpCSpinAnimStep->GetValue();
    int oldValue = mpCTimeLink->mCAnimStep.mBody;
    if (newValue != oldValue) 
	mpCTimeLink->SetAnimStepCommand(newValue, oldValue);
}

void PlayCtrlGUI_cls::
OnSpinAnimInterp(wxSpinEvent& event){
    int newValue = mpCSpinAnimInterp->GetValue();
    int oldValue = mpCTimeLink->mCAnimInterp.mBody;
    if (newValue != oldValue) 
	mpCTimeLink->SetAnimInterpCommand(newValue, oldValue);
}

void PlayCtrlGUI_cls::
OnSpinPrefetch(wxSpinEvent& event){
    int expectedMax = mpCTimeLink->GetExpectedPrefetchMax();
    int newValue = mpCSpinPrefetch->GetValue();

    if (newValue > expectedMax * 0.6 && newValue > 3){
	newValue = expectedMax * 0.6;
	mpCSpinPrefetch->SetValue(newValue);
    }

    int oldValue = mpCTimeLink->mPrefetchRange;
    if (newValue != oldValue) 
	mpCTimeLink->SetPrefetchCommand(newValue, oldValue);
}

void PlayCtrlGUI_cls::
OnKeyDown(wxKeyEvent& event){
    event.SetId(GetParent()->GetId());
    GetParent()->GetEventHandler()->AddPendingEvent(event);
}

void PlayCtrlGUI_cls::
UpdateDisplayedValues(){
    mpCSpinAnimStep->SetValue(mpCTimeLink->mCAnimStep.mBody);
    mpCSpinAnimInterp->SetValue(mpCTimeLink->mCAnimInterp.mBody);
    mpCToggleRepeat->SetValue(mpCTimeLink->mCbRepeat.mbBody);
    mpCAutoAbort->SetValue(GLDrawData_cls::msbUseAbortion);
}

void PlayCtrlGUI_cls::
UpdateButtonColor(){
    if (mpCTimeLink->mbPlayTex == TRUE){
	if (mpCTimeLink->mPlayDirection == +1){
	    mpCButtonPlayFWD1->SetBackgroundColour(wxT("LIGHT BLUE"));
	    mpCButtonPlayBCK1->SetBackgroundColour(wxNullColour); 
	}
	else if (mpCTimeLink->mPlayDirection == -1){
	    mpCButtonPlayBCK1->SetBackgroundColour(wxT("LIGHT BLUE"));
	    mpCButtonPlayFWD1->SetBackgroundColour(wxNullColour); 
	}
    }
    else{
	mpCButtonPlayFWD1->SetBackgroundColour(wxNullColour);
	mpCButtonPlayBCK1->SetBackgroundColour(wxNullColour);
    }
}

void PlayCtrlGUI_cls::
RefreshGLPanels(){
    wxCommandEvent com(wxEVT_COMMAND_MENU_SELECTED, menuEditRefreshGL);
    wxGetTopLevelParent(this)->AddPendingEvent(com);

    wxCommandEvent com2(wxEVT_COMMAND_MENU_SELECTED, menuFilterRefresh);
    wxGetTopLevelParent(this)->AddPendingEvent(com2);
}


