// -*- c++ -*-
// "clsPlayCtrlGUI.cpp"

#ifndef _PLAY_CTRL_GUI_H
#define _PLAY_CTRL_GUI_H

#include "../WIDGETCTRL/clsWidgetCommon.h"

#include <wx/spinctrl.h>

class TimeCtrl_cls;
class wxCheckBoxEX;
class wxButtonEX;
class wxBitmapButtonEX;
class wxToggleButton; 

class PlayCtrlGUI_cls : public wxPanel, public WidgetCommon_cls {
 public:
    PlayCtrlGUI_cls(wxWindow *pCParent, TimeCtrl_cls *pCCtrl,
		    wxWindowID id, wxPoint pos, wxSize size);
    //~PlayCtrlGUI_cls();

    TimeCtrl_cls *mpCTimeLink;

    wxCheckBoxEX *mpCCheckBoxPrefetch;
    wxCheckBoxEX *mpCCheckBoxQuickShow;

    wxButtonEX   *mpCButtonSetKeyAnc;
    wxButtonEX   *mpCButtonSetKeyPos;
    wxButtonEX   *mpCButtonSetKeyPosRot;
    
    wxBitmapButtonEX   *mpCButtonStepBCK2;
    wxBitmapButtonEX   *mpCButtonPlayBCK1;
    wxBitmapButtonEX   *mpCButtonStepBCK1;
    wxBitmapButtonEX   *mpCButtonStepFWD1;
    wxBitmapButtonEX   *mpCButtonPlayFWD1;
    wxBitmapButtonEX   *mpCButtonStepFWD2;
    wxBitmapButtonEX   *mpCButtonAbort;

    wxToggleButton     *mpCToggleRepeat;
    wxToggleButton     *mpCAutoAbort;

    wxSpinCtrl   *mpCSpinAnimStep;
    wxSpinCtrl   *mpCSpinAnimInterp;
    wxSpinCtrl   *mpCSpinPrefetch;

    void SetStaticText(wxBoxSizer *pBoxSizerSrc, wxString strTag);
    bool IsAbortClicked(wxPoint mousePos);
    void OnButtonSetKeyPos(wxCommandEvent &event);
    void OnButtonSetKeyPosRot(wxCommandEvent &event);
    void OnButtonSetKeyAnc(wxCommandEvent &event);
    void OnButtonStepBCK2(wxCommandEvent &event);
    void OnButtonPlayBCK1(wxCommandEvent &event);
    void OnButtonStepBCK1(wxCommandEvent &event);
    void OnButtonStepFWD1(wxCommandEvent &event);
    void OnButtonPlayFWD1(wxCommandEvent &event);
    void OnButtonStepFWD2(wxCommandEvent &event);
    void OnButtonAbort   (wxCommandEvent &event);
    void OnToggleRepeat  (wxCommandEvent &event);
    void OnToggleAutoAbort(wxCommandEvent &event);
    void OnSpinAnimStep  (wxSpinEvent &event);
    void OnSpinAnimInterp(wxSpinEvent &event);
    void OnSpinPrefetch  (wxSpinEvent &event);
    void OnKeyDown(wxKeyEvent& event);

    void UpdateDisplayedValues();
    void UpdateButtonColor();
    void RefreshGLPanels();
    

 private:
    // any class wishing to process wxWidgets events must use this macro
    DECLARE_EVENT_TABLE()
};

#endif
