// -*- c++ -*-
// "clsTimeCtrlGUIAA.h"

#include "clsTimeCtrlGUIAA.h"
#include "clsTimeCtrl.h"

#include "../COMMON/CommonDefinitions.h"

#include "../../wxWidgetEnumMenu.h"

BEGIN_EVENT_TABLE(TimeCtrlGUIAA_cls, wxPanel)
EVT_KEY_DOWN    (TLPanelBase_cls::OnKeyDown)
EVT_SIZE        (TimeCtrlGUIAA_cls::OnSize)
EVT_PAINT       (TimeCtrlGUIAA_cls::OnPaint)
EVT_MOUSE_EVENTS(TimeCtrlGUIAA_cls::OnMouse)
END_EVENT_TABLE()

TimeCtrlGUIAA_cls::
TimeCtrlGUIAA_cls(wxWindow *pCParent, TimeCtrl_cls *pCCtrl,
		  wxWindowID id, wxPoint pos, wxSize size):
TLPanelBase_cls(pCParent, pCCtrl, id, pos, size)
{
    mpCTimeSliderIcon = new wxIcon(wxT("ICONS/TimeSliderSmall.png"), wxBITMAP_TYPE_PNG);
    mpCTimeSliderIcon->SetWidth(9);
    mpCTimeSliderIcon->SetHeight(11);
}

TimeCtrlGUIAA_cls::
~TimeCtrlGUIAA_cls(){
    delete mpCTimeSliderIcon;
}

void TimeCtrlGUIAA_cls::
UpdateDisplay(wxAutoBufferedPaintDC &dc){

    dc.SetBackground(wxBrush(wxColour(216,216,216), wxSOLID));
    dc.Clear();

    SetMemberSize(GetClientSize());
    UpdateTLFrame();
    
    wxBrush PlayModeBrush(wxColour(216,216,216), wxSOLID);
    
    dc.SetPen(*wxTRANSPARENT_PEN);
    
    DrawWorkingArea(dc, mMinFrameWA, mMaxFrameWA, 0, mFrameMax);
    DrawWorkingAreaSlider(dc, mAAMin, mAAMax, 0, mFrameMax);
    
    // ̎Ԃ`
    DrawCurrentTime(dc, 0, mFrameMax);

    wxString Mes;
    dc.SetTextForeground(*wxRED);

    // ԗp̃ACR`
    if (mSelected == _TL_SEL_SLIDER)
	dc.DrawIcon(*mpCTimeSliderIcon, mXDraggingFrame-4, 2);
    else
	dc.DrawIcon(*mpCTimeSliderIcon, mXCurrentFrame-4, 2);
    
    // bZ[W`
    int offset = 0;
    if (mMousePosCurrent > mWidth * 0.7) offset = -40;

    if (HasCapture() == TRUE){
	wxString Mes;
	switch(mSelected){
	case _TL_SEL_MIN: Mes << mAAMin; break;
	case _TL_SEL_MAX: Mes << mAAMax; break;
	case _TL_SEL_SLIDER: Mes << mCurrentFrame; break;
	}
	dc.SetFont(*wxNORMAL_FONT);
	dc.SetTextForeground(*wxRED);
	dc.DrawText(Mes, mMousePosCurrent + 15 + offset, 0);
    }
}

void TimeCtrlGUIAA_cls::
ForceUpdateDisplay(){
    wxPaintEvent com;
    OnPaint(com);
}

bool TimeCtrlGUIAA_cls::SetNewIndexDragging(){
    mpCCtrlLink->SetFrameNative(mFrame_Dragged); return TRUE;
}

bool TimeCtrlGUIAA_cls::SetNewMinDragging(){
    mpCCtrlLink->SetAAMinNative(mMin_Dragged); return TRUE;
}

bool TimeCtrlGUIAA_cls::SetNewMaxDragging(){
    mpCCtrlLink->SetAAMaxNative(mMax_Dragged); return TRUE;
}


void TimeCtrlGUIAA_cls::SetNewMinFix(int minAtClick){
    mpCCtrlLink->SetAAMinCommand(mMin_Dragged, minAtClick);
}

void TimeCtrlGUIAA_cls::SetNewMaxFix(int maxAtClick){
    mpCCtrlLink->SetAAMaxCommand(mMax_Dragged, maxAtClick);
}

void TimeCtrlGUIAA_cls::
OnSize(wxSizeEvent& event){
    Refresh(FALSE);
    event.Skip();
}

void TimeCtrlGUIAA_cls::
OnPaint(wxPaintEvent& event){
    wxAutoBufferedPaintDC dc(this);
    UpdateDisplay(dc);
    event.Skip();
}

void TimeCtrlGUIAA_cls::
OnMouse(wxMouseEvent& event){
   
    SetRegion(0, mpCCtrlLink->mCMaxFrame.mBody);
    SetInitValue(event, mpCCtrlLink->mCAAMin.mBody, mpCCtrlLink->mCAAMax.mBody);
    
    ProcMouseEventBase(event);

    event.Skip();
}
