// "clsMemoryPanel.h"

#include "clsTimeCtrlGUITics.h"
#include "clsTimeCtrl.h"

#include "../../wxWidgetEnum.h"

#include "../COMMON/CommonDefinitions.h"

BEGIN_EVENT_TABLE(TimeCtrlGUITics_cls, wxPanel)
EVT_KEY_DOWN    (TLPanelBase_cls::OnKeyDown)
EVT_SIZE        (TimeCtrlGUITics_cls::OnSize)
EVT_PAINT       (TimeCtrlGUITics_cls::OnPaint)
END_EVENT_TABLE()

TimeCtrlGUITics_cls::
TimeCtrlGUITics_cls(wxWindow *pCParent, TimeCtrl_cls *pCCtrl, 
		wxWindowID id, wxPoint pos, wxSize size):
    TLPanelBase_cls(pCParent, pCCtrl, id, pos, size)
{
}

TimeCtrlGUITics_cls::
~TimeCtrlGUITics_cls(){
}

void TimeCtrlGUITics_cls::
UpdateDisplay(wxAutoBufferedPaintDC &dc){
   
    UpdateTLFrame();

    SetMemberSize(GetClientSize());
    SetParameter(GetClientSize(), mAAMin, mAAMax, _TL_BORDER_OFFSET);

    DrawTics(dc);
   
    dc.SetPen(*wxRED_PEN);
    CalcDeviceCoordinate(&mX0, &mX1, mCurrentFrame, mCurrentFrame, mAAMin, mAAMax);
    dc.DrawRectangle(mX0, 0, 1, mHeight);
}

void TimeCtrlGUITics_cls::
ForceUpdateDisplay(){
    wxPaintEvent com;
    OnPaint(com);
}

void TimeCtrlGUITics_cls::
OnSize(wxSizeEvent& event){
    Refresh(FALSE);
    event.Skip();
}

void TimeCtrlGUITics_cls::
OnPaint(wxPaintEvent& event){
    wxAutoBufferedPaintDC dc(this);
    UpdateDisplay(dc);
    event.Skip();
}

