
#include "clsUndoItemConstParam.h"
#include "../CONFITEM/clsConfItem.h"

#include "../COMMON/CommonDefinitions.h"

CommandSetValue_cls::
CommandSetValue_cls(void *pTarget, float value, int updateBit){
    mpTarget = pTarget;
    mType = _COMMAND_BASIC_FLOAT;
    mValueFloat = value;
    mUpdateBit = updateBit;
    mstrUndoTag = wxT("float");
}

CommandSetValue_cls::
CommandSetValue_cls(void *pTarget, double value, int updateBit){
    mpTarget = pTarget;
    mType = _COMMAND_BASIC_DOUBLE;
    mValueDouble = value;
    mUpdateBit = updateBit;
    mstrUndoTag = wxT("double");
}

CommandSetValue_cls::
CommandSetValue_cls(void *pTarget, unsigned int value, int updateBit){
    mpTarget = pTarget;
    mType = _COMMAND_BASIC_UNSIGNED_INT;
    mValueUnsignedInt = value;
    mUpdateBit = updateBit;
    mstrUndoTag = wxT("uint");
}

CommandSetValue_cls::
CommandSetValue_cls(void *pTarget, int value, int updateBit){
    mpTarget = pTarget;
    mType = _COMMAND_BASIC_INT;
    mValueInt = value;
    mUpdateBit = updateBit;
    mstrUndoTag = wxT("value");
}

CommandSetValue_cls::
CommandSetValue_cls(void *pTarget, bool value, int updateBit){
    mpTarget = pTarget;
    mType = _COMMAND_BASIC_BOOL;
    mValueBool = value;
    mUpdateBit = updateBit;
    mstrUndoTag = wxT("value");
}

CommandSetValue_cls::
CommandSetValue_cls(void *pTarget, wxString value, int updateBit){
    mpTarget = pTarget;
    mType = _COMMAND_BASIC_STRING;
    mValueString = value;
    mUpdateBit = updateBit;
    mstrUndoTag = wxT("str");
}

void CommandSetValue_cls::
Execute(bool bFlag){
    switch(mType){
    case _COMMAND_BASIC_FLOAT:
	*(float*)mpTarget = mValueFloat;
	break;
    case _COMMAND_BASIC_DOUBLE:
	*(double*)mpTarget = mValueDouble;
	break;
    case _COMMAND_BASIC_INT:
	*(int*)mpTarget = mValueInt;
	break;
    case _COMMAND_BASIC_UNSIGNED_INT:
	*(unsigned int*)mpTarget = mValueUnsignedInt;
	break;
    case _COMMAND_BASIC_BOOL:
	*(bool*)mpTarget = mValueBool;
	break;
    case _COMMAND_BASIC_STRING:
	*(wxString*)mpTarget = mValueString;
	break;
    }

    UpdateBit();
}

