
#include "clsUndoItemFilterParam.h"
#include "../FILTER/clsFilterCtrl.h"
#include "../PARAMETER/clsParameters.h"

#include "../../wxWidgetEnumMenu.h"
#include "../COMMON/CommonDefinitions.h"

CommandFilterValue_cls::
CommandFilterValue_cls(FilterCtrl_cls *pCTgt, wxString strTag, float value, int updateBit){
    mpCTgt = pCTgt;
    mstrTag = strTag;
    mType = _COMMAND_FILTER_FLOAT;
    mValueFloat = value;
    mUpdateBit = updateBit;
    mstrUndoTag = wxT("FilterFloat");
}

CommandFilterValue_cls::
CommandFilterValue_cls(FilterCtrl_cls *pCTgt, wxString strTag, double value, int updateBit){
    mpCTgt = pCTgt;
    mstrTag = strTag;
    mType = _COMMAND_FILTER_DOUBLE;
    mValueDouble = value;
    mUpdateBit = updateBit;
    mstrUndoTag = wxT("FilterDouble");
}

CommandFilterValue_cls::
CommandFilterValue_cls(FilterCtrl_cls *pCTgt, wxString strTag, unsigned int value, int updateBit){
    mpCTgt = pCTgt;
    mstrTag = strTag;
    mType = _COMMAND_FILTER_UNSIGNED_INT;
    mValueUnsignedInt = value;
    mUpdateBit = updateBit;
    mstrUndoTag = wxT("FilterUINT");
}

CommandFilterValue_cls::
CommandFilterValue_cls(FilterCtrl_cls *pCTgt, wxString strTag, int value, int updateBit){
    mpCTgt = pCTgt;
    mstrTag = strTag;
    mType = _COMMAND_FILTER_INT;
    mValueInt = value;
    mUpdateBit = updateBit;
    mstrUndoTag = wxT("FilterINT");
}

CommandFilterValue_cls::
CommandFilterValue_cls(FilterCtrl_cls *pCTgt, wxString strTag, bool value, int updateBit){
    mpCTgt = pCTgt;
    mstrTag = strTag;
    mType = _COMMAND_FILTER_BOOL;
    mValueBool = value;
    mUpdateBit = updateBit;
    mstrUndoTag = wxT("FilterBOOL");
}

CommandFilterValue_cls::
CommandFilterValue_cls(FilterCtrl_cls *pCTgt, wxString strTag, wxString value, int updateBit){
    mpCTgt = pCTgt;
    mstrTag = strTag;
    mType = _COMMAND_FILTER_STRING;
    mValueString = value;
    mUpdateBit = updateBit;
    mstrUndoTag = wxT("FilterSTR");
}




void CommandFilterValue_cls::
Execute(bool bFlag){
    switch(mType){
    case _COMMAND_FILTER_FLOAT:
	mpCTgt->SetValue(mstrTag, (double)mValueFloat, mValueInt, mValueString);
	break;
    case _COMMAND_FILTER_DOUBLE:
	mpCTgt->SetValue(mstrTag, mValueDouble, mValueInt, mValueString);
	break;
    case _COMMAND_FILTER_INT:
	mpCTgt->SetValue(mstrTag, mValueDouble, mValueInt, mValueString);
	break;
    case _COMMAND_FILTER_UNSIGNED_INT:
	mpCTgt->SetValue(mstrTag, mValueDouble, (int)mValueUnsignedInt, mValueString);
	break;
    case _COMMAND_FILTER_BOOL:
	mpCTgt->SetValue(mstrTag, mValueDouble, mValueBool, mValueString);
	break;
    case _COMMAND_FILTER_STRING:
	mpCTgt->SetValue(mstrTag, mValueDouble, mValueInt, mValueString);
	break;
    }

    UpdateBit();
}

//--------------

CommandFilterParamInit_cls::
CommandFilterParamInit_cls(FilterCtrl_cls *pCTgt, wxString strTagFilter, wxString strTagParam, int dimension, double *pValue, int updateBit){
    mpCTgt = pCTgt;
    mstrTagFilter = strTagFilter;
    mstrTagParam  = strTagParam;
    mDimension    = dimension;

    mpValue = new double [mDimension];
    for (int i = 0; i < mDimension; i++) mpValue[i] = pValue[i];

    mUpdateBit = updateBit | _COMMAND_UPDATE_DISPLAY_FILTER_PARAM;

    mstrUndoTag = wxT("ParamInit");
}

CommandFilterParamInit_cls::
~CommandFilterParamInit_cls(){
    delete [] mpValue;
}

void CommandFilterParamInit_cls::
Execute(bool bFlag){
    Parameters_cls::msbUndoCommandMake = FALSE;
    mpCTgt->SetParamInit(mstrTagFilter, mstrTagParam, mDimension, mpValue);
    
    Parameters_cls::msbUndoCommandMake = TRUE;
    UpdateBit();
}
