
#ifndef _UNDO_COMMAND_TIME_CTRL_H_
#define _UNDO_COMMAND_TIME_CTRL_H_

#include "clsUndoManager.h"

#define _COMMAND_TARGET_FRAME      0
#define _COMMAND_TARGET_INTERPSTEP 1
#define _COMMAND_TARGET_WAMIN      2
#define _COMMAND_TARGET_WAMAX      3
#define _COMMAND_TARGET_AAMIN      4
#define _COMMAND_TARGET_AAMAX      5
#define _COMMAND_TARGET_REPEAT     6
#define _COMMAND_TARGET_ANIMSTEP   7
#define _COMMAND_TARGET_ANIMINTERP 8
#define _COMMAND_TARGET_PREFETCH   9
#define _COMMAND_TARGET_MAXFRAME  10

class TimeCtrl_cls;

#ifdef _DEBUG
#include <stdlib.h>
#include <crtdbg.h>
#define new new(_NORMAL_BLOCK, __FILE__, __LINE__)
#endif

class CommandSetTimeCtrlValue_cls : public CommandItem_cls {
 public:
    CommandSetTimeCtrlValue_cls(TimeCtrl_cls *pCTarget, int target, int value);
    
    TimeCtrl_cls *mpCTarget;
    int mTarget;
    int mValue;
    
    void Execute(bool bFlag = _COMMAND_REDO);
};

class CommandStartAnim_cls : public CommandItem_cls {
 public:
    CommandStartAnim_cls(TimeCtrl_cls *pCTarget, int direction);

    TimeCtrl_cls *mpCTarget;
    int mDirection;

    void Execute(bool bFlag = _COMMAND_REDO);
};

class CommandStopAnim_cls :  public CommandItem_cls {
 public:
    CommandStopAnim_cls(TimeCtrl_cls *pCTarget, int frame);
    
    TimeCtrl_cls *mpCTarget;
    int mFrame;

    void Execute(bool bFlag = _COMMAND_REDO);
};

#endif
