// -*- c -*- 
// "clsFileDialogEX.h"

#include "clsFileDialogEX.h"
#include "../../COMMON/clsFilename.h"

#include "../../COMMON/CommonDefinitions.h"

wxFileDialogEX::
wxFileDialogEX(wxWindow* parent){
    mpCDialog = new wxFileDialog(parent, wxT("FileDialogEX"));
    mbLock = FALSE;
};

wxFileDialogEX::
~wxFileDialogEX(){
    delete mpCDialog;
}

void wxFileDialogEX::
SetMessage(wxString strMes){
    mpCDialog->SetMessage(strMes);
}

void wxFileDialogEX::
SetInitPathFull(wxString strPath){
    if (strPath == wxT("None")) return;
    SplitPath_cls CPath(strPath);
    mpCDialog->SetDirectory(CPath.GetPathStr(_FN_DRIVE_DIR));
    mpCDialog->SetFilename(CPath.GetPathStr(_FN_FNAME_EXT));
}

void wxFileDialogEX::
SetInitPath(wxString strDir, wxString strFileName){
    if (strDir != wxT(""))
	mpCDialog->SetDirectory(strDir);
    if (strFileName != wxT(""))
	mpCDialog->SetFilename(strFileName);
}

void wxFileDialogEX::
SetWildcard(wxString strWildCard){
    mpCDialog->SetWildcard(strWildCard);
}

int wxFileDialogEX::
ShowModal(){
    if (mbLock == TRUE) return FALSE;
    mbLock = TRUE;
    int retVal = mpCDialog->ShowModal();
    mbLock = FALSE;
    //SetWildcard(wxT("*"));
    SetStyle(wxFD_DEFAULT_STYLE);
    return retVal;
}

void wxFileDialogEX::
UnLock(){
    mbLock = FALSE;
}

void wxFileDialogEX::
SetStyle(long style){
    mpCDialog->SetWindowStyle(style);
}

wxString wxFileDialogEX::
GetDirectory(){
    return mpCDialog->GetDirectory();
}

wxString wxFileDialogEX::
GetFileName(){
    return mpCDialog->GetFilename();
}

wxString wxFileDialogEX::
GetPath(){
    return mpCDialog->GetPath();
}

wxFileDialogEX*   GpCFileDialog = NULL;
