// -*- c++ -*-
// "clsGrammerBase.h"
// (setq c-basic-offset 4)

#include "clsListCtrlEX.h"

#include "../WX/myArtProv.h"

BEGIN_EVENT_TABLE(wxListCtrlEX, wxWindow)
EVT_MOUSE_EVENTS(wxListCtrlEX::OnMouse)
EVT_LIST_KEY_DOWN(wxID_ANY, wxListCtrlEX::OnListKeyDown)
END_EVENT_TABLE()

wxListCtrlEX::
wxListCtrlEX(wxWindow* parent, wxWindowID id, 
	     const wxPoint& pos, const wxSize& size, long style):
wxListCtrl(parent, id, pos, size, style)
{
}

void wxListCtrlEX::
AddListItem(wxInt32 nID, std::vector < wxString > VstrItem){
    wxListItem listItem;
    
    if (nID == -1)
	nID = GetNextItem(-1, wxLIST_NEXT_ALL, wxLIST_STATE_SELECTED);
    
    if (nID == -1)// ǉ
	nID = GetItemCount();
    else
	;//nID++; //Î̎

    listItem.SetId(nID);
    listItem.SetMask(wxLIST_MASK_DATA | wxLIST_MASK_STATE);
    listItem.SetData(0L);

    wxString strNum; strNum << GetItemCount();
    listItem.SetText(VstrItem[0]);
    InsertItem(listItem);

    for (unsigned int i = 1; i < VstrItem.size(); i++) 
	SetItem(nID, i, VstrItem[i]);
}

void wxListCtrlEX::
SetListItem(wxInt32 nID, std::vector < wxString > VstrItem){
    for (unsigned int i = 0; i < VstrItem.size(); i++) 
	SetItem(nID, i, VstrItem[i]);
}

void wxListCtrlEX::
OnMouse(wxMouseEvent& event){
    static int cursor = 0;

    wxPoint pos = event.GetPosition();
    int flag = wxLIST_HITTEST_ONITEM;

    if (event.LeftDown() == TRUE) mDragStart = HitTest(pos, flag);
    if (event.LeftUp() == TRUE){
	mDragEnd   = HitTest(pos, flag);
	if (mDragEnd == -1)
	    mDragEnd = GetItemCount() - 1;
    }
    
    if (event.Dragging() == TRUE){
	if (event.LeftIsDown() == TRUE && cursor == 0){
	    SetCursor(wxCursor(ARTWX("wxART_DRAG_ITEM").ConvertToImage()));
	    cursor = 1;
	}

	int item = HitTest(pos, flag);
	for (int i = 0; i < GetItemCount(); i++) {
	    wxColor CBG = wxColor(255, 255, 255);
	    if (i == item) CBG = wxColor(255, 255, 216);
	    if (GetItemBackgroundColour(i) != CBG)
		SetItemBackgroundColour(i, CBG);
	}
    }

    if ((event.LeftUp() || event.LeftIsDown() == FALSE) && cursor == 1){
	SetCursor(wxNullCursor);
#ifdef WIN32
	WarpPointer(pos.x, pos.y);
#endif
	cursor = 0;
    }

    if (event.LeftUp() == TRUE || event.Leaving() == TRUE){
	for (int i = 0; i < GetItemCount(); i++) 
	    if (GetItemBackgroundColour(i) != wxColor(255, 255, 255))
		SetItemBackgroundColour(i, wxColor(255, 255, 255));
    }

    if (event.RightDown() == TRUE || event.LeftUp() == TRUE){
	event.SetId(GetId());
	GetParent()->GetEventHandler()->AddPendingEvent(event);
	return;
    }

    event.Skip(); //ʏ폈
}

void wxListCtrlEX::
OnListKeyDown(wxListEvent& event){
    GetParent()->GetEventHandler()->AddPendingEvent(event);
}
