// (setq c-basic-offset 4)
// "clsAtoiTextCtrl.h"

#include "clsTextCtrlEX.h"

TextCtrlEX_cls::
TextCtrlEX_cls(wxWindow *parent, wxWindowID id, wxString initStr,
	       wxPoint pos, wxSize size, long style, 
	       const wxValidator& validator) 
    : wxTextCtrl(parent, id, initStr,
		 pos, size, style)//, validator)
{
    mbAssignByTab = TRUE;
    mbReturnForTab = TRUE;
    mbHookWXK_SPACE = TRUE;
    mbPostOnTab = FALSE;

    SetWindowStyle(GetWindowStyle() | wxWANTS_CHARS);
    
    Connect(id, wxEVT_SET_FOCUS,
	    wxCommandEventHandler(TextCtrlEX_cls::OnFocus));
    Connect(id, wxEVT_KILL_FOCUS,
	    wxCommandEventHandler(TextCtrlEX_cls::OnKillFocus));
    Connect(id, wxEVT_KEY_DOWN,
	    wxKeyEventHandler(TextCtrlEX_cls::OnKeyDown));
    Connect(id, wxEVT_CHAR,
	    wxKeyEventHandler(TextCtrlEX_cls::OnChar));
}

void TextCtrlEX_cls::
EnableHookSpace(bool flag){
    mbHookWXK_SPACE = flag;
}

void TextCtrlEX_cls::
OnKillFocus(wxCommandEvent& event){
    UpdateValueFromText();
    event.Skip();
}

void TextCtrlEX_cls::
OnFocus(wxCommandEvent& event){
    SetSelection(-1, -1);
    event.Skip();
}

void TextCtrlEX_cls::
OnChar(wxKeyEvent& event){
    // $B>e$N(Bwindow$B$G%?%V0\F0$5$l$J$1$l$P$3$3$K%$%Y%s%H$,Mh$k$N$G<+A0$G(B
    if (event.GetKeyCode() == WXK_TAB){	
	if (mbAssignByTab == TRUE) UpdateValueFromText(TRUE);
	if (OnCharTab(event) == FALSE){
	    if ((GetWindowStyle() & wxTE_PROCESS_TAB) == FALSE){
		if ((event.GetModifiers() & wxMOD_SHIFT) ||
		    (event.GetModifiers() & wxMOD_CONTROL))
		    Navigate(wxNavigationKeyEvent::IsBackward);
		else
		    Navigate(wxNavigationKeyEvent::IsForward);
	    }
	    else
		WriteText(wxT("\t"));
	}
	return;
    }

    if (mbHookWXK_SPACE == TRUE && event.GetKeyCode() == WXK_SPACE){
	UpdateValueFromText();
	SetSelection(-1, -1);
	GetParent()->AddPendingEvent(event);
	return;
    }

    if (event.GetKeyCode() == WXK_RETURN){
#ifdef __WXMAC__
	UpdateValueFromText(TRUE);
#endif
	GetParent()->AddPendingEvent(event);
	if (mbReturnForTab == TRUE){
	    Navigate(wxNavigationKeyEvent::IsForward);
	    if (mbPostOnTab == TRUE){
		wxCommandEvent com(mEventType, mEventID);
		mpEventTarget->AddPendingEvent(com);
	    }
	}
	return;
    }

    event.Skip();
}

//#include "../../MYAPI/MsgBox.h"
//#include "../../../wxWidgetEnum.h"

void TextCtrlEX_cls::
OnKeyDown(wxKeyEvent& event){
    if (event.GetModifiers() == wxMOD_NONE || event.GetKeyCode() == WXK_TAB)
	event.Skip();
    if (event.GetKeyCode() != WXK_TAB && event.GetKeyCode() != '.')
	if (event.GetKeyCode() <= '0' && event.GetKeyCode() >= '9') 
	    wxPostEvent(GetParent()->GetEventHandler(), event);
    if (event.GetKeyCode() == WXK_TAB && mbPostOnTab == TRUE){
	wxCommandEvent com(mEventType, mEventID);
	mpEventTarget->AddPendingEvent(com);
	return;
    }
    
    event.Skip();
}

void TextCtrlEX_cls::
SetEventOnTab(wxWindow *pTarget, WXTYPE type, int id){
    mpEventTarget = pTarget;
    mbPostOnTab = TRUE;
    mEventType = type;
    mEventID = id;
}
