// -*- c -*- 
// "clsTextEntryDialogEX.cpp"

#include "clsTextEntryDialogEX.h"

#include "../../COMMON/CommonDefinitions.h"

#include <wx/statline.h>

BEGIN_EVENT_TABLE(TextEntryDialogEX_cls, wxDialog)
EVT_CLOSE (TextEntryDialogEX_cls::OnClose)
END_EVENT_TABLE()

TextEntryDialogEX_cls::
TextEntryDialogEX_cls(wxWindow *pCParent, wxString strMessage, wxString strTitle, wxString strInit) : 
    wxDialog(pCParent, wxID_ANY, strTitle, wxDP, wxSize(480, 360), wxDEFAULT_DIALOG_STYLE | wxRESIZE_BORDER){

    wxBoxSizer *pBoxSizerSrc = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer *pBoxSizerTop = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer *pBoxSizerButtons = new wxBoxSizer(wxHORIZONTAL);
    
    wxStaticText *pCMessage = new wxStaticText(this, wxID_ANY, strMessage);
    mpCTextCtrl = new wxTextCtrl(this, wxID_ANY, strInit, wxDPS, wxTE_MULTILINE | wxTE_PROCESS_TAB | wxWANTS_CHARS);
    wxStaticLine *pCLine = new wxStaticLine(this, wxID_ANY);

    wxButton *pCButtonOK = new wxButton(this, wxID_OK, wxT("OK"));
    wxButton *pCButtonCancel = new wxButton(this, wxID_CANCEL, wxT("Cancel"));

    int lineNum = strInit.Freq(wxT('\n'));
    if (lineNum > 6) SetSize(wxSize(480, 420));
    
    pBoxSizerTop->Add(-1,16);
    pBoxSizerTop->Add(pCMessage, 0, wxEXPAND);
    pBoxSizerTop->Add(-1,16);
    pBoxSizerTop->Add(mpCTextCtrl, 1, wxEXPAND);
    pBoxSizerTop->Add(-1,8);
    pBoxSizerTop->Add(pCLine, 0, wxEXPAND);
    pBoxSizerTop->Add(-1,8);
    
    pBoxSizerButtons->Add(-1, -1, wxEXPAND);
    pBoxSizerButtons->Add(pCButtonOK, 0);
    pBoxSizerButtons->Add(pCButtonCancel, 0); 

    pBoxSizerTop->Add(pBoxSizerButtons, 0, wxEXPAND);
    pBoxSizerTop->Add(-1,16);
        
    pBoxSizerSrc->Add(16, -1);
    pBoxSizerSrc->Add(pBoxSizerTop, 1, wxEXPAND);
    pBoxSizerSrc->Add(16, -1);

    SetSizer(pBoxSizerSrc);
}

wxString TextEntryDialogEX_cls::
GetValue(){
    if (mpCTextCtrl == NULL) return wxES;
    if (mstrEntry.IsEmpty() == FALSE) return mstrEntry;
    return mpCTextCtrl->GetValue();
}

void TextEntryDialogEX_cls::
OnClose(wxCloseEvent& event){
    // ~ŕƂɃf[^ێ邽
    // OKCANCELƂɂȂi2.8ƁHj
    mstrEntry = mpCTextCtrl->GetValue();
    mpCTextCtrl = NULL;
    event.Skip();
}
