// -*- c++ -*- 
// (setq c-basic-offset 4)
// "clsUpdateStatusBar.h"

#include "clsUpdateStatusBar.h"

#include "../../COMMON/CommonDefinitions.h"

#include "../../../clsFrameMain.h"
#include "../../../wxWidgetEnumMenu.h"

extern wxFrame  *GpCMainFrameCLS;
bool      GbForceAbort = FALSE;
int       GbAbortCounter = 0;

void UpdateStatusBar_cls::
BeginProgress(){
    msCStopWatch.Start(0);
    msDispatchTime = 0;
}

bool UpdateStatusBar_cls::
IsTimeLapsedEnough(){
    int time = msCStopWatch.Time();
    if (time > msDispatchTime + 200) 
	return TRUE;
    return FALSE;
}

void UpdateStatusBar_cls::
ClearAbort(){
    GbForceAbort = FALSE;
    GbAbortCounter = 0;
}

bool UpdateStatusBar_cls::
CheckAbortion(){
    if (GbForceAbort == TRUE){
	if (GbAbortCounter == 0){
	    msstrWarning << wxT("Forced Abort. ");
	    GbAbortCounter++;
	}
	return TRUE;
    }
    if (msbUseAbortion == TRUE && msCStopWatch.Time() > msAbortLimitMS){
	msstrWarning << wxT("Auto Aborted. ");
	GbForceAbort = TRUE;
	GbAbortCounter++;
	return TRUE;
    }
    return FALSE;
}

int UpdateStatusBar_cls::
GetProgressInterval(int num){
    mTotalIndex = num;
    int progressInterval = 100000;
    if (num > 2000000) progressInterval = num / 20;
    return progressInterval;
}

int UpdateStatusBar_cls::
CalcPercentage(int index){
    float ratio = (float)index / mTotalIndex;
    float percentage = (msFinFactor - msIniFactor) * ratio + msIniFactor;
    return (int) (percentage * 100);
}

void UpdateStatusBar_cls::
UpdateStatusBar(){
    static int sLock = 0;
    if (sLock != 0) return;

    ((FrameMain_cls*)GpCMainFrameCLS)->UpdateStatusText();
    msDispatchTime = msCStopWatch.Time();

    ((FrameMain_cls*)GpCMainFrameCLS)->CheckAbortion();

    //wxCommandEvent com(wxEVT_COMMAND_MENU_SELECTED, menuEditRefreshSB);
    //GpCMainFrameCLS->AddPendingEvent(com);

    /*
      if (sbAllowDispach == TRUE){
      if (wxTheApp->Pending()) wxTheApp->Dispatch();
      wxTheApp->Yield();
      }
    */

    sLock = 0;
}

void UpdateStatusBar_cls::
SetFactor(int index, int totalIndex){
    msIniFactor = (float)index / totalIndex;
    msFinFactor = ((float)index+1)/totalIndex;
}

//bool UpdateStatusBar_cls::sbAllowDispach = TRUE;

wxStopWatch UpdateStatusBar_cls::msCStopWatch;
int UpdateStatusBar_cls::msDispatchTime = 0;

float  UpdateStatusBar_cls::msIniFactor = 0;
float  UpdateStatusBar_cls::msFinFactor = 0;

int    UpdateStatusBar_cls::msAbortLimitMS = 1000;
bool   UpdateStatusBar_cls::msbUseAbortion = FALSE;
wxString UpdateStatusBar_cls::msstrWarning;
