// -*- c++ -*- 
// (setq c-basic-offset 4)
// "clsArtProv.cpp"

#ifndef _MY_ART_PROV_H_
#define _MY_ART_PROV_H_

#include <wx/artprov.h>
#include <wx/wx.h>

#include <vector>

#define ARTWX(a) wxArtProvider::GetBitmap(wxT(a))
#define ARTWXSIZE(a,b) wxArtProvider::GetBitmap(wxT(a), wxART_OTHER, b)
#define ARTWXFRAMEICON(a) wxArtProvider::GetBitmap(wxT(a), wxART_FRAME_ICON)
#define ART(a) wxArtProvider::GetBitmap(a)
#define ARTSIZE(a,b) wxArtProvider::GetBitmap(a, wxART_OTHER, b)

class MyArtProvider : public wxArtProvider {
public:
    MyArtProvider();

    void SetFrameIconSize();

protected:
    friend class wxArtProvider;

    std::vector < wxString > mVstrBtnIDList;
    std::vector < wxString > mVstrBtnImgList;
    std::vector < wxPoint > mVPoint;
    std::vector < wxSize > mVSize;

    void SetListItem(wxString strID, wxString strFile, 
		     wxPoint pos = wxDefaultPosition,
		     wxSize size = wxDefaultSize);

    wxBitmap CreateBitmap(const wxArtID& id,
			  const wxArtClient& client,
			  const wxSize& size);
    
    int mFrameIconSize;

    static int floor (float value);
    static float GetAverageRed
    (wxImage &CImage, float fX0, float fY0, float fX1, float fY1);
    static float GetAverageGreen
    (wxImage &CImage, float fX0, float fY0, float fX1, float fY1);
    static float GetAverageBlue
    (wxImage &CImage, float fX0, float fY0, float fX1, float fY1);
    static float GetAverageAlpha
    (wxImage &CImage, float fX0, float fY0, float fX1, float fY1);
    static void ConvertMaskToAlpha(wxImage& CImg);
    static wxImage GetSmallImageLinear(wxImage &CImage, wxSize sizeNew);
};

#endif
