// -*- c -*- 
// (setq c-basic-offset 4)
// "clsAtoiTextCtrl.h"

#include "clsAtoiTextCtrl.h"

AtoiTextCtrl_cls::
AtoiTextCtrl_cls(wxWindow *parent, wxWindowID id, int initvalue,
		 wxPoint pos, wxSize size) 
    : TextCtrlEX_cls(parent, id, 
		     wxString::Format(wxT("%d"), initvalue),
		     pos, size)
{
    mMin = -1;
    mMax = -1;
}

int AtoiTextCtrl_cls::
GetValue(){
    return wxAtoi(GetLineText(0));
}

void AtoiTextCtrl_cls::
UpdateValueFromText(bool assign){
    int value = wxAtoi(GetLineText(0));
    if (!(mMin == -1 && mMax == -1)){
	if (value < mMin) value = mMin;
	if (value > mMax) value = mMax;
	SetValueInt(value);
    }
    
    if (assign == TRUE){
	wxKeyEvent com(wxEVT_CHAR);
	com.m_keyCode = WXK_RETURN;
	com.SetId(GetId());
	GetParent()->AddPendingEvent(com);
    }
}

void AtoiTextCtrl_cls::
SetValueInt(int value){
    SetValue(wxString::Format(wxT("%d"), value));
}

void AtoiTextCtrl_cls::
SetRange(int min, int max){
    mMin = min; mMax = max;
}
