// -*- c -*- 
// "clsBitmapPanel.cpp"

#ifndef _BITMAP_PANEL_H_
#define _BITMAP_PANEL_H_

#include "clsWidgetCommon.h"
#include "EX/clsWidgetEX.h"

#include <vector>

#define _BMPANEL_DELETE_AT_DESTORY true

class BitmapPanel_cls : public wxPanel, public WidgetEX_cls, public WidgetCommon_cls {
 public:
    BitmapPanel_cls(wxWindow *parent, wxWindowID id, 
		    wxPoint pos = wxDefaultPosition,
		    wxSize size = wxDefaultSize);
    ~BitmapPanel_cls();

    int  mBoarderX, mBoarderY;
    void SetBoarder(int boarderX, int boarderY);    
    void SetAspect(int orient, float aspect);

    void UpdateDisplayUseP(wxPaintDC& dc);
    void UpdateDisplay(wxPaintDC& dc);
    void OnPaint(wxPaintEvent& event);
    void OnMouse(wxMouseEvent& event);

    bool mbDeleteAtDestroyDisable;
    bool mbButton;
    bool mbBorder;
    bool mbPushed;
    unsigned int mState;
    wxWindow *mpCMouseEventTarget;

    void SetMouseEventTarget(wxWindow *pCTgt);
    void AddBitmapP(wxBitmap* pBitmap, bool bDeleteAtDestroy = FALSE);
    void SetBitmapPDisable(wxBitmap* pBitmap, bool bDeleteAtDestroy = FALSE);
    std::vector < wxBitmap* > mVPBitmap;
    std::vector < bool > mVbDeleteAtDestroy;
    
    void AddBitmapStr(wxString strBitmap);
    void SetBitmapStrDisable(wxString strBitmap);
    std::vector < wxString > mVstrBitmap;

    wxBitmap *mpBitmapDisable;
    wxString mstrBitmapDisable;

    wxWindow* GetPWindow();

    void SetStatus(unsigned int status);
    void OnKeyDown(wxKeyEvent& event);
    
    // any class wishing to process wxWidgets events must use this macro
    DECLARE_EVENT_TABLE()
};

#endif
