// -*- c -*- 
// "clsDialogEX.h"

#include "clsDialogEXKey.h"
#include "clsMultiInputPanel.h"

//#include "../WIDGETCTRL/WX/myArtProv.h"
#include "../WIDGETCTRL/WX/clsFontProvider.h"

#include "../../wxWidgetEnumMenu.h"

BEGIN_EVENT_TABLE(wxDialogEXKey, wxDialog)
EVT_CLOSE(wxDialogEXKey::OnClose)
END_EVENT_TABLE()

wxDialogEXKey::
wxDialogEXKey(wxWindow* parent, wxWindowID id, const wxString& label,
	      const wxPoint& pos, const wxSize& size,
	      wxBitmap bitmap,
	      long style, const wxString& name) :
wxDialog(parent, id, label, pos, size, style | wxFRAME_FLOAT_ON_PARENT, name),
    mIDCloseButton(wxID_CANCEL), mbPreventDestroy(TRUE)
{
    SetBackgroundColour(wxColour(wxT("WHEAT")));
    SetFont(FontProvider_cls::GetFont(0));
    Connect(id, wxEVT_KEY_DOWN,
	    wxKeyEventHandler(wxDialogEXKey::OnKeyDown));
    if (bitmap.IsOk() == TRUE){
	wxIcon icon; icon.CopyFromBitmap(bitmap);
	SetIcon(icon);
    }
    mpCPos = NULL;
}

wxDialogEXKey::
~wxDialogEXKey(){
    MakeModal(FALSE);
}

void wxDialogEXKey::
SetPCPosInfoAtClose(wxPoint *pCPos){
    mpCPos = pCPos;
}

void wxDialogEXKey::
SetCloseButtonID(int IDCloseButton){
    mIDCloseButton = IDCloseButton;
}

wxBoxSizer *wxDialogEXKey::
GetPSizerStaticTextVCenter(wxWindow *pCParent, wxString strTag){
    wxBoxSizer *pBoxSizer = new wxBoxSizer(wxVERTICAL);
    wxStaticText *pCStaticText = new wxStaticText(pCParent, wxID_ANY, strTag);
    pBoxSizer->Add( -1, -1, 1, wxEXPAND);
    pBoxSizer->Add( pCStaticText, 0, wxEXPAND);
    pBoxSizer->Add( -1, -1, 1, wxEXPAND);
    return pBoxSizer;
}

#include "../MYAPI/MsgBox.h"

void wxDialogEXKey::
CloseEXKey(int retCode){
    if (mpCPos != NULL) *mpCPos = GetScreenPosition();

    if (IsModal() == TRUE)
	EndModal(retCode);
    else{
	if (mbPreventDestroy == TRUE)
	    Show(FALSE); 
	else
	    Destroy();
    }
}

void wxDialogEXKey::
OnKeyDown(wxKeyEvent& event){
    int code = event.GetKeyCode();
    
    switch(code){
    case 'W':
	if (event.GetModifiers() != wxMOD_CONTROL || 
	    mIDCloseButton == wxID_NONE)
	    break;
    case WXK_ESCAPE:
	wxCommandEvent event(wxEVT_COMMAND_BUTTON_CLICKED, wxID_CANCEL);
	GetEventHandler()->AddPendingEvent(event);
	break;
    }
    
    event.Skip();
}

void wxDialogEXKey::
OnClose(wxCloseEvent& event){
    if (mpCPos != NULL) *mpCPos = GetScreenPosition();
    event.Skip();
}

void wxDialogEXKey::
ResizeDialog(){
    GetSizer()->Layout();
    SetSizerAndFit(GetSizer());
    Refresh(TRUE);
}
