// -*- c -*- 
// "clsDualSlider.cpp"

#ifndef _DUALSLIDER_PANEL_H_
#define _DUALSLIDER_PANEL_H_

#include <wx/wx.h>

class InputItem_cls;

class DualSlider_cls : public wxPanel{
 public:
    DualSlider_cls(wxWindow *parent, InputItem_cls *pCParentInputItem,
		   wxWindowID id, 
		   int initvalue0, int initvalue1,
		   int min, int max,
		   wxPoint pos = wxDefaultPosition,
		   wxSize size = wxDefaultSize);

    void SetMemberSize(wxSize size);
    void SetValueDouble(double value0, double value1);
    void UpdateValueFromSlider();
    void SetRangeSliderWrapperDouble(int min, int max, int scale);
    double GetValue(int index);
    int GetValueFromPos(int posX);
    int GetSliderPosition(int index);
    int GetSliderPositionFromValue(float value);
    void UpdateDisplay();
    void OnPaint(wxPaintEvent& event);

    void CalcSelected(wxMouseEvent& event);
    void OnMouse(wxMouseEvent& event);

    InputItem_cls *mpCParentInputItem;

    int mWidth, mHeight;
    int mDisplayMode;
    int mItemNum;

    int mSelected;
    int mDraggingPos;
    bool mbCaptureMouse;
    unsigned int mState;
    
    int mValue[2];
    int mMin;
    int mMax;
    int mScale;
    
    wxWindow* GetPWindow();
    void CreateKeyDLG(int xpos, int ypos);
    void OnKeyDown(wxKeyEvent& event);

    // any class wishing to process wxWidgets events must use this macro
    DECLARE_EVENT_TABLE()
};

#endif
