// -*- c -*- 
// "clsGraphPanel.cpp"

#ifndef _GRAPH_PANEL_H_
#define _GRAPH_PANEL_H_

#include "clsWidgetCommon.h"

#include <wx/dcbuffer.h>
#include <vector>

#define _GRAPH_MONOCHROME 0
#define _GRAPH_RGBA       1

class ParamGroup_cls;

class GraphPanel_cls : public wxPanel, public WidgetCommon_cls {
 public:
    GraphPanel_cls(wxWindow *parent, wxWindowID id, 
		   wxPoint pos = wxDefaultPosition,
		   wxSize size = wxDefaultSize,
		   bool bColor = TRUE);
    ~GraphPanel_cls();

    ParamGroup_cls* mpCParamGroupLinked;
    bool mbInitialized;
    bool mbSelectGuide;
    bool mbSelectRegion;
    int mPanelWidth, mPanelHeight;
    wxMenu *mpCPopupMenu;

    std::vector < double > mVTicsX;
    std::vector < double > mVTicsY;

    void SetParamGroup(ParamGroup_cls *pCParamGroup);
    void ShowMenu();

    int  GetCoordX(double valueX);
    int  GetCoordY(double valueY);
    double GetDoubleX(int coordx);
    double GetDoubleY(int coordy);
    void GetSnippedDelta(int &dx, int &dy);
    void GetCurrentColor(float clr[3]);
    void SetGuide(double doubleIndex);
    void SetXViewRange(double minX, double maxX);
    void SetYViewRange(double minY, double maxY);
    void SetPenColor(wxAutoBufferedPaintDC &dc, int i);
    void SetBrushColor(wxAutoBufferedPaintDC &dc, int i);
    void DrawGraphOfParamGroup(wxAutoBufferedPaintDC &dc);
    void DrawTicsBox(wxAutoBufferedPaintDC& dc);
    void DrawSelectionBox(wxAutoBufferedPaintDC& dc);
    void SelectionCheck(bool bAdditive);
    void OnPaint(wxPaintEvent &event);
    void OnMouse(wxMouseEvent &event);

    int    mColorType;
    double mViewMinY, mViewMaxY;
    double mValueMinY, mValueMaxY;

    double mViewMinX, mViewMaxX;
    double mValueMinX, mValueMaxX;

    int    mGuideX;
    int    mCoordX, mCoordY;
    int    mCoordXAtClick, mCoordYAtClick;
    double mValueX, mValueY;
    double mValueXAtClick, mValueYAtClick;

    static wxColour msColorRGBA[4];

    void InsertKey();
    void DeleteKey();
    void SetKeyColor();
    void OnInsertKey(wxCommandEvent& event);
    void OnDeleteKey(wxCommandEvent& event);
    void OnColor(wxCommandEvent& event);
    void SetMode(int mode);
    void OnKeyDown(wxKeyEvent& event);
        
    // any class wishing to process wxWidgets events must use this macro
    DECLARE_EVENT_TABLE()
};

#endif
