// -*- c++ -*-
// "clsWidgetsCommon.cpp"

#include "clsWidgetCommon.h"

void WidgetCommon_cls::
SendEvent(wxWindow *pC, int type, int ID){
    wxCommandEvent com(type, ID);
    pC->GetEventHandler()->AddPendingEvent(com);
}

void WidgetCommon_cls::
SendEventToTop(wxWindow *pC, int type, int ID){
    wxCommandEvent com(type, ID);
    wxGetTopLevelParent(pC)->GetEventHandler()->AddPendingEvent(com);
}

void WidgetCommon_cls::
SendMenuEventToTop(wxWindow *pC, int ID){
    wxCommandEvent com(wxEVT_COMMAND_MENU_SELECTED, ID);
    wxGetTopLevelParent(pC)->GetEventHandler()->AddPendingEvent(com);
}

void WidgetCommon_cls::
SendEventToTopParent(wxWindow *pC, int type, int ID){
    wxCommandEvent com(type, ID);
    wxGetTopLevelParent(pC)->GetParent()->
	GetEventHandler()->AddPendingEvent(com);
}

void WidgetCommon_cls::
SendKeyEventToTop(wxWindow *pC, wxKeyEvent& event){
    event.SetId(wxGetTopLevelParent(pC)->GetId());
    wxGetTopLevelParent(pC)->GetEventHandler()->AddPendingEvent(event);
}

void WidgetCommon_cls::
SendMenuEvent(wxWindow *pC, int ID){
    wxCommandEvent com(wxEVT_COMMAND_MENU_SELECTED, ID);
    pC->GetEventHandler()->AddPendingEvent(com);
}

void WidgetCommon_cls::
SendButtonEvent(wxWindow *pC, int ID){
    wxCommandEvent com(wxEVT_COMMAND_BUTTON_CLICKED, ID);
    pC->GetEventHandler()->AddPendingEvent(com);
}

void WidgetCommon_cls::
SendMouseEvent(wxWindow *pC, wxMouseEvent& com){
    pC->GetEventHandler()->AddPendingEvent(com);
}

void WidgetCommon_cls::
SendMouseEvent(wxWindow *pC, int type, int ID){
    wxMouseEvent com(type);
    com.SetId(ID);
    pC->GetEventHandler()->AddPendingEvent(com);
}

void WidgetCommon_cls::
ConnectButton(wxWindow *pCThis, wxWindow *pC, wxObjectEventFunction func){
    pCThis->Connect(pC->GetId(), wxEVT_COMMAND_BUTTON_CLICKED, func);
}
