// (setq c-basic-offset 4)
// "clsFrameMain.h"
// "wxWidgetEnum.h"

#include "clsFrameMain.h"
#include "clsAboutBox.h"

#include "clsMain.h"

#include "SRC/MYAPI/MsgBox.h"

#include "SRC/COMMON/clsFilename.h"
#include "SRC/FILTER/clsFilterCtrl.h"
#include "SRC/FILTER/clsFilterBase.h"
#include "SRC/GLATTRIB/clsColorCurveGUI.h"
#include "SRC/GLATTRIB/clsGLAttributeGUI.h"
#include "SRC/GLCANVAS/clsGLCanvasCtrl.h"
#include "SRC/GLCANVAS/clsMainGLCanvas.h"
extern MainGLCanvas_cls* GpCurrentGLPanel;
extern bool GbGLLockDrawing;
#include "SRC/GLCANVAS/clsMoveItem.h"
#include "SRC/GLCANVAS/clsStereoGram.h"
#include "SRC/GRAPHIC/clsImgSequence.h"
#include "SRC/MAINCANVAS/clsDrawOption.h"
#include "SRC/MAINCANVAS/clsDrawOptionGUI.h"
#include "SRC/MAINCANVAS/clsExposure.h"
#include "SRC/MAINCANVAS/clsExposureGUI.h"
#include "SRC/MAINCANVAS/clsFilterPanelPain.h"
#include "SRC/MAINCANVAS/clsGLExtraFrame.h"
#include "SRC/MAINCANVAS/clsOverlay.h"
#include "SRC/MAINCANVAS/clsOverlayGUI.h"
#include "SRC/MAINCANVAS/clsTopHalfPanel.h"
#include "SRC/MAINCANVAS/clsBtmHalfPanel.h"
#include "SRC/MAINCANVAS/clsParamGUICtrl.h"
#include "SRC/MISC/clsHelpLauncher.h"
#include "SRC/MISC/clsIpAddress.h"
#include "SRC/MISC/clsMacAddress.h"
#include "SRC/MYGL/clsGLInfo.h"
#include "SRC/PANELS/clsDataLoader.h"
#include "SRC/PANELS/clsDataExporter.h"
#include "SRC/PANELS/clsPreference.h"
#include "SRC/PANELS/clsScene.h"
#include "SRC/PANELS/clsShortcut.h"
#include "SRC/PARTICLEDATA/clsParticleDataSeqCtrl.h"
#include "SRC/PARTICLEDATA/clsParticleDataSequence.h"
#include "SRC/PARTICLEDATA/clsPeriodicBoundary.h"
#include "SRC/PARTICLEDATA/clsShadowVolume.h"
#include "SRC/PARTICLEDATA/clsThreadFileReader.h"
extern ThreadFileReader_cls *GApCThreadReader[_MAX_THREAD_READ];
extern bool                  GAbThreadReaderFinished[_MAX_THREAD_READ];
extern int                   GAThreadReaderPercentage[_MAX_THREAD_READ];
extern int                   GAThreadReaderIndex[_MAX_THREAD_READ];
#include "SRC/POVRAY/clsPovRay.h"

#include "SRC/SCENEOBJ/clsCameraPathGUI.h"
#include "SRC/SCENEOBJ/clsLightSourceGUI.h"
#include "SRC/SCENEOBJ/clsTexPropertyGUI.h"
#include "SRC/TIMELINE/clsTimeCtrl.h"
#include "SRC/TIMELINE/clsPlayCtrlGUI.h"
#include "SRC/UNDO/clsUndoManager.h"
extern UndoManager_cls GCUndoList;
#include "SRC/UNDO/clsUndoItemFilterMake.h"
#include "SRC/UNDO/clsUndoItemFilterParam.h"
#include "SRC/WIDGETCTRL/EX/clsFileDialogEX.h"
#include "SRC/WIDGETCTRL/EX/clsColourDialogEX.h"
#include "SRC/WIDGETCTRL/WX/clsUpdateStatusBar.h"
#include "SRC/WIDGETCTRL/WX/clsFontProvider.h"
#include "SRC/WIDGETCTRL/WX/myArtProv.h"

extern wxColourDialogEX *GpCClrDialog;
extern wxFileDialogEX   *GpCFileDialog;

extern bool                  GbGLLockForLoadingData;
extern bool                  GbGLLockPlayWait;
extern bool                  GbGLLockModalDialog;
extern int                   GDrawingPercentage;
extern int                   GDrawingStage;

#include <fstream>
#include <sstream>
#include <wx/cursor.h>
#include <wx/choicdlg.h>
#include <wx/file.h>
#include <wx/filename.h>
#include <wx/gauge.h>
#include <wx/datetime.h>
#include <wx/numdlg.h>
#include <wx/stopwatch.h>
#include <wx/tglbtn.h>
#include <wx/thread.h>
#include <wx/tooltip.h>
#include <wx/vscroll.h>

#include "SRC/COMMON/CommonDefinitions.h"

#include "wxWidgetEnum.h"
#include "wxWidgetEnumMenu.h"
#include "wxWidgetString.h"

wxFrame  *GpCMainFrameCLS;
int       GShortcutKeycode;
int       GShortcutModifier;
extern bool GbForceAbort;
bool      GbQuitApplication = FALSE;

#ifdef WIN32
#define _WXDELIM_ wxT("\\")
#else
#define _WXDELIM_ wxT("/")
#endif

#ifdef WIN32
#define WCHARCONV(x) (wxString)wxConvLibc.cMB2WC(x)
#else
#define WCHARCONV(x) (wxString)wxConvUTF8.cMB2WC(x)
#endif

#ifdef WIN32
#define _WSIZE_OFFSET_X 0
#define _WSIZE_OFFSET_Y 0
#else
#define _WSIZE_OFFSET_X 10
#define _WSIZE_OFFSET_Y 24
#endif

#define TIMER_ID 0

// ÓIɃCxgт
BEGIN_EVENT_TABLE(FrameMain_cls, wxFrame)
//EVT_PAINT(FrameMain_cls::OnPaint)
EVT_CLOSE(FrameMain_cls::OnClose)
EVT_SIZE(FrameMain_cls::OnSize)
EVT_MENU(Minimal_Quit,           FrameMain_cls::OnQuit)
EVT_MENU(Minimal_About,          FrameMain_cls::OnAbout)
EVT_MENU(menuHelp,               FrameMain_cls::OnHelp)
EVT_MENU(menuEditUndo,           FrameMain_cls::OnMenuUndo)
EVT_MENU(menuEditRedo,           FrameMain_cls::OnMenuRedo)
EVT_MENU(menuEditScene,          FrameMain_cls::OnMenuScene)
EVT_MENU(menuEditPreference,     FrameMain_cls::OnMenuPreference)
EVT_MENU(menuEditShortcut,       FrameMain_cls::OnMenuShortcut)
EVT_MENU(menuEditGo,             FrameMain_cls::OnMenuGo)
EVT_MENU(menuEditTimeRemap,      FrameMain_cls::OnMenuTimeRemap)
EVT_MENU(menuEditRemoveCacheSnap,FrameMain_cls::OnMenuRemoveCacheSnap)
EVT_MENU(menuEditRemoveCacheAll, FrameMain_cls::OnMenuRemoveCacheAll)
EVT_MENU(menuEditRefreshGL,      FrameMain_cls::OnMenuRefreshGL)
EVT_MENU(menuEditRefreshTL,      FrameMain_cls::OnMenuRefreshTL)
EVT_MENU(menuEditRefreshSB,      FrameMain_cls::OnMenuRefreshSB)
EVT_MENU(menuEditRefreshAttrib,  FrameMain_cls::OnMenuRefreshAttrib)
EVT_MENU(menuEditRefreshIMGSEQ,  FrameMain_cls::OnMenuRefreshIMGSEQ)
EVT_MENU(menuEditRefreshCamConf, FrameMain_cls::OnMenuRefreshCamConf)
EVT_MENU(menuEditRefreshColor,   FrameMain_cls::OnMenuRefreshColor)
EVT_MENU(menuEditRefreshExporter,FrameMain_cls::OnMenuRefreshExporter)
EVT_MENU(menuEditRefreshDrawOptions,FrameMain_cls::OnMenuRefreshDrawOptions)
EVT_MENU(menuEditRefreshLight,   FrameMain_cls::OnMenuRefreshLight)
EVT_MENU(menuEditRefreshExposure,FrameMain_cls::OnMenuRefreshExposure)
EVT_MENU(menuEditRefreshStereo,  FrameMain_cls::OnMenuRefreshStereo)
EVT_MENU(menuEditRefreshTexture, FrameMain_cls::OnMenuRefreshTexture)
EVT_MENU(menuEditSelectGLAttrib, FrameMain_cls::OnMenuGLAttribSelect)
EVT_MENU(menuEditSyncGLCtrl,     FrameMain_cls::OnMenuSyncGLCtrl)
EVT_MENU(menuEditResizedTL,      FrameMain_cls::OnMenuResizedTL)
EVT_MENU(menuSelectDeselect,     FrameMain_cls::OnMenuDeselect)
EVT_MENU(menuFileOpenProject,    FrameMain_cls::OnMenuOpenProject)
EVT_MENU(menuFileSaveProject,    FrameMain_cls::OnMenuSaveProject)
EVT_MENU(menuFileSaveProjectAs,  FrameMain_cls::OnMenuSaveProjectAs)
EVT_MENU(menuFileOpenData,       FrameMain_cls::OnMenuLoadData)
EVT_MENU(menuFileExportData,     FrameMain_cls::OnMenuExportData)
EVT_MENU(menuFileExportPathPov,  FrameMain_cls::OnMenuExportPathPov)
EVT_MENU(menuFileSaveImageSnap,  FrameMain_cls::OnMenuSaveImageSnap)
EVT_MENU(menuFileSaveImageSeq,   FrameMain_cls::OnMenuSaveImageSeq)
EVT_MENU(menuItemSaveImgSeqBegin,FrameMain_cls::OnMenuSaveImgSeqBegin)
EVT_MENU(menuItemExportDataBegin,FrameMain_cls::OnMenuExportDataBegin)
EVT_MENU(menuFileCloseData,      FrameMain_cls::OnMenuCloseData)
EVT_MENU(menuPovExportSnap,      FrameMain_cls::OnMenuPovExportSnap)
EVT_MENU(menuPovRenderSnap,      FrameMain_cls::OnMenuPovRenderSnap)
EVT_MENU(menuPovExportAnim,      FrameMain_cls::OnMenuPovExportAnim)
EVT_MENU(menuPovRenderAnim,      FrameMain_cls::OnMenuPovRenderAnim)
EVT_MENU(menuFilterPopup,        FrameMain_cls::OnMenuFilterPopup)
EVT_MENU(menuFilterRefresh,      FrameMain_cls::OnMenuFilterRefresh)
EVT_MENU(menuFilterResize,       FrameMain_cls::OnMenuFilterResize)
EVT_MENU(menuFilterManipulate,   FrameMain_cls::OnMenuFilterManipulate)
EVT_MENU(menuFilterDelete,       FrameMain_cls::OnMenuFilterDelete)
EVT_MENU(menuFilterUp,           FrameMain_cls::OnMenuFilterUp)
EVT_MENU(menuFilterDown,         FrameMain_cls::OnMenuFilterDown)
EVT_MENU_RANGE(menuFilterBoolean, menuFilterBG, FrameMain_cls::OnMenuFilterAdd)
EVT_MENU_RANGE(GLMenuMoveToCamPos, GLMenuCenterItem, FrameMain_cls::OnGLMenu)
EVT_MENU(menuViewMainPanelType0, FrameMain_cls::OnMenuViewPanelType)
EVT_MENU(menuViewMainPanelType1, FrameMain_cls::OnMenuViewPanelType)
EVT_MENU(menuViewMainPanelType2, FrameMain_cls::OnMenuViewPanelType)
EVT_MENU(menuViewMainPanelType3, FrameMain_cls::OnMenuViewPanelType)
EVT_MENU(menuViewMainPanelType4, FrameMain_cls::OnMenuViewPanelType)
EVT_MENU(menuViewExtraPanel,     FrameMain_cls::OnMenuViewExtra)
EVT_MENU(menuDialogCameraPath,   FrameMain_cls::OnMenuCameraPath)
EVT_MENU(menuDialogLightSRC,     FrameMain_cls::OnMenuLighgtSRC)
EVT_MENU(menuDialogColorCurve,   FrameMain_cls::OnMenuColorCurve)
EVT_MENU(menuDialogPovRay,       FrameMain_cls::OnMenuPovRay)
EVT_MENU(menuDialogTexProperty,  FrameMain_cls::OnMenuTexProperty)
EVT_MENU(menuDialogStereogram,   FrameMain_cls::OnMenuStereogram)
EVT_MENU(menuDialogPeriodic,     FrameMain_cls::OnMenuPeriodicBoundary)
EVT_MENU(menuUnlock,             FrameMain_cls::OnMenuUnlock)
EVT_MENU(menuSpecial,            FrameMain_cls::OnMenuSpecial)
EVT_MENU(menuAboutGL,            FrameMain_cls::OnAboutGL)
EVT_MENU(menuAboutNetwork,       FrameMain_cls::OnAboutNetwork)
EVT_MENU(menuSetKeyPos,          FrameMain_cls::OnMenuSetKeyPos)
EVT_MENU(menuSetKeyPosRot,       FrameMain_cls::OnMenuSetKeyPosRot)
EVT_MENU(menuSetKeyAnc,          FrameMain_cls::OnMenuSetKeyAnc)
EVT_MENU(menuPlayStop,           FrameMain_cls::OnMenuPlayStop)
EVT_MENU(menuFullScreen,         FrameMain_cls::OnMenuFullScreen)
EVT_MENU(menuEscape,             FrameMain_cls::OnMenuEscape)
EVT_KEY_DOWN  (FrameMain_cls::OnKeyDown)
EVT_IDLE      (FrameMain_cls::OnIdle)
EVT_TIMER     (TIMER_ID, FrameMain_cls::OnTimer)
END_EVENT_TABLE()

FrameMain_cls::
FrameMain_cls(const wxString& title, Main_cls *pMain, int posx, int posy,
	      int width, int height) :
wxFrame(NULL, wxID_ANY, title, wxPoint(posx, posy), wxSize(width, height)),
    mCTimer(this, TIMER_ID)
{
    Show(TRUE);
    Freeze();
    mspCThis = this;
    mpCParent = pMain;
    GpCMainFrameCLS = this;
    mbHasOpenedProject = FALSE;
    mbRepeatPlay = FALSE;
    mpCHelpLauncher = NULL;

    wxIcon icon; icon.CopyFromBitmap(ARTWXFRAMEICON("wxART_PARTICLE"));
    SetIcon(icon); 
	  
    SetFont(FontProvider_cls::GetFont(0));
    //SetContents();
}

void FrameMain_cls::
SetContents(){
    // ߂ɕKv
    mpCPreference = new Preference_cls();
    
    // ŏɓǂłݒ
    wxString strFile = mpCParent->mstrExecuteDir + _WXDELIM_ + _CONFIGURE_FILE;
    std::wifstream ifstream(strFile.char_str(), std::ios::in);
    if (ifstream.fail() == FALSE){
	std::wstring wstrLine;
	while ( std::getline (ifstream, wstrLine)){
	    wxString strLine = wstrLine.c_str();
	    mpCPreference->mCUseQuadBuffer.ReadStrLine(strLine);
	}
    }

    SetExtraStyle(wxWS_EX_PROCESS_IDLE);

    mCTimer.Start(500);
        
    mCConfList.Add(&mCLastOpenedFileZJP, wxT("LastFileZJP="), wxT("None"));
    mCConfList.Add(&mCLastOpenedFileGRM, wxT("LastFileGRM="), wxT("None"));
    mCConfList.Add(&mCLastOpenedFileOUT, wxT("LastFileOUT="), wxT("None"));
    mCConfList.Add(&mCLastOpenedFileOBJ, wxT("LastFileOBJ="), wxT("None"));
    mCConfList.Add(&mCLastOpenedFileTEX, wxT("LastFileTEX="), wxT("None"));

    //Drag'nDrop
    //SetDropTarget(new DnDFile_cls(this));
    
    // TCU[
    wxBoxSizer  *pBoxSizerSrc = new wxBoxSizer(wxVERTICAL);

#ifdef _NO_SPLIT    
    mpCSplitterMain = NULL;
    mpCTopHalfPanel = new TopHalfPanel_cls(this, this);
    mpCBtmHalfPanel = new BtmHalfPanel_cls(this, this);
#ifdef _NO_PANEL01
    mpCTopHalfPanel->Hide();
    mpCBtmHalfPanel->Hide();
#else
    pBoxSizerSrc->Add(mpCTopHalfPanel, 4, wxEXPAND);
    pBoxSizerSrc->Add(mpCBtmHalfPanel, 1, wxEXPAND);
#endif
#else
    mpCSplitterMain = new
	wxSplitterWindow(this, wxID_ANY, wxDP, wxDS,
			 wxSP_NOBORDER | wxSP_3DSASH);
    mpCSplitterMain->SetSashGravity(0);
    Connect(mpCSplitterMain->GetId(),
	    wxEVT_COMMAND_SPLITTER_SASH_POS_CHANGED,
	    wxSplitterEventHandler(FrameMain_cls::OnSash));

    mpCTopHalfPanel = new TopHalfPanel_cls(mpCSplitterMain, this);
    mpCBtmHalfPanel = new BtmHalfPanel_cls(mpCSplitterMain, this);

    mpCTopHalfPanel->SetBackgroundColour(wxT("WHITE"));
    mpCBtmHalfPanel->SetBackgroundColour(wxT("BLACK"));

    mpCSplitterMain->SplitHorizontally(mpCTopHalfPanel, mpCBtmHalfPanel, -30);
    pBoxSizerSrc->Add(mpCSplitterMain, 1, wxEXPAND);
#endif

    mpCActiveGLCanvasLink = GetPCGLCanvas(0);
    GetPCTimeCtrl()->InstantiateGUIB(this);
    pBoxSizerSrc->Add(GetPCTimeCtrl()->mpCGUIPlay, 0, wxEXPAND);
    
    // ---

    InitMenu();
    CreateStatusBar(4);
    int statusBarWidth[4] = {-1, 180, 180, 240};
    GetStatusBar()->SetFieldsCount(4, statusBarWidth);
    GetStatusBar()->PushStatusText(wxT("field_0"), 0);
    GetStatusBar()->PushStatusText(wxT("field_1"), 1);
    GetStatusBar()->PushStatusText(wxT("field_2"), 2);
    GetStatusBar()->PushStatusText(wxT("field_3"), 3);

    mpCStatusGauge = new wxGauge(GetStatusBar(), wxID_ANY, 100, wxDPS, wxGA_HORIZONTAL);
    
    this->SetSizer(pBoxSizerSrc);

    SetFocus();
    //Refresh(false);

    MainGLCanvas_cls::InitializeStaticMembers(mpCParent->mpCOverlay);
    ShadowVolume_cls::InitializeStaticMembers();
    for (int i = 0; i < _MAX_THREAD_READ; i++) GAThreadReaderPercentage[i] = 100;

    GpCurrentGLPanel = GetPCGLCanvas(0);
    mpCGLExtFrame = new GLExtraFrame_cls(this, GetPCGLCanvas(0)->mpCGLContext);
    
    mInitSash = 150;
    if (mpCParent->mDisplaySize.GetHeight() > 1050) mInitSash = 210;

    //FitSplitterWindow(TRUE);
}

FrameMain_cls::
~FrameMain_cls(){
    delete mpCGLInfo;
    delete mpCPreference;
    delete mpCShortcut;
    delete GpCFileDialog;
    delete GpCClrDialog;

    delete mpCMenuFilterManipulate; // Ǘj[Ȃ̂
    MainGLCanvas_cls::DestructStaticMembers();
}

void FrameMain_cls::
FitSplitterWindow(bool bForce){
    if (mpCSplitterMain == NULL) return;

    int btmHalfPanelHeight = mpCBtmHalfPanel->GetSizer()->GetMinSize().GetHeight();
    if (btmHalfPanelHeight > 120) btmHalfPanelHeight = 120;

    int sashPos    = mpCSplitterMain->GetSashPosition();
    int windowSize = mpCSplitterMain->GetClientSize().GetHeight();
    int sashCandid = windowSize - btmHalfPanelHeight;
    mpCSplitterMain->SetMinimumPaneSize(80);

    if (bForce || (sashPos > sashCandid)){
	mpCSplitterMain->SetSashPosition(windowSize - mInitSash, TRUE);
	Refresh(TRUE);
    }
}

// ----------------------

PDataSequence_cls* FrameMain_cls::
GetPCActiveFileSequence(){
    return GetPCDataSeqCtrl()->GetPCActiveFileSequence();
}

GLCanvasCtrl_cls* FrameMain_cls::
GetPCGLCanvasCtrl(int index){
    if (index > 4) return mpCTopHalfPanel->mpCGLCtrl[0];
    if (index == 4)
	return mpCGLExtFrame->mpCGLCtrl;
    return mpCTopHalfPanel->mpCGLCtrl[index];
}

MainGLCanvas_cls* FrameMain_cls::
GetPCGLCanvas(int index){
    if (index == 4)
	return mpCGLExtFrame->mpCGLCtrl->mpCGLCanvas;
    return mpCTopHalfPanel->mpCGLCtrl[index]->mpCGLCanvas;
}

void FrameMain_cls::
ReconnectCameraPathGUI(){
    mpCParent->mpCCameraPathCtrl->mpCGUI->ReconnectView();
}

void FrameMain_cls::
PrepareTheFrame(int frame){
    if (GbGLLockForLoadingData == TRUE){
	printf("GbGLLockForLoadingData == TRUE\n");
	//printf("Prepare impossible\n");
	//exit(0);
    }
    bool bWaitFinish = FALSE;
    if (frame == _FM_FRAME_CURRENT){
	frame = GetPCTimeCtrl()->mFrame;
	bWaitFinish = TRUE;
    }
    
    double indexDoube = GetPCTimeCtrl()->GetRemappedIndexDouble(frame);
    int index = (int)indexDoube;
    double indexmod = indexDoube-index;
    GetPCDataSeqCtrl()->PrepareIndex
	(index, indexmod, GetPCTimeCtrl()->mCBlurCtrl.mbUseMotionBlur,
	 bWaitFinish);
}

void FrameMain_cls::
UpdateTitle(){
    if (mCLastOpenedFileZJP.mstrBody.IsEmpty() == TRUE)
	return SetTitle(_FRAME_MAIN_APPNAME);
    if (mbHasOpenedProject == FALSE) return;
    wxString strTitle = _APPNAME_SHORT;
    strTitle << wxT(" - ") << mCLastOpenedFileZJP.mstrBody;
    SetTitle(strTitle);
}

void FrameMain_cls::
EnableMenuItemPov(bool b0, bool b1, bool b2, bool b3){
    mpCMenuItemExportSnap->Enable(b0);
    mpCMenuItemExportAnim->Enable(b1);
    mpCMenuItemRenderSnap->Enable(b2);
    mpCMenuItemRenderAnim->Enable(b3);
}

bool FrameMain_cls::
IsTheFrameReady(int frame){
    if (frame == _FM_FRAME_CURRENT) frame = GetPCTimeCtrl()->mFrame;
    int step = GetPCTimeCtrl()->mInterpStep;
    double remappedDoubleIndex = 
	GetPCTimeCtrl()->GetRemappedIndexDouble(frame, step);
    int index = (int)remappedDoubleIndex;
    double indexmod = remappedDoubleIndex - index;
    return GetPCDataSeqCtrl()->IsTheIndexReady
	(index, indexmod, GetPCTimeCtrl()->mCBlurCtrl.mbUseMotionBlur);
}

bool FrameMain_cls::
IsTheFrameReading(int frame){
    if (frame == _FM_FRAME_CURRENT) frame = GetPCTimeCtrl()->mFrame;
    int index = GetPCTimeCtrl()->GetRemappedIndex(frame);
    return GetPCDataSeqCtrl()->IsTheIndexReading(index);
}

bool FrameMain_cls::
IsTheFrameLoaded(int frame){
    if (frame == _FM_FRAME_CURRENT) frame = GetPCTimeCtrl()->mFrame;
    int index = GetPCTimeCtrl()->GetRemappedIndex(frame);
    return GetPCDataSeqCtrl()->IsTheIndexLoaded(index);
}

// ----------------------

void FrameMain_cls::
OnClose(wxCloseEvent& event){
    if (mpCHelpLauncher != NULL) mpCHelpLauncher->Terminate();
    event.Skip();
}

void FrameMain_cls::
OnSize(wxSizeEvent& event){
    wxRect rect;
    if (GetStatusBar() != NULL){
	GetStatusBar()->GetFieldRect(1, rect);
	mpCStatusGauge->SetSize(rect.x, rect.y+2, rect.width, rect.height-4);
	mpCStatusGauge->SetRange(100);
    }
    event.Skip();
}

void FrameMain_cls::
OnQuit(wxCommandEvent& event){
    if (GbGLLockModalDialog == TRUE) return;
    GbGLLockModalDialog = TRUE;
    if (MsgBoxYesno(this, _("Query"), _("Really Quit ?")) == TRUE){
	GbQuitApplication = TRUE;
	mpCParent->WaitAllThreadFinish();
	mpCParent->QuitProcess();
	Close(true);
    }
    GbGLLockModalDialog = FALSE;
}

void FrameMain_cls::
OnAboutGL(wxCommandEvent& event){
    
    wxString strMessage;
    mpCGLInfo->GetAllGLInfo(strMessage);
    
    AboutBox_cls CAboutBox(this, wxID_ANY,
			   _("About Open GL"), strMessage);
    CAboutBox.HideURL();
    CAboutBox.ShowModal();
}

void FrameMain_cls::
OnAboutNetwork(wxCommandEvent& event){
    wxString strMessage;

    mpCParent->mpCIpAddress->GetStrAddress(strMessage);
    mpCParent->mpCMacAddress->GetStrInfo(strMessage);
    strMessage << ENDL;

    AboutBox_cls CAboutBox(this, wxID_ANY,
			   _("About Network"), strMessage);
    CAboutBox.HideURL();
    CAboutBox.ShowModal();
}

void FrameMain_cls::
OnAbout(wxCommandEvent& event){

    wxMemorySize mem_size_msz = wxGetFreeMemory(); 
    wxString strMem = mem_size_msz.ToString();
    if (strMem == wxT("-1")) strMem = wxT("Unknown");
    else {
	mem_size_msz /= 1024 * 1024;
	strMem = mem_size_msz.ToString();
    }
    
    wxString strMessage = 
	wxString::Format
	(_FRAME_MAIN_APPNAME _T("\n")
	 _T("%s %s\n%s %s\n%s %s MB\n%s %d\nProgrammed by Takaaki Takeda\n"),
	 _("Powered by"), wxVERSION_STRING,
	 _("running under"), wxGetOsDescription().c_str(),
	 _("free memory"), strMem.c_str(),
	 wxT("CoreNumber:"), wxThread::GetCPUCount()
	 );
    strMessage << wxT("InitializeTimeA:") << mpCParent->mInitializeTimeA << ENDL;
    strMessage << wxT("InitializeTimeB:") << mpCParent->mInitializeTimeB << ENDL;
    strMessage << wxT("InitializeTimeC:") << mpCParent->mInitializeTimeC << ENDL;

#ifdef WIN32
    strMessage << wxT("Registry: HungAppTimeout= ") << mpCParent->mHungAppTimeoutMS << ENDL;
    if (mpCParent->mHungAppTimeoutMS == -1)
	strMessage << _("!!) Heavy rendering may fails. See Manuals about window timeout.");
#endif
    
    AboutBox_cls CAboutBox(this, wxID_ANY,
			   _("About Zindaiji3"), strMessage);
    CAboutBox.ShowModal();
}

void FrameMain_cls::
OnHelp(wxCommandEvent &event){
    if (mpCHelpLauncher != NULL) return;
    mpCHelpLauncher = new HelpLauncher_cls(this, 
					   wxT("Resource/HELP/Zindaiji3.chm"));
    mpCHelpLauncher->Execute();
}

void FrameMain_cls::
OnSash(wxSplitterEvent& event){
    mpCBtmHalfPanel->RecheckSize();
}

void FrameMain_cls::
OnKeyDown(wxKeyEvent& event){
    mpCShortcut->ProcShortcutKey(event.GetModifiers(), 
				 event.GetKeyCode());
}

void FrameMain_cls::
PrepareFramesAhead(int range){
    range *= GetPCTimeCtrl()->mPrefetchRange;
    if (range > 0)
	for (int dframe = 1; dframe <= range; dframe++){
	    int targetFrame = GetPCTimeCtrl()->
		CalcNextFrame(_TIME_CTRL_CURRENT, dframe, FALSE);
	    if (targetFrame > (int)GetPCTimeCtrl()->mCMaxFrame.mBody) continue;
	    if (IsTheFrameReady(targetFrame) == FALSE &&
		IsTheFrameReading(targetFrame) == FALSE ){
		PrepareTheFrame(targetFrame);
		dframe = range; continue;
	    }
	}
    else if (range < 0)
	for (int dframe = -1; dframe >= range; dframe--){
	    int targetFrame = GetPCTimeCtrl()->
		CalcNextFrame(_TIME_CTRL_CURRENT, dframe, FALSE);
	    if (targetFrame < 0) continue;
	    if (IsTheFrameReady(targetFrame) == FALSE &&
		IsTheFrameReading(targetFrame) == FALSE){
		PrepareTheFrame(targetFrame);
		dframe = range; continue;
	    }
	}
}

/*
bool FrameMain_cls::
IsReadThreadIdle(){
    bool bIdle = FALSE;
    for (int i = 0; i < _MAX_THREAD_READ; i++)
	if (GApCThreadReader[i] == NULL) bIdle = TRUE;
    return bIdle;
}
*/

void FrameMain_cls::
OnIdle(wxIdleEvent& event){
    GetPCDataSeqCtrl()->CleanUpMemory(GetPCTimeCtrl()->mFrame,
				      GetPCTimeCtrl()->mCAnimStep.mBody);

    static int sInit = 0;
    if (sInit == 0){
#ifdef __WXMAC__	
	wxMilliSleep(500);
	SendMenuEvent(menuEditRefreshGL);
#endif
	mpCGLExtFrame->Hide();
	mpCGLExtFrame->SetSize(wxSize(640, 480));
	mpCGLExtFrame->Center();
	sInit = 1;

	FitSplitterWindow(TRUE);
    }
    

    if (ThreadFileReader_cls::IsReadThreadIdleAny() == TRUE){
	if (IsTheFrameReady(_FM_FRAME_CURRENT) == TRUE)
	    PrepareFramesAhead(GetPCTimeCtrl()->mPlayDirection);
    }
    else{
	SendMenuEvent(this, menuEditRefreshSB);
    }
    
    if (GbGLLockPlayWait == TRUE){
	return;
    }

    // ԂmPrevFrameƈPaint;
    if (mpCTopHalfPanel->CheckGLRefresh(GetPCTimeCtrl()->mFrame,
					GetPCTimeCtrl()->mInterpStep) == FALSE){
	wxMilliSleep(13);
	return;
    }

    bool bInnertia = FALSE;
    for (int i = 0; i < _GLCANVAS_INDEX_MAX; i++){
	MainGLCanvas_cls *pCGLCanvas = GetPCGLCanvas(i);
	if (pCGLCanvas->mbInnertia == TRUE){
	    bInnertia = TRUE;
	    pCGLCanvas->ProcViewOrItemDragging(TRUE);
	    if (GetPCTimeCtrl()->mbPlayTex == FALSE)
		pCGLCanvas->Refresh(FALSE);
	}
    }

    if (GetPCTimeCtrl()->mbPlayTex == TRUE){
	if (GetPCTimeCtrl()->ProcPlaying() == TRUE)
	    GbGLLockPlayWait = TRUE;
    }
    else if (bInnertia == TRUE) GetPCTimeCtrl()->Wait();

    GetPCPovRayCtrl()->ProcessRenderPovAnim();
}

void FrameMain_cls::
OnTimer(wxTimerEvent& event){
    for (int i = 0; i < _MAX_THREAD_READ; i++){
	if (GApCThreadReader[i] != NULL){
	    if (GAbThreadReaderFinished[i] == TRUE)
		GApCThreadReader[i] = NULL;
	}
    }
    //wxWakeUpIdle();
}

void FrameMain_cls::
OnMenuOpenProject(wxCommandEvent& event){
    GpCFileDialog->SetMessage(wxT("Select a project file"));
    GpCFileDialog->SetWildcard(wxT("Project file (*.zjp)|*.zjp"));
    if (mCLastOpenedFileZJP.mstrBody.IsEmpty() == FALSE){
	wxFileName CName = mCLastOpenedFileZJP.mstrBody;
	GpCFileDialog->SetInitPath(CName.GetPath(), CName.GetFullName());
    }
    
    if (GpCFileDialog->ShowModal() == wxID_OK){
	wxBeginBusyCursor();
	GetStatusBar()->SetStatusText(wxT("Reading Project..."), 3);

	GetPCTimeCtrl()->mFrame = 0;
	GetPCTimeCtrl()->mInterpStep = 0;
	
	GetPCDataSeqCtrl()->ClearData
	    (_ACTIVE_SEQUENCE, _SEQUENCE_ALL_INDEX, TRUE);
	mpCParent->ClearFilters();
	mpCParent->ReadProjectFile(GpCFileDialog->GetPath());
	mCLastOpenedFileZJP.mstrBody = GpCFileDialog->GetPath();
	mpCParent->UpdateGUIItems();
	mbHasOpenedProject = TRUE;

	mpCTopHalfPanel->ClearStatusGLPanels();
	mpCTopHalfPanel->RefreshGLPanels();
	mpCBtmHalfPanel->RefreshTLPanels();
	mpCTopHalfPanel->RefreshAttrib();
	mpCParent->mpCColorCurveCtrl->UpdateItems();
	
	SendMenuEvent(this, menuFilterResize);
	
	for (int i = 0; i < _MAX_FILTER_CTRL; i++)
	    mpCParent->mpCFilterCtrl[i]->UpdateInterpolatedValue(0);

	SendMenuEvent(this, menuFilterRefresh);
	SendMenuEvent(this, menuEditRefreshDrawOptions);

	mpCMenuEdit->Check(menuEditTimeRemap, GetPCTimeCtrl()->mCbUseTimeRemap.mbBody);
	wxEndBusyCursor();
	GetStatusBar()->SetStatusText(wxT(""), 3);
    }
    UpdateTitle();
}

void FrameMain_cls::
OnMenuSaveProject(wxCommandEvent& event){
    if (mbHasOpenedProject == FALSE){
	OnMenuSaveProjectAs(event);
	return;
    }

    if (GbGLLockModalDialog == TRUE) return;
    GbGLLockModalDialog = TRUE;

    wxBeginBusyCursor();
    bool bSucceed = mpCParent->SaveProjectFile(mCLastOpenedFileZJP.mstrBody, _FM_PROJECT_CONF);
    wxMilliSleep(500);
    wxEndBusyCursor();

    if (bSucceed == FALSE)	
	MsgBox(this, wxT("Error"), wxT("File writing failed."));

    GbGLLockModalDialog = FALSE;
    UpdateTitle();
}

void FrameMain_cls::
OnMenuSaveProjectAs(wxCommandEvent& event){
    GpCFileDialog->SetMessage(wxT("Select project file name to save"));
    GpCFileDialog->SetWildcard(wxT("Project file (*.zjp)|*.zjp"));
    GpCFileDialog->SetStyle(wxFD_SAVE | wxFD_OVERWRITE_PROMPT);
    if (mCLastOpenedFileZJP.mstrBody.IsEmpty() == FALSE){
	wxFileName CName = mCLastOpenedFileZJP.mstrBody;
	if (mbHasOpenedProject == TRUE)
	    GpCFileDialog->SetInitPath(CName.GetPath(), CName.GetFullName());
	else
	    GpCFileDialog->SetInitPath(CName.GetPath(), wxT(".zjp"));
    }
    
    if (GpCFileDialog->ShowModal() == wxID_OK){
	mpCParent->SaveProjectFile(GpCFileDialog->GetPath(), _FM_PROJECT_CONF);
	mbHasOpenedProject = TRUE;
	mCLastOpenedFileZJP.mstrBody = GpCFileDialog->GetPath();
	UpdateTitle();
    }
}

void FrameMain_cls::
OnMenuLoadData(wxCommandEvent& event){
    mpCParent->mpCDataLoader->OpenWindow(this);
}

void FrameMain_cls::
OnMenuExportData(wxCommandEvent& event){
    mpCParent->mpCDataExporter->OpenWindow(this);
}

void FrameMain_cls::
OnMenuExportPathPov(wxCommandEvent& event){
    mpCParent->ExportPovPath();
}

void FrameMain_cls::
OnMenuSaveImageSnap(wxCommandEvent& event){
    mpCActiveGLCanvasLink->mbSaveImageQueue = TRUE;
    mpCActiveGLCanvasLink->Refresh(FALSE);
}

void FrameMain_cls::
OnMenuSaveImageSeq(wxCommandEvent& event){
    int width, height;
    mpCActiveGLCanvasLink->GetClientSize(&width, &height);
    mpCParent->mpCImgSeq->SetGeom(width, height, mpCActiveGLCanvasLink->mCGLPerspDraw.mDeg);
    mpCParent->mpCImgSeq->mCInitNum.mBody = GetPCTimeCtrl()->mCWAMin.mBody;
    //mpCActiveGLCanvasLink->mpCImgSeqLinked = mpCParent->mpCImgSeq;
    MainGLCanvas_cls::mspCImgSeqLinked = mpCParent->mpCImgSeq;
    mpCParent->mpCImgSeq->SetDefaultPath(mCLastOpenedFileOUT.mstrBody);
    mpCParent->mpCImgSeq->OpenWindow(this);
}

void FrameMain_cls::
OnMenuSaveImgSeqBegin(wxCommandEvent& event){
    wxWindow *pC = mpCActiveGLCanvasLink->mspCImgSeqLinked->mpCGUI;
    if (mpCParent->mpCImgSeq->IsSizeValid(mpCGLInfo) == FALSE){
	MsgBox(pC, _("Size over flow. Open GL Texture size limit is reached,"), _("Save Image Sequence"));
	return;
    }
	

    if (mpCActiveGLCanvasLink->mCDisplayMode.mBody < _GL_CANVAS_LINKED_CAM0)
	if (MsgBoxYesno
	    (pC, _("Save Image Sequence"), _("Panel 0 is not linked to camera")) == TRUE){
	    mpCActiveGLCanvasLink->LinkageConnect();
	}

    if (mpCActiveGLCanvasLink->mCbShowItems.mbBody == TRUE){
	if (MsgBoxYesno
	    (pC, _("Save Image Sequence"), _("Items are shown. Hide them ?")) == TRUE){
	    mpCActiveGLCanvasLink->mCbShowItems.mbBody = FALSE;
	    mpCActiveGLCanvasLink->mpCGLCtrl->UpdateToggleButtonsAndParams();
	}
    }
    
    if (GetPCTimeCtrl()->mCAnimStep.mBody != 1){
	wxString strMes;
	strMes << _("Playing mode is Skipping: ") << GetPCTimeCtrl()->mCAnimStep.mBody << ENDL << _("Change Skipping to 1 ?");
	if (MsgBoxYesno
	    (mpCActiveGLCanvasLink->mspCImgSeqLinked->mpCGUI,
	     _("Save Image Sequence"), strMes) == TRUE){
	    GetPCTimeCtrl()->mCAnimStep.mBody = 1;
	    mpCBtmHalfPanel->RefreshTLPanels();
	}
    }

    if (mpCParent->mpCDrawOption->mCDownSize.mBody != 1){
	wxString strMes;
	strMes << _("Partiecles are downsized.") << ENDL << _("Show full particles?");
	if (MsgBoxYesno
	    (mpCActiveGLCanvasLink->mspCImgSeqLinked->mpCGUI,
	     _("Save Image Sequence"), strMes) == TRUE){
	    mpCParent->mpCDrawOption->mCDownSize.mBody = 1;
	    mpCTopHalfPanel->RefreshAttrib();
	}
    }

    mpCActiveGLCanvasLink->StartSaveImgSeqProcess(mpCParent->mpCImgSeq);
    mpCActiveGLCanvasLink->mCDrawInfo.ForceNewDraw();

    if (mpCActiveGLCanvasLink->mspCImgSeqLinked->mbSnapMode == TRUE)
	GetPCTimeCtrl()->StartPlayCommand(+1);
    else{
	GCUndoList.OpenBlock();
	GetPCTimeCtrl()->MoveFrameCommandLarge(-1);
	GetPCTimeCtrl()->StartPlayCommand(+1);
	GCUndoList.CloseBlock();
    }

    if (GetPCTimeCtrl()->mCbUseMotionBlur.mbBody == TRUE)
	GetPCTimeCtrl()->BeginMotionBlur();
}

void FrameMain_cls::
OnMenuExportDataBegin(wxCommandEvent& event){
    mpCActiveGLCanvasLink->StartExportDataProcess(mpCParent->mpCDataExporter);
    mpCActiveGLCanvasLink->mCDrawInfo.ForceNewDraw();

    GCUndoList.OpenBlock();
    GetPCTimeCtrl()->SetAnimInterpCommand(1, GetPCTimeCtrl()->mCAnimInterp.mBody);
    GetPCTimeCtrl()->MoveFrameCommandLarge(-1);
    GetPCTimeCtrl()->StartPlayCommand(+1);
    GCUndoList.CloseBlock();
    mpCTopHalfPanel->RefreshGLPanels();
}

void FrameMain_cls::
OnMenuCloseData(wxCommandEvent& event){
    mpCParent->CloseDataCommand();
    mpCTopHalfPanel->RefreshGLPanels();
    mpCBtmHalfPanel->RefreshTLPanels();
}

void FrameMain_cls::
OnMenuPovExportSnap(wxCommandEvent& event){
    int stereo = 0;
    mpCParent->ExportPovSnap(stereo, FALSE);
}

void FrameMain_cls::
OnMenuPovRenderSnap(wxCommandEvent& event){
    int stereo = 0;
    mpCParent->ExportPovSnap(stereo, TRUE);
    mpCParent->RenderPovSnap(stereo);
}

void FrameMain_cls::
OnMenuPovExportAnim(wxCommandEvent& event){
    if (GetPCPovRayCtrl()->StartExportPovAnim(0) == TRUE){
	mpCParent->SetTimeForPovAnim();
	GetPCGLCanvas(0)->StartExportPovStringProcess();
	GetPCTimeCtrl()->StartPlayCommand(+1);
    }
    else{
	SendMenuEvent(this, menuPlayStop);
	//wxCommandEvent com(wxEVT_COMMAND_MENU_SELECTED, menuPlayStop);
	//AddPendingEvent(com);
    }
}

void FrameMain_cls::
OnMenuPovRenderAnim(wxCommandEvent& event){
    if (GetPCPovRayCtrl()->StartExportPovAnim(_POV_ANIM) == TRUE){
	mpCParent->SetTimeForPovAnim();
	GetPCGLCanvas(0)->StartExportPovStringProcess();
	GetPCTimeCtrl()->StartPlayCommand(+1);
    }
    else
	SendMenuEvent(this, menuPlayStop);
}

void FrameMain_cls::
OnMenuGLAttribSelect(wxCommandEvent& event){
    mpCParent->SelectGLAttrib(mpCTopHalfPanel->GetPCGLAttrib(-1));
}

void FrameMain_cls::
OnMenuFilterPopup(wxCommandEvent& event){
    switch (event.GetExtraLong()){
    case 0:
	PopupMenu(mpCMenuFilterBoolean);
	break;
    case 1:
	PopupMenu(mpCMenuFilterObject);
	break;
    case 2:
	PopupMenu(mpCMenuFilterWorld);
	break;
    }
}

void FrameMain_cls::
OnMenuFilterRefresh(wxCommandEvent& event){
  for (int i = 0; i < _MAX_FILTER_CTRL; i++){
      mpCParent->mpCFilterCtrl[i]->UpdateInterpolatedValue(GetPCTimeCtrl()->GetDoubleIndex());
      mpCParent->mpCFilterCtrl[i]->UpdateValuesOnPanel();
      mpCParent->mpCFilterCtrl[i]->HideAndShowOnPanel();
  }
}

void FrameMain_cls::
OnMenuFilterResize(wxCommandEvent& event){
    for (int i = 0; i < _MAX_FILTER_CTRL; i++)
	mpCTopHalfPanel->mpCFilterPanelPain[i]->Freeze();
    mpCTopHalfPanel->RecalcSize();
    mpCTopHalfPanel->RecalcSize();
    for (int i = 0; i < _MAX_FILTER_CTRL; i++)
	mpCTopHalfPanel->mpCFilterPanelPain[i]->Thaw();
}

void FrameMain_cls::
OnMenuFilterManipulate(wxCommandEvent& event){
    PopupMenu(mpCMenuFilterManipulate);
}

void FrameMain_cls::
OnMenuFilterDelete(wxCommandEvent& event){
    mpCParent->DeleteSelectedFilter();
}

void FrameMain_cls::
OnMenuFilterUp(wxCommandEvent& event){
    mpCParent->MoveSelectedFilter(-1);
}

void FrameMain_cls::
OnMenuFilterDown(wxCommandEvent& event){
    mpCParent->MoveSelectedFilter(+1);
}

void FrameMain_cls::
ProcAddFilter(FilterCtrl_cls *pCFilterCtrl, int filterType){
    int pos = pCFilterCtrl->mVpCFilter.size();

    GCUndoList.OpenBlock(wxT("AddFilter"));
    GCUndoList.PushNewCommand
	(new CommandFilterMake_cls(pCFilterCtrl, filterType, pos, NULL),
	 new CommandFilterMake_cls(pCFilterCtrl, -1, pos, NULL));
    GCUndoList.ExecCurrent();
    double pValue[3] = {1.0, 1.0, 1.0};
    wxString strTagFilter = (*pCFilterCtrl->GetIterN(pos))->GetPCData()->mCstrCustomName.mstrBody;
    wxString strTagParam = (*pCFilterCtrl->GetIterN(pos))->GetPCData()->mpCScale->mstrGroupLabel;
    
    GCUndoList.PushNewCommand
	(new CommandFilterParamInit_cls(pCFilterCtrl, strTagFilter, strTagParam, 3, pValue, 0),
	 new CommandFilterParamInit_cls(pCFilterCtrl, strTagFilter, strTagParam, 3, pValue, 0)); // ͉ł
    GCUndoList.ExecCurrent();

    GCUndoList.CloseBlock(wxT("AddFilter"));
}

int FrameMain_cls::
GetFilterTypeFromEnum(int enumID){
    switch(enumID){
    case menuFilterBoolean:  return _FILTER_BOOLEAN;
    case menuFilterDataBox:  return _FILTER_DATABOX;
    case menuFilterObject:   return _FILTER_OBJECT;
    case menuFilterGrid:     return _FILTER_GRID;
    case menuFilterText:     return _FILTER_TEXT;
    case menuFilterFog:      return _FILTER_FOG;
    case menuFilterFiltering:return _FILTER_FILTERING;
    case menuFilterCopy:     return _FILTER_COPY;
    case menuFilterStick:    return _FILTER_STICK;
    case menuFilterBG:       return _FILTER_BG;
    }
    return 0;
}

void FrameMain_cls::
OnMenuFilterAdd(wxCommandEvent& event){
    int type = GetFilterTypeFromEnum(event.GetId());
    ProcAddFilter(FilterCtrl_cls::GetPCFilterCtrlFromType(type), type);
}

void FrameMain_cls::
OnGLMenu(wxCommandEvent& event){
    GpCurrentGLPanel->GetEventHandler()->AddPendingEvent(event);
}

void FrameMain_cls::
OnMenuCameraPath(wxCommandEvent& event){
    mpCParent->mpCCameraPathCtrl->DialogControl_cls::OpenWindow(this);
}

void FrameMain_cls::
OnMenuLighgtSRC(wxCommandEvent& event){
    mpCParent->mpCLightSRCCtrl->DialogControl_cls::OpenWindow(this);
    mpCParent->mpCLightSRCCtrl->mpCGUI->HideAndShowAll();
}

void FrameMain_cls::
OnMenuColorCurve(wxCommandEvent& event){
    mpCParent->OpenColorCurveDialog();
}

void FrameMain_cls::
OnMenuPovRay(wxCommandEvent& event){
    GetPCPovRayCtrl()->DialogControl_cls::OpenWindow(this);
}

void FrameMain_cls::
OnMenuTexProperty(wxCommandEvent& event){
    mpCParent->mpCTexPropertyCtrl->DialogControl_cls::OpenWindow(this);
}

void FrameMain_cls::
OnMenuStereogram(wxCommandEvent& event){
    mpCParent->mpCStereogram->DialogControl_cls::OpenWindow(this);
    mpCParent->mpCStereogram->mpCGUI->HideAndShowItems();
    mpCParent->mpCStereogram->mpCGUI->Refresh(TRUE);
}

void FrameMain_cls::
OnMenuPeriodicBoundary(wxCommandEvent& event){
    mpCParent->mpCPeriodic->DialogControl_cls::OpenWindow(this);
}

void FrameMain_cls::
OnMenuUnlock(wxCommandEvent& event){
    GbGLLockDrawing = FALSE;
}

void FrameMain_cls::
OnMenuSpecial(wxCommandEvent& event){
    int val;
    unsigned char ptmp[4];
    sscanf("02", "%x", &val); ptmp[0] = val;
    sscanf("00", "%x", &val); ptmp[1] = val;
    sscanf("00", "%x", &val); ptmp[2] = val;
    sscanf("00", "%x", &val); ptmp[3] = val;

    unsigned int tmp = *(unsigned int*)ptmp;
	 
    //mpCParent->Special();
}

void FrameMain_cls::
OnMenuViewPanelType(wxCommandEvent& event){
    int panelType = event.GetId() - menuViewMainPanelType0;
    mpCTopHalfPanel->SplitPanel(panelType);
}

void FrameMain_cls::
OnMenuViewExtra(wxCommandEvent& event){
    mpCGLExtFrame->Show(TRUE);
}

void FrameMain_cls::
OnMenuUndo(wxCommandEvent& event){
    mpCParent->Undo();
}

void FrameMain_cls::
OnMenuRedo(wxCommandEvent& event){
    mpCParent->Redo();
}

void FrameMain_cls::
OnMenuScene(wxCommandEvent& event){
    mpCParent->mpCScene->Open();
}

void FrameMain_cls::
OnMenuPreference(wxCommandEvent& event){
    mpCPreference->OpenWindow(this);
}

void FrameMain_cls::
OnMenuShortcut(wxCommandEvent& event){
    mpCShortcut->ProcShortcutKey(GShortcutModifier, GShortcutKeycode);
}

void FrameMain_cls::
OnMenuGo(wxCommandEvent& event){
    long frame = wxGetNumberFromUser(wxT("Frame"), wxT(""), _("Move Frame"),
				     GetPCTimeCtrl()->mFrame,
				     0, GetPCTimeCtrl()->mCMaxFrame.mBody);
    if (frame == -1) return;
    GetPCTimeCtrl()->SetFrameCommand(frame);
}

void FrameMain_cls::
OnMenuTimeRemap(wxCommandEvent& event){
    // SetBUseTimeRemapg
    GetPCTimeCtrl()->mCbUseTimeRemap.mbBody = event.IsChecked();
    mpCParent->mpCParamGUICtrlLink->HideAndShow();
    mpCParent->mpCParamGUICtrlLink->ResizeTL();
}

void FrameMain_cls::
OnMenuRemoveCacheSnap(wxCommandEvent& event){
    int index = GetPCTimeCtrl()->GetRemappedIndex(_TIME_CTRL_CURRENT);
    GetPCDataSeqCtrl()->ClearData
	(_ACTIVE_SEQUENCE, index, FALSE);
}

void FrameMain_cls::
OnMenuRemoveCacheAll(wxCommandEvent& event){
    GetPCDataSeqCtrl()->ClearData
	(_ACTIVE_SEQUENCE, _SEQUENCE_ALL_INDEX, FALSE);
}

void FrameMain_cls::
OnMenuRefreshGL(wxCommandEvent& event){
    // Jʒu̒Ǐ]
    for (int i = 0; i < _GLCANVAS_INDEX_MAX; i++)
	GetPCGLCanvas(i)->mDoubleIndexPrev = -1; 
    
    if (mpCGLExtFrame->IsShownOnScreen() == TRUE){
	mpCGLExtFrame->mpCGLCtrl->mpCGLCanvas->Refresh(FALSE);
    }

    mpCTopHalfPanel->RefreshGLPanels();
}

void FrameMain_cls::
OnMenuRefreshTL(wxCommandEvent& event){
    GetPCTimeCtrl()->RefreshGUI();
    mpCBtmHalfPanel->RefreshTLPanels();
}

void FrameMain_cls::
UpdateStatusText(){
wxString strDrawPercentage, strReadPercentage;

    switch(GDrawingStage){
    case 0: 
	strDrawPercentage << wxT("Drawing "); break;
    case 1:
	strDrawPercentage << wxT("Shadow "); break;
    case 2:
	strDrawPercentage << wxT("Drawing LH"); break;
    }
    
    if (GDrawingPercentage != -1){
	strDrawPercentage << GDrawingPercentage << wxT("%");
	//mpCStatusGauge->SetValue(GDrawingPercentage+1);
	mpCStatusGauge->SetValue(GDrawingPercentage);
    }
    else{
	strDrawPercentage = wxT("");
	mpCStatusGauge->SetRange(101);
	mpCStatusGauge->SetValue(101);
	mpCStatusGauge->SetRange(100);
	mpCStatusGauge->SetValue(100);
    }
    
    for (int i = 0; i < _MAX_THREAD_READ; i++){
	if (GAThreadReaderPercentage[i] != 100) 
	    strReadPercentage << 
		GAThreadReaderIndex[i] << wxT("-Load") <<
		GAThreadReaderPercentage[i] << wxT("% ") ;
    }

    int index = GetPCTimeCtrl()->GetRemappedIndex();
    wxString strFilename = 
	GetPCActiveFileSequence()->GetFilename(index);

    if (strFilename.Length() > 50){
	strFilename = strFilename.Right(50);
	strFilename.insert(0, wxT(".."));
    }
    GetStatusBar()->SetStatusText(strFilename, 0);
    GetStatusBar()->SetStatusText(strDrawPercentage, 2);
    GetStatusBar()->SetStatusText(strReadPercentage, 3);


}

void FrameMain_cls::
CheckAbortion(){
    wxMouseState mouseState = ::wxGetMouseState();
    wxPoint mousePos = ::wxGetMousePosition();
    bool isLeftDown = mouseState.LeftDown();
    if (isLeftDown == TRUE)
	GbForceAbort |= GetPCTimeCtrl()->mpCGUIPlay->IsAbortClicked(mousePos);
}

void FrameMain_cls::
OnMenuRefreshSB(wxCommandEvent& event){
    UpdateStatusText();
}

void FrameMain_cls::
OnMenuRefreshAttrib(wxCommandEvent& event){
    mpCTopHalfPanel->RefreshAttrib();
}

void FrameMain_cls::
OnMenuRefreshIMGSEQ(wxCommandEvent& event){
    mpCParent->mpCImgSeq->UpdateItems();
}

void FrameMain_cls::
OnMenuRefreshCamConf(wxCommandEvent& event){
    if (mpCParent->mpCCameraPathCtrl->mpCGUI != NULL)
	mpCParent->mpCCameraPathCtrl->mpCGUI->UpdateValuesAll();
}

void FrameMain_cls::
OnMenuRefreshColor(wxCommandEvent& event){
    mpCParent->mpCColorCurveCtrl->UpdateItems();
}

void FrameMain_cls::
OnMenuRefreshExporter(wxCommandEvent& event){
    if (mpCParent->mpCDataExporter->mpCGUI != NULL)
	mpCParent->mpCDataExporter->mpCGUI->mpCMNumExportParam->UpdateValues();
}

void FrameMain_cls::
OnMenuRefreshDrawOptions(wxCommandEvent& event){
    if (mpCParent->mpCDrawOption->mpCGUI != NULL){
	mpCParent->mpCDrawOption->mpCGUI->HideAndShow();
	mpCParent->mpCDrawOption->mpCGUI->mpCMInputPanel->UpdateValues();
    }
    if (mpCParent->mpCOverlay->mpCGUI != NULL)
	mpCParent->mpCOverlay->mpCGUI->mpCMInputPanel->UpdateValues();
    if (mpCParent->mpCExposure->mpCGUI != NULL)
	mpCParent->mpCExposure->mpCGUI->mpCMInputPanel->UpdateValues();
}

void FrameMain_cls::
OnMenuRefreshLight(wxCommandEvent& event){
    if (mpCParent->mpCLightSRCCtrl->mpCGUI != NULL){
	mpCParent->mpCLightSRCCtrl->mpCGUI->ReconnectParam();
	mpCParent->mpCLightSRCCtrl->mpCGUI->RemakeIconList(-2);
	mpCParent->mpCLightSRCCtrl->mpCGUI->mpCMInputLight->UpdateValues();
    }
}

void FrameMain_cls::
OnMenuRefreshExposure(wxCommandEvent& event){
    mpCParent->mpCExposure->mpCGUI->mpCMInputPanel->UpdateValues();
}

void FrameMain_cls::
OnMenuRefreshStereo(wxCommandEvent& event){
    mpCParent->mpCStereogram->mpCGUI->mpCMInputPanel->UpdateValues();
    mpCParent->mpCStereogram->mpCGUI->HideAndShowItems();
}

void FrameMain_cls::
OnMenuRefreshTexture(wxCommandEvent& event){
    //mpCParent->mpCTexPropertyCtrl->mpCGUI->mpCMInputTexture->UpdateValues();
    mpCParent->mpCTexPropertyCtrl->mpCGUI->UpdateValuesAll();
    //mpCParent->mpCTexPropertyCtrl->mpCGUI->HideAndShowItems();
}

void FrameMain_cls::
OnMenuDeselect(wxCommandEvent& event){
    MoveItem_cls::SetSelection
	(mpCParent->mpCParamGUICtrlLink->SelectObject(NULL));
}

void FrameMain_cls::
OnMenuSyncGLCtrl(wxCommandEvent& event){
    for (int i = 0; i < _GLCANVAS_INDEX_MAX; i++)
	GetPCGLCanvasCtrl(i)->UpdateWindow();
}

void FrameMain_cls::
OnMenuResizedTL(wxCommandEvent& event){
    mpCBtmHalfPanel->RecheckSize();
}

void FrameMain_cls::
OnMenuSetKeyPos(wxCommandEvent& event){
    mpCActiveGLCanvasLink->SetKeyPos();
    mpCTopHalfPanel->RefreshGLPanels();
    mpCBtmHalfPanel->RefreshTLPanels();
}

void FrameMain_cls::
OnMenuSetKeyPosRot(wxCommandEvent& event){
    mpCActiveGLCanvasLink->SetKeyPosRot();
    mpCTopHalfPanel->RefreshGLPanels();
    mpCBtmHalfPanel->RefreshTLPanels();
}

void FrameMain_cls::
OnMenuSetKeyAnc(wxCommandEvent& event){
    mpCActiveGLCanvasLink->SetKeyAnc();
    mpCTopHalfPanel->RefreshGLPanels();
    mpCBtmHalfPanel->RefreshTLPanels();
}

void FrameMain_cls::
OnMenuPlayStop(wxCommandEvent& event){
    mpCActiveGLCanvasLink->StopSaveImgSeqProcess();
    mpCActiveGLCanvasLink->StopExportDataProcess();
    mpCActiveGLCanvasLink->StopExportPovStringProcess();
    if (GetPCTimeCtrl()->mbPlayTex == TRUE && mbRepeatPlay != TRUE)
	GetPCTimeCtrl()->ProcStopPlaying();
    mbRepeatPlay = FALSE;
}

void FrameMain_cls::
OnMenuFullScreen(wxCommandEvent& event){
    mpCGLExtFrame->FullScreenMode();
}

void FrameMain_cls::
OnMenuEscape(wxCommandEvent& event){
    mpCGLExtFrame->FullScreenModeOff();
}

// ----------------------

PovRayCtrl_cls* FrameMain_cls::
GetPCPovRayCtrl(){
    return mpCParent->mpCPovRayCtrl;
}

TimeCtrl_cls* FrameMain_cls::
GetPCTimeCtrl(){
    return mpCParent->mpCTime;
}

PDataSeqCtrl_cls* FrameMain_cls::
GetPCDataSeqCtrl(){
    return mpCParent->mpCPDataSeqCtrl;
}

CameraPathCtrl_cls* FrameMain_cls::
GetPCPathCtrl(){
    return mpCParent->mpCCameraPathCtrl;
}

// ----------------------

wxString FrameMain_cls::
Serialize(){
    wxString strOut;
    strOut << mpCTopHalfPanel->Serialize();
    return strOut;
}

wxString FrameMain_cls::
SerializeForConfigure(){
    wxString strOut;
    strOut << mCConfList.SerializeAll();
    return strOut;
}

void FrameMain_cls::
ReadStrLine(std::wistream &istream, wxString strLine){
    mCConfList.ReadStrLineAll(strLine);
    mpCTopHalfPanel->ReadStrLine(istream, strLine);
}

FrameMain_cls* FrameMain_cls::mspCThis;
